<?php

class Sync_Product_Posts extends WP_Background_Process {

	/**
	 * @var string
	 */
	protected $action = 'sync_products';

	/**
	 * Task
	 *
	 * Override this method to perform any actions required on each
	 * queue item. Return the modified item for further processing
	 * in the next pass through. Or, return false to remove the
	 * item from the queue.
	 *
	 * @param mixed $item Queue item to iterate over
	 *
	 * @return mixed
	 */
	private $tokena = null;
	private $tokenb = null;
	private $endpoint = VENDORFUEL_API_URL 
							. '/admin/products'
							. '?apikey=' . VENDORFUEL_API_KEY;
	
	private $totalPages = 1;

	private $page = null;

	protected function task( $item ) {
		// Actions to perform
		//error_log('syncing product ' . $item);
		$this->page 	=   $item['page'];
		$this->tokena 	= $item['tokena'];
		$this->tokenb 	= $item['tokenb'];

		if(is_null($this->tokena) && is_null($this->tokenb)){
			// TODO: error
			return false;
		}
		$this->retrieveProducts($this->page);
		return false;
		// return false;
		// error_log($item);
		// return false;
		// if($item == 1000 )
		// 	return false;
		// else {
		// 	$item += 1;
		// 	$this->push_to_queue( $item );
		// 	//$this->save()->dispatch();
		// 	return false;
		// }

		
		// $this->tokena = $item->get_header('tokena');
		// $this->tokenb = $item->get_header('tokenb');
		// $page = 1;

		// if(is_null($this->tokena) && is_null($this->tokenb)){
		// 	// TODO: error
		// 	return false;
		// }
		
		// if($this->retrieveProducts($page)){
		// 	for($page = 2; $page <= $this->totalPages; $page++){
		// 		$this->retrieveProducts($page);
		// 	}
		// }asdfasdfasd
		// return false;
	}

	/**
	 * Complete
	 *
	 * Override if applicable, but ensure that the below actions are
	 * performed, or, call parent::complete().
	 */
	protected function complete() {
		parent::complete();
		error_log('completing item : ' . $this->page);

		if($this->page < $this->totalPages) {
			//error_log('pushing item : ' . ++$this->item);
			$item['page'] = $this->page + 1;
			$item['tokena'] = $this->tokena;
			$item['tokenb'] = $this->tokenb;

			$this->push_to_queue($item);
			$this->save()->dispatch();
		} else
			error_log('completed syncing product posts');

		// Show notice to user or perform some other arbitrary task...
	}

	protected function retrieveProducts($page){
		$this->endpoint .= '&tokena='
						. $this->tokena 
						. '&tokenb='.$this->tokenb
						. '&rpp=500'
						. '&status=active'
						. '&page='. $page;

		$response = wp_remote_get( 
						$this->endpoint
						, ['sslverify' => false,
							'timeout'     => 10,
						]
					);
		
		if( is_wp_error( $response ) ) {
			error_log($response->get_error_message());
		}
		
		$body = wp_remote_retrieve_body( $response );
		if( is_wp_error( $body ) ) {
			error_log($body->get_error_message());
			$body = wp_remote_retrieve_body( $response );
			if( is_wp_error( $body ) ) {
				error_log($body->get_error_message());
				return;
			}
		} 
		$response = json_decode($body);
		$products = $response->products;
		$this->totalPages = $products->last_page;
		error_log(print_r($response, true));
		foreach($products->data as $product){
			$slug = $product->slug;
            $product_id = $product->product_id;
            $content = '[vf-template name="product-detail" product_id="'.$product_id .'"]';
            $post = [
            'post_type'     =>  'vf-product',
            'post_title'    =>  $product->description,
            'post_name'    =>  $slug,
            'post_status'   =>  'publish',
            'post_content'  =>  $content
			];

            // if get post
            // update post
            // else
            //need post name (slug)
            $post_id = wp_insert_post($post);
			add_post_meta($post_id, 'vfmetadesc' , $product->long_description, true );
		}

		$this->totalPages = $products->last_page;
	}

}