<?php
    class vendorfuel_wprest_api extends WP_REST_Controller {
        protected $templates;
        protected $utilities;
        protected $queue;
        function __construct($u, $t, $q) {
            $this->templates = $t;
            $this->utilities = $u;
            $this->queue = $q;
        }
        function register() { //register routes
            register_rest_route( 'vendorfuel', '/settings/general', array(
                $this->utilities->build_readable_route($this, 'getGeneralSettings'),
                $this->utilities->build_editable_route($this, 'updateGeneralSettings'),
            ));
            register_rest_route( 'vendorfuel', '/product/post', array(
                $this->utilities->build_editable_route($this, 'updateProductPost'),
            ));
            register_rest_route( 'vendorfuel', '/wp/site/info', array(
                $this->utilities->build_readable_route($this, 'getWPSiteInfo'),            
            ));
            register_rest_route( 'vendorfuel', '/vendorfuel/pages', array(
                $this->utilities->build_readable_route($this, 'getVendorfuelPages'),
                $this->utilities->build_editable_route($this, 'updateVendorfuelPages'),
            ));
            register_rest_route( 'vendorfuel', '/settings/conversions', array(
                $this->utilities->build_readable_route($this, 'getConversionsSettings'),
                $this->utilities->build_editable_route($this, 'updateConversionsSettings'),
            ));
            register_rest_route( 'vendorfuel', '/settings/image', array(
                $this->utilities->build_readable_route($this, 'getImageSettings'),
                $this->utilities->build_editable_route($this, 'updateImageSettings'),
            ));
            register_rest_route( 'vendorfuel', '/settings/anguledit', array(
                $this->utilities->build_readable_route($this, 'getAnguleditSettings'),
                $this->utilities->build_editable_route($this, 'updateAnguleditSettings'),
            ));
            register_rest_route( 'vendorfuel', '/settings/paypal', array(
                $this->utilities->build_readable_route($this, 'getPayPalId'),
                $this->utilities->build_editable_route($this, 'setPayPalId'),
            ));

            register_rest_route( 'vendorfuel', '/payment/enabled', array(
                $this->utilities->build_readable_route($this, 'getEnabledPayments'),
                $this->utilities->build_editable_route($this, 'setEnabledPayments'),
            ));

            register_rest_route( 'vendorfuel', '/settings/stripe', array(
                $this->utilities->build_readable_route($this, 'getStripePK'),
                $this->utilities->build_editable_route($this, 'setStripePK'),
            ));
            register_rest_route( 'vendorfuel', '/settings/authnet', array(
                $this->utilities->build_readable_route($this, 'getAuthnetCreds'),
                $this->utilities->build_editable_route($this, 'setAuthnetCreds'),
            ));
            register_rest_route( 'vendorfuel', '/settings/squareup', array(
                $this->utilities->build_readable_route($this, 'getSquareUp'),
                $this->utilities->build_editable_route($this, 'setSquareUp'),
            ));
            register_rest_route( 'vendorfuel', '/templates', array(
                $this->utilities->build_readable_route($this, 'getTemplates'),
                $this->utilities->build_editable_route($this, 'updateTemplates'),
            ));
            register_rest_route( 'vendorfuel', '/template', array(
		        $this->utilities->build_editable_route($this, 'updateTemplate'),
            ));
            
            register_rest_route( 'vendorfuel', '/templatesJS', array(
                $this->utilities->build_readable_route($this, 'getTemplateJS'),
		        $this->utilities->build_editable_route($this, 'updateTemplatesJS'),
	        ));
	        register_rest_route( 'vendorfuel', '/histories', array(
		        $this->utilities->build_readable_route($this, 'getEdits'),
	        ));
	        register_rest_route( 'vendorfuel', '/history', array(
		        $this->utilities->build_readable_route($this, 'getEdit'),
	        ));
            register_rest_route( 'vendorfuel', '/sync-caches', array(
                $this->utilities->build_readable_route($this, 'syncCaches'),
            ));
            register_rest_route( 'vendorfuel', '/branding', array(
                $this->utilities->build_readable_route($this, 'getBranding'),
                $this->utilities->build_editable_route($this, 'updateBranding'),
            ));
            register_rest_route( 'vendorfuel', '/settings/store', array(
                $this->utilities->build_readable_route($this, 'getStoreOptions'),
                $this->utilities->build_editable_route($this, 'setStoreOptions'),
            ));
            register_rest_route( 'vendorfuel', '/vendorfuel/saveBrandCss', array(
                $this->utilities->build_editable_route($this, 'updateBrandCss'),
            ));

            register_rest_route( 'vendorfuel', '/syncProductPosts', array(
                $this->utilities->build_readable_route($this, 'syncProductPosts'),
            ));

            register_rest_route( 'vendorfuel', '/syncCategoryPosts', array(
                $this->utilities->build_readable_route($this, 'syncCategoryPosts'),
            ));
        }

        function syncProductPosts(WP_REST_Request $request){   
                 $param = [];
                $param['page'] = 1; 
                $param['tokena'] = $request->get_header('tokena');
                $param['tokenb'] =   $request->get_header('tokenb');

                $this->queue->products_posts_sync->push_to_queue( $param);
                $this->queue->products_posts_sync->save()->dispatch();
        }

        function syncCategoryPosts(WP_REST_Request $request){   
            $param = [];
           $param['page'] = 1; 
           $param['tokena'] = $request->get_header('tokena');
           $param['tokenb'] =   $request->get_header('tokenb');

           $this->queue->categories_posts_sync->push_to_queue( $param);
           $this->queue->categories_posts_sync->save()->dispatch();
   }

        function updateProductPost(WP_REST_Request $request){
            $slug = $request['product']['slug'];
            $product_id = $request['product']['product_id'];
            $content = '[vf-template name="product-detail" product_id="'.$product_id.'"]';
            $post = [
            'post_type'     =>  'vf-product',
            'post_title'    =>  $request['product']['description'],
            'post_name'    =>  $slug,
            'post_status'   =>  'published',
            'post_content'  =>  $content
            ];
            // if get post
            // update post
            // else
            //need post name (slug)
            return rest_ensure_response(wp_insert_post($post));
        }

        function updateBrandCss(WP_REST_Request $request) {
            $css = $request['css'];
            file_put_contents('wp-content/vendorfuel/styles.css', $css);
            
            $resp = [
                status => 'File Saved'
            ];
            return rest_ensure_response($resp);
        }

        function getWPSiteInfo() {
            $wp_name = get_bloginfo();
            $url = get_bloginfo('wpurl');
            $info = [
                'name' => $wp_name,
                'url' => $url,
            ];
            return rest_ensure_response(json_decode(json_encode($info),true));
        }

        function getStoreOptions() {
            return rest_ensure_response(get_option('vendorfuel-store-options'));
        }
        function setStoreOptions(WP_REST_Request $request) { 
            $store = array_merge(
                ['name'=> $request['name']],
                ['url'=> $request['url']],
                ['default_order_prefix'=> $request['default_order_prefix']],
                ['default_customer_prefix'=> $request['default_customer_prefix']],
                ['options' => json_decode($request['options'],true)]);
            return rest_ensure_response(update_option("vendorfuel-store-options", json_decode(json_encode($store), FALSE)));
        }

        function getBranding() {
            return rest_ensure_response(get_option('vendorfuel-branding'));
        }
        function updateBranding(WP_REST_Request $request) {
            $branding = $request['branding'];
            return rest_ensure_response(update_option("vendorfuel-branding", json_decode(json_encode($branding), FALSE)));
        }

        //ENDPOINT CALLBACKS
        function getGeneralSettings() {
            return rest_ensure_response(get_option('vendorfuel-general-settings'));
        }
        function updateGeneralSettings(WP_REST_Request $request) {
            $settings = json_decode($request['settings']);
            return rest_ensure_response(update_option("vendorfuel-general-settings", $settings));
        }
        
        function getVendorfuelPages() {

            $anguledit_settings = get_option('vendorfuel-anguledit-settings');
            $vf_pages = $anguledit_settings->template_map;
                
            //$vf_pages = get_option('vendorfuel-pages');
            $wp_pages = array();
            $pages = array_merge(get_posts([
                'posts_per_page'   => -1
            ]), get_pages());
            for ($i = 0; $i < count($pages); $i++) {
                $wp_pages[$i]['url'] = get_permalink($pages[$i]);
                $wp_pages[$i]['id'] = $pages[$i]->ID;
                $wp_pages[$i]['title'] = $pages[$i]->post_title;
            }
            $all_pages = [$vf_pages, $wp_pages];
            return rest_ensure_response($all_pages);
        }
        function updateVendorfuelPages(WP_REST_Request $request) {
            $settings = json_decode($request['map']);
            $vf_page_update = array();

            foreach($settings as $page => $val) {
                $vf_page_update[$page] = array('id' => $val->id, 'url' => $val->url, 'title' => $val->title, 'template' => $val->template);
            }
            foreach($vf_page_update as $key => $page){
                $page['url'] = esc_url_raw($page['url']);
                 if(filter_var($page['url'], FILTER_VALIDATE_URL) === FALSE){
                    unset($vf_page_update[$key]); 
                } else {
                    $vf_page_update[$key] = $page; 
                }
            }
            $anguledit_settings = get_option('vendorfuel-anguledit-settings');
            $anguledit_settings->template_map = json_decode(json_encode($vf_page_update), FALSE);
            return rest_ensure_response(update_option("vendorfuel-anguledit-settings", $anguledit_settings));
        }
        function getConversionsSettings() {
            return rest_ensure_response(get_option('vendorfuel-conversions-settings'));
        }
        function updateConversionsSettings(WP_REST_Request $request) {
            $settings = json_decode($request['settings']);
            return rest_ensure_response(update_option("vendorfuel-conversions-settings", $settings));
        }
        function getImageSettings() {
            return rest_ensure_response(get_option('vendorfuel-image-settings'));
        }
        function updateImageSettings(WP_REST_Request $request) {
            $settings = json_decode($request['settings']);
            return rest_ensure_response(update_option("vendorfuel-image-settings", $settings));
        }
        function getAnguleditSettings() {
            return rest_ensure_response(get_option('vendorfuel-anguledit-settings'));
        }
        function updateAnguleditSettings(WP_REST_Request $request) {
            $settings = json_decode($request['settings']);
            $edit_history_shortened = $this->utilities->shorten_history(wp_get_current_user(), $settings->editHistoryCount);
            return array('settings_saved' => rest_ensure_response(update_option("vendorfuel-anguledit-settings", $settings)), 'edit_history_shortened' => $edit_history_shortened);
        }
        function getPayPalId() {
            return rest_ensure_response(get_option('vendorfuel-paypal-id'));
        }
        function setPayPalId(WP_REST_Request $request) {
            $id = $request['paypal_client_id'];
            update_option("vendorfuel-paypal-id", $id);
            $response = [];
            $response['notifications'] = ['Payment Gateways Updated.'];
            $response['errors'] = [];
            return $response;
        }

        function getAuthnetCreds() {
            $id = get_option('vendorfuel-authnet-id');
            $key = get_option('vendorfuel-authnet-public-key');
           // return rest_ensure_response(get_option('vendorfuel-authnet'));
        }
        function setAuthnetCreds(WP_REST_Request $request) {
            $id = $request['id'];
            $key = $request['public_key'];
            update_option("vendorfuel-authnet-id", $id);
            update_option("vendorfuel-authnet-public-key", $key);

            $response = [];
            $response['notifications'] = ['Payment Gateways Updated.'];
            $response['errors'] = [];
            return $response;
        }

        function getStripePK() {
            return rest_ensure_response(get_option('vendorfuel-stripe-pk'));
        }
        function setStripePK(WP_REST_Request $request) {
            $id = $request['stripe_pk'];
            update_option("vendorfuel-stripe-pk", $id);
            $response = [];
            $response['notifications'] = ['Payment Gateways Updated.'];
            $response['errors'] = [];
            return $response;
        }

        function getEnabledPayments() {
            return rest_ensure_response(get_option('vendorfuel-enabled-payments'));
        }
        function setEnabledPayments(WP_REST_Request $request) {
            $gateway = $request['gateway'];
            $existing_enabled = get_option('vendorfuel-enabled-payments');
            foreach($gateway as $key => $value){
                foreach($value as $k => $v){
                    if($k != 'enabled' && $k != 'paypal_checkout_enabled'){
                        unset($gateway[$key][$k]);
                    } else {
                        if($k == 'enabled'){
                            foreach($existing_enabled as $k2 => $v2){
                                $existing_enabled[$k2]['enabled'] = 0;
                            }
                        }
                    }
                }
            }
            if(!$existing_enabled){
                $existing_enabled = array();
            }
            $merged = array_merge($existing_enabled, $gateway);
            update_option("vendorfuel-enabled-payments", $merged);

            $response = [];
            $response['notifications'] = ['Payment Gateways Updated.'];
            $response['errors'] = [];
            return $response;
        }

        function getSquareUp() {
            return rest_ensure_response(get_option('vendorfuel-square-location-id'));
        }
        function setSquareUp(WP_REST_Request $request) {
            $id = $request['location_id'];
            update_option("vendorfuel-square-location-id", $id);
            $response = [];
            $response['notifications'] = ['Payment Gateways Updated.'];
            $response['errors'] = [];
            return $response;
        }

        function getTemplates(WP_REST_Request $request) {
            $template_cache = $this->utilities->get_cache(wp_get_current_user(), null, false, "dev");
            return $template_cache['data'];
        }
        function updateTemplate(WP_REST_Request $request) {
            return $this->templates->update($request, wp_get_current_user(), true);
        }
        function updateTemplates(WP_REST_Request $request) {
            return $this->templates->update($request, wp_get_current_user());
        }
        function updateTemplatesJS(WP_REST_Request $request) {
            return $this->templates->updateMinJS($request);
        }
        function getTemplateJS(WP_REST_Request $request) {
            return $this->templates->getMinJS();
        }
	    function getEdits(WP_REST_Request $request) {
		    $template_name =  $request['template_name'];
		    $edits = $this->utilities->get_template_edits(wp_get_current_user(), $template_name);
		    return $edits;
	    }
        function getEdit(WP_REST_Request $request) {
	        $template_name =  $request['template_name'];
	        $timestamp =  $request['timestamp'];
	        return $this->utilities->get_template_edit(wp_get_current_user(), $template_name, $timestamp);
        }
        function syncCaches(WP_REST_Request $request) {
            return $this->templates->sync_caches(wp_get_current_user(), boolval(json_decode($request['pull'])));
        }
        // PERMISSION CHECK CALLBACK
        function permission_check( WP_REST_Request $request ) { //ensure only authorized access to editable routes
            if ( is_user_logged_in() ) {
                $headers = $request->get_headers();
                $nonce = $headers['x_wp_nonce'][0];
                if ( wp_verify_nonce($nonce, 'wp_rest') ) { return true; } else { return false; }
            } else { return false; }
        }
    }
?>