<?php
    class vendorfuel_enqueue {
        protected $utilities;
        function __construct($u) {
            $this->utilities = $u;
            $this->general_settings = get_option('vendorfuel-general-settings');
            
            if ( is_admin() ) {
                $this->plugin_data = get_plugin_data(VENDORFUEL_ROOT_DIR . "/vendorfuel.php");
            }
        }
        /**
         * Enqueue assets for the plugin
         */
        function plugin() { 
            /**
             * SCRIPTS
             */
            
            wp_enqueue_script( 'bootstrap', '//stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js', array( 'jquery' ) );
            wp_enqueue_script( 'angular', '//code.angularjs.org/1.7.5/angular.min.js' );
            wp_enqueue_script( 'vendorfuel-local-storage', '//cdnjs.cloudflare.com/ajax/libs/angular-local-storage/0.7.1/angular-local-storage.min.js');
            wp_enqueue_script( 'angular-resource', '//code.angularjs.org/1.7.5/angular-resource.min.js' );
            wp_enqueue_script( 'angular-sanitize', '//code.angularjs.org/1.7.5/angular-sanitize.min.js' );
            wp_enqueue_script( 'angular-cookies', '//code.angularjs.org/1.7.5/angular-cookies.min.js' );
            wp_enqueue_script( 'angular-router', '//cdnjs.cloudflare.com/ajax/libs/angular-ui-router/1.0.23/angular-ui-router.min.js' );
            wp_enqueue_script( 'angular-animate', '//code.angularjs.org/1.7.5/angular-animate.min.js' );
            wp_enqueue_script( 'angular-touch', '//code.angularjs.org/1.7.5/angular-touch.min.js' );
            wp_enqueue_script( 'slick-js' , '//cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.9.0/slick.js');
            wp_enqueue_script( 'angular-slick-js' , '//cdnjs.cloudflare.com/ajax/libs/angular-slick-carousel/3.1.7/angular-slick.min.js');
            wp_enqueue_script( 'ace', '//cdnjs.cloudflare.com/ajax/libs/ace/1.4.2/ace.js' );
            wp_enqueue_script( 'ui-ace', '//cdn.jsdelivr.net/npm/angular-ui-ace@0.2.3/src/ui-ace.min.js' );
            wp_enqueue_script( 'ui-bootstrap', VENDORFUEL_ROOT_URL . 'assets/lib/js/ui-bootstrap-tpls-3.0.6.min.js', null, null, false );
            wp_enqueue_script( 'color-picker', VENDORFUEL_ROOT_URL . 'assets/lib/js/color-picker.min.js', null, null, false );
            wp_enqueue_script( 'beePlugin', '//app-rsrc.getbee.io/plugin/BeePlugin.js' );
            wp_enqueue_script( 'blob-beePlugin',  VENDORFUEL_ROOT_URL . 'assets/lib/beefree.io/myproject/Blob.js', null, null, false );
            wp_enqueue_script( 'fileSaver-beePlugin',  VENDORFUEL_ROOT_URL . 'assets/lib/beefree.io/myproject/fileSaver.js', null, null, false );
            wp_enqueue_script( 'papa-parse',  '//unpkg.com/papaparse@5.0.0/papaparse.min.js');

            /**
             * ANGULAR APP AND DEPENDENCIES - CONCATENATE AND MINIFY FOR PROODUCTION
             */
            if(!$this->general_settings->debug){
                wp_enqueue_script( 'vendorfuel-plugin-app', VENDORFUEL_ROOT_URL . 'assets/app/dist/vendorfuel-app.min.js', null, $this->plugin_data['Version'], false);
            } else {
                wp_enqueue_script( 'vendorfuel-plugin-app', VENDORFUEL_ROOT_URL . 'assets/app/dist/vendorfuel-app.js', null, $this->plugin_data['Version'], false);
            }
            
            wp_enqueue_script( 'vendorfuel-app-tinymcejs', '//cdnjs.cloudflare.com/ajax/libs/tinymce/4.9.4/tinymce.min.js');
            wp_enqueue_script( 'vendorfuel-app-code', '//cdnjs.cloudflare.com/ajax/libs/tinymce/4.9.4/plugins/code/plugin.min.js', array('jquery'));
            
            /**
             * STYLES
             */
            wp_enqueue_style( 'bootstrap', '//stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css' );
            wp_enqueue_style( 'fontawesome', '//cdnjs.cloudflare.com/ajax/libs/font-awesome/5.4.2/css/all.min.css' );
            wp_enqueue_style( 'sizer', VENDORFUEL_ROOT_URL . 'assets/lib/css/sizer.css' );
            wp_enqueue_style( 'color-picker', VENDORFUEL_ROOT_URL . 'assets/lib/css/color-picker.min.css' );
            wp_enqueue_style( 'main', VENDORFUEL_ROOT_URL . 'styles.css' );
            wp_enqueue_style( 'slick-theme-css' , '//cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.9.0/slick-theme.css');
            wp_enqueue_style( 'slick-css' , '//cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.9.0/slick.min.css');

            /**
             * LOCALIZED VARIABLES
             * These variables will be available to our AngularJS application 
             */
            wp_localize_script( 'vendorfuel-plugin-app', 'localized',
                array(
                    'dir' => array(
                        'url' => VENDORFUEL_ROOT_URL,
                        'root' => VENDORFUEL_ROOT_DIR,
                        'content' => content_url() . "/vendorfuel/",
                        'templates' => VENDORFUEL_ROOT_URL . '/assets/app/templates/',
                        'wpRestUrl' => get_rest_url()
                    ),
                    'settings' => array(
                        'general' => $this->general_settings,
                        'conversion' => get_option('vendorfuel-conversion-settings'),
                        'image' => get_option('vendorfuel-image-settings'),
                        'store' => get_option('vendorfuel-store-options')
                    ),
                    'nonce' => wp_create_nonce( 'wp_rest' ),
                    'plugin_data' => $this->plugin_data,
                    'branding' => get_option('vendorfuel-branding'),
                )
            );
            wp_enqueue_media();
            wp_enqueue_editor();
    }
        /**
         * Enqueue assets for the front-end
         */
    function frontend() {
            /**
             * SCRIPTS
             */

            wp_enqueue_script( 'angular', '//code.angularjs.org/1.7.5/angular.min.js', null, null, true );
            wp_enqueue_script( 'angular-resource', '//code.angularjs.org/1.7.5/angular-resource.min.js', null, null, true );
            wp_enqueue_script( 'angular-sanitize', '//code.angularjs.org/1.7.5/angular-sanitize.min.js' , null, null, true);
            wp_enqueue_script( 'angular-cookies', '//code.angularjs.org/1.7.5/angular-cookies.min.js', null, null, true );
            wp_enqueue_script( 'angular-router', '//cdnjs.cloudflare.com/ajax/libs/angular-ui-router/1.0.23/angular-ui-router.min.js', null, null, true );
           

            if($this->general_settings->uibootstrap3){
                wp_enqueue_script( 'ui-bootstrap', VENDORFUEL_ROOT_URL . 'assets/lib/js/ui-bootstrap-tpls-3.0.6.min.js', null, null, true );
            } else {
                wp_enqueue_script( 'ui-bootstrap', '//cdnjs.cloudflare.com/ajax/libs/angular-ui-bootstrap/2.5.0/ui-bootstrap-tpls.min.js', null, null, true);
            }
            
            wp_enqueue_script( 'bootstrap', '//stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js', array( 'jquery' ), null, true );
            wp_enqueue_script( 'slick-js' , '//cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.9.0/slick.js', null, null, true);
            wp_enqueue_script( 'angular-slick-js' , '//cdnjs.cloudflare.com/ajax/libs/angular-slick-carousel/3.1.7/angular-slick.min.js', null, null, true);
            /**
             * ANGULAR APP AND DEPENDENCIES - CONCATENATE AND MINIFY FOR PROODUCTION
             */
            /**
             * Cloud files
             */
            wp_enqueue_script( 'vendorfuel-local-storage', 'https://api.vendorfuel.com/assets/lib/js/angular-local-storage.min.js', null, null, true);
                //if debug mode enabled, enqueue the non-minified vendorfuel app file
            wp_enqueue_script( 'vendorfuel-cloud-app', 'https://api.vendorfuel.com/assets/app/dist/'.VENDORFUEL_JS_VERSION.'/vendorfuel-app.min.js', null, null, true);
                //if debug mode disabled, enqueue the minified vendorfuel app file

            /**
             * Local files
             */
            //wp_enqueue_script( 'vendorfuel-app-svc-localized', VENDORFUEL_ROOT_URL . 'assets/app/dev/services/localized.js', null, null, false );
            //wp_enqueue_script( 'vendorfuel-app-svc-debug', VENDORFUEL_ROOT_URL . 'assets/app/dev/services/debug.js', null, null, false );
            //wp_enqueue_script( 'vendorfuel-app-svc-utils', VENDORFUEL_ROOT_URL . 'assets/app/dev/services/utils.js' );

            if ($this->utilities->ActiveBranch(wp_get_current_user()) != "live") {
                wp_enqueue_script( 'vendorfuel-local-controllers', DEV_CONTROLLER_CACHE_FILE_URL , null,  time(), true);
            } else {
                wp_enqueue_script( 'vendorfuel-local-controllers', CONTROLLER_CACHE_FILE_URL, null, time(), true );
            }

            $enabled_payments = get_option('vendorfuel-enabled-payments');
            $stripe_enabled = false;
            if(is_array($enabled_payments)){
                if(array_key_exists('qualpay', $enabled_payments) && array_key_exists('enabled', $enabled_payments['qualpay'])  && $enabled_payments['qualpay']['enabled'] ){
                    wp_enqueue_script( 'qualpay-js', 'https://app.qualpay.com/hosted/embedded/js/qp-embedded-sdk.min.js',null,null,true );
                    wp_enqueue_style( 'qualpay-css', 'https://app.qualpay.com/hosted/embedded/css/qp-embedded.css' );
                }

                if(array_key_exists('authnet', $enabled_payments) && array_key_exists('enabled', $enabled_payments['authnet'])  && $enabled_payments['authnet']['enabled'] ){
                //check sandbox?
                    wp_enqueue_script( 'accept-js', 'https://js.authorize.net/v1/Accept.js',null,null,true);
                }
                if(array_key_exists('stripe', $enabled_payments) && array_key_exists('enabled', $enabled_payments['stripe'])  && $enabled_payments['stripe']['enabled'] ){
                    wp_enqueue_script( 'stripe-js', 'https://js.stripe.com/v3/',null,null,true);
                    $stripe_enabled = true;
                } 

                if(array_key_exists('squareup', $enabled_payments) && array_key_exists('enabled', $enabled_payments['squareup'])  && $enabled_payments['squareup']['enabled'] ){
                    //check sandbox?
                    wp_enqueue_script( 'squareup-js', 'https://js.squareup.com/v2/paymentform', null, null, true );
                    wp_enqueue_style( 'squareup-css' , 'https://api.vendorfuel.com/assets/lib/css/squareuppaymentform.css');
                }
            }
  
            /**
             * STYLES
             */
            wp_enqueue_style( 'vendorfuel-theme-css', '/wp-content/vendorfuel/styles.css',null, time(), null );
            wp_enqueue_style( 'vendorfuel-css', VENDORFUEL_ROOT_URL . 'components.css' );
            wp_enqueue_style( 'fontawesome', '//cdnjs.cloudflare.com/ajax/libs/font-awesome/5.4.2/css/all.min.css' );
            wp_enqueue_style( 'sizer', VENDORFUEL_ROOT_URL . 'assets/lib/css/sizer.css' );
             wp_enqueue_style( 'slick-theme-css' , '//cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.9.0/slick-theme.css');
            wp_enqueue_style( 'slick-css' , '//cdnjs.cloudflare.com/ajax/libs/slick-carousel/1.9.0/slick.min.css');

            /**
             * LOCALIZED VARIABLES
             * These variables will be available to our AngularJS application 
             */
            $anguledit_settings = get_option('vendorfuel-anguledit-settings');
            wp_localize_script( 'vendorfuel-cloud-app', 'localized',
                array(
                    'dir' => array(
                        'url' => VENDORFUEL_ROOT_URL,
                        'root' => VENDORFUEL_ROOT_DIR,
                        'content' => content_url() . "/vendorfuel/",
//                        'templates' => VENDORFUEL_ROOT_URL . '/assets/app/dist/templates/',
                        'wpRestUrl' => get_rest_url()
                    ),
                    'settings' => array(
                        'general' => $this->general_settings,
                        'gateway' => get_option('vendorfuel-gateway-settings'),
                        'conversion' => get_option('vendorfuel-conversion-settings'),
                        'image' => get_option('vendorfuel-image-settings'),
                        'store' => get_option('vendorfuel-store-options'),
                        'stripe_pk' => get_option('vendorfuel-stripe-pk'),
                        'stripe_enabled' => $stripe_enabled,
                        'authnet_public_key' => get_option('vendorfuel-authnet-public-key'),
                        'authnet_id' => get_option('vendorfuel-authnet-id'),
                        'square_location_id' => get_option('vendorfuel-square-location-id'),
                    ),
                    'pages' => $anguledit_settings->template_map,
                    'branding' => get_option('vendorfuel-branding'),             
                )
            );

            wp_localize_script('vendorfuel-cloud-app', 'params', sanitize_post(array_merge($_GET, $_POST)));         
        }
    }
?>