<?php
    class vendorfuel_initialize {
        protected $utilities;
        function __construct($u) {
            $this->utilities = $u;
        }
        function settings() { //verify plugin settings exist. if they do not, create them
            if (!get_option('vendorfuel-general-settings')) { //general settings
                $settings = array(
                    "apiUrl" => "https://api.vendorfuel.com/production", 
                    "apiKey" => "", 
                    "uibootstrap3" => 1, 
                    "theme" => "", 
                    "customizedStyle" => "vfuel01", 
                    "btnText" => "", 
                    "productSlug" => "", 
                    "catSlug" => "", 
                    "loggedInText" => "", 
                    "useLargeThumbs" => 0, 
                    "requireAddress" => 0, 
                    "debug" => 0, 
                    "test" => 0, 
                    "minJS" => 0, 
                    "cache" => 0, 
                    "redirectToCart" => 0, 
                    "pagination" => 0, 
                    "confirmDelete" => 0, 
                    "confirmNavigate" => 0, 
                    "showRating" => 0, 
                    "enableRecyclable" => 0, 
                    "confirmationThumbs" => 0,
                    "checkout" => [
                        "company_option" => 0,
                        "purchase_order_option" => 0,
                        "issuing_office_option" => 0,
                        "cost_center_option" => 0,
                        "attention_option" => 0,
                        "notes_option" => 0
                    ]
                );
                add_option("vendorfuel-general-settings", json_decode(json_encode($settings), FALSE));
            }
            if (!get_option('vendorfuel-conversions-settings')) { //conversions settings
                $settings = array(
                    "google" => array (
                        "enabled" => false,
                        "id" => "",
                        "label" => "",
                        "tracking" => ""
                    )
                );
                add_option("vendorfuel-conversions-settings",json_decode(json_encode($settings), FALSE));
            }
            if (!get_option('vendorfuel-store-options')) { //conversions settings
                $settings = array(
                    'name'=> '',
                    'url'=>'',
                    'options' => json_decode(json_encode([
                        'Load Footer Template' => true,
                        'Load Menu Nav Template' => true
                    ]),true)
                );
                add_option("vendorfuel-store-options",json_decode(json_encode($settings), FALSE));
            }
            if (!get_option('vendorfuel-image-settings')) { //image settings
                $settings = array(
                    "storage" => array (
                        "repository" => 0,
                        "api_key" => ""
                    ),
                    "thumbnail_size" => array (
                        "w" => 120,
                        "h" => 90,
                        "crop" => true
                    ),
                    "medium_size" => array (
                        "w" => 480,
                        "h" => 396
                    ),
                    "large_size" => array (
                        "w" => 680,
                        "h" => 300
                    )
                );
                add_option("vendorfuel-image-settings",json_decode(json_encode($settings), FALSE));
            }            
            if (!get_option('vendorfuel-anguledit-settings')) { //anguledit settings
                $settings = array(
                    "devBranchActive" => false,
                    "template_map" => array(),
	                "editHistoryCount" => 5
                );
                add_option("vendorfuel-anguledit-settings", json_decode(json_encode($settings), FALSE));
            }
        }     
        function pages() { //add required plugin pages
            $anguledit_options = get_option('vendorfuel-anguledit-settings');
            
                $pageArr = array( //TODO: move this into a template map creator on the AngulEdit view. This template map will allow pages to be accessed in the VendorFuel app as individual objects with parameters like url.
                    array( "title" => "Account", "template" => "account" ),
                    array( "title" => "Addresses", "template" => "addresses" ),
                    array( "title" => "Forgot Password", "template" => "forgot-password" ),
                    array( "title" => "Cart", "template" => "cart" ),
                    array( "title" => "Catalog", "template" => "catalog" ),
                    array( "title" => "Checkout", "template" => "checkout" ),
                    array( "title" => "Favorites", "template" => "favorites" ),
                    array( "title" => "Forgot Password", "template" => "forgot-password" ),
                    array( "title" => "Group Account", "template" => "group-account" ),
                    array( "title" => "Group Orders", "template" => "group-orders" ),
                    array( "title" => "Home", "template" => "home" ),
                    array( "title" => "Login", "template" => "login" ),
                    array( "title" => "", "template" => "" ),
                    array( "title" => "Order by SKU", "template" => "order-by-sku" ),
                    array( "title" => "Orders", "template" => "orders" ),
                    array( "title" => "Product Detail", "template" => "product-detail" ),
                    array( "title" => "Register", "template" => "register" ),
                    array( "title" => "Reset Password", "template" => "reset-password" ),
                    array( "title" => "Saved Cart", "template" => "saved-cart" ),
                    array( "title" => "Saved Carts", "template" => "saved-carts" ),
                    array( "title" => "View Order", "template" => "view-order" )   
                );
                $template_map = array();
                foreach ($pageArr as $page) {
                    $tempPage = get_page_by_title( $page['title'] );
                    if (!$tempPage && $page['title'] !== "") {
                        $slug = strtolower(str_replace(' ', '-', $page['title']));
                        $newPage = array(
                            'post_title' => wp_strip_all_tags( $page['title'] ),
                            'post_content' => '[vf-template name="' . $page['template'] . '"]',
                            'post_type' => 'page',
                            'post_status' => 'publish',
                            'post_slug' => $slug
                        );
                        $id = wp_insert_post( $newPage );
                        $page_url = get_permalink($id);//strtolower($page['title']);//get_post_permalink($id);
                        $template_map[$slug] = array('title' => $page['title'], 'template' => $page['template'], 'url' => $page_url, 'id' => $id);
                    } else if($tempPage != null) {
                        $tempPage = $tempPage->to_array();
                        $id = $tempPage['ID'];
                        $slug = strtolower(str_replace(' ', '-', $page['title']));
                        $page_url = get_permalink($id);//strtolower($page['title']);//get_post_permalink($id);
                        $template_map[$slug] = array('title' => $page['title'], 'template' => $page['template'], 'url' => $page_url, 'id' => $id);
                    }
                }
                if (!empty($template_map)) {
                    if($anguledit_options->template_map){
                        $template_map = array_merge($template_map, json_decode(json_encode($anguledit_options->template_map),true));
                    }
                    $settings = array(
                        "devBranchActive" => $anguledit_options->devBranchActive,
                        "template_map" => json_decode(json_encode($template_map), true)
                    );
                    update_option('vendorfuel-anguledit-settings',json_decode(json_encode($settings), FALSE));
                }
            
        }
        function content() { //build the front-end angular app
            $this->utilities->build_app(wp_get_current_user());
        }
        function initialize() { //initialize the plugin
            $this->settings(); //verify and initialize plugin settings
            $this->pages(); //create required pages
            $this->content(); //generate front end apps
        }

        
    }