<?php
    class vendorfuel_templates {
        private static $instance = null;
        public static function get_instance(){
            if (self::$instance == null) {
                self::$instance = new vendorfuel_templates();
            }
            return self::$instance;
        }
        protected $utilities;
        function __construct() {
            $this->utilities = vendorfuel_utilities::get_instance();
        }
        function update($request, $current_user, $single = false) { //update template cache
            $this->utilities->file_check();
            $template_cache = $this->utilities->get_cache($current_user, null, false);
            $data = $template_cache['data'];
            $response = array();
            if ($single) {
            	$template_name = $request["template"]["name"];
                $template_index = $data["map"][$template_name];
                $data["templates"][$template_index] = $request["template"];
	            $temp_history = $this->utilities->get_history($current_user);
	            if ($temp_history !== false) {
	            	$temp_history_item = array(
	            		'date' => date("Y-m-d H:i:s"),
	            		'template' => $request["template"]
		            );
		            if (!$temp_history['history'][$template_name]) {
			            $temp_history['history'][$template_name] = array();
		            }
		            $history_count = array_unshift($temp_history['history'][$template_name], $temp_history_item);
		            $history_max_count = get_option('vendorfuel-anguledit-settings')->editHistoryCount;
		            if ($history_count > $history_max_count) {
		            	array_pop($temp_history['history'][$template_name]);
		            }
		            $this->utilities->save_history($current_user, $temp_history);
		            $response['edits'] = $this->utilities->get_template_edits($current_user, $template_name);
                }

                $response['notifications'] = ['Template '. $request["template"]["name"] .' updated.'];
                $response['errors'] = [];
            } else {
                $data["templates"] = $request["templates"];
                $data["map"] = $request["map"];
            }
            $response['cacheSaved'] = $this->utilities->save_cache($data, $current_user);
            $response['appBuilt'] = rest_ensure_response($this->utilities->build_app($current_user));

            if (!is_null($override_branch)) {
                $branch = $override_branch;
            }
            if ($branch == "dev") {
                $app_file = DEV_CONTROLLER_CACHE_FILE_DIR;
            $tempJavascript = "";
            foreach($template_cache['templates'] as $item) {
                if (!empty($item['js'])) {
                    $tempJavascript .= $item['js'] . "\n";
                }
            }
            return rest_ensure_response(file_put_contents($app_file, $tempJavascript));
            } else {
                return true;
            }
            
            return $response;
        }

        public function updateMinJS($request) { //update template cache
            if(isset($request['templateJS'])) { 
                $app_file = CONTROLLER_CACHE_FILE_DIR;
                return rest_ensure_response(file_put_contents($app_file, $request['templateJS']));
            } 
            return FALSE;
        }

        public function getMinJS() { //update template cache
            $app_file = CONTROLLER_CACHE_FILE_DIR;
            return rest_ensure_response(file_get_contents($app_file));
        }

        public function sync_caches($current_user, $liveToDev = false) { //sync template caches with each other
            $this->utilities->file_check();
            $live_branch = "live";
            $dev_branch = "dev";
            if ($liveToDev) {
               $temp_cache = $this->utilities->get_cache($current_user, null, false, $live_branch);
               $cache_synced = $this->utilities->save_cache($temp_cache['data'], $current_user, $dev_branch);
            } else {
                $temp_cache = $this->utilities->get_cache($current_user, null, false, $dev_branch);
                $cache_synced = $this->utilities->save_cache($temp_cache['data'], $current_user, $live_branch);
            }
            $live_build = $this->utilities->build_app($current_user, $live_branch);
            $dev_build = $this->utilities->build_app($current_user, $dev_branch);
            return array('liveBuild' => $live_build, 'devBuild' => $dev_build, 'cachesSynced' => $cache_synced, 'cache' => $temp_cache['data']);
        }
        function shortcode($name) {
            return do_shortcode($this->utilities->get_cache(wp_get_current_user(), $name, true));
        }
    }