"use strict";

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function () {
  'use strict';
})();

var vfApp = vfApp || {};
vfApp = angular.module('vendorfuelApp', ['ui.router', 'ngResource', 'ngCookies', 'ngSanitize', 'ui.bootstrap', 'ui.ace', 'ngAnimate', 'ngTouch', 'slickCarousel', 'LocalStorageModule', 'colorpicker']);
angular.module('vendorfuelApp').config(['$stateProvider', '$urlRouterProvider', '$httpProvider', 'localStorageServiceProvider', '$sceDelegateProvider', function ($stateProvider, $urlRouterProvider, $httpProvider, localStorageServiceProvider, $sceDelegateProvider) {
  $urlRouterProvider.otherwise('/');
  $stateProvider.state('root', {
    views: {
      'header': {
        templateUrl: localized.dir.templates + '/header.html',
        controller: 'HeaderController'
      },
      'menu': {
        templateUrl: localized.dir.templates + '/menu.html',
        controller: 'MenuController'
      },
      'content': {
        template: '<div ui-view></div>'
      },
      'footer': {
        templateUrl: localized.dir.templates + '/footer.html',
        controller: 'FooterController'
      }
    }
  }).state('dashboard', {
    parent: 'root',
    url: '/dashboard',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/dashboard.html',
        controller: 'DashboardController'
      },
      'loading@dashboard': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-dashboard');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('contact-us', {
    parent: 'root',
    url: '/contact-us',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/contact-us.html',
        controller: 'ContactController'
      },
      'loading@contact-us': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('reports', {
    parent: 'root',
    url: '/reports',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/reports.html',
        controller: 'ReportsController'
      },
      'loading@reports': {
        template: '<img class="w-200 m-t-40"\
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-reports');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('payments', {
    parent: 'root',
    url: '/payments',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/payments.html',
        controller: 'PaymentsController'
      },
      'loading@payments': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('settings', {
    parent: 'root',
    url: '/settings/:activeTab?:id',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/settings.html',
        controller: 'SettingsController'
      },
      'loading@settings': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: null,
      id: null
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-settings');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('subscribe', {
    parent: 'root',
    url: '/subscribe',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/subscribe.html',
        controller: 'SubscribeController'
      },
      'loading@reports': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('login', {
    parent: 'root',
    url: '/login',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/login.html',
        controller: 'LoginController'
      },
      'loading@login': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('reset-password', {
    parent: 'root',
    url: '/reset-password?code&auth',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/reset-password.html',
        controller: 'ResetPasswordController'
      },
      'loading@login': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true,
        code: null,
        auth: null
      }
    }
  }).state('logout', {
    parent: 'root',
    url: '/logout',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/logout.html',
        controller: 'LogoutController'
      },
      'loading@logout': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('tenant-login', {
    parent: 'root',
    url: '/tenant-login',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/tenant-login.html',
        controller: 'TenantLoginController'
      },
      'loading@login': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('admin', {
    parent: 'root',
    url: '/admin',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/admin-accounts.html',
        controller: 'AdminAccountsController'
      },
      'loading@admin': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-admin');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('anguledit', {
    parent: 'root',
    url: '/anguledit',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/anguledit.html',
        controller: 'AnguleditController'
      },
      'loading@anguledit': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-anguledit');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('email', {
    parent: 'root',
    url: '/email',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/email.html',
        controller: 'EmailController'
      },
      'loading@email': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-email');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog', {
    parent: 'root',
    url: '/catalog',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog.html',
        controller: 'CatalogController'
      },
      'loading@catalog': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-catalog');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog-products', {
    //catalog (categories, products, collections, manufacturers, banners, pricesheets, costsheets, venodrs, promo-codes,images, uom)
    parent: 'root',
    url: '/catalog-products/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog-products.html',
        controller: 'CatalogProductsController'
      },
      'loading@catalog-products': {
        template: '<img class="w-200 m-t-40" \
                                    ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      },
      product: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-catalog');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog-collections', {
    parent: 'root',
    url: '/catalog-colllections/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog-collections.html',
        controller: 'CatalogCollectionsController'
      },
      'loading@catalog-collections': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-catalog');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog-pricesheets', {
    parent: 'root',
    url: '/catalog-pricesheets/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog-pricesheets.html',
        controller: 'CatalogPricesheetsController'
      },
      'loading@catalog-pricesheets': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-catalog');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog-categories', {
    parent: 'root',
    url: '/catalog-categories/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog-categories.html',
        controller: 'CatalogCategoriesController'
      },
      'loading@catalog-categories': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-catalog');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog-promocodes', {
    parent: 'root',
    url: '/catalog-promocodes/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog-promocodes.html',
        controller: 'CatalogPromoCodesController'
      },
      'loading@catalog-promocodes': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-catalog');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog-manufacturers', {
    parent: 'root',
    url: '/catalog-manufacturers/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog-manufacturers.html',
        controller: 'CatalogManufacturersController'
      },
      'loading@catalog-manufacturers': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-catalog');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog-uom', {
    parent: 'root',
    url: '/catalog-uom/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog-uom.html',
        controller: 'CatalogUomController'
      },
      'loading@catalog-uom': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-catalog');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog-banners', {
    parent: 'root',
    url: '/catalog-banners/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog-banners.html',
        controller: 'CatalogBannersController'
      },
      'loading@catalog-banners': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-catalog');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('catalog-reviews', {
    parent: 'root',
    url: '/catalog-reviews/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/catalog-reviews.html',
        controller: 'ReviewsController'
      },
      'loading@catalog-reviews': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('customers', {
    parent: 'root',
    url: '/customers',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/customers.html',
        controller: 'CustomersController'
      },
      'loading@customers': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-customers');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('customers-groups', {
    parent: 'root',
    url: '/customers-groups/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/customers-groups.html',
        controller: 'GroupsController'
      },
      'loading@customers-groups': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      },
      customer: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-customers');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('customers-accounts', {
    parent: 'root',
    url: '/customers-accounts/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/customers-accounts.html',
        controller: 'AccountsController'
      },
      'login@customers-accounts': {
        templateUrl: localized.dir.templates + '/login.html',
        controller: 'LoginController'
      },
      'loading@customers-accounts': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      },
      customer: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      setActiveWordPressMenuItem('#vf-menu-item-customers');
    },
    onExit: function onExit() {
      unsetActiveWordPressMenuItem();
    }
  }).state('taxes', {
    parent: 'root',
    url: '/taxes',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/taxes.html',
        controller: 'TaxesController'
      },
      'login@taxes': {
        templateUrl: localized.dir.templates + '/login.html',
        controller: 'LoginController'
      },
      'loading@taxes': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('shipping', {
    parent: 'root',
    url: '/shipping',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/shipping.html',
        controller: 'ShippingController'
      },
      'login@shipping': {
        templateUrl: localized.dir.templates + '/login.html',
        controller: 'LoginController'
      },
      'loading@shipping': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('shipping-flat-rates', {
    parent: 'root',
    url: '/shipping-flat-rates/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/shipping-flat-rates.html',
        controller: 'ShippingFlatRatesController'
      },
      'login@shipping-flat-rates': {
        templateUrl: localized.dir.templates + '/login.html',
        controller: 'LoginController'
      },
      'loading@shipping-flat-rates': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('shipping-parcels', {
    parent: 'root',
    url: '/shipping-parcels/:activeTab',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/shipping-parcels.html',
        controller: 'ShippingParcelsController'
      },
      'login@shipping-parcels': {
        templateUrl: localized.dir.templates + '/login.html',
        controller: 'LoginController'
      },
      'loading@shipping-parcels': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('orders', {
    parent: 'root',
    url: '/orders',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/orders.html',
        controller: 'OrdersController'
      },
      'login@orders': {
        templateUrl: localized.dir.templates + '/login.html',
        controller: 'LoginController'
      },
      'loading@orders': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      },
      order: {
        dynamic: true
      }
    }
  }).state('tutorial', {
    parent: 'root',
    url: '/tutorial',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/tutorial.html',
        controller: 'TutorialController'
      },
      'login@tutorial': {
        templateUrl: localized.dir.templates + '/login.html',
        controller: 'LoginController'
      },
      'loading@tutorial': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('branding', {
    parent: 'root',
    url: '/branding',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/branding.html',
        controller: 'BrandingController'
      },
      'loading@branding': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('billing', {
    parent: 'root',
    url: '/billing',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/billing.html',
        controller: 'BillingController'
      },
      'loading@billing': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('accounting', {
    parent: 'root',
    url: '/accounting',
    views: {
      '@': {
        templateUrl: localized.dir.templates + '/accounting.html',
        controller: 'AccountingController'
      },
      'loading@accounting': {
        template: '<img class="w-200 m-t-40" \
                                ng-src="{{rootUrl}}/assets/img/loading.gif">'
      }
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  });
  $httpProvider.interceptors.push('vfAdminInterceptor');
  localStorageServiceProvider.setPrefix('vf').setStorageCookie(0, '/').setStorageType('sessionStorage');

  function setActiveWordPressMenuItem(id) {
    jQuery(id).parent().parent().addClass('current');
  }

  function unsetActiveWordPressMenuItem() {
    var menuItemIdArr = ['dashboard', 'admin', 'customers', 'catalog', 'anguledit', 'email', 'orders', 'reports', 'shipping', 'taxes', 'payments', 'branding', 'settings'];
    angular.forEach(menuItemIdArr, function (item) {
      jQuery('#vf-menu-item-' + item).parent().parent().removeClass('current');
    });
  }

  $sceDelegateProvider.resourceUrlWhitelist([// Allow same origin resource loads.
  'self', // Allow loading from our assets domain.  Notice the difference between * and **.
  'https://*.payfabric.com/**']);
}]);
angular.module('vendorfuelApp').run(["$rootScope", "$location", "Admin", "Debug", function ($rootScope, $location, Admin, Debug) {
  $rootScope.rootUrl = localized.dir.url;
  $rootScope.wpApiUrl = localized.dir.wpRestApi + 'vendorfuel';
  $rootScope.generalSettings = localized.settings.general;
  $rootScope.vfApiUrl = $rootScope.generalSettings.apiUrl;
  $rootScope.apiKey = $rootScope.generalSettings.apiKey;
  Debug.log('Localized API Key', localized.apiKey);
  $rootScope.pageNum = 0;
  $rootScope.collapsed = false;

  if (!$rootScope.apiKey) {
    Debug.log('No API key set!');

    if (Admin.authed) {
      Debug.log('No API key set!');
      Admin.Logout();
    }

    $location.path('/subscribe');
  }
}]);
angular.module('vendorfuelApp').service('Debug', ['Localized', function (Localized) {
  var debugMode = Localized.debugMode;

  this.log = function (lA, lB, lC, lD) {
    if (debugMode) {
      if (lA && lB && lC && lD) {
        console.log(lA, lB, lC, lD);
      } else if (lA && lB && lC) {
        console.log(lA, lB, lC);
      } else if (lA && lB) {
        console.log(lA, lB);
      } else if (lA) {
        console.log(lA);
      }
    }
  };
}]);
angular.module('vendorfuelApp').service('Localized', function () {
  this.debugMode = localized.settings.general.debug;
  this.root = {
    url: localized.dir.url,
    path: localized.dir.root
  };
  this.apiUrl = localized.settings.general.apiUrl;
  this.apiKey = localized.settings.general.apiKey;
  this.wpRestUrl = localized.dir.wpRestUrl + 'vendorfuel';
  this.wpNonce = localized.nonce;
  this.plugin_data = localized.plugin_data;
  this.branding = localized.branding;
  this.notifications = [];

  this.ClearNotifications = function () {
    this.notifications.splice(0, this.notifications.length);
  };

  this.PushNotification = function (notification) {
    var msg = notification.message;

    if (msg && msg !== 'undefined' && msg !== null && msg !== '' && msg !== 'OK') {
      this.notifications.push(notification);
    }
  };

  this.GetNotifications = function () {
    return this.notifications;
  };

  this.RemoveNotification = function (index) {
    console.log('!');

    if (this.notifications[index] !== undefined) {
      this.notifications.splice(index, 1);
    } else {
      this.notifications.push({
        'type': 'danger',
        'message': 'Whoops! Unable to remove notification.'
      });
    }
  };

  this.responseMessages = [];

  this.ClearResponseMsg = function () {
    this.responseMessages.splice(0, this.responseMessages.length);
  };

  this.PushResponseMsg = function (notification) {
    var msg = notification.message;

    if (msg && msg !== 'undefined' && msg !== null && msg !== '' && msg !== 'OK') {
      this.responseMessages.push(notification);
    }
  };

  this.GetResponseMsgs = function () {
    return this.responseMessages;
  };

  this.RemoveResponseMsg = function (index) {
    console.log('!');

    if (this.responseMessages[index] !== undefined) {
      this.responseMessages.splice(index, 1);
    } else {
      this.responseMessages.push({
        'type': 'danger',
        'message': 'Whoops! Unable to remove notification.'
      });
    }
  };

  this.RemoveAllNoticfitcations = function () {
    if (this.responseMessage !== undefined) {
      this.responseMessages = [];
    } else {
      this.responseMessages.push({
        'type': 'danger',
        'message': 'Whoops! Unable to remove notifications.'
      });
    }
  };
});
angular.module('vendorfuelApp').service('Utils', ['$http', 'Localized', '$location', 'Admin', 'Tenant', function ($http, Localized, $location, Admin, Tenant) {
  var ReturnLocation = null;
  var redirecting = false;

  function httpPromise(req) {
    var promise = $http(req).then(function successCallback(response) {
      Localized.responseMessages = [];

      if (response.data) {
        if (response.data.notifications) {
          for (var i = 0; i < response.data.notifications.length; i++) {
            Localized.PushResponseMsg({
              type: 'success',
              message: response.data.notifications[i]
            });
          }

          for (var j = 0; j < response.data.errors.length; j++) {
            Localized.PushResponseMsg({
              type: 'danger',
              message: response.data.errors[j]
            });
          }
        }

        return response.data;
      } else {
        Localized.responseMessages = [];
        Localized.PushResponseMsg({
          type: 'danger',
          message: response.statusText
        });
        return response;
      }
    }, function errorCallback(response) {
      if (response.status === 401) {
        if (!response.config.url.includes('tenant')) {
          Admin.Logout();
        } else {
          Tenant.Logout();
        }
      }

      Localized.PushResponseMsg({
        type: 'danger',
        message: response.statusText
      });
      return response;
    });
    return promise;
  }

  this.HttpGet = function (endpoint, params, data) {
    params = params || {};
    data = data || {};
    var req = {
      method: 'GET',
      url: endpoint,
      params: params,
      data: data
    };
    return httpPromise(req);
  };

  this.HttpPost = function (endpoint, params, data) {
    params = params || {};
    data = data || {};
    var req = {
      method: 'POST',
      url: endpoint,
      params: params,
      data: data
    };
    return httpPromise(req);
  };

  this.HttpPut = function (endpoint, params, data) {
    params = params || {};
    data = data || {};
    var req = {
      method: 'PUT',
      url: endpoint,
      params: params,
      data: data
    };
    return httpPromise(req);
  };

  this.GetHttpPromise = function (req) {
    return httpPromise(req);
  };

  this.urlParser = parser();

  this.setLocation = function (location, should_return) {
    if (!this.redirecting) {
      this.redirecting = true;
      console.log('redirecting');

      if (should_return === true) {
        this.ReturnLocation = $location.url();
      }

      $location.path(location);
    }
  };

  this.setActiveWordPressMenuItem = function (page) {
    var wpMenuIdArr = ['#vf-menu-item-dashboard', '#vf-menu-item-admin', '#vf-menu-item-customers', '#vf-menu-item-', '#vf-menu-item-', '#vf-menu-item-', '#vf-menu-item-', '#vf-menu-item-', '#vf-menu-item-', '#vf-menu-item-', '#vf-menu-item-', '#vf-menu-item-']; // TODO: Remove current class from all menu items
    // TODO: Add current class to the specified menu item
    // jQuery('#vf-menu-item-dashboard').parent().parent().removeClass( "current" );
    // jQuery('#vf-menu-item-taxes').parent().parent().addClass( "current" );
  };

  this.cleanKey = function (str) {
    return str.toLowerCase().replace(/\s+/g, '-');
  };

  this.cleanErrorMessages = function (str) {
    return str.toString().trim();
  };

  this.trimExtraSp = function (str) {
    return str.replace(/\s+/g, '');
  };

  function parser() {
    var _parser = document.createElement('a');

    _parser.href = window.location.href;
    _parser._params = {};
    _parser._pathPieces = _parser.pathname.replace(/^\/+|\/+$/g, '').split('/');
    var paramString = _parser.search;

    if (paramString.charAt(0) === '?') {
      var hashes = paramString.slice(1).split('&');

      for (var i = 0; i < hashes.length; i++) {
        var hash = hashes[i].split('=');
        _parser._params[hash[0]] = hash[1];
      }
    }

    _parser.param = function (key) {
      return _parser._params[key];
    };

    _parser.pathPiece = function (index) {
      return _parser._pathPieces[index];
    };

    return _parser;
  }
}]);
angular.module('vendorfuelApp').factory('Admin', ['$http', '$cookies', '$location', 'Localized', 'Debug', 'TwoFactorModal', function ($http, $cookies, $location, Localized, Debug, TwoFactorModal) {
  var service = {};
  var admin = {
    authed: false,
    name: '',
    tokens: {
      a: '',
      b: '',
      jwt: ''
    }
  };
  service.login_errors = {};

  service.Login = function (e, p, a) {
    //TODO: get api url from settings factory
    Debug.log('LOGGING IN');
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/login',
      data: {
        email: e,
        password: p,
        authenticator: a
      }
    };
    var promise = $http(req).then(function successCallback(response) {
      if (Object.keys(response.data.errors).length > 0) {
        Debug.log('Login errors: ', response.data.errors);
        service.login_errors = response.data.errors;
      } else {
        if (response.data.token_2fa) {
          var callback = {
            confirm: function confirm(confirmResponse) {
              console.log(confirmResponse);
              var req = {
                method: 'POST',
                url: Localized.apiUrl + '/admin/authenticate',
                data: {
                  token_2fa: response.data.token_2fa,
                  auth_code: confirmResponse.code_2fa
                }
              };
              var promise2 = $http(req).then(function (resp) {
                service.SetTokens(resp.data.name, resp.data.tokena, resp.data.tokenb);
              }, function (errResp) {
                Debug.log(errResp);
              });
            },
            cancel: function cancel(cancelResponse) {
              var req = {
                method: 'POST',
                url: Localized.apiUrl + '/admin/clear-secret',
                data: {
                  token_2fa: response.data.token_2fa
                }
              };
              var promise3 = $http(req).then(function (resp) {}, function (errResp) {
                Debug.log(errResp);
              });
            },
            params: {
              imgSrc: response.data.qrCodeUrl,
              code_2fa: ''
            }
          };
          var modalMessage = '<p>Scan the QR code then enter your VendorFuel authentication code from your mobile app</p>';
          modalMessage += '<label for=\'mdlMsg\'>Authenticator: </label>';
          modalMessage += '<input id=\'mdlMsg\' type=\'text\' ng-model=\'callbackParams.code_2fa\' ng-change=\'ApplyChangeToCallback()\'>';
          TwoFactorModal.Show(callback, 'Google 2-Factor Authentication', modalMessage, 'Back', 'Complete');
        } else {
          service.SetTokens(response.data.name, response.data.tokena, response.data.tokenb);
        }

        var wpReq1 = {
          method: 'GET',
          url: Localized.wpRestUrl + '/templatesJS/'
        };
        $http(wpReq1).then(function (resp) {
          if (resp.data === '' || resp === false) {
            var wpReq2 = {
              method: 'GET',
              url: Localized.apiUrl + '/templates/combined-js'
            };
            $http(wpReq2).then(function (resp) {
              if (resp.data.js !== undefined) {
                var wpReq3 = {
                  method: 'PUT',
                  url: Localized.wpRestUrl + '/templatesJS/',
                  params: {},
                  data: {
                    templateJS: resp.data.js
                  }
                };
                $http(wpReq3).then(function (resp) {//$scope.saving = false;
                });
              }
            }, function (errResp) {
              Debug.log(errResp);
            });
          }
        }, function (errResp) {
          Debug.log(errResp);
        });
      }

      return response;
    }, function errorCallback(response) {
      if (response.xhrStatus === 'error') {
        service.login_errors.error = 'Invalid VendorFuel API URL.';
      }

      if (Object.keys(response.data.errors).length > 0) {
        Debug.log('Login errors: ', response.data.errors);
        service.login_errors = response.data.errors;
      }

      return response;
    });
    jQuery('#vf-menu-item-logout').css('display', 'block');
    return promise;
  };

  service.LoginErrors = function () {
    return service.login_errors;
  };

  service.Download = function (req) {
    return req + '?apikey=' + Localized.apiKey + '&tokena=' + $cookies.get('vendorfuel-admin-tokena') + '&tokenb=' + $cookies.get('vendorfuel-admin-tokenb');
  };

  service.Logout = function () {
    Debug.log('LOGGING OUT');
    admin.name = null;
    $cookies.remove('vendorfuel-admin-name');
    admin.tokens.a = null;
    $cookies.remove('vendorfuel-admin-tokena');
    admin.tokens.b = null;
    $cookies.remove('vendorfuel-admin-tokenb');
    admin.tokens.jwt = null;
    $cookies.remove('vendorfuel-tenant-token');
    admin.authed = false;
  };

  service.Authed = function () {
    var tokenA = $cookies.get('vendorfuel-admin-tokena');
    var tokenB = $cookies.get('vendorfuel-admin-tokenb');
    var token = $cookies.get('vendorfuel-tenant-token');

    if (tokenA && tokenB) {
      admin.authed = true;
    } else {
      admin.authed = false;
    }

    if (admin.authed) {
      jQuery('#vf-menu-item-logout').parent().parent().removeClass('logout');
    } else {
      jQuery('#vf-menu-item-logout').parent().parent().addClass('logout');
    }

    return admin.authed;
  };

  service.SetTokens = function (name, tokena, tokenb, jwt) {
    admin.name = name;
    $cookies.put('vendorfuel-admin-name', admin.name);
    admin.tokens.a = tokena;
    $cookies.put('vendorfuel-admin-tokena', admin.tokens.a);
    admin.tokens.b = tokenb;
    $cookies.put('vendorfuel-admin-tokenb', admin.tokens.b);

    if (jwt) {
      admin.tokens.jwt = jwt;
      $cookies.put('vendorfuel-tenant-token', admin.tokens.jwt);
    }

    admin.authed = true;
    return admin.authed;
  };

  if (service.Authed()) {
    jQuery('#vf-menu-item-logout').css('display', 'block');
  }

  return service;
}]);
angular.module('vendorfuelApp').factory('Anguledit', ['$http', 'Localized', '$q', 'Debug', 'Utils', 'Admin', function ($http, Localized, $q, Debug, Utils, Admin) {
  var service = {};
  return service;
}]);
angular.module('vendorfuelApp').factory('customerAccounts', [function () {
  var service = {}; //Select State DATA

  var states = [{
    'name': 'Alabama',
    'val': 'AL'
  }, {
    'name': 'Alaska',
    'val': 'AK'
  }, {
    'name': 'Arizona',
    'val': 'AZ'
  }, {
    'name': 'Arkansas',
    'val': 'AR'
  }, {
    'name': 'California',
    'val': 'CA'
  }, {
    'name': 'Colorado',
    'val': 'CO'
  }, {
    'name': 'Connecticut',
    'val': 'CT'
  }, {
    'name': 'Delaware',
    'val': 'DE'
  }, {
    'name': 'Florida',
    'val': 'FL'
  }, {
    'name': 'Georgia',
    'val': 'GA'
  }, {
    'name': 'Hawaii',
    'val': 'HI'
  }, {
    'name': 'Idaho',
    'val': 'ID'
  }, {
    'name': 'Illinois',
    'val': 'IL'
  }, {
    'name': 'Indiana',
    'val': 'IN'
  }, {
    'name': 'Iowa',
    'val': 'IA'
  }, {
    'name': 'Kansas',
    'val': 'KS'
  }, {
    'name': 'Kentucky',
    'val': 'KY'
  }, {
    'name': 'Louisiana',
    'val': 'LA'
  }, {
    'name': 'Maine',
    'val': 'ME'
  }, {
    'name': 'Maryland',
    'val': 'MD'
  }, {
    'name': 'Massachusetts',
    'val': 'MA'
  }, {
    'name': 'Michigan',
    'val': 'MI'
  }, {
    'name': 'Minnesota',
    'val': 'MN'
  }, {
    'name': 'Mississippi',
    'val': 'MS'
  }, {
    'name': 'Missouri',
    'val': 'MO'
  }, {
    'name': 'Montana',
    'val': 'MT'
  }, {
    'name': 'Nebraska',
    'val': 'NE'
  }, {
    'name': 'Nevada',
    'val': 'NV'
  }, {
    'name': 'New Hampshire',
    'val': 'NH'
  }, {
    'name': 'New Jersey',
    'val': 'NJ'
  }, {
    'name': 'New Mexico',
    'val': 'NM'
  }, {
    'name': 'New York',
    'val': 'NY'
  }, {
    'name': 'North Carolina',
    'val': 'NC'
  }, {
    'name': 'North Dakota',
    'val': 'ND'
  }, {
    'name': 'Ohio',
    'val': 'OH'
  }, {
    'name': 'Oklahoma',
    'val': 'OK'
  }, {
    'name': 'Oregon',
    'val': 'OR'
  }, {
    'name': 'Pennsylvania',
    'val': 'PA'
  }, {
    'name': 'Rhode Island',
    'val': 'RI'
  }, {
    'name': 'South Carolina',
    'val': 'SC'
  }, {
    'name': 'South Dakota',
    'val': 'SD'
  }, {
    'name': 'Tennessee',
    'val': 'TN'
  }, {
    'name': 'Texas',
    'val': 'TX'
  }, {
    'name': 'Utah',
    'val': 'UT'
  }, {
    'name': 'Vermont',
    'val': 'VT'
  }, {
    'name': 'Virgin Islands',
    'val': 'VI'
  }, {
    'name': 'Virginia',
    'val': 'VA'
  }, {
    'name': 'Washington',
    'val': 'WA'
  }, {
    'name': 'West Virginia',
    'val': 'WV'
  }, {
    'name': 'Wisconsin',
    'val': 'WI'
  }, {
    'name': 'Wyoming',
    'val': 'WY'
  }];

  service.customerData = function () {
    var data = {};
    data.states = states;
    return data;
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('EmailsData', ['$http', '$cookies', '$location', function ($http, $cookies, $location) {
  var service = {}; //$scope.allData =

  var shipmentOptions = [{
    name: 'Site Name',
    value: '%[site-name]%'
  }, {
    name: 'Customer Name',
    value: '%[customer-name]%'
  }, {
    name: 'Shipping Name',
    value: '%[shipping-name]%'
  }, {
    name: 'Shipping Address 1',
    value: '%[shipping-address1]%'
  }, {
    name: 'Shipping Address 2',
    value: '%[shipping-address2]%'
  }, {
    name: 'Shipping City',
    value: '%[shipping-city]%'
  }, {
    name: 'Shipping State',
    value: '%[shipping-state]%'
  }, {
    name: 'Shipping Zip',
    value: '%[shipping-zip]%'
  }, {
    name: 'Shipping Phone',
    value: '%[shipping-phone]%'
  }, {
    name: 'Shipping Email',
    value: '%[shipping-email]%'
  }, {
    name: 'Payment Method',
    value: '%[payment-method]%'
  }, {
    name: 'Subtotal',
    value: '%[subtotal]%'
  }, {
    name: 'Shipping Total',
    value: '%[shipping-total]%'
  }, {
    name: 'Tax Rate',
    value: '%[tax-rate]%'
  }, {
    name: 'Tax Total',
    value: '%[tax-total]%'
  }, {
    name: 'Total',
    value: '%[total]%'
  }, {
    name: 'Billing Name',
    value: '%[billing-name]%'
  }, {
    name: 'Billing Address 1',
    value: '%[billing-address1]%'
  }, {
    name: 'Billing Address 2',
    value: '%[billing-address2]%'
  }, {
    name: 'Billing City',
    value: '%[billing-city]%'
  }, {
    name: 'Billing State',
    value: '%[billing-state]%'
  }, {
    name: 'Billing Zip',
    value: '%[billing-zip]%'
  }, {
    name: 'Billing Email',
    value: '%[billing-email]%'
  }, {
    name: 'Billing Phone',
    value: '%[billing-phone]%'
  }, {
    name: 'First Name',
    value: '%[first-name]%'
  }, {
    name: 'Last Name',
    value: '%[last-name]%'
  }, {
    name: 'Cost Center Code',
    value: '%[cost-center-code]%'
  }, {
    name: 'Purchase Order',
    value: '%[purchase-order]%'
  }, {
    name: 'Issuing Office',
    value: '%[issuing-office]%'
  }, {
    name: 'Notes',
    value: '%[notes]%'
  }, {
    name: 'Organization',
    value: '%[organization]%'
  }, {
    name: 'Attention',
    value: '%[attention]%'
  }, {
    name: 'Approver',
    value: '%[approver]%'
  }, {
    name: 'Approver Notes',
    value: '%[approver-notes]%'
  }, {
    name: 'Promotion Discount',
    value: '%[promo-discount]%'
  }, {
    name: 'EBT Discount',
    value: '%[ebt-discount]%'
  }, {
    name: 'F1 Name',
    value: '%[f1-name]%'
  }, {
    name: 'F1 valueue',
    value: '%[f1-name]%'
  }, {
    name: 'F2 Name',
    value: '%[f2-name]%'
  }, {
    name: 'F2 value',
    value: '%[f2-name]%'
  }, {
    name: 'F3 Name',
    value: '%[f3-name]%'
  }, {
    name: 'F3 value',
    value: '%[f3-name]%'
  }, {
    name: 'F4 Name',
    value: '%[f4-name]%'
  }, {
    name: 'F4 value',
    value: '%[f4-name]%'
  }, {
    name: 'F5 Name',
    value: '%[f5-name]%'
  }, {
    name: 'F5 value',
    value: '%[f5-name]%'
  }, {
    name: 'F6 Name',
    value: '%[f6-name]%'
  }, {
    name: 'F6 value',
    value: '%[f6-name]%'
  }, {
    name: 'RMA Purchase ID',
    value: '%[rma-purchase-id]%'
  }, {
    name: 'RMA Product ID',
    value: '%[rma-product-id]%'
  }, {
    name: 'RMA Sku',
    value: '%[rma-sku]%'
  }, {
    name: 'RMA Description',
    value: '%[rma-description]%'
  }, {
    name: 'RMA Purchase Date',
    value: '%[rma-purchase-date]%'
  }, {
    name: 'RMA Reason',
    value: '%[rma-reason]%'
  }, {
    name: 'RMA Quantity',
    value: '%[rma-quantity]%'
  }, {
    name: 'RMA Email',
    value: '%[rma-email]%'
  }, {
    name: 'RMA Notes',
    value: '%[rma-notes]%'
  }, {
    name: 'RMA Id',
    value: '%[rma-id]%'
  }, {
    name: 'Shipping Date',
    value: '%[shipping-date]%'
  }, {
    name: 'Shipping Carrier',
    value: '%[shipping-carrier]%'
  }, {
    name: 'Shipping Code',
    value: '%[shipping-code]%'
  }, {
    name: 'Order Date',
    value: '%[order-date]%'
  }, {
    name: 'Shipping Id',
    value: '%[shipping-id]%'
  }];
  var shipmentConditionals = [{
    name: 'Site Name',
    value: '%{[site-name] %[site-name]% }%'
  }, {
    name: 'Customer Name',
    value: '%{[customer-name] %[customer-name]% }%'
  }, {
    name: 'Shipping Name',
    value: '%{[shipping-name] %[shipping-name]% }%'
  }, {
    name: 'Shipping Address 1',
    value: '%{[shipping-address1] %[shipping-address1]% }%'
  }, {
    name: 'Shipping Address 2',
    value: '%{[shipping-address2] %[shipping-address2]% }%'
  }, {
    name: 'Shipping City',
    value: '%{[shipping-city] %[shipping-city]% }%'
  }, {
    name: 'Shipping State',
    value: '%{[shipping-state] %[shipping-state]% }%'
  }, {
    name: 'Shipping Zip',
    value: '%{[shipping-zip] %[shipping-zip]% }%'
  }, {
    name: 'Shipping Phone',
    value: '%{[shipping-phone] %[shipping-phone]% }%'
  }, {
    name: 'Shipping Email',
    value: '%{[shipping-email] %[shipping-email]% }%'
  }, {
    name: 'Payment Method',
    value: '%{[payment-method] %[payment-method]% }%'
  }, {
    name: 'Subtotal',
    value: '%{[subtotal] %[subtotal]% }%'
  }, {
    name: 'Shipping Total',
    value: '%{[shipping-total] %[shipping-total]% }%'
  }, {
    name: 'Tax Rate',
    value: '%{[tax-rate] %[tax-rate]% }%'
  }, {
    name: 'Tax Total',
    value: '%{[tax-total] %[tax-total]% }%'
  }, {
    name: 'Total',
    value: '%{[total] %[total]% }%'
  }, {
    name: 'Billing Name',
    value: '%{[billing-name] %[billing-name]% }%'
  }, {
    name: 'Billing Address 1',
    value: '%{[billing-address1] %[billing-address1]% }%'
  }, {
    name: 'Billing Address 2',
    value: '%{[billing-address2] %[billing-address2]% }%'
  }, {
    name: 'Billing City',
    value: '%{[billing-city] %[billing-city]% }%'
  }, {
    name: 'Billing State',
    value: '%{[billing-state] %[billing-state]% }%'
  }, {
    name: 'Billing Zip',
    value: '%{[billing-zip] %[billing-zip]% }%'
  }, {
    name: 'Billing Email',
    value: '%{[billing-email] %[billing-email]% }%'
  }, {
    name: 'Billing Phone',
    value: '%{[billing-phone] %[billing-phone]% }%'
  }, {
    name: 'First Name',
    value: '%{[first-name] %[first-name]% }%'
  }, {
    name: 'Last Name',
    value: '%{[last-name] %[last-name]% }%'
  }, {
    name: 'Cost Center Code',
    value: '%{[cost-center-code] %[cost-center-code]% }%'
  }, {
    name: 'Purchase Order',
    value: '%{[purchase-order] %[purchase-order]% }%'
  }, {
    name: 'Issuing Office',
    value: '%{[issuing-office] %[issuing-office]% }%'
  }, {
    name: 'Notes',
    value: '%{[notes] %[notes]% }%'
  }, {
    name: 'Organization',
    value: '%{[organization] %[organization]% }%'
  }, {
    name: 'Attention',
    value: '%{[attention] %[attention]% }%'
  }, {
    name: 'Approver',
    value: '%{[approver] %[approver]% }%'
  }, {
    name: 'Approver Notes',
    value: '%{[approver-notes] %[approver-notes]% }%'
  }, {
    name: 'Promotion Discount',
    value: '%{[promo-discount] %[promo-discount]% }%'
  }, {
    name: 'EBT Discount',
    value: '%{[ebt-discount] %[ebt-discount]% }%'
  }, {
    name: 'F1 Name',
    value: '%{[f1-name] %[f1-name]% }%'
  }, {
    name: 'F1 value',
    value: '%{[f1-value] %[f1-value]% }%'
  }, {
    name: 'F2 Name',
    value: '%{[f2-name] %[f2-name]% }%'
  }, {
    name: 'F2 value',
    value: '%{[f2-value] %[f2-value]% }%'
  }, {
    name: 'F3 Name',
    value: '%{[f3-name] %[f3-name]% }%'
  }, {
    name: 'F3 value',
    value: '%{[f3-value] %[f3-value]% }%'
  }, {
    name: 'F4 Name',
    value: '%{[f4-name] %[f4-name]% }%'
  }, {
    name: 'F4 value',
    value: '%{[f4-value] %[f4-value]% }%'
  }, {
    name: 'F5 Name',
    value: '%{[f5-name] %[f5-name]% }%'
  }, {
    name: 'F5 value',
    value: '%{[f5-value] %[f5-value]% }%'
  }, {
    name: 'F6 Name',
    value: '%{[f6-name] %[f6-name]% }%'
  }, {
    name: 'F6 value',
    value: '%{[f6-value] %[f6-value]% }%'
  }, {
    name: 'RMA Purchase ID',
    value: '%{[rma-purchase-id] %[rma-purchase-id]% }%'
  }, {
    name: 'RMA Product ID',
    value: '%{[rma-product-id] %[rma-product-id]% }%'
  }, {
    name: 'RMA Sku',
    value: '%{[rma-sku] %[rma-sku]% }%'
  }, {
    name: 'RMA Description',
    value: '%{[rma-description] %[rma-description]% }%'
  }, {
    name: 'RMA Purchase Date',
    value: '%{[rma-purchase-date] %[rma-purchase-date]% }%'
  }, {
    name: 'RMA Reason',
    value: '%{[rma-reason] %[rma-reason]% }%'
  }, {
    name: 'RMA Quantity',
    value: '%{[rma-quantity] %[rma-quantity]% }%'
  }, {
    name: 'RMA Email',
    value: '%{[rma-email] %[rma-email]% }%'
  }, {
    name: 'RMA Notes',
    value: '%{[rma-notes] %[rma-notes]% }%'
  }, {
    name: 'RMA Id',
    value: '%{[rma-id] %[rma-id]% }%'
  }, {
    name: 'Shipping Date',
    value: '%{[shipping-date] %[shipping-date]% }%'
  }, {
    name: 'Shipping Carrier',
    value: '%{[shipping-carrier] %[shipping-carrier]% }%'
  }, {
    name: 'Shipping Code',
    value: '%{[shipping-code] %[shipping-code]% }%'
  }, {
    name: 'Order Date',
    value: '%{[order-date] %[order-date]% }%'
  }, {
    name: 'Shipping Id',
    value: '%{[shipping-id] %[shipping-id]% }%'
  }];
  var checkoutOptions = [{
    name: 'Site Name',
    value: '%[site-name]%'
  }, {
    name: 'Customer Name',
    value: '%[customer-name]%'
  }, {
    name: 'Shipping Name',
    value: '%[shipping-name]%'
  }, {
    name: 'Shipping Address 1',
    value: '%[shipping-address1]%'
  }, {
    name: 'Shipping Address 2',
    value: '%[shipping-address2]%'
  }, {
    name: 'Shipping City',
    value: '%[shipping-city]%'
  }, {
    name: 'Shipping State',
    value: '%[shipping-state]%'
  }, {
    name: 'Shipping Zip',
    value: '%[shipping-zip]%'
  }, {
    name: 'Shipping Phone',
    value: '%[shipping-phone]%'
  }, {
    name: 'Shipping Email',
    value: '%[shipping-email]%'
  }, {
    name: 'Payment Method',
    value: '%[payment-method]%'
  }, {
    name: 'Subtotal',
    value: '%[subtotal]%'
  }, {
    name: 'Shipping Total',
    value: '%[shipping-total]%'
  }, {
    name: 'Tax Rate',
    value: '%[tax-rate]%'
  }, {
    name: 'Tax Total',
    value: '%[tax-total]%'
  }, {
    name: 'Total',
    value: '%[total]%'
  }, {
    name: 'Billing Name',
    value: '%[billing-name]%'
  }, {
    name: 'Billing Address 1',
    value: '%[billing-address1]%'
  }, {
    name: 'Billing Address 2',
    value: '%[billing-address2]%'
  }, {
    name: 'Billing City',
    value: '%[billing-city]%'
  }, {
    name: 'Billing State',
    value: '%[billing-state]%'
  }, {
    name: 'Billing Zip',
    value: '%[billing-zip]%'
  }, {
    name: 'Billing Email',
    value: '%[billing-email]%'
  }, {
    name: 'Billing Phone',
    value: '%[billing-phone]%'
  }, {
    name: 'First Name',
    value: '%[first-name]%'
  }, {
    name: 'Last Name',
    value: '%[last-name]%'
  }, {
    name: 'Cost Center Code',
    value: '%[cost-center-code]%'
  }, {
    name: 'Purchase Order',
    value: '%[purchase-order]%'
  }, {
    name: 'Issuing Office',
    value: '%[issuing-office]%'
  }, {
    name: 'Notes',
    value: '%[notes]%'
  }, {
    name: 'Organization',
    value: '%[organization]%'
  }, {
    name: 'Attention',
    value: '%[attention]%'
  }, {
    name: 'Approver',
    value: '%[approver]%'
  }, {
    name: 'Approver Notes',
    value: '%[approver-notes]%'
  }, {
    name: 'Promotion Discount',
    value: '%[promo-discount]%'
  }, {
    name: 'EBT Discount',
    value: '%[ebt-discount]%'
  }, {
    name: 'F1 Name',
    value: '%[f1-name]%'
  }, {
    name: 'F1 valueue',
    value: '%[f1-name]%'
  }, {
    name: 'F2 Name',
    value: '%[f2-name]%'
  }, {
    name: 'F2 value',
    value: '%[f2-name]%'
  }, {
    name: 'F3 Name',
    value: '%[f3-name]%'
  }, {
    name: 'F3 value',
    value: '%[f3-name]%'
  }, {
    name: 'F4 Name',
    value: '%[f4-name]%'
  }, {
    name: 'F4 value',
    value: '%[f4-name]%'
  }, {
    name: 'F5 Name',
    value: '%[f5-name]%'
  }, {
    name: 'F5 value',
    value: '%[f5-name]%'
  }, {
    name: 'F6 Name',
    value: '%[f6-name]%'
  }, {
    name: 'F6 value',
    value: '%[f6-name]%'
  }, {
    name: 'Order Date',
    value: '%[order-date]%'
  }];
  var checkoutConditionals = [{
    name: 'Site Name',
    value: '%{[site-name] %[site-name]% }%'
  }, {
    name: 'Customer Name',
    value: '%{[customer-name] %[customer-name]% }%'
  }, {
    name: 'Shipping Name',
    value: '%{[shipping-name] %[shipping-name]% }%'
  }, {
    name: 'Shipping Address 1',
    value: '%{[shipping-address1] %[shipping-address1]% }%'
  }, {
    name: 'Shipping Address 2',
    value: '%{[shipping-address2] %[shipping-address2]% }%'
  }, {
    name: 'Shipping City',
    value: '%{[shipping-city] %[shipping-city]% }%'
  }, {
    name: 'Shipping State',
    value: '%{[shipping-state] %[shipping-state]% }%'
  }, {
    name: 'Shipping Zip',
    value: '%{[shipping-zip] %[shipping-zip]% }%'
  }, {
    name: 'Shipping Phone',
    value: '%{[shipping-phone] %[shipping-phone]% }%'
  }, {
    name: 'Shipping Email',
    value: '%{[shipping-email] %[shipping-email]% }%'
  }, {
    name: 'Payment Method',
    value: '%{[payment-method] %[payment-method]% }%'
  }, {
    name: 'Subtotal',
    value: '%{[subtotal] %[subtotal]% }%'
  }, {
    name: 'Shipping Total',
    value: '%{[shipping-total] %[shipping-total]% }%'
  }, {
    name: 'Tax Rate',
    value: '%{[tax-rate] %[tax-rate]% }%'
  }, {
    name: 'Tax Total',
    value: '%{[tax-total] %[tax-total]% }%'
  }, {
    name: 'Total',
    value: '%{[total] %[total]% }%'
  }, {
    name: 'Billing Name',
    value: '%{[billing-name] %[billing-name]% }%'
  }, {
    name: 'Billing Address 1',
    value: '%{[billing-address1] %[billing-address1]% }%'
  }, {
    name: 'Billing Address 2',
    value: '%{[billing-address2] %[billing-address2]% }%'
  }, {
    name: 'Billing City',
    value: '%{[billing-city] %[billing-city]% }%'
  }, {
    name: 'Billing State',
    value: '%{[billing-state] %[billing-state]% }%'
  }, {
    name: 'Billing Zip',
    value: '%{[billing-zip] %[billing-zip]% }%'
  }, {
    name: 'Billing Email',
    value: '%{[billing-email] %[billing-email]% }%'
  }, {
    name: 'Billing Phone',
    value: '%{[billing-phone] %[billing-phone]% }%'
  }, {
    name: 'First Name',
    value: '%{[first-name] %[first-name]% }%'
  }, {
    name: 'Last Name',
    value: '%{[last-name] %[last-name]% }%'
  }, {
    name: 'Cost Center Code',
    value: '%{[cost-center-code] %[cost-center-code]% }%'
  }, {
    name: 'Purchase Order',
    value: '%{[purchase-order] %[purchase-order]% }%'
  }, {
    name: 'Issuing Office',
    value: '%{[issuing-office] %[issuing-office]% }%'
  }, {
    name: 'Notes',
    value: '%{[notes] %[notes]% }%'
  }, {
    name: 'Organization',
    value: '%{[organization] %[organization]% }%'
  }, {
    name: 'Attention',
    value: '%{[attention] %[attention]% }%'
  }, {
    name: 'Approver',
    value: '%{[approver] %[approver]% }%'
  }, {
    name: 'Approver Notes',
    value: '%{[approver-notes] %[approver-notes]% }%'
  }, {
    name: 'Promotion Discount',
    value: '%{[promo-discount] %[promo-discount]% }%'
  }, {
    name: 'EBT Discount',
    value: '%{[ebt-discount] %[ebt-discount]% }%'
  }, {
    name: 'F1 Name',
    value: '%{[f1-name] %[f1-name]% }%'
  }, {
    name: 'F1 value',
    value: '%{[f1-value] %[f1-value]% }%'
  }, {
    name: 'F2 Name',
    value: '%{[f2-name] %[f2-name]% }%'
  }, {
    name: 'F2 value',
    value: '%{[f2-value] %[f2-value]% }%'
  }, {
    name: 'F3 Name',
    value: '%{[f3-name] %[f3-name]% }%'
  }, {
    name: 'F3 value',
    value: '%{[f3-value] %[f3-value]% }%'
  }, {
    name: 'F4 Name',
    value: '%{[f4-name] %[f4-name]% }%'
  }, {
    name: 'F4 value',
    value: '%{[f4-value] %[f4-value]% }%'
  }, {
    name: 'F5 Name',
    value: '%{[f5-name] %[f5-name]% }%'
  }, {
    name: 'F5 value',
    value: '%{[f5-value] %[f5-value]% }%'
  }, {
    name: 'F6 Name',
    value: '%{[f6-name] %[f6-name]% }%'
  }, {
    name: 'F6 value',
    value: '%{[f6-value] %[f6-value]% }%'
  }, {
    name: 'Order Date',
    value: '%{[order-date] %[order-date]% }%'
  }];
  var registerOptions = [{
    name: 'Customer Name',
    value: '%[registration-name]%'
  }, {
    name: 'Site Name',
    value: '%[site-name]%'
  }];
  var rmaOptions = [{
    name: 'RMA Purchase ID',
    value: '%[rma-purchase-id]%'
  }, {
    name: 'RMA Product ID',
    value: '%[rma-product-id]%'
  }, {
    name: 'RMA SKU',
    value: '%[rma-sku]%'
  }, {
    name: 'RMA Description',
    value: '%[rma-description]%'
  }, {
    name: 'RMA Purchase Date',
    value: '%[rma-purchase-date]%'
  }, {
    name: 'RMA Reason',
    value: '%[rma-reason]%'
  }, {
    name: 'RMA Quantity',
    value: '%[rma-quantity]%'
  }, {
    name: 'RMA Contact',
    value: '%[rma-contact]%'
  }, {
    name: 'RMA Notes',
    value: '%[rma-notes]%'
  }, {
    name: 'RMA Request Date',
    value: '%[rma-request-date]%'
  }, {
    name: 'RMA Status',
    value: '%[rma-status]%'
  }];

  service.dataEmail = function () {
    var data = {};
    data.shipmentOptions = shipmentOptions;
    data.shipmentConditionals = shipmentConditionals;
    data.checkoutOptions = checkoutOptions;
    data.checkoutConditionals = checkoutConditionals;
    data.registerOptions = registerOptions;
    data.rmaOptions = rmaOptions;
    console.log(data);
    return data;
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('vfAdminInterceptor', ['$q', '$cookies', '$rootScope', 'Localized', 'Debug', function ($q, $cookies, $rootScope, Localized, Debug) {
  var interceptor = {};

  interceptor.request = function (config) {
    var tokenA = null;
    var tokenB = null;
    var adminJwt = null;
    var logTitle = null;

    if (config.url.includes(Localized.apiUrl)) {
      tokenA = $cookies.get('vendorfuel-admin-tokena');
      tokenB = $cookies.get('vendorfuel-admin-tokenb');
      adminJwt = $cookies.get('vendorfuel-tenant-token');
      logTitle = '';
      config.params = config.params || {};

      if (tokenA) {
        config.params.tokena = tokenA;
      }

      if (tokenB) {
        config.params.tokenb = tokenB;
      }

      if (adminJwt) {
        config.params.token = adminJwt;
      }

      if (Localized.apiKey) {
        config.params.apikey = Localized.apiKey;
      }

      logTitle = 'VF API Request - ' + config.method + config.url.replace(Localized.apiUrl, ': ');
    } else if (config.url.includes(Localized.wpRestUrl)) {
      var wpNonce = Localized.wpNonce;
      config.headers = config.headers || {};
      config.headers['x-wp-nonce'] = wpNonce;
      config.headers.tokena = $cookies.get('vendorfuel-admin-tokena');
      config.headers.tokenb = $cookies.get('vendorfuel-admin-tokenb');
      logTitle = 'WP REST API Request - ' + config.method + config.url.replace(Localized.wpRestUrl, ': ');
    }

    if (logTitle !== '') {
      Debug.log(logTitle, config);
    }

    return config || $q.when(config);
  };

  interceptor.requestError = function (rejection) {
    var logTitle = '';

    if (rejection.config.url.includes(Localized.apiUrl)) {
      logTitle = 'VF API Request ERROR';
    } else if (rejection.config.url.includes(Localized.wpRestUrl)) {
      logTitle = 'WP REST API Request ERROR';
    }

    if (logTitle !== '') {
      Debug.log(logTitle, rejection);
    }

    return $q.reject(rejection);
  };

  interceptor.response = function (response) {
    var logTitle = '';

    if (response.config.url.includes(Localized.apiUrl)) {
      if (response.data.errors && response.data.errors.length > 0) {
        logTitle = 'VF API Response ERROR - ' + response.config.method + response.config.url.replace(Localized.apiUrl, ': ') + ' [' + response.data.errors[0] + ']';
      } else {
        logTitle = 'VF API Response - ' + response.config.method + response.config.url.replace(Localized.apiUrl, ': ');
      }
    } else if (response.config.url.includes(Localized.wpRestUrl)) {
      logTitle = 'WP REST API Response - ' + response.config.method + response.config.url.replace(Localized.wpRestUrl, ': ');
    }

    if (logTitle !== '') {
      if (response.title) {
        logTitle += ' - ' + response.method + ': ' + response.title;
      }

      Debug.log(logTitle, response);
    }

    return response || $q.when(response);
  };

  interceptor.responseError = function (rejection) {
    var logTitle = '';

    if (rejection.config.url.includes(Localized.apiUrl)) {
      logTitle = 'VF API Response ERROR - ' + rejection.config.method + rejection.config.url.replace(Localized.apiUrl, ': ');
    } else if (rejection.config.url.includes(Localized.wpRestUrl)) {
      logTitle = 'WP REST API Response ERROR - ' + rejection.config.method + rejection.config.url.replace(Localized.wpRestUrl, ': ');
    }

    if (logTitle !== '') {
      if (rejection.title) {
        logTitle += ' - ' + rejection.method + ': ' + rejection.title;
      }

      Debug.log(logTitle, rejection);
    }

    return $q.reject(rejection);
  };

  return interceptor;
}]);
angular.module('vendorfuelApp').factory('AlertModal', ['$uibModal', '$window', 'Localized', 'Debug', '$sce', function ($uibModal, $window, Localized, Debug, $sce) {
  var service = {};

  service.Show = function (callback, title, message, optionConfirm, backdrop, highlightedButton) {
    message = message || '';
    optionConfirm = optionConfirm || 'Confirm';
    backdrop = backdrop || true;
    highlightedButton = highlightedButton || 0;
    var optionWidth,
        tempConfirmWidth = optionConfirm.length;
    optionWidth = tempConfirmWidth * 9 + 24;
    var callbackParams = callback.params || {};
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/alert.html',
      backdrop: backdrop,
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.modalTitle = $sce.trustAsHtml(title);
        $scope.modalMessage = $sce.trustAsHtml(message);
        $scope.optionConfirm = optionConfirm;
        $scope.optionWidth = optionWidth;
        $scope.highlightedButton = highlightedButton;

        $scope.Confirm = function () {
          $uibModalInstance.close();
        };
      }]
    }).result.then(function () {
      callback.confirm(callbackParams);
    }, function () {
      callback.confirm(callbackParams);
    });
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('ConfirmModal', ['$uibModal', '$window', 'Localized', 'Debug', '$sce', function ($uibModal, $window, Localized, Debug, $sce) {
  var service = {};

  service.Show = function (callback, title, message, optionCancel, optionConfirm, backdrop, highlightedButton) {
    callback = callback;
    title = title;
    message = message || '';
    optionCancel = optionCancel || 'Cancel';
    optionConfirm = optionConfirm || 'Confirm';
    backdrop = backdrop || true;
    highlightedButton = highlightedButton || 0;
    var optionWidth,
        tempCancelWidth = optionCancel.length,
        tempConfirmWidth = optionConfirm.length;

    if (tempCancelWidth > tempConfirmWidth) {
      optionWidth = tempCancelWidth * 9 + 24;
    } else {
      optionWidth = tempConfirmWidth * 9 + 24;
    }

    var callbackParams = callback.params || {};
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/confirm.html',
      backdrop: backdrop,
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.callbackParams = callbackParams;
        $scope.modalTitle = $sce.trustAsHtml(title);
        $scope.modalMessage = $sce.trustAsHtml(message);
        $scope.modalImg = callbackParams.imgSrc;
        $scope.optionCancel = optionCancel;
        $scope.optionConfirm = optionConfirm;
        $scope.optionWidth = optionWidth;
        $scope.highlightedButton = highlightedButton;

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };

        $scope.Confirm = function () {
          $uibModalInstance.close();
        };

        $scope.ApplyChangeToCallback = function () {
          callbackParams = $scope.callbackParams;
          console.log(callbackParams);
        };
      }]
    }).result.then(function () {
      if (callback.confirm) {
        callback.confirm(callbackParams);
      }
    }, function () {
      if (callback.cancel) {
        callback.cancel(callbackParams);
      }
    });
  };

  return service;
}]);
angular.module('vendorfuelApp').directive('compileHtml', ["$compile", function ($compile) {
  return {
    restrict: 'A',
    link: function link(scope, elem, attrs) {
      scope.$watch(function () {
        return scope.$eval(attrs.compileHtml);
      }, function (value) {
        elem.html(value);
        $compile(elem.contents())(scope);
      });
    }
  };
}]);
angular.module('vendorfuelApp').factory('EditModal', ['$uibModal', '$window', 'Localized', 'Debug', '$sce', '$compile', function ($uibModal, $window, Localized, Debug, $sce, $compile) {
  var service = {};

  service.Show = function (callback, valueObj, title, message, optionCancel, optionConfirm, backdrop, highlightedButton) {
    message = message || '';
    optionCancel = optionCancel || 'Cancel';
    optionConfirm = optionConfirm || 'Confirm';
    backdrop = backdrop || true;
    highlightedButton = highlightedButton || 0;
    var optionWidth,
        tempCancelWidth = optionCancel.length,
        tempConfirmWidth = optionConfirm.length;

    if (tempCancelWidth > tempConfirmWidth) {
      optionWidth = tempCancelWidth * 9 + 24;
    } else {
      optionWidth = tempConfirmWidth * 9 + 24;
    }

    var callbackParams = callback.params || {};
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/edit.html',
      backdrop: backdrop,
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.modalTitle = $sce.trustAsHtml(title);
        $scope.modalMessage = $sce.trustAsHtml(message);
        $scope.optionCancel = optionCancel;
        $scope.optionConfirm = optionConfirm;
        $scope.optionWidth = optionWidth;
        $scope.highlightedButton = highlightedButton;
        $scope.valueObj = valueObj;

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };

        $scope.Confirm = function () {
          $uibModalInstance.close();
        };
      }]
    }).result.then(function () {
      if (callback.confirm) {
        callback.confirm(callbackParams, valueObj);
      }
    }, function () {
      if (callback.cancel) {
        callback.cancel(callbackParams, valueObj);
      }
    });
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('SearchModal', ['$uibModal', '$window', 'Localized', 'Debug', 'RelationshipSearch', function ($uibModal, $window, Localized, Debug, RelationshipSearch) {
  var service = {};

  service.Show = function (callback, title, pageConfig, message, optionCancel, optionConfirm, backdrop) {
    message = message || '';
    optionCancel = optionCancel || 'Cancel';
    optionConfirm = optionConfirm || 'Confirm';
    backdrop = backdrop || true;
    var optionWidth,
        tempCancelWidth = optionCancel.length,
        tempConfirmWidth = optionConfirm.length;

    if (tempCancelWidth > tempConfirmWidth) {
      optionWidth = tempCancelWidth * 9 + 24;
    } else {
      optionWidth = tempConfirmWidth * 9 + 24;
    }

    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/search.html',
      backdrop: backdrop,
      size: 'lg',
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.relationshipSearch = RelationshipSearch; //Service containing the main functionality for searching and matching relationships

        $scope.modalTitle = title;
        $scope.modalMessage = message;
        $scope.optionCancel = optionCancel;
        $scope.optionConfirm = optionConfirm;
        $scope.optionWidth = optionWidth;
        $scope.pageConfig = pageConfig;
        $scope.removedIds = [];
        $scope.removedObjs = [];
        $scope.addedIds = [];
        $scope.addedObjs = [];
        $scope.deselectedIds = [];
        $scope.deselectedObjs = [];
        $scope.unselectedIds = [];
        $scope.unselectedObjs = [];
        $scope.loading = true;
        $scope.filterBy = ['Search For', 'Search For'];
        $scope.rppValues = [15, 30, 50, 100];
        $scope.per_page = [$scope.rppValues[0], $scope.rppValues[0]];
        $scope.tab = 0;
        $scope.hasOneTab = false;

        if (pageConfig.tabs.length === 1) {
          $scope.hasOneTab = true;
        }

        $scope.results = [[], []];
        $scope.rawResults = [[], []];
        $scope.pagination = [];

        $scope.TabChanged = function (i) {
          $scope.tab = i;
        };

        $scope.selectItem = function (index, tab) {
          var id = $scope.rawResults[tab][index][pageConfig.tabs[tab].id];

          if (tab === 0) {
            if (pageConfig.tabs[0].selectOne) {
              if ($scope.addedIds.length) {
                if ($scope.addedIds.includes(id)) {
                  var i = $scope.addedIds.indexOf(id);
                  $scope.addedIds.splice(i, 1);
                  $scope.addedObjs.splice(i, 1);
                } else {
                  var j = $scope.addedIds.indexOf(id);
                  $scope.addedIds.splice(j, 1);
                  $scope.addedObjs.splice(j, 1);
                  $scope.addedIds.push(id);
                  $scope.addedObjs.push($scope.rawResults[tab][index]);
                }
              } else {
                $scope.addedIds.push(id);
                $scope.addedObjs.push($scope.rawResults[tab][index]);
              }
            } else {
              if ($scope.addedIds.includes(id)) {
                var k = $scope.addedIds.indexOf(id);
                $scope.addedIds.splice(k, 1);
                $scope.addedObjs.splice(k, 1);
                $scope.unselectedIds.push(id);
                $scope.unselectedObjs.push($scope.rawResults[tab][index]);
              } else {
                if ($scope.unselectedIds.includes(id)) {
                  var l = $scope.deselectedIds.indexOf(id);
                  $scope.unselectedIds.splice(l, 1);
                  $scope.unselectedObjs.splice(l, 1);
                }

                $scope.addedIds.push(id);
                $scope.addedObjs.push($scope.rawResults[tab][index]);
              }
            }
          }

          if (tab === 1) {
            if ($scope.removedIds.includes(id)) {
              var q = $scope.removedIds.indexOf(id);
              $scope.removedIds.splice(q, 1);
              $scope.removedObjs.splice(q, 1);
              $scope.deselectedIds.push(id);
              $scope.deselectedObjs.push($scope.rawResults[tab][index]);
            } else {
              if ($scope.deselectedIds.includes(id)) {
                var r = $scope.deselectedIds.indexOf(id);
                $scope.deselectedIds.splice(r, 1);
                $scope.deselectedObjs.splice(r, 1);
              }

              $scope.removedIds.push(id);
              $scope.removedObjs.push($scope.rawResults[tab][index]);
            }
          }
        };

        $scope.Init = function () {
          var total = pageConfig.tabs.length,
              done = 0;

          if (pageConfig.updatedItems) {
            for (var i = 0; i < pageConfig.updatedItems.length; i++) {
              if (pageConfig.updatedItems[i].action === 'add') {
                $scope.addedIds.push(pageConfig.updatedItems[i].value[pageConfig.tabs[0].id]);
                $scope.addedObjs.push(pageConfig.updatedItems[i].value);
              }

              if (pageConfig.updatedItems[i].action === 'remove' && !$scope.hasOneTab) {
                $scope.removedIds.push(pageConfig.updatedItems[i].value[pageConfig.tabs[0].id]);
                $scope.removedObjs.push(pageConfig.updatedItems[i].value);
              }
            }
          }

          $scope.relationshipSearch.Init(pageConfig.tabs[0].http).then(function (resp) {
            $scope.pagination[0] = resp[pageConfig.tabs[0].relationships[0]];
            resp[pageConfig.tabs[0].relationships[0]].data.forEach(function (val) {
              $scope.rawResults[0].push(val);
              $scope.results[0].push($scope.relationshipSearch.ProcessResults(0, pageConfig, val));
            });
          }).finally(function () {
            if (++done >= total) {
              $scope.loading = false;
            }
          });

          if (!$scope.hasOneTab) {
            $scope.relationshipSearch.Init(pageConfig.tabs[1].http).then(function (resp) {
              $scope.pagination[1] = resp[pageConfig.tabs[1].relationships[0]][pageConfig.tabs[1].relationships[1]];
              resp[pageConfig.tabs[1].relationships[0]][pageConfig.tabs[1].relationships[1]].data.forEach(function (val) {
                $scope.rawResults[1].push(val);
                $scope.results[1].push($scope.relationshipSearch.ProcessResults(1, pageConfig, val));
              });
            }).finally(function () {
              if (++done >= total) {
                $scope.loading = false;
              }
            });
          }
        };

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };

        $scope.Confirm = function () {
          var callbackResults = [];

          if ($scope.removedObjs.length) {
            for (var i = 0; i < $scope.removedObjs.length; i++) {
              callbackResults.push({
                action: 'remove',
                value: $scope.removedObjs[i]
              });
            }
          }

          if ($scope.addedObjs.length) {
            for (var j = 0; j < $scope.addedObjs.length; j++) {
              callbackResults.push({
                action: 'add',
                value: $scope.addedObjs[j]
              });
            }
          }

          if ($scope.unselectedObjs.length) {
            for (var k = 0; k < $scope.unselectedObjs.length; k++) {
              callbackResults.push({
                action: 'unselect',
                value: $scope.unselectedObjs[k]
              });
            }
          }

          if ($scope.deselectedObjs.length) {
            for (var l = 0; l < $scope.deselectedObjs.length; l++) {
              callbackResults.push({
                action: 'deselect',
                value: $scope.deselectedObjs[l]
              });
            }
          }

          $uibModalInstance.close(callbackResults);
        };

        $scope.Search = function (rpp, page) {
          $scope.loading = true;
          $scope.pageConfig.tabs[$scope.tab].http.params.rpp = rpp;
          $scope.pageConfig.tabs[$scope.tab].http.params.page = page || 1;

          if ($scope.filterBy[$scope.tab] === 'Filter Results') {
            $scope.pageConfig.tabs[$scope.tab].http.params.q = '';
          }

          $scope.relationshipSearch.Search($scope.pageConfig.tabs[$scope.tab].http).then(function (resp) {
            if ($scope.tab === 0) {
              $scope.results[0] = [];
              $scope.rawResults[0] = [];
              $scope.pagination[0] = resp[pageConfig.tabs[0].relationships[0]];
              resp[pageConfig.tabs[0].relationships[0]].data.forEach(function (val) {
                $scope.rawResults[0].push(val);
                $scope.results[0].push($scope.relationshipSearch.ProcessResults(0, pageConfig, val));
              });
            } else {
              $scope.results[1] = [];
              $scope.rawResults[1] = [];
              $scope.pagination[1] = resp[pageConfig.tabs[1].relationships[0]][pageConfig.tabs[1].relationships[1]];
              resp[pageConfig.tabs[1].relationships[0]][pageConfig.tabs[1].relationships[1]].data.forEach(function (val) {
                $scope.rawResults[1].push(val);
                $scope.results[1].push($scope.relationshipSearch.ProcessResults(1, pageConfig, val));
              });
            }
          }).finally(function () {
            $scope.loading = false;
          });
        };

        $scope.Init();
      }]
    }).result.then(function (resp) {
      callback.confirm(resp);
    }, function () {
      callback.cancel();
    });
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('SelectModal', ['$uibModal', '$window', 'Localized', 'Debug', '$sce', function ($uibModal, $window, Localized, Debug, $sce) {
  var service = {};
  /** @function Show
   * Takes in an array of options and allows for activating/deactivating each option individually, or en-mass. Each option is an object with the following parameters: name, value, and active. This array of options is returned to the callback function for handling
   * */

  service.Show = function (callback, title, optionArr, optionCancel, optionConfirm, backdrop, highlightedButton) {
    optionCancel = optionCancel || 'Cancel';
    optionConfirm = optionConfirm || 'Confirm';
    backdrop = backdrop || true;
    highlightedButton = highlightedButton || 0;
    var optionWidth,
        tempCancelWidth = optionCancel.length,
        tempConfirmWidth = optionConfirm.length;

    if (tempCancelWidth > tempConfirmWidth) {
      optionWidth = tempCancelWidth * 9 + 24;
    } else {
      optionWidth = tempConfirmWidth * 9 + 24;
    }

    var callbackParams = callback.params || {};
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/select.html',
      backdrop: backdrop,
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.modalTitle = $sce.trustAsHtml(title);
        $scope.options = optionArr;
        $scope.optionCancel = optionCancel;
        $scope.optionConfirm = optionConfirm;
        $scope.optionWidth = optionWidth;
        $scope.highlightedButton = highlightedButton;
        /**
         * Used to filter the options
         * @type {string}
         */

        $scope.filterTerm = '';
        /**
         * Array of options
         * @type {array}
         */

        callbackParams = $scope.options;
        /**
         * @function OptionFilter
         * Filter the array of options based on the filterTerm variable and return only matching results
         */

        $scope.OptionFilter = function (row) {
          return row.name.indexOf($scope.filterTerm || '') !== -1 || row.value.indexOf($scope.filterTerm || '') !== -1;
        };
        /**
         * @function SelectAll
         * Activate all options using the MassSelect function
         */


        $scope.SelectAll = function () {
          massSelect(true);
        };
        /**
         * @function SelectNone
         * Deactivate all options using the MassSelect function
         */


        $scope.SelectNone = function () {
          massSelect(false);
        };
        /**
         * @function MassSelect
         * Activate/Deactivate all options
         */


        function massSelect(value) {
          angular.forEach($scope.options, function (option) {
            option.active = value;
          });
        }

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };

        $scope.Confirm = function () {
          $uibModalInstance.close();
        };
      }]
    }).result.then(function () {
      if (callback.confirm) {
        callback.confirm(callbackParams);
      }
    }, function () {
      if (callback.cancel) {
        callback.cancel(callbackParams);
      }
    });
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('TwoFactorModal', ['$uibModal', '$window', 'Localized', 'Debug', '$sce', function ($uibModal, $window, Localized, Debug, $sce) {
  var service = {};

  service.Show = function (callback, title, message, optionCancel, optionConfirm, backdrop, highlightedButton) {
    message = message || '';
    optionCancel = optionCancel || 'Cancel';
    optionConfirm = optionConfirm || 'Confirm';
    backdrop = backdrop || true;
    highlightedButton = highlightedButton || 0;
    var optionWidth,
        tempCancelWidth = optionCancel.length,
        tempConfirmWidth = optionConfirm.length;

    if (tempCancelWidth > tempConfirmWidth) {
      optionWidth = tempCancelWidth * 9 + 24;
    } else {
      optionWidth = tempConfirmWidth * 9 + 24;
    }

    var callbackParams = callback.params || {};
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/two-factor.html',
      backdrop: backdrop,
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.callbackParams = callbackParams;
        $scope.modalTitle = $sce.trustAsHtml(title);
        $scope.modalMessage = $sce.trustAsHtml(message);
        $scope.modalImg = callbackParams.imgSrc;
        $scope.optionCancel = optionCancel;
        $scope.optionConfirm = optionConfirm;
        $scope.optionWidth = optionWidth;
        $scope.highlightedButton = highlightedButton;

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };

        $scope.Confirm = function () {
          $uibModalInstance.close();
        };

        $scope.ApplyChangeToCallback = function () {
          callbackParams = $scope.callbackParams;
          console.log(callbackParams);
        };
      }]
    }).result.then(function () {
      if (callback.confirm) {
        callback.confirm(callbackParams);
      }
    }, function () {
      if (callback.cancel) {
        callback.cancel(callbackParams);
      }
    });
  };

  return service;
}]);
angular.module('vendorfuelApp').directive('compileHtml', ["$compile", function ($compile) {
  return {
    restrict: 'A',
    link: function link(scope, elem, attrs) {
      scope.$watch(function () {
        return scope.$eval(attrs.compileHtml);
      }, function (value) {
        elem.html(value);
        $compile(elem.contents())(scope);
      });
    }
  };
}]);
angular.module('vendorfuelApp').factory('ViewModal', ['$uibModal', '$window', 'Localized', 'Utils', 'Debug', function ($uibModal, $window, Localized, Utils, Debug) {
  var service = {};

  service.Show = function (callback, title, dataSet, message, optionCancel, optionConfirm, backdrop) {
    message = message || '';
    optionCancel = optionCancel || 'Cancel';
    optionConfirm = optionConfirm || 'Confirm';
    backdrop = backdrop || true;
    var optionWidth,
        tempCancelWidth = optionCancel.length,
        tempConfirmWidth = optionConfirm.length;

    if (tempCancelWidth > tempConfirmWidth) {
      optionWidth = tempCancelWidth * 9 + 24;
    } else {
      optionWidth = tempConfirmWidth * 9 + 24;
    }

    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/view.html',
      backdrop: backdrop,
      size: 'lg',
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.modalTitle = title;
        $scope.modalMessage = message;
        $scope.optionCancel = optionCancel;
        $scope.optionConfirm = optionConfirm;
        $scope.optionWidth = optionWidth;
        $scope.result = dataSet;
        $scope.loading = false;
        $scope.editable = false;
        $scope.priceIndex = 0;
        $scope.priceSheet = $scope.result.pricesheets[$scope.priceIndex].price_sheet_id;

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };

        $scope.Confirm = function () {
          if ($scope.form1.$dirty || $scope.form2.$dirty) {
            $scope.loading = true;
            var req = {
              method: 'POST',
              url: Localized.apiUrl + '/admin/product/modify/',
              data: $scope.result
            };
            Utils.GetHttpPromise(req).then(function (resp) {
              $uibModalInstance.close();
            }).finally(function () {
              $scope.loading = false;
            });
          } else {
            $scope.Cancel();
          }
        };

        $scope.changePricesheet = function () {
          $scope.priceIndex = $scope.result.pricesheets.map(function (e) {
            return e.price_sheet_id;
          }).indexOf($scope.priceSheet);
        };
      }]
    }).result.then(function (results) {
      callback.confirm(results);
    }, function () {
      callback.cancel();
    });
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('orders', [function () {
  var service = {}; //Select State DATA

  var states = [{
    'name': 'Alabama',
    'val': 'AL'
  }, {
    'name': 'Alaska',
    'val': 'AK'
  }, {
    'name': 'Arizona',
    'val': 'AZ'
  }, {
    'name': 'Arkansas',
    'val': 'AR'
  }, {
    'name': 'California',
    'val': 'CA'
  }, {
    'name': 'Colorado',
    'val': 'CO'
  }, {
    'name': 'Connecticut',
    'val': 'CT'
  }, {
    'name': 'Delaware',
    'val': 'DE'
  }, {
    'name': 'Florida',
    'val': 'FL'
  }, {
    'name': 'Georgia',
    'val': 'GA'
  }, {
    'name': 'Hawaii',
    'val': 'HI'
  }, {
    'name': 'Idaho',
    'val': 'ID'
  }, {
    'name': 'Illinois',
    'val': 'IL'
  }, {
    'name': 'Indiana',
    'val': 'IN'
  }, {
    'name': 'Iowa',
    'val': 'IA'
  }, {
    'name': 'Kansas',
    'val': 'KS'
  }, {
    'name': 'Kentucky',
    'val': 'KY'
  }, {
    'name': 'Louisiana',
    'val': 'LA'
  }, {
    'name': 'Maine',
    'val': 'ME'
  }, {
    'name': 'Maryland',
    'val': 'MD'
  }, {
    'name': 'Massachusetts',
    'val': 'MA'
  }, {
    'name': 'Michigan',
    'val': 'MI'
  }, {
    'name': 'Minnesota',
    'val': 'MN'
  }, {
    'name': 'Mississippi',
    'val': 'MS'
  }, {
    'name': 'Missouri',
    'val': 'MO'
  }, {
    'name': 'Montana',
    'val': 'MT'
  }, {
    'name': 'Nebraska',
    'val': 'NE'
  }, {
    'name': 'Nevada',
    'val': 'NV'
  }, {
    'name': 'New Hampshire',
    'val': 'NH'
  }, {
    'name': 'New Jersey',
    'val': 'NJ'
  }, {
    'name': 'New Mexico',
    'val': 'NM'
  }, {
    'name': 'New York',
    'val': 'NY'
  }, {
    'name': 'North Carolina',
    'val': 'NC'
  }, {
    'name': 'North Dakota',
    'val': 'ND'
  }, {
    'name': 'Ohio',
    'val': 'OH'
  }, {
    'name': 'Oklahoma',
    'val': 'OK'
  }, {
    'name': 'Oregon',
    'val': 'OR'
  }, {
    'name': 'Pennsylvania',
    'val': 'PA'
  }, {
    'name': 'Rhode Island',
    'val': 'RI'
  }, {
    'name': 'South Carolina',
    'val': 'SC'
  }, {
    'name': 'South Dakota',
    'val': 'SD'
  }, {
    'name': 'Tennessee',
    'val': 'TN'
  }, {
    'name': 'Texas',
    'val': 'TX'
  }, {
    'name': 'Utah',
    'val': 'UT'
  }, {
    'name': 'Vermont',
    'val': 'VT'
  }, {
    'name': 'Virgin Islands',
    'val': 'VI'
  }, {
    'name': 'Virginia',
    'val': 'VA'
  }, {
    'name': 'Washington',
    'val': 'WA'
  }, {
    'name': 'West Virginia',
    'val': 'WV'
  }, {
    'name': 'Wisconsin',
    'val': 'WI'
  }, {
    'name': 'Wyoming',
    'val': 'WY'
  }]; //SELECT COUNTRIES DATA

  var countries = [{
    'name': 'Afghanistan',
    'val': 'AF'
  }, {
    'name': 'Albania',
    'val': 'AL'
  }, {
    'name': 'Algeria',
    'val': 'DZ'
  }, {
    'name': 'American Samoa',
    'val': 'AS'
  }, {
    'name': 'Andorra',
    'val': 'AD'
  }, {
    'name': 'Angola',
    'val': 'AO'
  }, {
    'name': 'Anguilla',
    'val': 'AI'
  }, {
    'name': 'Antarctica',
    'val': 'AQ'
  }, {
    'name': 'Antigua and Barbuda',
    'val': 'AG'
  }, {
    'name': 'Argentina',
    'val': 'AR'
  }, {
    'name': 'Armenia',
    'val': 'AM'
  }, {
    'name': 'Aruba',
    'val': 'AW'
  }, {
    'name': 'Australia',
    'val': 'AU'
  }, {
    'name': 'Austria',
    'val': 'AT'
  }, {
    'name': 'Azerbaijan',
    'val': 'AZ'
  }, {
    'name': 'Bahamas',
    'val': 'BS'
  }, {
    'name': 'Bahrain',
    'val': 'BH'
  }, {
    'name': 'Bangladesh',
    'val': 'BD'
  }, {
    'name': 'Barbados',
    'val': 'BB'
  }, {
    'name': 'Belarus',
    'val': 'BY'
  }, {
    'name': 'Belgium',
    'val': 'BE'
  }, {
    'name': 'Belize',
    'val': 'BZ'
  }, {
    'name': 'Benin',
    'val': 'BJ'
  }, {
    'name': 'Bermuda',
    'val': 'BM'
  }, {
    'name': 'Bhutan',
    'val': 'BT'
  }, {
    'name': 'Bolivia, Plurinational State of',
    'val': 'BO'
  }, {
    'name': 'Bonaire, Sint Eustatius and Saba',
    'val': 'BQ'
  }, {
    'name': 'Bosnia and Herzegovina',
    'val': 'BA'
  }, {
    'name': 'Botswana',
    'val': 'BW'
  }, {
    'name': 'Bouvet Island',
    'val': 'BV'
  }, {
    'name': 'Brazil',
    'val': 'BR'
  }, {
    'name': 'British Indian Ocean Territory',
    'val': 'IO'
  }, {
    'name': 'Brunei Darussalam',
    'val': 'BN'
  }, {
    'name': 'Bulgaria',
    'val': 'BG'
  }, {
    'name': 'Burkina Faso',
    'val': 'BF'
  }, {
    'name': 'Burundi',
    'val': 'BI'
  }, {
    'name': 'Cambodia',
    'val': 'KH'
  }, {
    'name': 'Cameroon',
    'val': 'CM'
  }, {
    'name': 'Canada',
    'val': 'CA'
  }, {
    'name': 'Cape Verde',
    'val': 'CV'
  }, {
    'name': 'Cayman Islands',
    'val': 'KY'
  }, {
    'name': 'Central African Republic',
    'val': 'CF'
  }, {
    'name': 'Chad',
    'val': 'TD'
  }, {
    'name': 'Chile',
    'val': 'CL'
  }, {
    'name': 'China',
    'val': 'CN'
  }, {
    'name': 'Christmas Island',
    'val': 'CX'
  }, {
    'name': 'Cocos (Keeling) Islands',
    'val': 'CC'
  }, {
    'name': 'Colombia',
    'val': 'CO'
  }, {
    'name': 'Comoros',
    'val': 'KM'
  }, {
    'name': 'Congo',
    'val': 'CG'
  }, {
    'name': 'Congo, the Democratic Republic of the',
    'val': 'CD'
  }, {
    'name': 'Cook Islands',
    'val': 'CK'
  }, {
    'name': 'Costa Rica',
    'val': 'CR'
  }, {
    'name': 'Croatia',
    'val': 'HR'
  }, {
    'name': 'Cuba',
    'val': 'CU'
  }, {
    'name': 'Curaçao',
    'val': 'CW'
  }, {
    'name': 'Cyprus',
    'val': 'CY'
  }, {
    'name': 'Czech Republic',
    'val': 'CZ'
  }, {
    'name': 'Côte d\'Ivoire',
    'val': 'CI'
  }, {
    'name': 'Denmark',
    'val': 'DK'
  }, {
    'name': 'Djibouti',
    'val': 'DJ'
  }, {
    'name': 'Dominica',
    'val': 'DM'
  }, {
    'name': 'Dominican Republic',
    'val': 'DO'
  }, {
    'name': 'Ecuador',
    'val': 'EC'
  }, {
    'name': 'Egypt',
    'val': 'EG'
  }, {
    'name': 'El Salvador',
    'val': 'SV'
  }, {
    'name': 'Equatorial Guinea',
    'val': 'GQ'
  }, {
    'name': 'Eritrea',
    'val': 'ER'
  }, {
    'name': 'Estonia',
    'val': 'EE'
  }, {
    'name': 'Ethiopia',
    'val': 'ET'
  }, {
    'name': 'Falkland Islands (Malvinas)',
    'val': 'FK'
  }, {
    'name': 'Faroe Islands',
    'val': 'FO'
  }, {
    'name': 'Fiji',
    'val': 'FJ'
  }, {
    'name': 'Finland',
    'val': 'FI'
  }, {
    'name': 'France',
    'val': 'FR'
  }, {
    'name': 'French Guiana',
    'val': 'GF'
  }, {
    'name': 'French Polynesia',
    'val': 'PF'
  }, {
    'name': 'French Southern Territories',
    'val': 'TF'
  }, {
    'name': 'Gabon',
    'val': 'GA'
  }, {
    'name': 'Gambia',
    'val': 'GM'
  }, {
    'name': 'Georgia',
    'val': 'GE'
  }, {
    'name': 'Germany',
    'val': 'DE'
  }, {
    'name': 'Ghana',
    'val': 'GH'
  }, {
    'name': 'Gibraltar',
    'val': 'GI'
  }, {
    'name': 'Greece',
    'val': 'GR'
  }, {
    'name': 'Greenland',
    'val': 'GL'
  }, {
    'name': 'Grenada',
    'val': 'GD'
  }, {
    'name': 'Guadeloupe',
    'val': 'GP'
  }, {
    'name': 'Guam',
    'val': 'GU'
  }, {
    'name': 'Guatemala',
    'val': 'GT'
  }, {
    'name': 'Guernsey',
    'val': 'GG'
  }, {
    'name': 'Guinea',
    'val': 'GN'
  }, {
    'name': 'Guinea-Bissau',
    'val': 'GW'
  }, {
    'name': 'Guyana',
    'val': 'GY'
  }, {
    'name': 'Haiti',
    'val': 'HT'
  }, {
    'name': 'Heard Island and McDonald Islands',
    'val': 'HM'
  }, {
    'name': 'Holy See (Vatican City State)',
    'val': 'VA'
  }, {
    'name': 'Honduras',
    'val': 'HN'
  }, {
    'name': 'Hong Kong',
    'val': 'HK'
  }, {
    'name': 'Hungary',
    'val': 'HU'
  }, {
    'name': 'Iceland',
    'val': 'IS'
  }, {
    'name': 'India',
    'val': 'IN'
  }, {
    'name': 'Indonesia',
    'val': 'ID'
  }, {
    'name': 'Iran, Islamic Republic of',
    'val': 'IR'
  }, {
    'name': 'Iraq',
    'val': 'IQ'
  }, {
    'name': 'Ireland',
    'val': 'IE'
  }, {
    'name': 'Isle of Man',
    'val': 'IM'
  }, {
    'name': 'Israel',
    'val': 'IL'
  }, {
    'name': 'Italy',
    'val': 'IT'
  }, {
    'name': 'Jamaica',
    'val': 'JM'
  }, {
    'name': 'Japan',
    'val': 'JP'
  }, {
    'name': 'Jersey',
    'val': 'JE'
  }, {
    'name': 'Jordan',
    'val': 'JO'
  }, {
    'name': 'Kazakhstan',
    'val': 'KZ'
  }, {
    'name': 'Kenya',
    'val': 'KE'
  }, {
    'name': 'Kiribati',
    'val': 'KI'
  }, {
    'name': 'Korea, Democratic People\'s Republic of',
    'val': 'KP'
  }, {
    'name': 'Korea, Republic of',
    'val': 'KR'
  }, {
    'name': 'Kuwait',
    'val': 'KW'
  }, {
    'name': 'Kyrgyzstan',
    'val': 'KG'
  }, {
    'name': 'Lao People\'s Democratic Republic',
    'val': 'LA'
  }, {
    'name': 'Latvia',
    'val': 'LV'
  }, {
    'name': 'Lebanon',
    'val': 'LB'
  }, {
    'name': 'Lesotho',
    'val': 'LS'
  }, {
    'name': 'Liberia',
    'val': 'LR'
  }, {
    'name': 'Libya',
    'val': 'LY'
  }, {
    'name': 'Liechtenstein',
    'val': 'LI'
  }, {
    'name': 'Lithuania',
    'val': 'LT'
  }, {
    'name': 'Luxembourg',
    'val': 'LU'
  }, {
    'name': 'Macao',
    'val': 'MO'
  }, {
    'name': 'Macedonia, the former Yugoslav Republic of',
    'val': 'MK'
  }, {
    'name': 'Madagascar',
    'val': 'MG'
  }, {
    'name': 'Malawi',
    'val': 'MW'
  }, {
    'name': 'Malaysia',
    'val': 'MY'
  }, {
    'name': 'Maldives',
    'val': 'MV'
  }, {
    'name': 'Mali',
    'val': 'ML'
  }, {
    'name': 'Malta',
    'val': 'MT'
  }, {
    'name': 'Marshall Islands',
    'val': 'MH'
  }, {
    'name': 'Martinique',
    'val': 'MQ'
  }, {
    'name': 'Mauritania',
    'val': 'MR'
  }, {
    'name': 'Mauritius',
    'val': 'MU'
  }, {
    'name': 'Mayotte',
    'val': 'YT'
  }, {
    'name': 'Mexico',
    'val': 'MX'
  }, {
    'name': 'Micronesia, Federated States of',
    'val': 'FM'
  }, {
    'name': 'Moldova, Republic of',
    'val': 'MD'
  }, {
    'name': 'Monaco',
    'val': 'MC'
  }, {
    'name': 'Mongolia',
    'val': 'MN'
  }, {
    'name': 'Montenegro',
    'val': 'ME'
  }, {
    'name': 'Montserrat',
    'val': 'MS'
  }, {
    'name': 'Morocco',
    'val': 'MA'
  }, {
    'name': 'Mozambique',
    'val': 'MZ'
  }, {
    'name': 'Myanmar',
    'val': 'MM'
  }, {
    'name': 'Namibia',
    'val': 'NA'
  }, {
    'name': 'Nauru',
    'val': 'NR'
  }, {
    'name': 'Nepal',
    'val': 'NP'
  }, {
    'name': 'Netherlands',
    'val': 'NL'
  }, {
    'name': 'New Caledonia',
    'val': 'NC'
  }, {
    'name': 'New Zealand',
    'val': 'NZ'
  }, {
    'name': 'Nicaragua',
    'val': 'NI'
  }, {
    'name': 'Niger',
    'val': 'NE'
  }, {
    'name': 'Nigeria',
    'val': 'NG'
  }, {
    'name': 'Niue',
    'val': 'NU'
  }, {
    'name': 'Norfolk Island',
    'val': 'NF'
  }, {
    'name': 'Northern Mariana Islands',
    'val': 'MP'
  }, {
    'name': 'Norway',
    'val': 'NO'
  }, {
    'name': 'Oman',
    'val': 'OM'
  }, {
    'name': 'Pakistan',
    'val': 'PK'
  }, {
    'name': 'Palau',
    'val': 'PW'
  }, {
    'name': 'Palestine, State of',
    'val': 'PS'
  }, {
    'name': 'Panama',
    'val': 'PA'
  }, {
    'name': 'Papua New Guinea',
    'val': 'PG'
  }, {
    'name': 'Paraguay',
    'val': 'PY'
  }, {
    'name': 'Peru',
    'val': 'PE'
  }, {
    'name': 'Philippines',
    'val': 'PH'
  }, {
    'name': 'Pitcairn',
    'val': 'PN'
  }, {
    'name': 'Poland',
    'val': 'PL'
  }, {
    'name': 'Portugal',
    'val': 'PT'
  }, {
    'name': 'Puerto Rico',
    'val': 'PR'
  }, {
    'name': 'Qatar',
    'val': 'QA'
  }, {
    'name': 'Romania',
    'val': 'RO'
  }, {
    'name': 'Russian Federation',
    'val': 'RU'
  }, {
    'name': 'Rwanda',
    'val': 'RW'
  }, {
    'name': 'Réunion',
    'val': 'RE'
  }, {
    'name': 'Saint Barthélemy',
    'val': 'BL'
  }, {
    'name': 'Saint Helena, Ascension and Tristan da Cunha',
    'val': 'SH'
  }, {
    'name': 'Saint Kitts and Nevis',
    'val': 'KN'
  }, {
    'name': 'Saint Lucia',
    'val': 'LC'
  }, {
    'name': 'Saint Martin (French part)',
    'val': 'MF'
  }, {
    'name': 'Saint Pierre and Miquelon',
    'val': 'PM'
  }, {
    'name': 'Saint Vincent and the Grenadines',
    'val': 'VC'
  }, {
    'name': 'Samoa',
    'val': 'WS'
  }, {
    'name': 'San Marino',
    'val': 'SM'
  }, {
    'name': 'Sao Tome and Principe',
    'val': 'ST'
  }, {
    'name': 'Saudi Arabia',
    'val': 'SA'
  }, {
    'name': 'Senegal',
    'val': 'SN'
  }, {
    'name': 'Serbia',
    'val': 'RS'
  }, {
    'name': 'Seychelles',
    'val': 'SC'
  }, {
    'name': 'Sierra Leone',
    'val': 'SL'
  }, {
    'name': 'Singapore',
    'val': 'SG'
  }, {
    'name': 'Sint Maarten (Dutch part)',
    'val': 'SX'
  }, {
    'name': 'Slovakia',
    'val': 'SK'
  }, {
    'name': 'Slovenia',
    'val': 'SI'
  }, {
    'name': 'Solomon Islands',
    'val': 'SB'
  }, {
    'name': 'Somalia',
    'val': 'SO'
  }, {
    'name': 'South Africa',
    'val': 'ZA'
  }, {
    'name': 'South Georgia and the South Sandwich Islands',
    'val': 'GS'
  }, {
    'name': 'South Sudan',
    'val': 'SS'
  }, {
    'name': 'Spain',
    'val': 'ES'
  }, {
    'name': 'Sri Lanka',
    'val': 'LK'
  }, {
    'name': 'Sudan',
    'val': 'SD'
  }, {
    'name': 'Suriname',
    'val': 'SR'
  }, {
    'name': 'Svalbard and Jan Mayen',
    'val': 'SJ'
  }, {
    'name': 'Swaziland',
    'val': 'SZ'
  }, {
    'name': 'Sweden',
    'val': 'SE'
  }, {
    'name': 'Switzerland',
    'val': 'CH'
  }, {
    'name': 'Syrian Arab Republic',
    'val': 'SY'
  }, {
    'name': 'Taiwan, Province of China',
    'val': 'TW'
  }, {
    'name': 'Tajikistan',
    'val': 'TJ'
  }, {
    'name': 'Tanzania, United Republic of',
    'val': 'TZ'
  }, {
    'name': 'Thailand',
    'val': 'TH'
  }, {
    'name': 'Timor-Leste',
    'val': 'TL'
  }, {
    'name': 'Togo',
    'val': 'TG'
  }, {
    'name': 'Tokelau',
    'val': 'TK'
  }, {
    'name': 'Tonga',
    'val': 'TO'
  }, {
    'name': 'Trinidad and Tobago',
    'val': 'TT'
  }, {
    'name': 'Tunisia',
    'val': 'TN'
  }, {
    'name': 'Turkey',
    'val': 'TR'
  }, {
    'name': 'Turkmenistan',
    'val': 'TM'
  }, {
    'name': 'Turks and Caicos Islands',
    'val': 'TC'
  }, {
    'name': 'Tuvalu',
    'val': 'TV'
  }, {
    'name': 'Uganda',
    'val': 'UG'
  }, {
    'name': 'Ukraine',
    'val': 'UA'
  }, {
    'name': 'United Arab Emirates',
    'val': 'AE'
  }, {
    'name': 'United Kingdom',
    'val': 'GB'
  }, {
    'name': 'United States',
    'val': 'US'
  }, {
    'name': 'United States Minor Outlying Islands',
    'val': 'UM'
  }, {
    'name': 'Uruguay',
    'val': 'UY'
  }, {
    'name': 'Uzbekistan',
    'val': 'UZ'
  }, {
    'name': 'Vanuatu',
    'val': 'VU'
  }, {
    'name': 'Venezuela, Bolivarian Republic of',
    'val': 'VE'
  }, {
    'name': 'Viet Nam',
    'val': 'VN'
  }, {
    'name': 'Virgin Islands, British',
    'val': 'VG'
  }, {
    'name': 'Virgin Islands, U.S.',
    'val': 'VI'
  }, {
    'name': 'Wallis and Futuna',
    'val': 'WF'
  }, {
    'name': 'Western Sahara',
    'val': 'EH'
  }, {
    'name': 'Yemen',
    'val': 'YE'
  }, {
    'name': 'Zambia',
    'val': 'ZM'
  }, {
    'name': 'Zimbabwe',
    'val': 'ZW'
  }, {
    'name': 'Åland Islands',
    'val': 'AX'
  }];

  service.ordersData = function () {
    var data = {};
    data.states = states;
    data.countries = countries;
    return data;
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('PriceSheets', ['$http', 'Localized', '$q', 'Debug', 'Utils', 'Admin', function ($http, Localized, $q, Debug, Utils, Admin) {
  //FACTORY VARIABLES
  var service = {};
  service.errors = {}; //FACTORY PRIVATE FUNCTIONS

  function getPriceSheets(tab, url) {
    var httpUrl = Localized.apiUrl + url;

    if (!url) {
      httpUrl = Localized.wpRestUrl + '/admin/price-sheet/' + tab.name + '/get';
    }

    var promise = Utils.HttpGet(httpUrl).then(function successCallback(response) {
      tab.saved = response;
    }, function errorCallback(response) {
      tab.saved = response;
    });
    return promise;
  }

  function postPriceSheets(tab, params, url) {
    var httpUrl = Localized.apiUrl + url;

    if (!url) {
      httpUrl = Localized.wpRestUrl + '/admin/price-sheet/' + tab.name + '/post';
    }

    var promise = Utils.HttpPost(httpUrl, params).then(function successCallback(response) {
      if (response.errors) {
        service.errors = response.errors;
      }
    }, function errorCallback(response) {
      if (response.errors) {
        service.errors = response.errors;
      }
    });
    return promise;
  }

  function putSettings(tab, params, url) {
    var httpUrl = Localized.apiUrl + url;

    if (!url) {
      httpUrl = Localized.wpRestUrl + '/admin/price-sheet/' + tab.name + '/post';
    }

    var promise = Utils.HttpPut(httpUrl, params).then(function successCallback(response) {
      if (response.errors) {
        service.errors = response.errors;
      }
    }, function errorCallback(response) {
      if (response.errors) {
        service.errors = response.errors;
      }
    });
    return promise;
  } //FACTORY PUBLIC FUNCTIONS AND DATA


  service.list = {
    name: 'list',
    saved: {},
    Get: function Get() {
      return getPriceSheets(service.list, '/admin/price-sheet/list');
    },
    Set: function Set() {
      var params = {
        settings: JSON.stringify(service.list)
      };
      return postPriceSheets(service.list, params).then(function () {
        if (service.list.apiUrl !== Localized.apiUrl) {
          Localized.apiUrl = service.list.apiUrl;
          Admin.Logout();
        }

        if (service.list.apiKey !== Localized.apiKey) {
          Localized.apiKey = service.list.apiKey;
          Admin.Logout();
        }
      });
    }
  };
  return service;
}]);
angular.module('vendorfuelApp').factory('Products', ['$http', 'Localized', 'Debug', 'Utils', '$q', function ($http, Localized, Debug, Utils, $q) {
  var categories = [];
  var parcels = [];
  var selectOptions = {
    'description': 'Description',
    'sku': 'SKU',
    'mfg_part_num': 'Mfg Part Num',
    'manufacturer': 'Manufacturer'
  };
  var termOptions = {
    'like': 'Contains',
    'not like': 'Does Not Contain',
    '=': 'Equals (=)',
    '!=': 'Does Not Equal (!=)',
    '>': 'Greater Than (>)',
    '<': 'Less Than (<)'
  };
  var statuses = {
    'active': 'Active',
    'discontinued': 'Discontinued',
    'inactive': 'Inactive'
  };

  function setCategories() {
    var req = {
      method: 'GET',
      url: Localized.apiUrl + '/admin/category/',
      params: {
        rpp: 999
      }
    };
    return Utils.GetHttpPromise(req).then(function (resp) {
      categories = resp.categories;
      return resp;
    });
  }

  function getCategories() {
    return categories;
  }

  function setParcels() {
    return Utils.HttpGet(Localized.apiUrl + '/admin/shipping/parcel').then(function (resp) {
      parcels = resp.parcels;
      return resp;
    });
  }

  function getParcels() {
    return parcels;
  }

  function getTermOptions() {
    return termOptions;
  }

  function getSelectOptions() {
    return selectOptions;
  }

  function getStatuses() {
    return statuses;
  }

  return {
    setCategories: setCategories,
    getCategories: getCategories,
    setParcels: setParcels,
    getParcels: getParcels,
    getSelectOptions: getSelectOptions,
    getTermOptions: getTermOptions,
    getStatuses: getStatuses
  };
}]);
angular.module('vendorfuelApp').factory('RelationshipSearch', ['$http', 'Localized', '$q', 'Debug', 'Utils', 'Admin', function ($http, Localized, $q, Debug, Utils, Admin) {
  var service = {};

  service.Init = function (req) {
    return Utils.GetHttpPromise(req).then(function (resp) {
      return resp;
    });
  };

  service.Search = function (req) {
    return Utils.GetHttpPromise(req).then(function (resp) {
      return resp;
    });
  };

  service.ProcessResults = function (tab, pageConfig, item) {
    var fields = {};
    var level;
    var levelItem;
    var duplicate;
    var returnField = '';
    fields[pageConfig.tabs[tab].id] = item[pageConfig.tabs[tab].id];

    for (var i = 0; i < pageConfig.tabs[tab].fields.length; i++) {
      levelItem = item;
      level = tab ? 1 : 0;
      duplicate = false;
      returnField = pageConfig.tabs[tab].fields[i];

      if (pageConfig.tabs[tab].fields[i].indexOf('.') > -1) {
        if (levelItem[pageConfig.tabs[tab].relationships[level + 1]]) {
          levelItem = levelItem[pageConfig.tabs[tab].relationships[++level]];
        } else {
          levelItem = levelItem[pageConfig.tabs[tab].relationships[level]];
        }

        pageConfig.tabs[tab].fields[i] = pageConfig.tabs[tab].fields[i].replace('.', '');
        duplicate = true;
      } else {
        while (levelItem && !levelItem.hasOwnProperty(pageConfig.tabs[tab].fields[i])) {
          levelItem = levelItem[pageConfig.tabs[tab].relationships[++level]];
        }
      }

      if (pageConfig.tabs[tab].fields[i] === 'image' && levelItem.image && levelItem.image[Object.keys(levelItem.image)[0]]) {
        fields[returnField] = levelItem.image[Object.keys(levelItem.image)[0]].thumb_url;
      } else {
        if (levelItem) {
          fields[returnField] = levelItem[pageConfig.tabs[tab].fields[i]] ? pageConfig.tabs[tab].fieldPrefixes[i] + levelItem[pageConfig.tabs[tab].fields[i]] : levelItem[pageConfig.tabs[tab].fields[i]];
        } else {
          fields[returnField] = pageConfig.tabs[tab].fieldPrefixes[i] + 'N/A';
        }
      }

      if (duplicate) {
        pageConfig.tabs[tab].fields[i] = '.' + pageConfig.tabs[tab].fields[i];
      }
    }

    return fields;
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('Reports', ['$http', '$cookies', '$location', function ($http, $cookies, $location) {
  var service = {};
  var storeTables = {};
  var joinTables = {};
  var allTables = {};

  service.getStoreTables = function () {
    return storeTables;
  };

  service.getAllTables = function () {
    return allTables;
  };

  service.getComparators = function () {
    return ['contains', '!contains', '=', '!=', '>', '<', 'begins', '!begins', 'ends', '!ends'];
  };

  storeTables.admin_groups = [{
    name: 'Group Id',
    value: 'admin_groups.group_id',
    table: 'admin_groups'
  }, {
    name: 'Type',
    value: 'admin_groups.type',
    table: 'admin_groups'
  }, {
    name: 'Group',
    value: 'admin_groups.group',
    table: 'admin_groups'
  }, {
    name: 'Description',
    value: 'admin_groups.description',
    table: 'admin_groups'
  }, {
    name: 'Users',
    value: 'admin_groups.users',
    table: 'admin_groups'
  }];
  storeTables.admin_users = [{
    name: 'Admin User Id',
    value: 'admin_users.id',
    table: 'admin_users'
  }, {
    name: 'Name',
    value: 'admin_users.name',
    table: 'admin_users'
  }, {
    name: 'Email',
    value: 'admin_users.email',
    table: 'admin_users'
  }, {
    name: 'Last Login',
    value: 'admin_users.last_login_at',
    table: 'admin_users'
  }, {
    name: 'Created',
    value: 'admin_users.created_at',
    table: 'admin_users'
  }];
  storeTables.banner_areas = [{
    name: 'Area Id',
    value: 'banner_areas.area_id',
    table: 'banner_areas'
  }, {
    name: 'Name',
    value: 'banner_areas.name',
    table: 'banner_areas'
  }, {
    name: 'Description',
    value: 'banner_areas.description',
    table: 'banner_areas'
  }];
  storeTables.categories = [{
    name: 'Category Id',
    value: 'categories.cat_id',
    table: 'categories'
  }, {
    name: 'Parent Id',
    value: 'categories.parent_id',
    table: 'categories'
  }, {
    name: 'Title',
    value: 'categories.title',
    table: 'categories'
  }, {
    name: 'UNSPSC',
    value: 'categories.unspsc',
    table: 'categories'
  }, {
    name: 'Slug',
    value: 'categories.slug',
    table: 'categories'
  }];
  storeTables.customers_new = [{
    name: 'Name',
    value: 'customers_new.name',
    table: 'customers_new'
  }, {
    name: 'Customer Id',
    value: 'customers_new.customer_id',
    table: 'customers_new'
  }, {
    name: 'Email',
    value: 'customers_new.email',
    table: 'customers_new'
  }, {
    name: 'Punchout Identity',
    value: 'customers_new.punchout_identity',
    table: 'customers_new'
  }, {
    name: 'Shared Secret',
    value: 'customers_new.punchout_secret',
    table: 'customers_new'
  }, {
    name: 'Terms',
    value: 'customers_new.terms',
    table: 'customers_new'
  }, {
    name: 'Order Prefix',
    value: 'customers_new.order_prefix',
    table: 'customers_new'
  }, {
    name: 'Limit Type',
    value: 'customers_new.limit_type',
    table: 'customers_new'
  }, {
    name: 'Limit',
    value: 'customers_new.limit',
    table: 'customers_new'
  }, {
    name: 'Group ',
    value: 'customers_new.group_id',
    table: 'customers_new'
  }, {
    name: 'Price Sheet Id',
    value: 'customers_new.price_sheet_id',
    table: 'customers_new'
  }, {
    name: 'Credit Line',
    value: 'customers_new.credit_line',
    table: 'customers_new'
  }, {
    name: 'Email Optin',
    value: 'customers_new.optin',
    table: 'customers_new'
  }, {
    name: 'Taxable',
    value: 'customers_new.taxable',
    table: 'customers_new'
  }, {
    name: 'Punchout Only',
    value: 'customers_new.punchout_only',
    table: 'customers_new'
  }, {
    name: 'Lock Billing',
    value: 'customers_new.lock_billing',
    table: 'customers_new'
  }, {
    name: 'Lock Shipping',
    value: 'customers_new.lock_shipping',
    table: 'customers_new'
  }, {
    name: 'Change Password',
    value: 'customers_new.change_pw',
    table: 'customers_new'
  }, {
    name: 'Group Admin',
    value: 'customers_new.group_admin',
    table: 'customers_new'
  }, {
    name: 'Approve Orders',
    value: 'customers_new.approver',
    table: 'customers_new'
  }, {
    name: 'Pending Emails',
    value: 'customers_new.pending_emails',
    table: 'customers_new'
  }];
  storeTables.customer_groups = [{
    name: 'Group Id',
    value: 'customer_groups.group_id',
    table: 'customer_groups'
  }, {
    name: 'Parent Group Id',
    value: 'customer_groups.parent_group_id',
    table: 'customer_groups'
  }, {
    name: 'Name',
    value: 'customer_groups.name',
    table: 'customer_groups'
  }, {
    name: 'Default Price Sheet',
    value: 'customer_groups.default_price_sheet',
    table: 'customer_groups'
  }, {
    name: 'Group Invite Code',
    value: 'customer_groups.group_invite_code',
    table: 'customer_groups'
  }, {
    name: 'Authorized Emails',
    value: 'customer_groups.authorized_emails',
    table: 'customer_groups'
  }, {
    name: 'Group Registration Available',
    value: 'customer_groups.group_registration_available',
    table: 'customer_groups'
  }, {
    name: 'Order Prefix',
    value: 'customer_groups.order_prefix',
    table: 'customer_groups'
  }, {
    name: 'Terms',
    value: 'customer_groups.terms',
    table: 'customer_groups'
  }, {
    name: 'Punchout Identity',
    value: 'customer_groups.punchout_identity',
    table: 'customer_groups'
  }, {
    name: 'Punchout Secret',
    value: 'customer_groups.punchout_secret',
    table: 'customer_groups'
  }, {
    name: 'Shipping Mode',
    value: 'customer_groups.shipping_mode',
    table: 'customer_groups'
  }];
  storeTables.email_templates = [{
    name: 'Template Id',
    value: 'email_templates.id',
    table: 'email_templates'
  }, {
    name: 'Type',
    value: 'email_templates.type',
    table: 'email_templates'
  }, {
    name: 'Sender Name',
    value: 'email_templates.sender_name',
    table: 'email_templates'
  }, {
    name: 'Sender Email',
    value: 'email_templates.sender_email',
    table: 'email_templates'
  }, {
    name: 'Subject',
    value: 'email_templates.subject',
    table: 'email_templates'
  }, {
    name: 'Message',
    value: 'email_templates.message',
    table: 'email_templates'
  }, {
    name: 'Notification Emails',
    value: 'email_templates.notification_emails',
    table: 'email_templates'
  }];
  storeTables.manufacturers = [{
    name: 'Manufacturer Id',
    value: 'manufacturers.mfg_id',
    table: 'manufacturers'
  }, {
    name: 'Manufacturer',
    value: 'manufacturers.manufacturer',
    table: 'manufacturers'
  }, {
    name: 'Info',
    value: 'manufacturers.mfg_info',
    table: 'manufacturers'
  }, {
    name: 'Website',
    value: 'manufacturers.mfg_website',
    table: 'manufacturers'
  }, {
    name: 'Logo',
    value: 'manufacturers.mfg_logo',
    table: 'manufacturers'
  }];
  storeTables.parcels = [{
    name: 'Parcel Id',
    value: 'parcels.id',
    table: 'parcels'
  }, {
    name: 'Title',
    value: 'parcels.title',
    table: 'parcels'
  }, {
    name: 'Length',
    value: 'parcels.length',
    table: 'parcels'
  }, {
    name: 'Width',
    value: 'parcels.width',
    table: 'parcels'
  }, {
    name: 'Height',
    value: 'parcels.height',
    table: 'parcels'
  }, {
    name: 'Units',
    value: 'parcels.distance_unit',
    table: 'parcels'
  }];
  storeTables.collections = [{
    name: 'Collection Id',
    value: 'collections.id',
    table: 'collections'
  }, {
    name: 'Name',
    value: 'collections.name',
    table: 'collections'
  }];
  storeTables.order_notifications = [{
    name: 'Notification Id',
    value: 'order_notifications.notification_id',
    table: 'order_notifications'
  }, {
    name: 'Order Id',
    value: 'order_notifications.order_id',
    table: 'order_notifications'
  }, {
    name: 'Status',
    value: 'order_notifications.status',
    table: 'order_notifications'
  }, {
    name: 'Type',
    value: 'order_notifications.type',
    table: 'order_notifications'
  }, {
    name: 'Recipient',
    value: 'order_notifications.recipient',
    table: 'order_notifications'
  }, {
    name: 'body',
    value: 'order_notifications.body',
    table: 'order_notifications'
  }, {
    name: 'Response',
    value: 'order_notifications.response',
    table: 'order_notifications'
  }];
  storeTables.product_uom = [{
    name: 'uom Id',
    value: 'product_uom.uom_id',
    table: 'product_uom'
  }, {
    name: 'uom',
    value: 'product_uom.uom',
    table: 'product_uom'
  }, {
    name: 'Code',
    value: 'product_uom.code',
    table: 'product_uom'
  }, {
    name: 'Description',
    value: 'product_uom.description',
    table: 'product_uom'
  }];
  storeTables.price_sheets_index = [{
    name: 'Price Sheet Id',
    value: 'price_sheets_index.price_sheet_id',
    table: 'price_sheets_index'
  }, {
    name: 'Sheet',
    value: 'price_sheets_index.sheet',
    table: 'price_sheets_index'
  }, {
    name: 'Site Id',
    value: 'price_sheets_index.site_id',
    table: 'price_sheets_index'
  }, {
    name: 'GP Price Sheet',
    value: 'price_sheets_index.gp_price_sheet',
    table: 'price_sheets_index'
  }];
  storeTables.products = [{
    name: 'Product Id',
    value: 'products.product_id',
    table: 'products'
  }, {
    name: 'SKU',
    value: 'products.sku',
    table: 'products'
  }, {
    name: 'Slug',
    value: 'products.slug',
    table: 'products'
  }, {
    name: 'UPC',
    value: 'products.upc',
    table: 'products'
  }, {
    name: 'Price',
    value: 'products.price',
    table: 'products'
  }, {
    name: 'Qty',
    value: 'products.qty',
    table: 'products'
  }, {
    name: 'MFG Id',
    value: 'products.mfg_id',
    table: 'products'
  }, {
    name: 'Brand Name',
    value: 'products.brand_name',
    table: 'products'
  }, {
    name: 'Country',
    value: 'products.country',
    table: 'products'
  }, {
    name: 'Device',
    value: 'products.device',
    table: 'products'
  }, {
    name: 'Family',
    value: 'products.family',
    table: 'products'
  }, {
    name: 'Green',
    value: 'products.green',
    table: 'products'
  }, {
    name: 'Green Attributes',
    value: 'products.green_attributes',
    table: 'products'
  }, {
    name: 'Hazmat',
    value: 'products.hazmat',
    table: 'products'
  }, {
    name: 'Includes',
    value: 'products.includes',
    table: 'products'
  }, {
    name: 'Keywords',
    value: 'products.keywords',
    table: 'products'
  }, {
    name: 'Model',
    value: 'products.model',
    table: 'products'
  }, {
    name: 'Msds',
    value: 'products.msds',
    table: 'products'
  }, {
    name: 'Rebate',
    value: 'products.rebate',
    table: 'products'
  }, {
    name: 'Related',
    value: 'products.related',
    table: 'products'
  }, {
    name: 'Alternates',
    value: 'products.alternates',
    table: 'products'
  }, {
    name: 'Truck Only',
    value: 'products.truck_only',
    table: 'products'
  }, {
    name: 'Category',
    value: 'products.category_id',
    table: 'products'
  }, {
    name: 'UoM ID',
    value: 'products.uomid',
    table: 'products'
  }, {
    name: 'UoM Qty',
    value: 'products.uomqty',
    table: 'products'
  }, {
    name: 'UoM Desc',
    value: 'products.uomdesc',
    table: 'products'
  }, {
    name: 'Description',
    value: 'products.description',
    table: 'products'
  }, {
    name: 'Long Description',
    value: 'products.long_description',
    table: 'products'
  }, {
    name: 'Attribute 1 Name',
    value: 'products.att1n',
    table: 'products'
  }, {
    name: 'Attribute 1 Data',
    value: 'products.att1d',
    table: 'products'
  }, {
    name: 'Attribute 2 Name',
    value: 'products.att2n',
    table: 'products'
  }, {
    name: 'Attribute 2 Data',
    value: 'products.att2d',
    table: 'products'
  }, {
    name: 'Attribute 3 Name',
    value: 'products.att3n',
    table: 'products'
  }, {
    name: 'Attribute 3 Data',
    value: 'products.att3d',
    table: 'products'
  }, {
    name: 'Attribute 4 Name',
    value: 'products.att4n',
    table: 'products'
  }, {
    name: 'Attribute 4 Data',
    value: 'products.att4d',
    table: 'products'
  }, {
    name: 'Attribute 5 Name',
    value: 'products.att5n',
    table: 'products'
  }, {
    name: 'Attribute 5 Data',
    value: 'products.att5d',
    table: 'products'
  }, {
    name: 'Attribute 6 Name',
    value: 'products.att6n',
    table: 'products'
  }, {
    name: 'Attribute 6 Data',
    value: 'products.att6d',
    table: 'products'
  }, {
    name: 'Attribute 7 Name',
    value: 'products.att7n',
    table: 'products'
  }, {
    name: 'Attribute 7 Data',
    value: 'products.att7d',
    table: 'products'
  }, {
    name: 'Attribute 8 Name',
    value: 'products.att8n',
    table: 'products'
  }, {
    name: 'Attribute 8 Data',
    value: 'products.att8d',
    table: 'products'
  }, {
    name: 'Attribute 9 Name',
    value: 'products.att9n',
    table: 'products'
  }, {
    name: 'Attribute 9 Data',
    value: 'products.att9d',
    table: 'products'
  }, {
    name: 'Attribute 10 Name',
    value: 'products.att10n',
    table: 'products'
  }, {
    name: 'Attribute 10 Data',
    value: 'products.att10d',
    table: 'products'
  }, {
    name: 'Attribute 11 Name',
    value: 'products.att11n',
    table: 'products'
  }, {
    name: 'Attribute 11 Data',
    value: 'products.att11d',
    table: 'products'
  }, {
    name: 'Attribute 12 Name',
    value: 'products.att12n',
    table: 'products'
  }, {
    name: 'Attribute 12 Data',
    value: 'products.att12d',
    table: 'products'
  }, {
    name: 'Attribute 13 Name',
    value: 'products.att13n',
    table: 'products'
  }, {
    name: 'Attribute 13 Data',
    value: 'products.att13d',
    table: 'products'
  }, {
    name: 'Attribute 14 Name',
    value: 'products.att14n',
    table: 'products'
  }, {
    name: 'Attribute 14 Data',
    value: 'products.att14d',
    table: 'products'
  }, {
    name: 'Attribute 15 Name',
    value: 'products.att15n',
    table: 'products'
  }, {
    name: 'Attribute 15 Data',
    value: 'products.att15d',
    table: 'products'
  }, {
    name: 'Attribute 16 Name',
    value: 'products.att16n',
    table: 'products'
  }, {
    name: 'Attribute 16 Data',
    value: 'products.att16d',
    table: 'products'
  }, {
    name: 'Attribute 17 Name',
    value: 'products.att17n',
    table: 'products'
  }, {
    name: 'Attribute 17 Data',
    value: 'products.att17d',
    table: 'products'
  }, {
    name: 'Attribute 18 Name',
    value: 'products.att18n',
    table: 'products'
  }, {
    name: 'Attribute 18 Data',
    value: 'products.att18d',
    table: 'products'
  }, {
    name: 'Mfg Part #',
    value: 'products.mfg_part_num',
    table: 'products'
  }, {
    name: 'Ability One Sku',
    value: 'products.ability_one_sku',
    table: 'products'
  }, {
    name: 'Status',
    value: 'products.status',
    table: 'products'
  }, {
    name: 'Rating',
    value: 'products.average_rating',
    table: 'products'
  }];
  storeTables.orders = [{
    name: 'Order Id',
    value: 'orders.order_id',
    table: 'orders'
  }, {
    name: 'Group Id',
    value: 'orders.group_id',
    table: 'orders'
  }, {
    name: 'Customer Id',
    value: 'orders.customer_id',
    table: 'orders'
  }, {
    name: 'Approver Id',
    value: 'orders.approver_id',
    table: 'orders'
  }, {
    name: 'Shipping Id',
    value: 'orders.shipping_id',
    table: 'orders'
  }, {
    name: 'Billing Id',
    value: 'orders.billing_id',
    table: 'orders'
  }, {
    name: 'Cost Center Id',
    value: 'orders.cost_center_id',
    table: 'orders'
  }, {
    name: 'Shipping Rule Id',
    value: 'orders.shipping_rule_id',
    table: 'orders'
  }, {
    name: 'Cost Center Code',
    value: 'orders.cost_center_code',
    table: 'orders'
  }, {
    name: 'Price Sheet',
    value: 'orders.price_sheet',
    table: 'orders'
  }, {
    name: 'Loc Id',
    value: 'orders.loc_id',
    table: 'orders'
  }, {
    name: 'Trx Redeemed',
    value: 'orders.trx_redeemed',
    table: 'orders'
  }, {
    name: 'Status',
    value: 'orders.status',
    table: 'orders'
  }, {
    name: 'Order Shipped',
    value: 'orders.order_shipped',
    table: 'orders'
  }, {
    name: 'Tracking Code',
    value: 'orders.tracking_code',
    table: 'orders'
  }, {
    name: 'Shipping Method',
    value: 'orders.shipping_method',
    table: 'orders'
  }, {
    name: 'Shipping Carrier',
    value: 'orders.shipping_carrier',
    table: 'orders'
  }, {
    name: 'Order Date',
    value: 'orders.order_date',
    table: 'orders'
  }, {
    name: 'Subtotal',
    value: 'orders.subtotal',
    table: 'orders'
  }, {
    name: 'Tax',
    value: 'orders.tax',
    table: 'orders'
  }, {
    name: 'Tax Rate',
    value: 'orders.tax_rate',
    table: 'orders'
  }, {
    name: 'Shipping',
    value: 'orders.shipping',
    table: 'orders'
  }, {
    name: 'Discount',
    value: 'orders.discount',
    table: 'orders'
  }, {
    name: 'Promo Discount',
    value: 'orders.promo_discount',
    table: 'orders'
  }, {
    name: 'Total Amount',
    value: 'orders.total_amt',
    table: 'orders'
  }, {
    name: 'RR PO Num',
    value: 'orders.rr_po_num',
    table: 'orders'
  }, {
    name: 'Issuing Office',
    value: 'orders.issuing_office',
    table: 'orders'
  }, {
    name: 'Approver',
    value: 'orders.approver',
    table: 'orders'
  }, {
    name: 'Attention',
    value: 'orders.attention',
    table: 'orders'
  }, {
    name: 'Organization',
    value: 'orders.organization',
    table: 'orders'
  }, {
    name: 'First Name',
    value: 'orders.first_name',
    table: 'orders'
  }, {
    name: 'Last Name',
    value: 'orders.last_name',
    table: 'orders'
  }, {
    name: 'Email',
    value: 'orders.email',
    table: 'orders'
  }, {
    name: 'Phone',
    value: 'orders.phone',
    table: 'orders'
  }, {
    name: 'Billing First Name',
    value: 'orders.bill_first_name',
    table: 'orders'
  }, {
    name: 'Billing Last Name',
    value: 'orders.bill_last_name',
    table: 'orders'
  }, {
    name: 'Billing Email',
    value: 'orders.bill_email',
    table: 'orders'
  }, {
    name: 'Billing Phone',
    value: 'orders.bill_phone',
    table: 'orders'
  }, {
    name: 'Payment Method',
    value: 'orders.payment_method',
    table: 'orders'
  }, {
    name: 'Credit Line',
    value: 'orders.credit_line',
    table: 'orders'
  }, {
    name: 'Credit Card',
    value: 'orders.credit_card',
    table: 'orders'
  }, {
    name: 'CC Type',
    value: 'orders.cctype',
    table: 'orders'
  }, {
    name: 'Shipping Profile',
    value: 'orders.shipping_profile',
    table: 'orders'
  }, {
    name: 'Address 1',
    value: 'orders.address1',
    table: 'orders'
  }, {
    name: 'Address 2',
    value: 'orders.address2',
    table: 'orders'
  }, {
    name: 'City',
    value: 'orders.city',
    table: 'orders'
  }, {
    name: 'State',
    value: 'orders.state',
    table: 'orders'
  }, {
    name: 'Zip',
    value: 'orders.zip',
    table: 'orders'
  }, {
    name: 'Billing Address 1',
    value: 'orders.bill_address1',
    table: 'orders'
  }, {
    name: 'Billing Address 2',
    value: 'orders.bill_address2',
    table: 'orders'
  }, {
    name: 'Billing City',
    value: 'orders.bill_city',
    table: 'orders'
  }, {
    name: 'Billing State',
    value: 'orders.bill_state',
    table: 'orders'
  }, {
    name: 'Billing Zip',
    value: 'orders.bill_zip',
    table: 'orders'
  }, {
    name: 'Notes',
    value: 'orders.notes',
    table: 'orders'
  }, {
    name: 'GSA Total',
    value: 'orders.gsa_total',
    table: 'orders'
  }, {
    name: 'Other Total',
    value: 'orders.other_total',
    table: 'orders'
  }, {
    name: 'Approver Notes',
    value: 'orders.approver_notes',
    table: 'orders'
  }, {
    name: 'Promo Codes',
    value: 'orders.promo_codes',
    table: 'orders'
  }, {
    name: 'F1 Replace Field',
    value: 'orders.f1_replace_field',
    table: 'orders'
  }, {
    name: 'F1 Name',
    value: 'orders.f1_name',
    table: 'orders'
  }, {
    name: 'F1 XML Location',
    value: 'orders.f1_xml_location',
    table: 'orders'
  }, {
    name: 'F1 Value',
    value: 'orders.f1_value',
    table: 'orders'
  }, {
    name: 'F2 Replace Field',
    value: 'orders.f2_replace_field',
    table: 'orders'
  }, {
    name: 'F2 Name',
    value: 'orders.f2_name',
    table: 'orders'
  }, {
    name: 'F2 XML Location',
    value: 'orders.f2_xml_location',
    table: 'orders'
  }, {
    name: 'F2 Value',
    value: 'orders.f2_value',
    table: 'orders'
  }, {
    name: 'F3 Name',
    value: 'orders.f3_name',
    table: 'orders'
  }, {
    name: 'F3 Value',
    value: 'orders.f3_name',
    table: 'orders'
  }, {
    name: 'F4 Name',
    value: 'orders.f4_name',
    table: 'orders'
  }, {
    name: 'F4 Value',
    value: 'orders.f4_name',
    table: 'orders'
  }, {
    name: 'F5 Name',
    value: 'orders.f5_name',
    table: 'orders'
  }, {
    name: 'F5 Value',
    value: 'orders.f5_name',
    table: 'orders'
  }, {
    name: 'F6 Name',
    value: 'orders.f6_name',
    table: 'orders'
  }, {
    name: 'F6 Value',
    value: 'orders.f6_name',
    table: 'orders'
  }, {
    name: 'Reference Id',
    value: 'orders.reference_id',
    table: 'orders'
  }, {
    name: 'Payload Id',
    value: 'orders.payload_id',
    table: 'orders'
  }, {
    name: 'Postback Url',
    value: 'orders.postback_url',
    table: 'orders'
  }, {
    name: 'Shipping Token',
    value: 'orders.shipping_token',
    table: 'orders'
  }];
  joinTables.price_sheets = [{
    name: 'Id',
    value: 'price_sheets.ps_item_id',
    table: 'price_sheets'
  }, {
    name: 'Price Sheet Id',
    value: 'price_sheets.price_sheet_id',
    table: 'price_sheets'
  }, {
    name: 'Product Id',
    value: 'price_sheets.product_id',
    table: 'price_sheets'
  }, {
    name: 'Sku',
    value: 'price_sheets.sku',
    table: 'price_sheets'
  }, {
    name: 'GSA',
    value: 'price_sheets.gsa',
    table: 'price_sheets'
  }, {
    name: 'Ability One',
    value: 'price_sheets.ability_one',
    table: 'price_sheets'
  }, {
    name: 'Core List',
    value: 'price_sheets.core_list',
    table: 'price_sheets'
  }, {
    name: 'Price',
    value: 'price_sheets.price',
    table: 'price_sheets'
  }];
  joinTables.product_collection = [{
    name: 'Collection Id',
    value: 'product_collection.collection_id',
    table: 'product_collection'
  }, {
    name: 'Product ID',
    value: 'product_collection.product_id',
    table: 'product_collection'
  }];
  joinTables.purchased_items = [{
    name: 'Purchase Id',
    value: 'purchased_items.purch_id',
    table: 'purchased_items'
  }, {
    name: 'Customer Id',
    value: 'purchased_items.customer_id',
    table: 'purchased_items'
  }, {
    name: 'Order Id',
    value: 'purchased_items.order_id',
    table: 'purchased_items'
  }, {
    name: 'Product Id',
    value: 'purchased_items.product_id',
    table: 'purchased_items'
  }, {
    name: 'Purchase Date',
    value: 'purchased_items.purchase_date',
    table: 'purchased_items'
  }, {
    name: 'Quantity',
    value: 'purchased_items.qty',
    table: 'purchased_items'
  }, {
    name: 'Price',
    value: 'purchased_items.price',
    table: 'purchased_items'
  }, {
    name: 'GSA',
    value: 'purchased_items.gsa',
    table: 'purchased_items'
  }, {
    name: 'Ability One',
    value: 'purchased_items.ability_one',
    table: 'purchased_items'
  }, {
    name: 'Core List',
    value: 'purchased_items.core_list',
    table: 'purchased_items'
  }, {
    name: 'Return Status',
    value: 'purchased_items.return_status',
    table: 'purchased_items'
  }, {
    name: 'Return Request Date',
    value: 'purchased_items.return_request_date',
    table: 'purchased_items'
  }, {
    name: 'Return Respone Notes',
    value: 'purchased_items.return_response_notes',
    table: 'purchased_items'
  }, {
    name: 'Return Reason',
    value: 'purchased_items.return_reason',
    table: 'purchased_items'
  }, {
    name: 'Return Qty',
    value: 'purchased_items.return_qty',
    table: 'purchased_items'
  }, {
    name: 'Return Contact',
    value: 'purchased_items.return_contact',
    table: 'purchased_items'
  }, {
    name: 'Return Boxes',
    value: 'purchased_items.return_boxes',
    table: 'purchased_items'
  }];
  joinTables.saved_billing = [{
    name: 'Id',
    value: 'saved_billing.billing_id',
    table: 'saved_billing'
  }, {
    name: 'Customer Id',
    value: 'saved_billing.customer_id',
    table: 'saved_billing'
  }, {
    name: 'Name',
    value: 'saved_billing.billing_name',
    table: 'saved_billing'
  }, {
    name: 'First Name',
    value: 'saved_billing.first_name',
    table: 'saved_billing'
  }, {
    name: 'Last Name',
    value: 'saved_billing.last_name',
    table: 'saved_billing'
  }, {
    name: 'Email',
    value: 'saved_billing.email',
    table: 'saved_billing'
  }, {
    name: 'Address 1',
    value: 'saved_billing.address1',
    table: 'saved_billing'
  }, {
    name: 'Address 2',
    value: 'saved_billing.address2',
    table: 'saved_billing'
  }, {
    name: 'City',
    value: 'saved_billing.city',
    table: 'saved_billing'
  }, {
    name: 'State',
    value: 'saved_billing.state',
    table: 'saved_billing'
  }, {
    name: 'Zip',
    value: 'saved_billing.zip',
    table: 'saved_billing'
  }, {
    name: 'Area Code',
    value: 'saved_billing.areacode',
    table: 'saved_billing'
  }, {
    name: 'Phone',
    value: 'saved_billing.phone',
    table: 'saved_billing'
  }, {
    name: 'Active',
    value: 'saved_billing.active',
    table: 'saved_billing'
  }];
  joinTables.saved_shipping = [{
    name: 'Id',
    value: 'saved_shipping.shipping_id',
    table: 'saved_shipping'
  }, {
    name: 'Customer Id',
    value: 'saved_shipping.customer_id',
    table: 'saved_shipping'
  }, {
    name: 'Name',
    value: 'saved_shipping.shipping_name',
    table: 'saved_shipping'
  }, {
    name: 'First Name',
    value: 'saved_shipping.first_name',
    table: 'saved_shipping'
  }, {
    name: 'Last Name',
    value: 'saved_shipping.last_name',
    table: 'saved_shipping'
  }, {
    name: 'Email',
    value: 'saved_shipping.email',
    table: 'saved_shipping'
  }, {
    name: 'Address 1',
    value: 'saved_shipping.address1',
    table: 'saved_shipping'
  }, {
    name: 'Address 2',
    value: 'saved_shipping.address2',
    table: 'saved_shipping'
  }, {
    name: 'City',
    value: 'saved_shipping.city',
    table: 'saved_shipping'
  }, {
    name: 'State',
    value: 'saved_shipping.state',
    table: 'saved_shipping'
  }, {
    name: 'Zip',
    value: 'saved_shipping.zip',
    table: 'saved_shipping'
  }, {
    name: 'Area Code',
    value: 'saved_shipping.areacode',
    table: 'saved_shipping'
  }, {
    name: 'Phone',
    value: 'saved_shipping.phone',
    table: 'saved_shipping'
  }, {
    name: 'Active',
    value: 'saved_shipping.active',
    table: 'saved_shipping'
  }];
  joinTables.pending_items = [{
    name: 'Id',
    value: 'pending_items.pend_id',
    table: 'pending_items'
  }, {
    name: 'Cart Items Id',
    value: 'pending_items.cart_item_id',
    table: 'pending_items'
  }, {
    name: 'Order Id',
    value: 'pending_items.order_id',
    table: 'pending_items'
  }, {
    name: 'Product Id',
    value: 'pending_items.product_id',
    table: 'pending_items'
  }, {
    name: 'Qty',
    value: 'pending_items.qty',
    table: 'pending_items'
  }, {
    name: 'Price',
    value: 'pending_items.price',
    table: 'pending_items'
  }];
  joinTables.inventory_logs = [{
    name: 'Id',
    value: 'inventory_logs.id',
    table: 'inventory_logs'
  }, {
    name: 'Product Id',
    value: 'inventory_logs.product_id',
    table: 'inventory_logs'
  }, {
    name: 'In',
    value: 'inventory_logs.inventory_in',
    table: 'inventory_logs'
  }, {
    name: 'Out',
    value: 'inventory_logs.inventory_out',
    table: 'inventory_logs'
  }, {
    name: 'Date',
    value: 'inventory_logs.created_at',
    table: 'inventory_logs'
  }];
  allTables = Object.assign({}, storeTables);
  allTables.inventory_logs = joinTables.inventory_logs;
  allTables.pending_items = joinTables.pending_items;
  allTables.price_sheets = joinTables.price_sheets;
  allTables.purchased_items = joinTables.purchased_items;
  allTables.saved_billing = joinTables.saved_billing;
  allTables.saved_shipping = joinTables.saved_shipping;
  return service;
}]);
angular.module('vendorfuelApp').factory('Settings', ['$http', 'Localized', '$q', 'Debug', 'Utils', 'Admin', function ($http, Localized, $q, Debug, Utils, Admin) {
  //FACTORY VARIABLES
  var service = {};
  service.errors = {}; //FACTORY PRIVATE FUNCTIONS

  function getSettings(tab, url) {
    var httpUrl = Localized.apiUrl + url;

    if (!url) {
      httpUrl = Localized.wpRestUrl + '/settings/' + tab.name;
    }

    var promise = Utils.HttpGet(httpUrl).then(function successCallback(response) {
      tab.saved = response;
    }, function errorCallback(response) {
      tab.saved = response;
    });
    return promise;
  }

  function postSettings(tab, params, url, data) {
    var httpUrl = Localized.apiUrl + url;

    if (!url) {
      httpUrl = Localized.wpRestUrl + '/settings/' + tab.name;
    }

    var promise = Utils.HttpPost(httpUrl, params, data).then(function successCallback(response) {
      if (response.errors) {
        service.errors = response.errors;
      }
    }, function errorCallback(response) {
      if (response.errors) {
        service.errors = response.errors;
      }
    });
    return promise;
  }

  function putSettings(tab, params, url, data) {
    var httpUrl = Localized.apiUrl + url;

    if (!url) {
      httpUrl = Localized.wpRestUrl + '/settings/' + tab.name + '/post';
    }

    var promise = Utils.HttpPut(httpUrl, params, data).then(function successCallback(response) {
      if (response.errors) {
        service.errors = response.errors;
      }
    }, function errorCallback(response) {
      if (response.errors) {
        service.errors = response.errors;
      }
    });
    return promise;
  } //FACTORY PUBLIC FUNCTIONS AND DATA


  service.general = {
    name: 'general',
    saved: {},
    Get: function Get() {
      return getSettings(service.general);
    },
    Set: function Set() {
      var params = {
        settings: JSON.stringify(service.general.saved)
      };
      return postSettings(service.general, params).then(function () {
        if (service.general.saved.apiUrl !== Localized.apiUrl) {
          Localized.apiUrl = service.general.saved.apiUrl;
          Admin.Logout();
        }

        if (service.general.saved.apiKey !== Localized.apiKey) {
          Localized.apiKey = service.general.saved.apiKey;
          Admin.Logout();
        }
      });
    }
  };
  service.store = {
    name: 'store',
    saved: {},
    Get: function Get() {
      return getSettings(service.store, '/stores').then(function () {
        service.store.saved = service.store.saved.store;
      });
    },
    Set: function Set() {
      var params = {
        'name': service.store.saved.name,
        'url': service.store.saved.url,
        'default_order_prefix': service.store.saved.default_order_prefix,
        'default_customer_prefix': service.store.saved.default_customer_prefix,
        'options': service.store.saved.options,
        'checkout': service.store.saved.checkout
      };
      postSettings(service.store, params);
      return putSettings(service.store, null, '/stores', params);
    },
    Changed: function Changed(i, enabled) {}
  };
  service.conversions = {
    name: 'conversions',
    saved: {},
    Get: function Get() {
      return getSettings(service.conversions);
    },
    Set: function Set() {
      var params = {
        settings: JSON.stringify(service.conversions.saved)
      };
      return postSettings(service.conversions, params);
    },
    Changed: function Changed(enabled) {
      if (!enabled) {
        service.conversions.saved.google.id = '';
        service.conversions.saved.google.label = '';
        service.conversions.saved.google.tracking = false;
      }
    }
  };
  service.image = {
    name: 'image',
    saved: {},
    Get: function Get() {
      return getSettings(service.image).then(function () {
        service.image.ChangeRepo();
      });
    },
    Set: function Set() {
      var params = {
        settings: JSON.stringify(service.image.saved)
      };
      return postSettings(service.image, params);
    },
    repositories: [{
      name: 'Local',
      value: 0
    }, {
      name: 'Amazon S3',
      value: 1
    }, {
      name: 'MaxCDN',
      value: 2
    }],
    apiKeyRequired: false,
    Changed: function Changed() {
      service.image.saved.storage.repository = service.image.saved.imageRepository.value;

      if (service.image.saved.imageRepository.value === 1) {
        service.image.apiKeyRequired = true;
      } else {
        service.image.apiKeyRequired = false;
        service.image.saved.storage.api_key = '';
      }
    }
  };
  service.anguledit = {
    name: 'anguledit',
    saved: {},
    Get: function Get() {
      return getSettings(service.anguledit);
    },
    Set: function Set() {
      var params = {
        settings: JSON.stringify(service.anguledit.saved)
      };
      return postSettings(service.anguledit, params).then(function () {});
    }
  };
  service.gateways = {
    name: 'gateways',
    saved: {},
    Get: function Get() {
      return getSettings(service.gateways, '/admin/gateways').then(function () {
        service.gateways.saved.gateways.authnet.enabled = service.gateways.saved.gateways.authnet.enabled === 'true';
        service.gateways.saved.gateways.paypal.enabled = service.gateways.saved.gateways.paypal.enabled === 'true';
        service.gateways.Changed(0, service.gateways.saved.gateways.authnet.enabled);
        service.gateways.Changed(1, service.gateways.saved.gateways.paypal.enabled);
      });
    },
    Set: function Set() {
      var params = {
        'gateways[authnet][enabled]': service.gateways.saved.gateways.authnet.enabled,
        'gateways[authnet][id]': service.gateways.saved.gateways.authnet.id,
        'gateways[authnet][key]': service.gateways.saved.gateways.authnet.key,
        'gateways[paypal][enabled]': service.gateways.saved.gateways.paypal.enabled,
        'gateways[paypal][client_id]': service.gateways.saved.gateways.paypal.client_id,
        'gateways[paypal][secret]': service.gateways.saved.gateways.paypal.secret
      };
      return putSettings(service.gateways, params, '/admin/gateways');
    },
    Changed: function Changed(i, enabled) {
      if (!enabled && i === 0) {
        service.gateways.saved.gateways.authnet.id = '';
        service.gateways.saved.gateways.authnet.key = '';
      } else if (!enabled && i === 1) {
        service.gateways.saved.gateways.paypal.client_id = '';
        service.gateways.saved.gateways.paypal.secret = '';
      }
    }
  };
  service.billing = {
    name: 'billing',
    saved: {},
    Get: function Get() {
      return getSettings(service.billing, '/tenant/billing/check');
    },
    Set: function Set() {
      var params = {
        firstName: service.billing.saved.first_name,
        lastName: service.billing.saved.last_name,
        number: service.billing.saved.card.number,
        expiryMonth: service.billing.saved.card.expMonth,
        expiryYear: service.billing.saved.card.expYear,
        cvv: service.billing.saved.card.cvv
      };
      return postSettings(service.billing, params, '/tenant/billing/update');
    },
    Cancel: function Cancel() {
      var params = {
        store: service.billing.saved.store.id
      };
      return postSettings(service.billing, params, '/tenant/billing/cancel');
    },
    cancelling: false
  };
  return service;
}]);
angular.module('vendorfuelApp').factory('taxes', [function () {
  var service = {}; //Select State DATA

  var stateOptions = [{
    name: 'Alabama',
    value: 'AL',
    active: false
  }, {
    name: 'Alaska',
    value: 'AK',
    active: false
  }, {
    name: 'Arizona',
    value: 'AZ',
    active: false
  }, {
    name: 'Arkansas',
    value: 'AR',
    active: false
  }, {
    name: 'California',
    value: 'CA',
    active: false
  }, {
    name: 'Colorado',
    value: 'CO',
    active: false
  }, {
    name: 'Connecticut',
    value: 'CT',
    active: false
  }, {
    name: 'Delaware',
    value: 'DE',
    active: false
  }, {
    name: 'District of Columbia',
    value: 'DC',
    active: false
  }, {
    name: 'Florida',
    value: 'FL',
    active: false
  }, {
    name: 'Georgia',
    value: 'GA',
    active: false
  }, {
    name: 'Hawaii',
    value: 'HI',
    active: false
  }, {
    name: 'Idaho',
    value: 'ID',
    active: false
  }, {
    name: 'Illinois',
    value: 'IL',
    active: false
  }, {
    name: 'Indiana',
    value: 'IN',
    active: false
  }, {
    name: 'Iowa',
    value: 'IA',
    active: false
  }, {
    name: 'Kansas',
    value: 'KS',
    active: false
  }, {
    name: 'Kentucky',
    value: 'KY',
    active: false
  }, {
    name: 'Louisiana',
    value: 'LA',
    active: false
  }, {
    name: 'Maine',
    value: 'ME',
    active: false
  }, {
    name: 'Montana',
    value: 'MT',
    active: false
  }, {
    name: 'Nebraska',
    value: 'NE',
    active: false
  }, {
    name: 'Nevada',
    value: 'NV',
    active: false
  }, {
    name: 'New Hampshire',
    value: 'NH',
    active: false
  }, {
    name: 'New Jersey',
    value: 'NJ',
    active: false
  }, {
    name: 'New Mexico',
    value: 'NM',
    active: false
  }, {
    name: 'New York',
    value: 'NY',
    active: false
  }, {
    name: 'North Carolina',
    value: 'NC',
    active: false
  }, {
    name: 'North Dakota',
    value: 'ND',
    active: false
  }, {
    name: 'Ohio',
    value: 'OH',
    active: false
  }, {
    name: 'Oklahoma',
    value: 'OK',
    active: false
  }, {
    name: 'Oregon',
    value: 'OR',
    active: false
  }, {
    name: 'Maryland',
    value: 'MD',
    active: false
  }, {
    name: 'Massachusetts',
    value: 'MA',
    active: false
  }, {
    name: 'Michigan',
    value: 'MI',
    active: false
  }, {
    name: 'Minnesota',
    value: 'MN',
    active: false
  }, {
    name: 'Mississippi',
    value: 'MS',
    active: false
  }, {
    name: 'Missouri',
    value: 'MO',
    active: false
  }, {
    name: 'Pennsylvania',
    value: 'PA',
    active: false
  }, {
    name: 'Rhode Island',
    value: 'RI',
    active: false
  }, {
    name: 'South Carolina',
    value: 'SC',
    active: false
  }, {
    name: 'South Dakota',
    value: 'SD',
    active: false
  }, {
    name: 'Tennessee',
    value: 'TN',
    active: false
  }, {
    name: 'Texas',
    value: 'TX',
    active: false
  }, {
    name: 'Utah',
    value: 'UT',
    active: false
  }, {
    name: 'Vermont',
    value: 'VT',
    active: false
  }, {
    name: 'Virginia',
    value: 'VA',
    active: false
  }, {
    name: 'Washington',
    value: 'WA',
    active: false
  }, {
    name: 'West Virginia',
    value: 'WV',
    active: false
  }, {
    name: 'Wisconsin',
    value: 'WI',
    active: false
  }, {
    name: 'Wyoming',
    value: 'WY',
    active: false
  }];

  service.taxesData = function () {
    var data = {};
    data.stateTaxes = stateOptions;
    return data;
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('Tenant', ['$http', '$cookies', '$location', 'Localized', 'Debug', function ($http, $cookies, $location, Localized, Debug) {
  var service = {};
  var tenant = {
    authed: false,
    name: '',
    tokens: {
      a: '',
      b: '',
      jwt: ''
    }
  };
  service.login_errors = {};

  service.Login = function (e, p) {
    //TODO: get api url from settings factory
    Debug.log('LOGGING IN');
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/tenant/login',
      data: {
        email: e,
        password: p
      }
    };
    var promise = $http(req).then(function successCallback(response) {
      if (Object.keys(response.data.errors).length > 0) {
        Debug.log('Login errors: ', response.data.errors);
        service.login_errors = response.data.errors;
      } else {
        tenant.name = response.data.name;
        $cookies.put('vendorfuel-tenant-name', tenant.name);
        tenant.tokens.jwt = response.data.token;
        $cookies.put('vendorfuel-tenant-token', tenant.tokens.jwt);
        tenant.authed = true;
      }

      return response;
    }, function errorCallback(response) {
      if (response.xhrStatus === 'error') {
        service.login_errors.error = 'Invalid VendorFuel API URL.';
      }

      if (Object.keys(response.data.errors).length > 0) {
        Debug.log('Login errors: ', response.data.errors);
        service.login_errors = response.data.errors;
      }

      return response;
    });
    return promise;
  };

  service.LoginErrors = function () {
    return service.login_errors;
  };

  service.Logout = function () {
    Debug.log('LOGGING OUT');
    tenant.name = null;
    $cookies.remove('vendorfuel-tenant-name');
    tenant.tokens.jwt = null;
    $cookies.remove('vendorfuel-tenant-token');
    tenant.authed = false;
  };

  service.Authed = function () {
    var token = $cookies.get('vendorfuel-tenant-token');

    if (token) {
      tenant.authed = true;
    } else {
      tenant.authed = false;
    }

    return tenant.authed;
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('uom', [function () {
  var service = {}; //UOM CODES

  var uomCodes = [{
    'name': 'Bag',
    'val': 'BG'
  }, {
    'name': 'Barrel',
    'val': 'BA'
  }, {
    'name': 'Bolt',
    'val': 'BT'
  }, {
    'name': 'Box',
    'val': 'BX'
  }, {
    'name': 'Bunch',
    'val': 'BH'
  }, {
    'name': 'Bundle',
    'val': 'BND'
  }, {
    'name': 'Butt',
    'val': 'BU'
  }, {
    'name': 'Card',
    'val': 'CRD'
  }, {
    'name': 'Case',
    'val': 'CS'
  }, {
    'name': 'Centimeter',
    'val': 'CM'
  }, {
    'name': 'Container',
    'val': 'CON'
  }, {
    'name': 'Crate',
    'val': 'CR'
  }, {
    'name': 'Dozen',
    'val': 'DZ'
  }, {
    'name': 'Each',
    'val': 'EA'
  }, {
    'name': 'Envelope',
    'val': 'EN'
  }, {
    'name': 'Foot',
    'val': 'FT'
  }, {
    'name': 'Kilogram',
    'val': 'KG'
  }, {
    'name': 'Kilograms',
    'val': 'KGS'
  }, {
    'name': 'Liter',
    'val': 'L'
  }, {
    'name': 'Meter',
    'val': 'M'
  }, {
    'name': 'Package',
    'val': 'PK'
  }, {
    'name': 'Packet',
    'val': 'PA'
  }, {
    'name': 'Pallet',
    'val': 'PAL'
  }, {
    'name': 'Piece',
    'val': 'PC'
  }, {
    'name': 'Pieces',
    'val': 'PCS'
  }, {
    'name': 'Pound',
    'val': 'LB'
  }, {
    'name': 'Roll',
    'val': 'ROL'
  }, {
    'name': 'Set',
    'val': 'SET'
  }, {
    'name': 'Square Meter',
    'val': 'SME'
  }, {
    'name': 'Square Ft',
    'val': 'SQFT'
  }, {
    'name': 'Tube',
    'val': 'TUBE'
  }, {
    'name': 'Yard',
    'val': 'YD'
  }];

  service.uomData = function () {
    var data = {};
    data.uomCodes = uomCodes;
    return data;
  };

  return service;
}]);
angular.module('vendorfuelApp').factory('WarningModal', ['$uibModal', 'Localized', '$sce', function ($uibModal, Localized, $sce) {
  var service = {};

  service.Show = function (callback, title, message, optionConfirm, backdrop, highlightedButton) {
    message = message || '';
    optionConfirm = optionConfirm || 'Confirm';
    backdrop = backdrop || true;
    highlightedButton = highlightedButton || 0;
    var tempConfirmWidth = optionConfirm.length;
    var optionWidth = tempConfirmWidth * 9 + 24;
    var callbackParams = callback.params || {};
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/warning.html',
      backdrop: backdrop,
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.modalTitle = $sce.trustAsHtml(title);
        $scope.modalMessage = $sce.trustAsHtml(message);
        $scope.optionConfirm = optionConfirm;
        $scope.optionWidth = optionWidth;
        $scope.highlightedButton = highlightedButton;

        $scope.Confirm = function () {
          $uibModalInstance.close();
        };
      }]
    }).result.then(function () {
      if (callback.confirm) {
        callback.confirm(callbackParams);
      }
    });
  };

  return service;
}]);
angular.module('vendorfuelApp').directive('copyToClipboard', function () {
  return {
    restrict: 'A',
    link: function link(scope, elem, attrs) {
      elem.on('click', function () {
        if (attrs.copyToClipboard) {
          var $temp_input = jQuery('<input>');
          jQuery('clipboard').append($temp_input);
          $temp_input.val(attrs.copyToClipboard).select();
          document.execCommand('copy');
        }
      });
    }
  };
});
angular.module('vendorfuelApp').directive('format', ['$filter', function ($filter) {
  return {
    require: '?ngModel',
    link: function link(scope, elem, attrs, ctrl) {
      var dec = '.';

      if (!ctrl) {
        return;
      }

      ctrl.$formatters.unshift(function (a) {
        return $filter(attrs.format)(ctrl.$modelValue);
      });
      elem.bind('focus', function () {
        elem.val(ctrl.$modelValue);
      });
      elem.bind('blur', function (event) {
        var plainNumber = elem.val().replace(/[^\d|\-+|\.+]/g, '');
        elem.val($filter(attrs.format)(plainNumber));
      });
      angular.element(elem).on('keypress', function (e) {
        var newVal = $(this).val() + (e.charCode !== 0 ? String.fromCharCode(e.charCode) : '');

        if ($(this).val().search(/(.*)\.[0-9][0-9]/) === 0 && newVal.length > $(this).val().length) {
          if (e.charCode !== 8) {
            e.preventDefault();
          }
        }
      });
    }
  };
}]);
angular.module('vendorfuelApp').filter('tel', function () {
  return function (tel) {
    if (!tel) {
      return '';
    }

    var regex = '/^+/';
    var value = tel.toString().trim().replace(regex, '');

    if (value.match(/[^0-9]/)) {
      return tel;
    }

    var country, city, number;

    switch (value.length) {
      case 1:
      case 2:
      case 3:
        city = value;
        break;

      default:
        if (value.length === 11) {
          country = value.slice(0, 1);
          city = value.slice(1, 4);
          number = value.slice(4);
        } else {
          city = value.slice(0, 3);
          number = value.slice(3);
        }

    }

    if (number && value.length === 11) {
      // country = '1';
      number = number.slice(0, 3) + '-' + number.slice(3, 7);
      return (country + ' (' + city + ') ' + number).trim();
    } else if (number) {
      if (number.length > 3) {
        number = number.slice(0, 3) + '-' + number.slice(3, 7);
      } else {
        number = number;
      }

      return ('(' + city + ') ' + number).trim();
    } else {
      return '(' + city;
    }
  };
}); // vfApp.directive("compareTo", compareTo);

angular.module('vendorfuelApp').directive('phoneInput', ["$filter", "$browser", function ($filter, $browser) {
  return {
    require: 'ngModel',
    link: function link($scope, $element, $attrs, ngModelCtrl) {
      var listener = function listener() {
        var value = $element.val().replace(/[^0-9]/g, '');
        $element.val($filter('tel')(value, false));
      }; // This runs when we update the text field


      ngModelCtrl.$parsers.push(function (viewValue) {
        return viewValue.replace(/[^0-9]/g, '').slice(0, 10);
      }); // This runs when the model gets updated on the scope directly and keeps our view in sync

      ngModelCtrl.$render = function () {
        $element.val($filter('tel')(ngModelCtrl.$viewValue, false));
      };

      $element.bind('change', listener);
      $element.bind('keydown', function (event) {
        var key = event.keyCode; // If the keys include the CTRL, SHIFT, ALT, or META keys, or the arrow keys, do nothing.
        // This lets us support copy and paste too

        if (key === 91 || 15 < key && key < 19 || 37 <= key && key <= 40) {
          return;
        }

        $browser.defer(listener); // Have to do this or changes don't get picked up properly
      });
      $element.bind('paste cut', function () {
        $browser.defer(listener);
      });
    }
  };
}]);
angular.module('vendorfuelApp').filter('phone', function () {
  return function (phone) {
    console.log(phone);

    if (!phone) {
      return '';
    }

    var value = phone.toString().trim().replace(/^\+/, '');

    if (value.match(/[^0-9]/)) {
      return phone;
    }

    var country, city, number;

    switch (value.length) {
      case 1:
      case 2:
      case 3:
        city = value;
        break;

      default:
        city = value.slice(0, 3);
        number = value.slice(3);
    }

    if (number) {
      if (number.length > 3) {
        number = number.slice(0, 3) + '-' + number.slice(3, 7);
      } else {
        number = number;
      }

      return ('(' + city + ') ' + number).trim();
    } else {
      return '(' + city;
    }
  };
});
angular.module('vendorfuelApp').directive('resize', ['$window', function ($window) {
  return function ($scope) {
    getSizing();
    angular.element($window).bind('resize', function () {
      $scope.$apply(function () {
        getSizing();
      });
    });

    function getSizing() {
      $scope.width = $window.innerWidth;
      checkSizing($scope.width);
    }

    function checkSizing(w) {
      if (w < 576) {
        setBools(true);
      } else if (w >= 576 && w < 768) {
        setBools(false, true);
      } else if (w >= 768 && w < 992) {
        setBools(false, false, true);
      } else if (w >= 992 && w < 1200) {
        setBools(false, false, false, true);
      } else if (w >= 1200) {
        setBools(false, false, false, false, true);
      }
    }

    function setBools(xs, sm, md, lg, xl) {
      $scope.isXS = xs || false;
      $scope.isSM = sm || false;
      $scope.isMD = md || false;
      $scope.isLG = lg || false;
      $scope.isXL = xl || false;
    }
  };
}]);
angular.module('vendorfuelApp').controller('AccountingController', ['$scope', '$rootScope', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', function ($scope, $rootScope, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
  //Controller instantiation and injection of the following: $scope and $rootScope (local and global scope), $http (used to make HTTP requests), Admin (VF Admin factory), ConfirmModal (VF modal to confirm actions), Settings (VF factory to update and retrieve settings)
  //SCOPE VARIABLES AND INITIALIZATION
  $rootScope.pageNum = 14;
  $rootScope.pageName = 'Accounting';
  $scope.loading = true;
  $scope.saving = false;
  $scope.saved = false;
  $rootScope.breadcrumbs = [{
    name: 'Accounting',
    state: null
  }]; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;

  $scope.link = function () {
    var req = {
      method: 'GET',
      url: Localized.apiUrl + '/admin/accounting/quickbooks/auth'
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (resp.authUrl) {
        window.open(resp.authUrl, '_blank', 'location=yes,scrollbars=no,status=no');
      }
    }, function (errResp) {
      Debug.log(errResp);
    });
  };

  $scope.unlink = function () {
    var req = {
      method: 'GET',
      url: Localized.apiUrl + '/admin/accounting/quickbooks/unlink'
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.localized.PushResponseMsg({
        'type': 'success',
        'message': 'Quickbooks has been unlinked.'
      });
    }, function (errResp) {
      Debug.log(errResp);
    });
  };
}]);
angular.module('vendorfuelApp').controller('AdminAccountsController', ['$scope', '$rootScope', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', function ($scope, $rootScope, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
  $rootScope.pageNum = 2;
  $rootScope.breadcrumbs = [{
    name: 'Admin Accounts',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.loading = false;
  $scope.loadingMore = false;
  $scope.searchTerm = '';
  $scope.showPassword = false;
  $scope.showPasswordConf = false;
  $scope.saving = false;
  $scope.searchParams = {};
  $scope.saved = false;
  $scope.activeTab = 0;
  $scope.editName = false;
  $scope.newAdmin = {};
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    'rpp': $scope.rppValues[0],
    'page': 1
  };
  $scope.adminAccountsEndpoint = Localized.apiUrl + '/admin/user/'; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils; //FUNCTIONS

  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    var req = {
      method: 'GET',
      url: $scope.adminAccountsEndpoint
    };

    switch (i) {
      case 0:
        //First tab selected
        req.url += 'list';
        req.params = $scope.searchParams;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.adminAccounts = resp.admin_users;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        $scope.loading = false;
        break;
    }
  };

  $scope.AddUser = function () {
    $scope.saving = true;
    var params = {};
    params.name = $scope.newAdmin.name;
    params.email = $scope.newAdmin.email;
    params.password = $scope.newAdmin.password;

    if ($scope.newAdmin.active === true) {
      params.active = 1;
    } else {
      params.active = 0;
    }

    var req = {
      method: 'POST',
      url: $scope.adminAccountsEndpoint + 'modify',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      console.log(resp);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.saving = false;
    });
  };

  $scope.UpdateUser = function () {
    $scope.saving = true;
    var params = {};

    if ($scope.selectedAccount.active === true) {
      params.active = 1;
    } else {
      params.active = 0;
    }

    params.password = $scope.selectedAccount.new_password;
    params.email = $scope.selectedAccount.email;
    params.name = $scope.selectedAccount.name;
    params.user_id = $scope.selectedAccount.id;
    var req = {
      method: 'POST',
      url: $scope.adminAccountsEndpoint + 'modify',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.saving = false;
    });
  };

  $scope.ChangeTab = function (tabIndex, accountIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedAccount = $scope.adminAccounts.data[accountIndex];

    if (!$scope.selectedAccount.deleted_at) {
      $scope.selectedAccount.active = true;
    } else {
      $scope.selectedAccount.active = false;
    }
  };

  $scope.ToggleShowPassword = function (type) {
    if (type === 'password') {
      $scope.showPassword = !$scope.showPassword;
    }

    if (type === 'conf') {
      $scope.showPasswordConf = !$scope.showPasswordConf;
    }
  };

  $scope.SearchAccounts = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.adminAccountsEndpoint + 'list',
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.adminAccounts = resp.admin_users;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  if ($scope.activeTab === null) {
    $scope.activeTab = 0;
  }
}]);
/**
 * @file The controller for the template editing admin page.
 * @author VendorFuel < info@vendorfuel.com >
 */

angular.module('vendorfuelApp').controller('AnguleditController', ['$scope', '$rootScope', '$state', 'Admin', 'Localized', 'Anguledit', 'Debug', 'Utils', '$sce', '$q', 'Settings', 'ConfirmModal', 'EditModal', 'AlertModal', 'WarningModal', function ($scope, $rootScope, $state, Admin, Localized, Anguledit, Debug, Utils, $sce, $q, Settings, ConfirmModal, EditModal, WarningModal) {
  $scope.warning = WarningModal;
  $scope.confirm = ConfirmModal;
  $scope.editKey = false;
  $rootScope.pageNum = 5;
  $rootScope.pageName = 'Template Editor';
  $scope.duplicateMessage = 'You already have a key with the same label!';
  $scope.admin = Admin;
  $scope.saving = false;
  $scope.addSuccess = '';
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.settings = Settings;
  $scope.anguledit = Anguledit;
  $scope.templateEndpoint = Localized.apiUrl + '/templates/';
  $scope.loading = true;
  $scope.saving = false;
  $scope.user = {
    loginEmail: '',
    loginPassword: ''
  };
  $rootScope.breadcrumbs = [{
    name: 'Template Editor',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.firstWarning = true;

  $scope.currentBranch = function () {
    if ($scope.settings.anguledit.saved.devBranchActive) {
      return 'DEV';
    } else if (!$scope.settings.anguledit.saved.devBranchActive) {
      return 'LIVE';
    }
  };

  $scope.LoginCallback = function () {
    $scope.loading = true;
    $scope.Load();
  };

  $scope.alerts = [];

  $scope.AddAlert = function (type, msg) {
    var tempAlert = {
      type: type,
      msg: $sce.trustAsHtml(msg)
    };
    $scope.alerts.push(tempAlert);
  };

  $scope.CloseAlert = function (index) {
    $scope.alerts.splice(index, 1);
  };

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  };

  $scope.activeTab = 0;
  $scope.remoteTemplates = {}; //Templates in the cloud

  $scope.localTemplates = {}; //Templates in the cache

  $scope.templates = {
    //Templates in the editors
    list: [],
    selected: null,
    newName: '',
    editingEnabled: false
  };
  $scope.template = {
    //selected template
    name: '',
    content: '',
    js: '',
    css: ''
  };
  $scope.anguledit = {
    previewPopup: true,
    components: [{
      name: 'Template',
      value: 0
    }, {
      name: 'Template Map',
      value: 1
    }, {
      name: 'Run',
      value: 2
    }, {
      name: 'Service',
      value: 3
    }, {
      name: 'Factory',
      value: 4
    }, {
      name: 'Directive',
      value: 5
    }, {
      name: 'Filter',
      value: 6
    }],
    selectedComponent: null
  };
  $scope.object = Object;
  $scope.templates = [];
  $scope.pages = {};
  $scope.newKey = ''; //public functions

  $scope.ChangeEdit = function (index) {
    var count = 0;
    $scope.keyMessage = '';

    for (var i = 0; i < $scope.templates.length; i++) {
      if ($scope.templates[i].editKey === true && $scope.templates[index].editKey === false) {
        count++;
        $scope.keyMessage = 'You are currently editing another key. You are only able to edit one key at a time.';
      } else if ($scope.templates[i].editKey === true && $scope.templates[index].editKey === true) {
        count = 0;
      }
    }

    if (count <= 0) {
      if ($scope.templates[index].isDuplicate === true) {
        $scope.templates[index].editKey = false;
      }

      $scope.templates[index].editKey = !$scope.templates[index].editKey;
    }
  };

  $scope.DuplicateKeyClass = function (isDuplicate) {
    return isDuplicate ? 'input-group-addon danger' : 'input-group-text';
  };

  $scope.RemoveTemplateKey = function (i) {
    $scope.templates.splice(i, 1);
    $scope.localized.PushResponseMsg({
      'type': 'success',
      'message': 'Map Successfully Removed'
    });
  };

  $scope.AddKey = function (newKey) {
    newKey = Utils.cleanKey(newKey);
    var newArray = Object.values($scope.templates);

    for (var i = 0; i < newArray.length; i++) {
      var obj = newArray[i];

      if (obj.key === newKey) {
        return $scope.matchingKeys();
      }
    }

    $scope.templates.push({
      key: newKey,
      url: '',
      editKey: false
    });
    $scope.localized.PushResponseMsg({
      'type': 'success',
      'message': 'Key Successfully Saved'
    });
  };

  $scope.updateIndex = function (index) {
    $scope.ChangeEdit(index);
  };

  $scope.verifyDuplicate = function () {
    var sorted, i;
    sorted = $scope.templates.concat().sort(function (a, b) {
      if (a.key > b.key) {
        return 1;
      }

      if (a.key < b.key) {
        return -1;
      }

      return 0;
    });

    for (i = 0; i < $scope.templates.length; i++) {
      sorted[i].isDuplicate = sorted[i - 1] && sorted[i - 1].key === sorted[i].key || sorted[i + 1] && sorted[i + 1].key === sorted[i].key;
    }
  };

  $scope.checkIndexes = function () {
    for (var i = 0; i < $scope.templates.length; i++) {
      if ($scope.templates[i].isDuplicate === true) {
        return true;
      } else {
        return false;
      }
    }
  };

  $scope.SaveMap = function (i) {
    var templateMap = {};
    $scope.saving = true;
    angular.forEach($scope.templates, function (template, index) {
      angular.forEach($scope.pages, function (page, key) {
        if (page.url === template.url) {
          templateMap[Utils.cleanKey(template.key)] = {
            url: page.url,
            id: page.id,
            title: page.title,
            template: template.key
          };
        }
      });
    });
    var params = {
      map: JSON.stringify(templateMap)
    };
    var req = {
      method: 'POST',
      url: $scope.localized.wpRestUrl + '/vendorfuel/pages',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      Debug.log('my resp', resp);
    }, function (errResp) {
      Debug.log('error', errResp);
    }).finally(function () {
      $scope.saving = false;
      $scope.localized.PushResponseMsg({
        'type': 'success',
        'message': 'Map Successfully Saved'
      });
    });
  };

  $scope.returnToDashboard = function () {
    $state.go('dashboard');
  };

  $scope.warningAnguledit = function () {
    if ($scope.firstWarning) {
      console.log('COnfirm Modal: ', ConfirmModal);
      var callback = {
        confirm: $scope.firstWarning = false,
        cancel: $scope.returnToDashboard
      };
      ConfirmModal.Show(callback, 'Heads Up!', 'It looks like you\'re getting ready to make changes to the active templates. <br>We strongly recommend you do not make changes to these templates unless you are familiar/proficient with <b>AngularJS 1.7.5</b>. Making changes to the active templates can potentially <b style="color:#FF0000;">break</b> your site. Please make sure to have a backup of each template on hand before saving any changes/modifications.', 'Dashboard', 'I Understand', 'static', 1);
    }
  };

  $scope.matchingKeys = function () {
    var callback = {
      warning: $scope.random
    };
    WarningModal.Show(callback, 'Keys', '<strong>Duplicate keys detected:</strong> Each Key should have unique name property.', null, 'static');
  };

  $scope.GetPages = function () {
    var req = {
      method: 'GET',
      url: $scope.localized.wpRestUrl + '/vendorfuel/pages'
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.pages = resp[1];
      console.log('response to see where what i get  ', $scope.pages);
      angular.forEach(resp[0], function (val, key) {
        $scope.templates.push({
          key: Utils.cleanKey(key),
          id: val.id,
          template: val.template,
          title: val.title,
          url: val.url,
          editKey: false
        });
      });
      console.log('Response: ', resp);
      console.log('Templates: ', $scope.templates);
    }, function (errResp) {
      Debug.log('error', errResp);
    }).finally(function () {});
  };

  $scope.ContentEditorLoaded = function (e) {
    $scope.contentEditor = e;
    editorConfig(e);
  };

  $scope.ContentEditorChanged = function (e) {};

  $scope.JavascriptEditorLoaded = function (e) {
    $scope.javascriptEditor = e;
    editorConfig(e);
  };

  $scope.JavascriptEditorChanged = function (e) {};

  $scope.CssEditorLoaded = function (e) {
    $scope.cssEditor = e;
    editorConfig(e);
  };

  $scope.CssEditorChanged = function (e) {};

  $scope.SelectTemplate = function () {
    var params = {
      template_name: $scope.templates.selected.name
    };
    var data = {};
    $scope.utils.HttpGet($scope.localized.wpRestUrl + '/histories', params, data).then(function (resp) {
      if (resp) {
        $scope.templates.selected.edits = resp;
      }

      $scope.templates.editingEnabled = true;
    });
  };

  $scope.Load = function () {
    $scope.loading = true;

    if (Settings.anguledit.saved.devBranchActive) {
      loadTemplates(true).then(function (templateList) {
        $scope.templates.list = templateList;
        $scope.loading = false;
      });
    } else {
      loadTemplates(false).then(function (templateList) {
        $scope.templates.list = templateList;
        $scope.CacheSaveTemplates($scope.templates.list);
        $scope.loading = false;
      });
    }
  };

  $scope.SaveTemplate = function () {
    $scope.saving = true;
    var params = {};
    var data = {
      name: $scope.templates.selected.name,
      content: $scope.templates.selected.content,
      js: $scope.templates.selected.js
    };

    if (Settings.anguledit.saved.devBranchActive) {
      $scope.CacheSaveTemplate($scope.templates.selected);
    } else {
      $scope.utils.HttpPut($scope.localized.apiUrl + '/templates/' + $scope.templates.selected.id, params, data).then(function (resp) {
        if (resp.minJS !== undefined) {
          $scope.SaveMinifiedJS(resp.minJS);
        }

        $scope.CacheSaveTemplate($scope.templates.selected);
      });
    }
  };

  $scope.DeleteTemplate = function (template) {
    $scope.saving = true;
    var req = {
      method: 'DELETE',
      url: $scope.templateEndpoint,
      data: template
    };
    req.url += template.id;
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.saving = false;
    });
  };

  $scope.CacheSaveTemplates = function (templates) {
    var params = {};
    var data = {
      templates: templates,
      map: createMap(templates)
    };
    $scope.utils.HttpPost($scope.localized.wpRestUrl + '/templates', params, data);
  };

  $scope.SaveMinifiedJS = function (templateJS) {
    var params = {};
    var data = {
      templateJS: templateJS
    };
    $scope.utils.HttpPut($scope.localized.wpRestUrl + '/templatesJS', params, data).then(function (resp) {
      $scope.AddAlert('success', '<strong>Success!</strong> Templates Minified JS saved.');
      $scope.saving = false;
    });
  };

  $scope.CacheSaveTemplate = function (template) {
    var params = {};
    var data = {
      template: {
        id: template.id,
        bse_id: template.base_id,
        name: template.name,
        content: template.content,
        js: template.js
      }
    };
    $scope.utils.HttpPut($scope.localized.wpRestUrl + '/template', params, data).then(function (resp) {
      $scope.AddAlert('success', '<strong>Success!</strong> Template saved.');

      if (resp.edits) {
        $scope.templates.selected.edits = resp.edits;
      }

      $scope.saving = false;
    });
  };

  $scope.AddTemplate = function () {
    $scope.templates.selected = null;
    var tempTemplate = {
      base_id: null,
      content: $scope.templates.selected || '<!-- Template Content -->',
      created_at: timestamp(),
      id: null,
      js: '',
      name: $scope.templates.newName,
      updated_at: timestamp()
    };
    var params = {};
    var data = {
      name: tempTemplate.name,
      content: tempTemplate.content
    };
    $scope.utils.HttpPost($scope.localized.apiUrl + '/templates', params, data).then(function (response) {
      console.log(response);
      tempTemplate.id = response.template.id;
      $scope.templates.list.push(tempTemplate);
      $scope.templates.newName = '';
      $scope.CacheSaveTemplate(tempTemplate);
      $scope.templates.selected = tempTemplate;
      $scope.templates.editingEnabled = true;

      if (response.minJS !== undefined) {
        $scope.SaveMinifiedJS(response.minJS);
      }
    });
  };

  $scope.RestoreEditCallback = function () {
    var params = {
      template_name: $scope.templates.selected.name,
      timestamp: $scope.templates.selected.edits[$scope.tempRestoreIndex]
    };
    var data = {};
    $scope.utils.HttpGet($scope.localized.wpRestUrl + '/history', params, data).then(function (resp) {
      $scope.templates.selected.content = resp.template.content;
      $scope.templates.selected.js = resp.template.js;
    });
  };

  $scope.RestoreEditConfirm = function () {
    $scope.tempRestoreIndex = $scope.templates.selected.edits.indexOf($scope.templates.selected.editRestoreIndex);
    var callback = {
      confirm: $scope.RestoreEditCallback
    };
    ConfirmModal.Show(callback, 'Restore Edit', 'Are you sure you would like to restore the edit saved at ' + $scope.templates.selected.edits[$scope.tempRestoreIndex].date + '? <br/><br/><strong>NOTE: Any unsaved changes will be <span class=\'text-danger\'>lost</span>!</strong>', 'Cancel', 'Confirm', true, 1);
  };

  $scope.ChangeEditorTheme = function (theme) {
    if (theme === 'dark') {
      $scope.contentEditor.setTheme('ace/theme/monokai');
      $scope.javascriptEditor.setTheme('ace/theme/monokai');
      $scope.cssEditor.setTheme('ace/theme/monokai');
    } else {
      $scope.contentEditor.setTheme('ace/theme/chrome');
      $scope.javascriptEditor.setTheme('ace/theme/chrome');
      $scope.cssEditor.setTheme('ace/theme/chrome');
    }
  };

  $scope.TabChanged = function (i) {
    if ($scope.contentEditor && $scope.javascriptEditor && $scope.cssEditor) {
      switch (i) {
        case 0:
          $scope.contentEditor.focus();
          break;

        case 1:
          $scope.javascriptEditor.focus();
          break;

        case 2:
          $scope.cssEditor.focus();
          break;
      }
    }
  };

  $scope.SwitchBranchConfirmCallback = function () {
    $scope.templates.editingEnabled = false;
    $scope.templates.selected = null;
    $scope.settings.anguledit.Set().then(function () {
      $scope.Load();
    });
  };

  $scope.SwitchBranchCancelCallback = function () {
    Settings.anguledit.saved.devBranchActive = !Settings.anguledit.saved.devBranchActive;
  };

  $scope.SwitchBranchConfirm = function () {
    var toBranch = 'LIVE';
    var fromBranch = 'DEVELOPMENT';

    if (Settings.anguledit.saved.devBranchActive) {
      toBranch = 'DEVELOPMENT';
      fromBranch = 'LIVE';
    }

    var callback = {
      confirm: $scope.SwitchBranchConfirmCallback,
      cancel: $scope.SwitchBranchCancelCallback
    };
    ConfirmModal.Show(callback, 'Switch branch', 'Are you sure you would like to switch from the ' + fromBranch + ' branch, to the ' + toBranch + ' branch? <br/><br/><strong>NOTE: Any unsaved changes will be <span class=\'text-danger\'>lost</span>!</strong>', 'Cancel', 'Confirm', true, 1);
  };

  $scope.SyncBranchesConfirmCallback = function (params) {
    var pull = params.pull;
    var progressCount = 0;
    var progressMax = $scope.templates.list.length * 4;
    $scope.progressStatusText = 'Preparing data for sync';
    progressCount = progressMax / 4;
    $scope.progressPercentage = progressCount / progressMax;
    $scope.loading = true;
    $scope.saving = true;
    $scope.utils.HttpGet($scope.localized.wpRestUrl + '/sync-caches', params).then(function (resp) {
      $scope.templates.list = resp.cache.templates;

      if (pull) {
        progressCount = progressMax;
        $scope.progressPercentage = progressCount / progressMax;
        $scope.templates.editingEnabled = false;
        $scope.templates.selected = null;
        $scope.saving = false;
        $scope.Load();
      } else {
        $scope.progressStatusText = 'Syncing local dev and live caches';
        progressCount = progressMax / 2 + 1;
        $scope.progressPercentage = progressCount / progressMax;
        var templates = resp.cache.templates;
        var params = {};
        var promises = [];
        var promise = {};
        angular.forEach(templates, function (template) {
          var data = {
            content: template.content,
            js: template.js
          };
          promise = $scope.utils.HttpPut($scope.localized.apiUrl + '/templates/' + template.id, params, data).then(function (resp) {
            if (progressCount < progressMax / 4 * 3) {
              progressCount = progressMax / 4 * 3 + 2;
            }

            if (resp.minJS !== undefined) {
              $scope.SaveMinifiedJS(resp.minJS);
            }

            $scope.progressStatusText = 'Syncing local cache with the cloud';
            progressCount++;
            $scope.progressPercentage = progressCount / progressMax;
          });
          promises.push(promise);
        });
        $q.all(promises).finally(function () {
          $scope.templates.editingEnabled = false;
          $scope.templates.selected = null;
          $scope.saving = false;
          $scope.Load();
        });
      }
    });
  };
  /**
   * Will pull & overwrite with the latest JS code from the release branch
   * @function
  */


  $scope.pullJSUpdates = function () {
    ConfirmModal.Show({
      confirm: function confirm() {
        $scope.utils.HttpPost($scope.localized.apiUrl + '/templates/update-js-to-master').then(function (resp) {
          /**
           * Load updated templates.
           * @todo Return templates straight from pull route. Pass to load? New Helper function?
           */
          if (resp.minJS !== undefined) {
            $scope.SaveMinifiedJS(resp.minJS);
          }

          $scope.Load();
        });
      }
    }, 'Pull Latest JS Updates', 'Are you sure you want to pull the latest JS Updates? \
      <br><strong>This will overwrite any changes you\'ve made to JS. HTML Content will not be touched.</strong>', 'Cancel', 'Confirm', true, 1);
  };

  $scope.SyncBranchesConfirm = function (pull) {
    var toBranch = 'LIVE';
    var fromBranch = 'DEVELOPMENT';
    var action = 'push';

    if (pull) {
      toBranch = 'DEVELOPMENT';
      fromBranch = 'LIVE';
      action = 'pull';
    }

    var callback = {
      confirm: $scope.SyncBranchesConfirmCallback,
      params: {
        pull: pull
      }
    };
    ConfirmModal.Show(callback, 'Sync branches', 'Are you sure you would like to ' + action + ' the ' + fromBranch + ' branch to the ' + toBranch + ' branch? <br/><br/><strong>NOTE: Any unsaved changes will be <span class=\'text-danger\'>lost</span>, the ' + toBranch + ' branch will be <span class=\'text-danger\'>overwritten</span>, and this <span class=\'text-danger\'>cannot be undone</span>.</strong>', 'Cancel', 'Confirm', true, 1);
  };

  $scope.ModalEditedCallback = function (params, value) {
    Debug.log('Modal Edit Callback', Settings.anguledit.saved.template_map[params.index], value);
  };

  $scope.SaveEditHistoryCount = function () {
    console.log($scope.settings.anguledit.saved);
    $scope.settings.anguledit.Set();
    $scope.localized.PushResponseMsg({
      'type': 'success',
      'message': 'Save History Successfully Saved'
    });
    $scope.addSuccess = Localized.GetResponseMsgs();
  };

  $scope.EditTemplateMapping = function (url, i) {
    var valueObject = {
      type: 0,
      placeholder: 'Template URL',
      value: url
    };
    var callback = {
      confirm: $scope.ModalEditedCallback,
      params: {
        index: i
      }
    };
    EditModal.Show(callback, valueObject, 'Edit Template Mapping', '', 'Cancel', 'Save', true, 1);
  }; //Private functions


  function loadTemplates(local, params) {
    params = params || {};
    var endpoint = $scope.localized.apiUrl;

    if (local) {
      endpoint = $scope.localized.wpRestUrl;
    }

    var promise = $scope.utils.HttpGet(endpoint + '/templates', params).then(function (response) {
      if (response) {
        return response.templates;
      }
    });
    return promise;
  }

  function RandomInterval(min, max) {
    return Math.random() * (max - min) + min;
  }

  function timestamp() {
    var tempDate = new Date(),
        tempDay = addLeadingZero(tempDate.getDate()),
        tempMonth = addLeadingZero(tempDate.getMonth() + 1),
        tempYear = tempDate.getFullYear(),
        tempHours = tempDate.getHours();
    var tempMinutes = tempDate.getMinutes();
    var tempSeconds = tempDate.getSeconds();
    return [tempYear, tempMonth, tempDay].join('-') + ' ' + [tempHours, tempMinutes, tempSeconds].join(':');
  }

  function addLeadingZero(item) {
    var temp = '0' + item;
    return temp.slice(-2);
  }

  function getLast(arr) {
    return arr[arr.length - 1];
  }

  function createMap(templates) {
    var tempMap = {};
    angular.forEach(templates, function (template, index) {
      tempMap[template.name] = index;
    });
    return tempMap;
  }

  function editorConfig(e) {
    e.commands.addCommand({
      name: 'save',
      bindKey: {
        win: 'Ctrl-S',
        mac: 'Cmd-S'
      },
      exec: function exec(e) {
        $scope.SaveTemplate();
      }
    });
  } //Initialize view


  Settings.anguledit.Get().then(function () {
    if ($scope.admin.Authed()) {
      $scope.Load();
    } else {
      $scope.loading = false;
    }
  });
  $scope.GetPages();
}]);
angular.module('vendorfuelApp').controller('BillingController', ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'Tenant', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', function ($scope, $rootScope, $state, $stateParams, Admin, Tenant, ConfirmModal, Settings, Debug, Utils, Localized) {
  //Controller instantiation and injection of the following: $scope and $rootScope (local and global scope), $http (used to make HTTP requests), Admin (VF Admin factory), ConfirmModal (VF modal to confirm actions), Settings (VF factory to update and retrieve settings)
  //SCOPE VARIABLES AND INITIALIZATION
  $rootScope.pageNum = 14;
  $rootScope.pageName = 'Billing';
  $scope.loading = true;
  $scope.saving = false;
  $scope.saved = false;
  $scope.activeTab = parseInt($stateParams.activeTab);
  $rootScope.breadcrumbs = [{
    name: 'VendorFuel Subscription',
    state: null
  }]; //FACTORIES

  $scope.admin = Admin;
  $scope.tenant = Tenant;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.loadingWallet = false;
  $scope.loadedWallet = false;
  $scope.walletUrl = null;

  if ($stateParams.id) {
    updateBilling($stateParams.id);
  }

  function updateBilling(id) {
    $scope.settings.billing.saved.cardId = id;
    delete $scope.settings.billing.saved.card;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/tenant/billing/update',
      data: $scope.settings.billing.saved
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      Debug.log(resp);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  }

  $scope.retrieveWalletUrl = function () {
    if (!$scope.loadingWallet && !$scope.loadedWallet) {
      $scope.loadingWallet = true;
      $scope.loadedWallet = false;
      var req = {
        method: 'GET',
        url: Localized.apiUrl + '/tenant/billing/wallet/url',
        params: {
          'return_url': Localized.apiUrl + '/tenant/PayFabricReturn/'
        }
      };
      Utils.GetHttpPromise(req).then(function (resp) {
        console.log(resp);
        $scope.walletUrl = resp.url;
        var win = window.open($scope.walletUrl, '_blank', 'channelmode=yes,fullscreen=no,menubar=no,titlebar=no,toolbar=no,status=no,width=800,height=800');
        var timer = setInterval(function () {
          if (win.closed) {
            clearInterval(timer);
            $scope.LoadBillingSettings();
          }
        }, 1000);
        $scope.loadedWallet = true;
      }, function (errResp) {
        Debug.log(errResp);
      }).finally(function () {
        $scope.loadingWallet = false;
      });
    }
  }; //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true;
    $scope.LoadBillingSettings();
  };

  $scope.TransitionState = function () {
    $state.transitionTo('settings', {
      activeTab: $scope.activeTab
    }, {
      location: true,
      inherit: true,
      relative: $state.$current,
      notify: false
    });
  };

  $scope.SubmitUpdate = function (i, form) {
    $scope.UpdateBillingSettings(form);
  };

  function getSettings(tab) {
    var promise = tab.Get().then(function successCallback(response) {
      console.log('!!', tab.saved);
      $scope.loading = false;
    }, function errorCallback(response) {
      $scope.loading = false;
    });
    return promise;
  }

  function updateSettings(tab, form) {
    Settings.errors = {};
    $scope.saving = true;
    $scope.saved = false;
    $scope.cancelled = false;
    var promise = tab.Set().then(function successCallback(response) {
      $scope.saving = false;
      $scope.saved = Object.keys(Settings.errors).length === 0;
      form.$setPristine();
      form.$setUntouched();
    }, function errorCallback(response) {
      $scope.saving = false;
    });
    return promise;
  }

  $scope.LoadGatewaysSettings = function () {
    $scope.loading = true;

    if ($scope.admin.Authed()) {
      getSettings(Settings.gateways);
    } else {
      $scope.loading = false;
    }
  };

  $scope.LoadBillingSettings = function (r) {
    if (r === undefined) {
      r = false;
    }

    $scope.loading = true;

    if ($scope.tenant.Authed()) {
      getSettings(Settings.billing);
    } else {
      $scope.loading = false;
    }
  };

  $scope.UpdateGeneralSettings = function (form) {
    if ($scope.settings.general.saved.apiUrl === '' || $scope.settings.general.saved.apiKey === '') {
      Admin.Logout();
    }

    updateSettings(Settings.general, form);
  };

  $scope.UpdateConversionsSettings = function (form) {
    updateSettings(Settings.conversions, form);
  };

  $scope.UpdateImageSettings = function (form) {
    updateSettings(Settings.image, form);
  };

  $scope.UpdateGatewaysSettings = function (form) {
    updateSettings(Settings.gateways, form);
  };

  $scope.UpdateBillingSettings = function (form) {
    updateSettings(Settings.billing, form).then(function () {
      getSettings(Settings.billing);
    });
  };

  $scope.CancelSubscription = function () {
    $scope.saving = true;
    $scope.saved = false;
    $scope.cancelled = false;
    Settings.billing.cancelling = true;
    Settings.billing.Cancel().then(function () {
      getSettings(Settings.billing).then(function () {
        $scope.saving = false;

        if (Settings.billing.saved.status !== 'active') {
          $scope.cancelled = true;
          Settings.billing.cancelling = false;
        }
      });
    });
  };

  $scope.SubscriptionNotcancelled = function () {
    Debug.log('CANCELLATION NOT CONFIRMED!');
  };

  $scope.ConfirmCancelSubscription = function () {
    var callback = {
      confirm: $scope.DoubleCancellation,
      cancel: $scope.SubscriptionNotcancelled
    };
    ConfirmModal.Show(callback, 'Are you sure you want to cancel your subscription?', 'If there is anything we can do to change your mind please let us know.', 'No', 'Yes');
  };

  $scope.DoubleCancellation = function () {
    var callback = {
      confirm: $scope.CancelSubscription,
      cancel: $scope.SubscriptionNotcancelled
    };
    ConfirmModal.Show(callback, 'Are you absolutely sure?', 'We will be sorry to see you go...', 'No', 'Yes');
  };

  $scope.LoadBillingSettings();
}]);
angular.module('vendorfuelApp').controller('BrandingController', ['$scope', 'Admin', 'Localized', 'Debug', 'Utils', '$rootScope', function ($scope, Admin, Localized, Debug, Utils, $rootScope) {
  $rootScope.pageNum = 13;
  $rootScope.pageName = 'Branding';
  $scope.loading = true;
  $scope.saving = false;
  $scope.saved = false;
  $rootScope.breadcrumbs = [{
    name: 'Branding',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.booleanOptions = [{
    value: true,
    title: 'Yes'
  }, {
    value: false,
    title: 'No'
  }];
  $scope.pageTitleOptions = [{
    value: 'block !important',
    title: 'Yes'
  }, {
    value: 'none !important',
    title: 'No'
  }];
  $scope.brandingOptions = [{
    option: 'themeColors',
    title: 'Theme Colors'
  }, {
    option: 'fontColors',
    title: 'Font Colors'
  }, {
    option: 'menuStyles',
    title: 'Menu Styling'
  }, {
    option: 'buttonStyles',
    title: 'Button Styles'
  }, {
    option: 'miscStyles',
    title: 'More Settings'
  }];
  $scope.selectedOption = $scope.brandingOptions[0]; //FACTORIES

  $scope.admin = Admin;
  $scope.utils = Utils;
  $scope.branding = Localized.branding;
  $scope.localized = Localized; // $scope.logoUrlEndpoint = `${Localized.wpRestUrl}/branding`;

  $scope.logoUrlEndpoint = Localized.apiUrl + '/admin/branding';
  $scope.branding = {
    themeColor: {
      titleVal: 'block !important'
    },
    url: {
      primary: '',
      alternate: '',
      placeholder: ''
    },
    miscStyles: {
      showCards: true,
      showContainerCards: true
    }
  };

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  };

  $scope.getBranding = function () {
    $scope.loading = true;
    var wpReq = {
      method: 'GET',
      url: Localized.wpRestUrl + '/branding'
    };
    Utils.GetHttpPromise(wpReq).then(function (resp) {
      if (resp.themeColor) {
        $scope.branding.themeColor = resp.themeColor;
      }

      if (resp.miscStyles) {
        $scope.branding.miscStyles = resp.miscStyles;
      } else {
        $scope.branding.miscStyles = {
          showCards: true,
          showContainerCards: true
        };
      }

      if (resp.url && Object.keys(resp.url).length >= 1) {
        $scope.branding.url = {
          primary: resp.url.primary,
          alternate: resp.url.alternate,
          placeholder: resp.url.palceholder
        };
      } else {
        $scope.branding.url = {
          primary: '',
          alternate: '',
          placeholder: ''
        };
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    }); // var req = {
    //   method: "GET",
    //   url: $scope.logoUrlEndpoint
    // };
    // Utils.GetHttpPromise(req).then(function(resp) {
    //       // $scope.logoURL = resp.data.url;
    //     Debug.log("Resp: ", resp);
    //   },
    //   function(errResp) {
    //     Debug.log(errResp);
    //   }
    // ).finally(function() {
    //   $scope.loading = false;
    // });
  };

  $scope.getBranding();

  $scope.submit = function () {
    $scope.saving = true;
    var params = $scope.branding.themeColor;
    var req = {
      method: 'POST',
      url: $scope.logoUrlEndpoint,
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      var req2 = {
        method: 'POST',
        url: Localized.wpRestUrl + '/vendorfuel/saveBrandCss',
        data: {
          css: resp.css
        }
      };
      Utils.GetHttpPromise(req2).then(function (resp2) {});
      var req3 = {
        method: 'POST',
        url: Localized.wpRestUrl + '/branding',
        data: {
          'branding': $scope.branding
        }
      };
      Utils.GetHttpPromise(req3).then(function (resp2) {
        console.log('Third Resp:', resp2);
      });
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.saving = false;
      $scope.localized.PushResponseMsg({
        'type': 'success',
        'message': 'Branding Successfully Updated'
      });
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.CheckImageLength = function () {
    if ($scope.activeTab === 2) {
      if ($scope.selectedProduct.images && Object.keys($scope.selectedProduct.images).length > 1) {
        if (Object.keys($scope.selectedProduct.images).length >= 4) {
          $scope.slides = 3;
          $scope.scrollSlides = 3;
        } else {
          $scope.slides = Object.keys($scope.selectedProduct.images).length - 1;
          $scope.scrollSlides = 1;
        }
      } else {
        $scope.slides = 1;
        $scope.scrollSlides = 2;
      }
    } else if ($scope.activeTab === 1) {
      if ($scope.newProduct.images && Object.keys($scope.newProduct.images).length > 1) {
        if (Object.keys($scope.newProduct.images).length >= 4) {
          $scope.slides = 3;
          $scope.scrollSlides = 3;
        } else {
          $scope.slides = Object.keys($scope.newProduct.images).length - 1;
          $scope.scrollSlides = 1;
        }
      } else {
        $scope.slides = 1;
        $scope.scrollSlides = 2;
      }
    }
  };

  $scope.OpenMediaFrame = function (image) {
    var file_frame = wp.media({
      title: 'Select or Upload Logo image',
      library: {
        type: 'image'
      },
      button: {
        text: 'Select'
      },
      multiple: false
    });
    file_frame.on('select', function () {
      $scope.$apply(function () {
        $scope.attachment = file_frame.state().get('selection').first().toJSON();
        $scope.removingImage = true;

        if (image === 'primary') {
          $scope.branding.url.primary = $scope.attachment.url;
        } else if (image === 'alternate') {
          $scope.branding.url.alternate = $scope.attachment.url;
        } else if (image === 'placeholder') {
          $scope.branding.url.placeholder = $scope.attachment.url;
        }

        $scope.CheckImageLength();
      });
    });
    file_frame.open();
  };
}]);
angular.module('vendorfuelApp').controller('CatalogBannersController', ['$scope', '$rootScope', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', function ($scope, $rootScope, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
  $rootScope.pageNum = 4;
  $scope.object = Object;
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: 'catalog'
  }, {
    name: 'Banners',
    state: null
  }];
  $scope.loading = false;
  $scope.loadingMore = false;
  $scope.searchTerm = '';
  $scope.addSuccess = '';
  $scope.bannerAreaEndpoint = Localized.apiUrl + '/admin/banner-areas/';
  $scope.bannerEndpoint = Localized.apiUrl + '/admin/banner/';
  $scope.rppValues = [15, 30, 50, 100];
  $scope.per_page = $scope.rppValues[0];
  $scope.searchParams = {
    q: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.newBannerArea = {};
  $scope.newBanner = {};
  $scope.sortAscending = true;
  $scope.selectedBannerArea = null;
  $scope.selectedBanner = null;
  $scope.tinymceOptions = {
    inline: false,
    theme: 'modern',
    skin: 'lightgray',
    plugins: 'advlist autolink link image lists charmap print preview fullscreen code',
    toolbar: 'undo redo | styleselect | bold italic | link image alignleft aligncenter alignright | preview code | fullscreen'
  }; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  }; //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    var req = {
      method: 'GET',
      url: $scope.bannerAreaEndpoint
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.bannerAreas = resp.banner_areas;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        if ($scope.selectedBannerArea) {
          $scope.newBanner.area_id = $scope.selectedBannerArea.area_id;
        }

        $scope.loading = false;
        break;

      case 3:
        req.url += $scope.selectedBannerArea.area_id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedBannerArea = resp.banner_area;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 4:
        $scope.loading = false;
        break;
    }
  };

  $scope.AddBanner = function () {
    $scope.addingBanner = true;
    var req = {
      method: 'POST',
      url: $scope.bannerEndpoint + 'modify',
      data: $scope.newBanner
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      console.log('Banner Added: ', resp);

      if (resp.errors.length <= 0) {
        $scope.activeTab = 3;
        $scope.newBanner = {};
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.addingBanner = false;
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.AddBannerArea = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.bannerAreaEndpoint,
      data: $scope.newBannerArea
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (!resp.errors.length) {
        $scope.selectedBannerArea = {
          area_id: resp.area_id
        };
        $scope.activeTab = 3;
        $scope.newBannerArea = {};
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.ChangeTab = function (tabIndex, index) {
    $scope.activeTab = tabIndex;
    $scope.selectedBannerArea = $scope.bannerAreas.data[index];
  };

  $scope.ChangeBannerTab = function (tabIndex, index) {
    $scope.activeTab = tabIndex;
    $scope.selectedBanner = $scope.selectedBannerArea.banners[index];
  };

  $scope.RemoveBanner = function () {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var params = {
          bid: $scope.selectedBanner.banner_id
        };
        var req = {
          method: 'POST',
          url: $scope.bannerEndpoint + 'remove',
          data: params
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          if (resp.errors.length <= 0) {
            $scope.selectedBanner = {};
            $scope.activeTab = 3;
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
      },
      cancel: function cancel() {
        return;
      }
    };
    ConfirmModal.Show(callback, 'Delete Banner?', 'This will completely remove the banner from the store. This action cannot be undone.', 'Back', 'DELETE');
  };

  $scope.RemoveBannerArea = function () {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var req = {
          method: 'DELETE',
          url: $scope.bannerAreaEndpoint + $scope.selectedBannerArea.area_id
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedBannerArea = null;
          $scope.activeTab = 0;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
      },
      cancel: function cancel() {
        return;
      }
    };
    ConfirmModal.Show(callback, 'Delete Banner Area?', 'This will delete the area and all banners associated with it. This cannot be undone.', 'Back', 'DELETE');
  };

  $scope.SearchResults = function (resp) {
    //callback that is used by the search modal
    if ($scope.activeTab === 2) {
      $scope.addParams.products = [];
      resp.forEach(function (item) {
        $scope.addParams.products.push(item.value);
      });
    }

    if ($scope.activeTab === 3) {
      $scope.editedProducts = [];
      resp.forEach(function (item) {
        $scope.editedProducts.push(item.value.product_id);
      });
    }
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchBannerAreas($scope.searchParams.page);
  };

  $scope.SearchBannerAreas = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.bannerAreaEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.bannerAreas = resp.banner_areas;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.UpdateBannerArea = function () {
    $scope.updatingArea = true;
    var req = {
      method: 'PUT',
      url: $scope.bannerAreaEndpoint + $scope.selectedBannerArea.area_id,
      data: $scope.selectedBannerArea
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.updatingArea = false;
    });
  };

  $scope.UpdateBannerContent = function () {
    $scope.updatingBanner = true; // var params = {};

    var params = $scope.selectedBanner;
    params.bid = $scope.selectedBanner.banner_id;
    var req = {
      method: 'POST',
      url: $scope.bannerEndpoint,
      data: params
    };
    req.url += 'modify';
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.updatingBanner = false;
    });
  };
}]);
angular.module('vendorfuelApp').controller('CatalogCategoriesController', ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', function ($scope, $rootScope, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, SearchModal) {
  $rootScope.pageNum = 4;
  $scope.searchTerm = '';
  $scope.filterBy = '';
  $scope.activeTab = parseInt($stateParams.activeTab);
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: 'catalog',
    url: null
  }, {
    name: 'Categories',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.loading = false;
  $scope.loadingProducts = false;
  $scope.categoryHierarchyEndpoint = Localized.apiUrl + '/admin/category/hierarchy/';
  $scope.categoryEndpoint = Localized.apiUrl + '/admin/category/';
  $scope.productEndpoint = Localized.apiUrl + '/admin/products/';
  $scope.selectedCategory = null;
  $scope.searchParams = {
    'rpp': 15,
    'page': 1
  };
  $scope.editName = false;
  $scope.showChanges = false;
  $scope.object = Object;
  $scope.editedProducts = [];
  $scope.addParams = {};
  $scope.rppValues = [15, 30, 50, 100];
  $scope.per_page = $scope.rppValues[0];
  $scope.sortAscending = true; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.addSuccess = '';

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
    return true;
  }; //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TransitionState = function () {
    $state.transitionTo('catalog-categories', {
      activeTab: $scope.activeTab
    }, {
      location: true,
      inherit: true,
      relative: $state.$current,
      notify: false
    });
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    $scope.editedProducts = [];
    $scope.showChanges = false;
    var req = {
      method: 'GET',
      url: $scope.categoryEndpoint
    };

    switch (i) {
      case 0:
        $scope.addSuccess = '';
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.categories = resp.categories;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        req.url += $scope.selectedCategory.cat_id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedCategory = resp.category;

          if ($scope.selectedCategory.parent_category) {
            $scope.selectedCategory.parentCategoryTitle = $scope.selectedCategory.parent_category.title;
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.CheckCategory();
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.syncCategoryPosts = function () {
    var params = {};
    var data = {};
    $scope.utils.HttpGet($scope.localized.wpRestUrl + '/syncCategoryPosts', params, data).then(function (resp, $scope) {
      $scope.saving = false;
    });
  };

  $scope.generateSlugs = function () {
    var req = {
      method: 'POST',
      url: $scope.categoryEndpoint + 'slug/generate'
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.AddCategory = function () {
    $scope.loading = true;
    var params = {
      'title': $scope.addParams.title,
      'parent_id': $scope.addParams.parent_id,
      'avatax_tax_code': $scope.addParams.avatax_tax_code,
      'unspsc': $scope.addParams.unspsc,
      'slug': $scope.addParams.slug,
      'image': $scope.addParams.img_url,
      'products': []
    };
    angular.forEach($scope.addParams.products, function (value, key) {
      params.products.push(value.value.product_id);
    });
    params.image = $scope.addParams.img_url;
    var req = {
      method: 'POST',
      url: $scope.categoryEndpoint,
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      // $scope.categories = resp.categories;
      if (!resp.errors.length) {
        $scope.addParams = {};
        $scope.addSuccess = Localized.GetResponseMsgs();
        $scope.selectedCategory = resp.category;
        $scope.activeTab = 2;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.ChangeView = function () {
    $scope.viewProducts = !$scope.viewProducts;
  };

  $scope.CheckCategory = function () {
    if ($scope.selectedCategory.products.data.length >= 1) {
      $scope.viewProducts = true;
    } else {
      $scope.viewProducts = false;
    }
  };

  $scope.ChangeEdit = function () {
    $scope.editName = !$scope.editName;
  };

  $scope.ChangeTab = function (tabIndex, categoryIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedCategory = $scope.categories.data[categoryIndex];
  };

  $scope.DeleteCategory = function (id) {
    $scope.deleting = true;
    var req = {
      method: 'DELETE',
      url: $scope.categoryEndpoint + id
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.deleting = false;
    });
  };

  $scope.OpenMediaFrame = function (image) {
    var file_frame = wp.media({
      title: 'Select or Upload Logo image',
      library: {
        type: 'image'
      },
      button: {
        text: 'Select'
      },
      multiple: false
    });
    file_frame.on('select', function () {
      $scope.$apply(function () {
        $scope.attachment = file_frame.state().get('selection').first().toJSON();
        $scope.removingImage = true;

        if (image === 'add_img') {
          $scope.addParams.img_url = $scope.attachment.url;
        } else if (image === 'update_img') {
          $scope.selectedCategory.img_url = $scope.attachment.url;
        }
      });
    });
    file_frame.open();
  };

  $scope.OpenSearchModalAdd = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.productEndpoint,
          params: {
            q: ''
          }
        },
        relationships: ['products', 'category'],
        fields: ['sku', 'image', 'description', 'title'],
        fieldPrefixes: ['', '', '', 'Category: '],
        id: 'product_id',
        selectOne: false
      }],
      updatedItems: $scope.addParams.products
    };
    callback = {
      confirm: $scope.ProductSearchResults,
      cancel: function cancel() {}
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.addParams.title || 'New Category', data, 'Add items');
  };

  $scope.OpenSearchModalUpdate = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.productEndpoint,
          params: {
            q: '',
            excludedField: 'category_id',
            excludedId: $scope.selectedCategory.cat_id,
            excludedTable: 'products'
          }
        },
        relationships: ['products', 'category'],
        fields: ['sku', 'image', 'description', 'title'],
        fieldPrefixes: ['', '', '', 'Category: '],
        id: 'product_id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.categoryEndpoint + $scope.selectedCategory.cat_id,
          params: {
            q: '',
            'searchFields[]': ['description', 'sku']
          }
        },
        relationships: ['category', 'products'],
        fields: ['sku', 'image', 'description', 'status'],
        fieldPrefixes: ['', '', '', 'Category: '],
        id: 'product_id'
      }],
      updatedItems: $scope.editedProducts
    };
    callback = {
      confirm: $scope.ProductSearchResults,
      cancel: function cancel() {}
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.selectedCategory.title, data, 'Add items');
  };

  $scope.OpenParentCatSearchModal = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.categoryEndpoint,
          params: {
            q: ''
          }
        },
        relationships: ['categories', 'parent_category'],
        fields: ['cat_id', 'title', '.cat_id', '.title'],
        fieldPrefixes: ['ID: ', 'Category: ', 'Parent ID: ', 'Parent: '],
        id: 'cat_id',
        selectOne: true
      }]
    };
    callback = {
      confirm: $scope.CategorySearchResults,
      cancel: function cancel() {}
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Select Parent Category', data, 'Add items');
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchCategories($scope.searchParams.page);
  };

  $scope.SearchCategories = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.categoryEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.categories = resp.categories;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.SearchCategory = function (rpp, page) {
    $scope.productsLoading = true;
    $scope.searchParams.rpp = rpp;
    $scope.searchParams.page = page || 1;
    $scope.searchParams['searchFields[]'] = ['description', 'sku'];
    var req = {
      method: 'GET',
      url: $scope.categoryEndpoint + $scope.selectedCategory.cat_id,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedCategory = resp.category;

      if ($scope.selectedCategory.parent_category) {
        $scope.selectedCategory.parentCategoryTitle = $scope.selectedCategory.parent_category.title;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.productsLoading = false;
    });
  };

  $scope.CategorySearchResults = function (resp) {
    if ($scope.activeTab === 1) {
      $scope.addParams.parent_id = resp[0].value.cat_id;
      $scope.addParams.parentCategoryTitle = resp[0].value.title;
    }

    if ($scope.activeTab === 2) {
      $scope.selectedCategory.parent_id = resp[0].value.cat_id;
      $scope.selectedCategory.parentCategoryTitle = resp[0].value.title;
    }
  };

  $scope.ProductSearchResults = function (resp) {
    //callback that is used by the search modal
    if ($scope.activeTab === 1) {
      $scope.addParams.products = resp;
    }

    if ($scope.activeTab === 2) {
      $scope.editedProducts = resp;
    }
  };

  $scope.SearchSubCategory = function (id) {
    $scope.loading = true;
    var req = {
      method: 'GET',
      url: $scope.categoryEndpoint + id
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedCategory = resp.category;

      if ($scope.selectedCategory.parent_category) {
        $scope.selectedCategory.parentCategoryTitle = $scope.selectedCategory.parent_category.title;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.CheckCategory();
      $scope.loading = false;
    });
  };

  $scope.ShowChanges = function () {
    $scope.showChanges = !$scope.showChanges;
  };

  $scope.UpdateCategory = function () {
    $scope.loading = true;
    var params = {
      'title': $scope.selectedCategory.title,
      'parent_id': $scope.selectedCategory.parent_id,
      'avatax_tax_code': $scope.selectedCategory.avatax_tax_code,
      'unspsc': $scope.selectedCategory.unspsc,
      'slug': $scope.selectedCategory.slug,
      'image': $scope.selectedCategory.img_url,
      'products': []
    };
    angular.forEach($scope.editedProducts, function (value, key) {
      params.products.push(value.value.product_id);
    });
    var req = {
      method: 'PUT',
      url: $scope.categoryEndpoint + $scope.selectedCategory.cat_id,
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (!resp.errors.length) {
        $scope.TabChanged(2);
        $scope.addSuccess = Localized.GetResponseMsgs();
      } else {
        $scope.addSuccess = Localized.GetNotifications();
        $scope.loading = false;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      Debug.log('Loading: ', $scope.loading); // $scope.loading = false;
    });
  };

  $scope.ViewParent = function () {
    $scope.loading = true;
    var req = {
      method: 'GET',
      url: $scope.categoryEndpoint + $scope.selectedCategory.parent_id
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedCategory = resp.category;

      if ($scope.selectedCategory.parent_category) {
        $scope.selectedCategory.parentCategoryTitle = $scope.selectedCategory.parent_category.title;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.CheckCategory();
      $scope.loading = false;
    });
  };
}]);
angular.module('vendorfuelApp').controller('CatalogCollectionsController', ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', 'ViewModal', function ($scope, $rootScope, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, SearchModal, ViewModal) {
  $rootScope.pageNum = 4;
  $scope.object = Object;
  $scope.activeTab = parseInt($stateParams.activeTab);
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: 'catalog'
  }, {
    name: 'Collections',
    state: null
  }];
  $scope.loading = false;
  $scope.loadingMore = false;
  $scope.addSuccess = '';
  $scope.searchTerm = '';
  $scope.productsLoading = false;
  $scope.saving = false;
  $scope.saved = false;
  $scope.activeTab = parseInt($stateParams.activeTab);
  $scope.searchParams = {};
  $scope.addParams = {
    products: []
  };
  $scope.rppValues = [15, 30, 50, 100];
  $scope.allColSearchParams = {
    q: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.showChanges = false;
  $scope.editName = false;
  $scope.sortAscending = true;
  $scope.collectionEndpoint = Localized.apiUrl + '/admin/product/collection/';
  $scope.productEndpoint = Localized.apiUrl + '/admin/products/';
  $scope.localized = Localized;
  $scope.object = Object;
  $scope.per_page = $scope.rppValues[0];
  $scope.editedProducts = [];
  $scope.selectedCollection = null; //Collection to show in the view tab
  //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  }; //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.ChangeEdit = function () {
    $scope.editName = !$scope.editName;
  };

  $scope.SearchResults = function (resp) {
    //callback that is used by the search modal
    if ($scope.activeTab === 1) {
      $scope.addParams.products = resp;
    } else if ($scope.activeTab === 2) {
      $scope.editedProducts = resp;
    }
  };

  $scope.SearchCancelled = function () {//callback that is used by the search modal
  };

  $scope.TransitionState = function () {
    $state.transitionTo('catalog-collections', {
      activeTab: $scope.activeTab
    }, {
      location: true,
      inherit: true,
      relative: $state.$current,
      notify: false
    });
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    var req = {
      method: 'GET',
      url: $scope.collectionEndpoint
    };

    switch (i) {
      case 0:
        //First tab selected
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.collections = resp.collections;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        //Second tab selected
        $scope.loading = false;
        break;

      case 2:
        req.url += $scope.selectedCollection.id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedCollection = resp.collection;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.ChangeTab = function (tabIndex, collectionIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedCollection = $scope.collections.data[collectionIndex];
  };

  $scope.OpenSearchModalUpdate = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.productEndpoint,
          params: {
            q: '',
            excludedField: 'collection_id',
            excludedId: $scope.selectedCollection.id,
            excludedTable: 'product_collection'
          }
        },
        relationships: ['products'],
        fields: ['sku', 'image', 'description', 'status'],
        fieldPrefixes: ['', '', '', 'Status: '],
        id: 'product_id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.collectionEndpoint + $scope.selectedCollection.id,
          params: {
            q: '',
            'searchFields[]': ['description', 'sku']
          }
        },
        relationships: ['collection', 'products'],
        fields: ['sku', 'image', 'description', 'status'],
        fieldPrefixes: ['', '', '', 'Status: '],
        id: 'product_id'
      }],
      updatedItems: $scope.editedProducts
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.selectedCollection.name, data, 'Add items');
  };

  $scope.OpenSearchModalAdd = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.productEndpoint,
          params: {
            q: ''
          }
        },
        relationships: ['products'],
        fields: ['sku', 'image', 'description', 'status'],
        fieldPrefixes: ['', '', '', 'Status: '],
        id: 'product_id',
        selectOne: false
      }],
      updatedItems: $scope.addParams.products
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.addParams.name || 'New Collection', data, 'Add items');
  };

  $scope.OpenViewModal = function (product) {
    $scope.callback = {};
    var callback = {
      confirm: function confirm() {
        $scope.TabChanged(2);
      },
      cancel: $scope.SearchCancelled
    };
    ViewModal.Show(callback, 'Quick View: ' + product.sku, product);
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.allColSearchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.allColSearchParams.sortBy = sortBy;
    $scope.allColSearchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchCollections($scope.allColSearchParams.page);
  };

  $scope.SearchCollections = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.allColSearchParams.q;
    $scope.allColSearchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.collectionEndpoint,
      params: $scope.allColSearchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.collections = resp.collections;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.SearchCollection = function (rpp, page) {
    $scope.productsLoading = true;
    $scope.searchParams.rpp = rpp;
    $scope.searchParams.page = page || 1;
    $scope.searchParams['searchFields[]'] = ['description', 'sku'];
    var req = {
      method: 'GET',
      url: $scope.collectionEndpoint + $scope.selectedCollection.id,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedCollection = resp.collection;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.productsLoading = false;
    });
  };

  $scope.AddCollection = function (id) {
    // If id is null, we are adding new collection
    $scope.loading = true;
    var updateParams = {
      products: []
    };
    var error = false;
    var req = {};

    if (id) {
      updateParams.name = $scope.selectedCollection.name;
      updateParams.image = $scope.selectedCollection.img_url;
      updateParams.products = $scope.editedProducts.map(function (product) {
        return product.value.product_id;
      });
      req = {
        method: 'PUT',
        url: $scope.collectionEndpoint + id,
        data: updateParams
      };
    } else {
      if ($scope.addParams.name && $scope.addParams.products.length) {
        for (var i = 0; i < $scope.addParams.products.length; i++) {
          updateParams.products.push($scope.addParams.products[i].value.product_id);
        }

        updateParams.name = $scope.addParams.name;
        updateParams.image = $scope.addParams.img_url;
        req = {
          method: 'POST',
          url: $scope.collectionEndpoint,
          data: updateParams
        };
      } else {
        error = true;
      }
    }

    if (!error) {
      Utils.GetHttpPromise(req).then(function (resp) {
        if (!id) {
          $scope.selectedCollection = {
            id: resp.collection_id,
            name: req.data.name
          };
          $scope.addParams = {
            products: []
          };
          $scope.activeTab = 2;
        } else {
          $scope.TabChanged(2);
          $scope.showChanges = false;
          $scope.editedProducts = [];
        }
      }, function (errResp) {
        Debug.log(errResp);
      }).finally(function () {
        $scope.addSuccess = Localized.GetResponseMsgs();
      });
    } else {
      $scope.loading = false;
    }
  };

  $scope.DeleteCollection = function (id) {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var req = {
          method: 'DELETE',
          url: $scope.collectionEndpoint + id
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.activeTab = 0;
          $scope.selectedCollection = null;
        }, function (errResp) {
          Debug.log(errResp);
        });
      },
      cancel: function cancel() {}
    };
    $scope.confirm.Show(callback, 'Delete Collection?', 'This will delete your collection and any products associated with it.', 'Back', 'DELETE');
  };

  $scope.ShowChanges = function () {
    $scope.showChanges = !$scope.showChanges;
  };

  $scope.ChangeView = function () {
    $scope.viewProducts = !$scope.viewProducts;
  };

  $scope.OpenMediaFrame = function (image) {
    var file_frame = wp.media({
      title: 'Select or Upload Logo image',
      library: {
        type: 'image'
      },
      button: {
        text: 'Select'
      },
      multiple: false
    });
    file_frame.on('select', function () {
      $scope.$apply(function () {
        $scope.attachment = file_frame.state().get('selection').first().toJSON();
        $scope.removingImage = true;

        if (image === 'add_img') {
          $scope.addParams.img_url = $scope.attachment.url;
        } else if (image === 'update_img') {
          $scope.selectedCollection.img_url = $scope.attachment.url;
        }
      });
    });
    file_frame.open();
  }; //If the view tab is selected, redirect to the search page since selected product is null


  if ($scope.activeTab === 2) {
    $scope.activeTab = 0;
    $scope.TransitionState();
  }
}]);
angular.module('vendorfuelApp').controller('CatalogManufacturersController', ['$scope', '$rootScope', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', function ($scope, $rootScope, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
  $rootScope.pageNum = 4;
  $scope.activeTab = parseInt($stateParams.activeTab);
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: 'catalog'
  }, {
    name: 'Manufacturers',
    state: null
  }];
  $scope.loading = false;
  $scope.loadingMore = false;
  $scope.searchTerm = '';
  $scope.addSuccess = '';
  $scope.productsLoading = false;
  $scope.saving = false;
  $scope.saved = false;
  $scope.activeTab = parseInt($stateParams.activeTab);
  $scope.manufacturerEndpoint = Localized.apiUrl + '/admin/manufacturers/';
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    q: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.addParams = {};
  $scope.addParams.mfg_logo = false;
  $scope.localized = Localized;
  $scope.manufacturers = [];
  $scope.manufacturer = {};
  $scope.selectedManufacturer = null;
  $scope.attachment = {}; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  }; //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.SearchResults = function (resp) {//callback that is used by the search modal
  };

  $scope.SearchCancelled = function () {//callback that is used by the search modal
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    var req = {
      method: 'GET',
      url: $scope.manufacturerEndpoint
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.manufacturers = resp.manufacturers;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        req.url += $scope.selectedManufacturer.mfg_id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.manufacturer = resp.manufacturer;
          $scope.manufacturer.mfg_logo = resp.manufacturer.mfg_logo ? true : false;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.ChangeTab = function (tabIndex, manufacturerIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedManufacturer = $scope.manufacturers.data[manufacturerIndex];
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchManufacturers($scope.searchParams.page);
  };

  $scope.SearchManufacturers = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.manufacturerEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.manufacturers = resp.manufacturers;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.AddManufacturer = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.manufacturerEndpoint,
      data: $scope.addParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (!resp.errors.length) {
        $scope.addParams = {};
        $scope.addParams.mfg_logo = false;
        $scope.selectedManufacturer = {
          mfg_id: resp.mfg_id
        };
        $scope.activeTab = 2;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.UpdateManufacturer = function () {
    $scope.loading = true;
    var req = {
      method: 'PUT',
      url: $scope.manufacturerEndpoint + $scope.manufacturer.mfg_id,
      data: $scope.manufacturer
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.DeleteManufacturer = function () {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var req = {
          method: 'DELETE',
          url: $scope.manufacturerEndpoint + $scope.manufacturer.mfg_id
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedManufacturer = null;
          $scope.activeTab = 0;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
          $scope.addSuccess = Localized.GetResponseMsgs();
        });
      },
      cancel: function cancel() {}
    };
    $scope.confirm.Show(callback, 'Delete Manufacturer?', 'This action cannot be undone.', 'Back', 'DELETE');
  };

  $scope.OpenMediaFrame = function () {
    var file_frame = wp.media({
      title: 'Select or Upload image',
      library: {
        type: 'image'
      },
      button: {
        text: 'Select'
      },
      multiple: false
    });
    file_frame.on('select', function () {
      // We set multiple to false so only get one image from the uploader
      $scope.$apply(function () {
        $scope.attachment = file_frame.state().get('selection').first().toJSON();

        if ($scope.activeTab === 2) {
          $scope.manufacturer.image_url = $scope.attachment.url;
        } else if ($scope.activeTab === 1) {
          $scope.addParams.image_url = $scope.attachment.url;
        }
      });
    }); // Finally, open the modal

    file_frame.open();
  }; //If the view tab is selected, redirect to the search page since selected manufacturer is null


  if ($scope.activeTab === 2) {
    $scope.activeTab = 0;
  }
}]);
angular.module('vendorfuelApp').controller('CatalogPricesheetsController', ['$scope', '$timeout', '$rootScope', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', 'ViewModal', '$window', function ($scope, $timeout, $rootScope, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, SearchModal, ViewModal, $window) {
  $rootScope.pageNum = 4;
  $scope.activeTab = parseInt($stateParams.activeTab);
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: 'catalog'
  }, {
    name: 'Price Sheets',
    state: null
  }];
  $scope.loading = true;
  $scope.loadingMore = false;
  $scope.searchTerm = '';
  $scope.productsLoading = false;
  $scope.saving = false;
  $scope.uploading = false;
  $scope.addSuccess = '';
  $scope.saved = false;
  $scope.loadingMore = false;
  $scope.activeTab = parseInt($stateParams.activeTab);
  $scope.pricesheetEndpoint = Localized.apiUrl + '/admin/pricesheets/';
  $scope.productEndpoint = Localized.apiUrl + '/admin/products/';
  $scope.batchEndpoint = Localized.apiUrl + '/admin/price-sheet/batch/';
  $scope.selectedPricesheet = null;
  $scope.addParams = {
    products: []
  };
  $scope.localized = Localized;
  $scope.editName = false;
  $scope.updatedPricesheetItems = [];
  $scope.editIndex = -1;
  $scope.object = Object;
  $scope.myFile = {};
  $scope.showChanges = false;
  $scope.rppValues = [15, 30, 50, 100];
  $scope.allPrShSearchParams = {
    q: '',
    searchBy: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.searchParams = {
    rpp: $scope.rppValues[0]
  };
  $scope.sortBatchParams = {
    'sort_by': 'batch_id',
    'sort_type': '',
    'status': 'pending'
  };
  $scope.batchListOptions = {
    'pending': 'Pending',
    'confirmed': 'Confirmed',
    'processing': 'Processing',
    'any': 'All'
  };
  $scope.sortAscending = true; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils; //FUNCTIONS

  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.SearchResults = function (resp) {
    //callback that is used by the search modal
    if ($scope.activeTab === 1) {
      if ($scope.addParams.products) {
        resp.forEach(function (product) {
          $scope.addParams.products.push(product);
          var currentIds = $scope.addParams.products.map(function (product) {
            return product.value.product_id;
          });

          if (currentIds.includes(product.value.product_id)) {
            $scope.addParams.products[$scope.addParams.products.length - 1].price = product.value.price;
          }
        });
      } else {
        $scope.addParams.products = [];
      }
    } else if ($scope.activeTab === 2) {
      var currentIds = $scope.updatedPricesheetItems.map(function (item) {
        return item.value.product_id;
      });
      $scope.updatedPricesheetItems = [];
      resp.forEach(function (item) {
        var included = currentIds.includes(item.value.product_id);

        if (item.action === 'add') {
          $scope.updatedPricesheetItems.push({
            action: 'add',
            value: {
              product_id: item.value.product_id,
              sku: item.value.sku,
              price: included ? item.value.price : 0.00,
              product: included ? item.value.product : item.value
            }
          });
        } else if (item.action === 'remove') {
          $scope.updatedPricesheetItems.push(item);
        }
      });
    } else if ($scope.activeTab === 3) {
      $scope.uploadPricesheetId = resp[0].value.price_sheet_id;
      $scope.uploadPricesheetName = resp[0].value.sheet;
    }
  };

  $scope.AddPricesheet = function (id) {
    // If id is null, we are adding new price sheet
    $scope.loading = true;
    var updateParams = {
      products: []
    };
    var isMissingNameOrProducts = false;
    var req = {}; // Update price sheet

    if (id) {
      updateParams.sheet = $scope.selectedPricesheet.sheet;
      updateParams.default_price_sheet = $scope.selectedPricesheet.default_price_sheet;
      updateParams.site_id = $scope.selectedPricesheet.site_id;
      updateParams.gp_price_sheet = $scope.selectedPricesheet.gp_price_sheet;

      for (var i = 0; i < $scope.updatedPricesheetItems.length; i++) {
        if ($scope.updatedPricesheetItems[i].value.price.includes('$')) {
          console.log('before: ', $scope.updatedPricesheetItems[i].value.price);
          $scope.updatedPricesheetItems[i].value.price = $scope.updatedPricesheetItems[i].value.price.slice(1, $scope.updatedPricesheetItems[i].value.price.length);
        }

        console.log('after: ', $scope.updatedPricesheetItems[i].value.price);
        updateParams.products.push({
          'product_id': $scope.updatedPricesheetItems[i].value.product_id,
          'sku': $scope.updatedPricesheetItems[i].value.sku,
          'price': $scope.updatedPricesheetItems[i].action === 'remove' ? 0.00 : $scope.updatedPricesheetItems[i].value.price // 'gsa', 'ability_one', 'core_list'

        });
      }

      req = {
        method: 'PUT',
        url: $scope.pricesheetEndpoint + id,
        data: updateParams
      };
    } // Add new price sheet
    else {
        if ($scope.addParams.name && $scope.addParams.products) {
          updateParams.sheet = $scope.addParams.name;
          updateParams.default_price_sheet = $scope.addParams.default_price_sheet || false;
          updateParams.site_id = $scope.addParams.site_id;
          updateParams.gp_price_sheet = $scope.addParams.gp_price_sheet;

          for (var j = 0; j < $scope.addParams.products.length; j++) {
            if ($scope.addParams.products[j].value.price) {
              if ($scope.addParams.products[j].value.price.includes('$')) {
                $scope.addParams.products[j].value.price = $scope.addParams.products[j].value.price.slice(0, $scope.addParams.products[j].value.price.length);
              }

              console.log($scope.addParams.products[j].value.price);
              updateParams.products.push({
                'product_id': $scope.addParams.products[j].value.product_id,
                'sku': $scope.addParams.products[j].value.sku,
                'price': $scope.addParams.productj[j].value.price // 'gsa', 'ability_one', 'core_list'

              });
            }
          }

          req = {
            method: 'POST',
            url: $scope.pricesheetEndpoint,
            data: updateParams
          };
        } else {
          isMissingNameOrProducts = true;
        }
      }

    if (!isMissingNameOrProducts) {
      console.log('URL: ', req.url);
      Utils.GetHttpPromise(req).then(function (resp) {
        if (!resp.errors.length) {
          if (!id) {
            $scope.selectedPricesheet = {
              price_sheet_id: resp.price_sheet_id,
              sheet: req.data.sheet
            };
            $scope.addParams = {};
            $scope.activeTab = 2;
          } else {
            $scope.TabChanged(2);
            $scope.updatedPricesheetItems = [];
            $scope.showChanges = false;
          }
        }
      }, function (errResp) {
        Debug.log(errResp);
      });
    } else {
      $scope.loading = false;
    }

    $scope.editName = false;
  };

  $scope.ChangeBatchTab = function (tabIndex, batchIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedBatch = $scope.batches[batchIndex];
  };

  $scope.ChangeEdit = function () {
    $scope.editName = !$scope.editName;
  };

  $scope.ChangeTab = function (tabIndex, pricesheetIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedPricesheet = $scope.pricesheets.data[pricesheetIndex];
  };

  $scope.ConfirmBatch = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'confirm',
      data: {
        batch_id: $scope.selectedBatch.batch_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedBatch = null;
      $scope.activeTab = 4;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.DeletePricesheet = function (id) {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var req = {
          method: 'DELETE',
          url: $scope.pricesheetEndpoint + id
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.activeTab = 0;
          $scope.selectedPricesheet = null;
        }, function (errResp) {
          Debug.log(errResp);
        });
      },
      cancel: function cancel() {}
    };
    $scope.confirm.Show(callback, 'Delete Price Sheet?', 'This action cannot be undone.', 'Back', 'DELETE');
  };

  $scope.editParams = function (pricesheetItem) {
    console.log('Item: ', pricesheetItem);

    for (var i = 0; i < $scope.updatedPricesheetItems.length; i++) {
      if ($scope.updatedPricesheetItems[i].value.product_id === pricesheetItem.product_id) {
        if ($scope.updatedPricesheetItems[i].action === 'remove') {
          return;
        }

        $scope.updatedPricesheetItems[i].value.price = pricesheetItem.price;
        return;
      }
    }

    $scope.updatedPricesheetItems.push({
      action: 'edited',
      value: pricesheetItem
    });
  };

  $scope.EditPrice = function (index) {
    $scope.editIndex = index;
  };

  $scope.RemoveUploadFile = function () {
    $scope.pricesheetUpload = null;
    $scope.localized.PushResponseMsg({
      'type': 'danger',
      'message': 'File Successfully Removed'
    });
  };

  $scope.SearchCancelled = function () {//callback that is used by the search modal
  };

  $scope.SearchPricesheet = function (page) {
    $scope.productsLoading = true;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.pricesheetEndpoint + $scope.selectedPricesheet.price_sheet_id,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedPricesheet = resp.pricesheet;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.productsLoading = false;
    });
  };

  $scope.SearchPricesheets = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.allPrShSearchParams.q;
    $scope.searchedBy = $scope.allPrShSearchParams.searchBy;
    $scope.allPrShSearchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.pricesheetEndpoint,
      params: $scope.allPrShSearchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.pricesheets = resp.pricesheets;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.SetDefault = function () {
    if ($scope.activeTab === 2) {
      $scope.selectedPricesheet.default_price_sheet = true;
    }

    if ($scope.activeTab === 1) {
      $scope.addParams.default_price_sheet = true;
    }
  };

  $scope.setFile = function (element) {
    $scope.$apply(function ($scope) {
      $scope.theFile = element.files[0];
      console.log('File: ', $scope.theFile);
    });
    var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.csv|.txt)$/;

    if (regex.test($scope.theFile.name.toLowerCase())) {
      if (typeof FileReader !== 'undefined') {
        var reader = new FileReader();

        reader.onload = function (e) {
          var products = [];
          var rows = e.target.result.split('\r\n');

          for (var i = 0; i < rows.length; i++) {
            var cells = rows[i].split(',');

            if (cells.length > 1) {
              var product = {};
              product.sku = cells[0];
              product.price = cells[1];
              product.gsa = cells[2];
              product.ability_one = cells[3];
              product.core_list = cells[4];
              products.push(product);
              $scope.$apply(function (scope, prods) {
                scope.pricesheetUpload = prods;
                scope.IsVisible = true;
              }.bind(null, [$scope, products]));
            }
          }

          $scope.setUploading();
        };

        reader.readAsText($scope.theFile); // $scope.setUploading();
      } else {
        $window.alert('This browser does not support HTML5.');
      }
    } else {
      $window.alert('Please upload a valid CSV file.');
    }
  };

  $scope.setUploading = function () {
    $scope.$apply(function ($scope) {
      $scope.uploading = !$scope.uploading;
      console.log($scope.uploading);
    });
  };

  $scope.ShowChanges = function () {
    $scope.showChanges = !$scope.showChanges;
  };

  $scope.SortBatchIndex = function (sortBy) {
    $scope.sortAscending = $scope.sortBatchParams.sort_by === sortBy ? !$scope.sortAscending : true;
    $scope.sortBatchParams.sort_by = sortBy;
    $scope.sortBatchParams.sort_type = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SortBatches();
  };

  $scope.SortBatches = function () {
    $scope.loadingMore = true;
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint + 'list',
      params: $scope.sortBatchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.batches = resp.search_results;

      for (var i = 0; i < $scope.batches.length; i++) {
        if ($scope.batches[i].status === 'processing') {
          $scope.UpdateBatchProgress();
          break;
        }
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.allPrShSearchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.allPrShSearchParams.sortBy = sortBy;
    $scope.allPrShSearchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchPricesheets($scope.allPrShSearchParams.page);
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    var req = {
      method: 'GET',
      url: $scope.pricesheetEndpoint
    }; // use the switch below to call any functions needed for each tab. i.e. api calls, funcitonality, etc.

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.pricesheets = resp.pricesheets;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        req.url += $scope.selectedPricesheet.price_sheet_id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedPricesheet = resp.pricesheet;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 3:
        $scope.loading = false;
        break;

      case 4:
        req = {
          method: 'GET',
          url: $scope.batchEndpoint + 'list',
          params: $scope.sortBatchParams
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.batches = resp.search_results;

          for (var i = 0; i < $scope.batches.length; i++) {
            if ($scope.batches[i].status === 'processing') {
              $scope.UpdateBatchProgress();
              break;
            }
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 5:
        req = {
          method: 'GET',
          url: $scope.batchEndpoint + 'view',
          params: {
            batch_id: $scope.selectedBatch.batch_id
          }
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedBatch = resp.batches[0];
          $scope.batchHeaders = resp.batches[0].columns;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.TransitionState = function () {
    $state.transitionTo('catalog-pricesheets', {
      activeTab: $scope.activeTab
    }, {
      location: true,
      inherit: true,
      relative: $state.$current,
      notify: false
    });
  };

  $scope.OpenSearchModalAdd = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.productEndpoint,
          params: {
            q: ''
          }
        },
        relationships: ['products'],
        fields: ['sku', 'image', 'description', 'status'],
        fieldPrefixes: ['', '', '', 'Status: '],
        id: 'product_id',
        selectOne: false
      }],
      updatedItems: $scope.addParams.products
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.addParams.name || 'New Price Sheet', config, 'Add items');
  };

  $scope.OpenSearchModalUpdate = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.productEndpoint,
          params: {
            q: '',
            excludedField: 'price_sheet_id',
            excludedId: $scope.selectedPricesheet.price_sheet_id,
            excludedTable: 'price_sheets'
          }
        },
        relationships: ['products'],
        fields: ['sku', 'image', 'description', 'status'],
        fieldPrefixes: ['', '', '', 'Status: '],
        id: 'product_id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.pricesheetEndpoint + $scope.selectedPricesheet.price_sheet_id,
          params: {
            q: ''
          }
        },
        relationships: ['pricesheet', 'pricesheetItems', 'product'],
        fields: ['sku', 'image', 'description', 'price'],
        fieldPrefixes: ['', '', '', 'Price: '],
        id: 'product_id'
      }],
      updatedItems: $scope.updatedPricesheetItems
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.selectedPricesheet.sheet, config, 'Add items');
  };

  $scope.OpenSearchModalPricesheet = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.pricesheetEndpoint,
          params: {
            q: ''
          }
        },
        relationships: ['pricesheets'],
        fields: ['price_sheet_id', 'sheet'],
        fieldPrefixes: ['ID: ', ''],
        id: 'price_sheet_id',
        selectOne: true
      }]
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Select Price Sheet', config, 'Add Price Sheet');
  };

  $scope.OpenViewModal = function (product) {
    $scope.callback = {};
    var callback = {
      confirm: function confirm() {
        $scope.TabChanged(3);
      },
      cancel: $scope.SearchCancelled
    };
    ViewModal.Show(callback, 'Quick View: ' + product.sku, product);
  };

  $scope.postUpload = function (index, id) {
    $scope.selectedBatch = {
      batch_id: id
    };
    $scope.activeTab = index;
  };

  $scope.UploadPricesheet = function () {
    $scope.loading = true;
    var fd = new FormData();
    fd.append('file', $scope.theFile);
    fd.append('price_sheet_id', $scope.uploadPricesheetId);
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'upload',
      data: fd,
      transformRequest: angular.identity,
      headers: {
        'Content-Type': undefined
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.postUpload(5, resp.batch_id);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.localized.PushResponseMsg({
        'type': 'success',
        'message': 'File Successfully Uploaded'
      });
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.UpdateBatchProgress = function () {
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint + 'list',
      params: $scope.sortBatchParams
    };
    var again = false;
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.batches = resp.search_results;

      for (var i = 0; i < $scope.batches.length; i++) {
        if ($scope.batches[i].status === 'processing' && $scope.activeTab === 4) {
          again = true;
          break;
        }
      }

      if (again) {
        $timeout(function () {
          $scope.UpdateBatchProgress();
        }, 1000);
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {});
  }; //If the view tab is selected, redirect to the search page since selected product is null


  if ($scope.activeTab === 2 || $scope.activeTab === 5) {
    $scope.activeTab = 0;
    $scope.TransitionState();
  }
}]);
angular.module('vendorfuelApp').controller('CatalogProductsController', ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'Products', 'SearchModal', '$timeout', '$window', function ($scope, $rootScope, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, Products, SearchModal, $timeout, $window) {
  $rootScope.pageNum = 4;
  $scope.activeTab = parseInt($stateParams.activeTab);
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: 'catalog'
  }, {
    name: 'Products',
    state: null
  }];
  $scope.loading = true;
  $scope.saving = false;
  $scope.saved = false;
  $scope.addSuccess = '';
  $scope.loadingMore = false;
  $scope.searchTerm = '';
  $scope.removingImage = false;
  $scope.selectedProduct = $stateParams.product || null;
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.attributesLength = 36;

  $scope.getNumber = function (num) {
    return new Array(num);
  };

  $scope.products = [];
  $scope.selectedBatch = null;
  $scope.myFile = {};
  $scope.newProduct = {
    status: 'active',
    images: {},
    pricesheets: [],
    parcels: []
  };
  $scope.sortBatchParams = {
    'sort_by': 'batch_id',
    'sort_type': ''
  };
  $scope.productEndpoint = Localized.apiUrl + '/admin/products/';
  $scope.batchEndpoint = Localized.apiUrl + '/admin/product/batch/';
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    rpp: $scope.rppValues[0]
  };
  $scope.tinymceOptions = {
    inline: false,
    theme: 'modern',
    skin: 'lightgray',
    plugins: 'advlist autolink link image lists charmap print preview fullscreen code',
    toolbar: 'undo redo | styleselect | bold italic | link image alignleft aligncenter alignright | preview code | fullscreen'
  };
  $scope.regValues = [{
    key: '1',
    value: 'Yes'
  }, {
    key: '0',
    value: 'No'
  }];
  $scope.searchModalPage = '';
  $scope.numAttributes = [];
  $scope.maxAttributes = 18;
  $scope.parcelWeightUnits = {
    'lb': 'Pounds',
    'kg': 'Kilograms'
  };
  $scope.slides = 0;
  $scope.scrollSlides = 0; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.productsFactory = Products;
  $scope.localized = Localized;
  $scope.utils = Utils;

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  };

  $scope.syncProductWPPosts = function () {
    var params = {};
    var data = {};
    $scope.utils.HttpGet($scope.localized.wpRestUrl + '/syncProductPosts', params, data).then(function (resp, $scope) {
      $scope.saving = false;
    });
  };

  $scope.generateSlugs = function () {
    var req = {
      method: 'POST',
      url: $scope.productEndpoint + 'slug/generate'
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  }; //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TransitionState = function () {
    $state.transitionTo('catalog-products', {
      activeTab: $scope.activeTab
    }, {
      location: true,
      inherit: true,
      relative: $state.$current,
      notify: false
    });
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    $scope.TransitionState();
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    var req = {
      method: 'GET',
      url: $scope.productEndpoint
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.products = resp.products;
          $scope.totalProducts = resp.products.total;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $timeout(function () {
          $scope.InitEditor();
        });
        $scope.SlickSetup();
        $scope.loading = false;
        break;

      case 2:
        req.url += $scope.selectedProduct.product_id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedProduct = resp.product;
          $scope.numAttributes = [];

          for (var i = 1; i <= 18; i++) {
            if ($scope.selectedProduct['att' + i + 'n'] || $scope.selectedProduct['att' + i + 'd']) {
              $scope.numAttributes.push(i);
            }
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $timeout(function () {
            $scope.InitEditor();
          });
          $scope.SlickSetup();
          $scope.loading = false;
        });
        break;

      case 3:
        $scope.loading = false;
        break;

      case 4:
        req = {
          method: 'GET',
          url: $scope.batchEndpoint + 'list',
          params: $scope.sortBatchParams
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.batches = resp.search_results;

          for (var i = 0; i < $scope.batches.length; i++) {
            if ($scope.batches[i].status === 'processing') {
              $scope.UpdateBatchProgress();
              break;
            }
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 5:
        req = {
          method: 'GET',
          url: $scope.batchEndpoint + 'view',
          params: {
            batch_id: $scope.selectedBatch.batch_id
          }
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedBatch = resp.batches[0];
          $scope.batchHeaders = resp.batches[0].columns;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      default:
        break;
    }
  };

  $scope.AddAttribute = function () {
    if ($scope.numAttributes.length >= $scope.maxAttributes) {
      return;
    }

    var i = 1;

    while ($scope.numAttributes.indexOf(i) !== -1) {
      i++;
    }

    $scope.numAttributes.push(i);
  };

  $scope.AddProduct = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.productEndpoint,
      data: $scope.newProduct
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (!resp.errors.length) {
        $scope.selectedProduct = {
          product_id: resp.product_id
        };
        $scope.activeTab = 2;
        $scope.newProduct = {
          status: 'active',
          images: {},
          pricesheets: [],
          parcels: []
        };
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.ChangeTab = function (tabIndex, productIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedProduct = $scope.products.data[productIndex];
  };

  $scope.CheckImageLength = function () {
    if ($scope.activeTab === 2) {
      if ($scope.selectedProduct.images && Object.keys($scope.selectedProduct.images).length > 1) {
        if (Object.keys($scope.selectedProduct.images).length >= 4) {
          $scope.slides = 3;
          $scope.scrollSlides = 3;
        } else {
          $scope.slides = Object.keys($scope.selectedProduct.images).length - 1;
          $scope.scrollSlides = 1;
        }
      } else {
        $scope.slides = 1;
        $scope.scrollSlides = 2;
      }
    } else if ($scope.activeTab === 1) {
      if ($scope.newProduct.images && Object.keys($scope.newProduct.images).length > 1) {
        if (Object.keys($scope.newProduct.images).length >= 4) {
          $scope.slides = 3;
          $scope.scrollSlides = 3;
        } else {
          $scope.slides = Object.keys($scope.newProduct.images).length - 1;
          $scope.scrollSlides = 1;
        }
      } else {
        $scope.slides = 1;
        $scope.scrollSlides = 2;
      }
    }
  };

  $scope.InitEditor = function () {
    if ($scope.activeTab === 1) {
      wp.editor.remove('add_description');
      wp.editor.initialize('add_description', {
        quicktags: true,
        tinymce: true
      });
    } else if ($scope.activeTab === 2) {
      wp.editor.remove('view_description');
      wp.editor.initialize('view_description', {
        quicktags: true,
        tinymce: true
      });
    }
  };

  $scope.OpenCatSearch = function () {
    $scope.searchModalPage = 'cat';
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/category/',
          params: {
            q: ''
          }
        },
        relationships: ['categories'],
        fields: ['cat_id', 'title', 'parent_id'],
        fieldPrefixes: ['ID: ', '', 'Parent ID: '],
        id: 'cat_id',
        selectOne: true
      }]
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Categories', data, 'Add items');
  };

  $scope.OpenMediaFrame = function () {
    var file_frame = wp.media({
      title: 'Select or Upload image',
      library: {
        type: 'image'
      },
      button: {
        text: 'Select'
      },
      multiple: false
    });
    file_frame.on('select', function () {
      // We set multiple to false so only get one image from the uploader
      $scope.$apply(function () {
        $scope.attachment = file_frame.state().get('selection').first().toJSON();
        console.log(file_frame.state().get('selection').first().toJSON());
        $scope.removingImage = true;
        var assigned = false,
            i = 0;

        if ($scope.activeTab === 2) {
          while (!assigned) {
            if ($scope.selectedProduct.images.hasOwnProperty('new' + i)) {
              i++;
            } else {
              $scope.selectedProduct.images['new' + i] = $scope.attachment;
              $scope.selectedProduct.images['new' + i].wpImg = true;
              assigned = true;
            }
          }
        } else if ($scope.activeTab === 1) {
          while (!assigned) {
            if ($scope.newProduct.images.hasOwnProperty('new' + i)) {
              i++;
            } else {
              $scope.newProduct.images['new' + i] = $scope.attachment;
              $scope.newProduct.images['new' + i].wpImg = true;
              assigned = true;
            }
          }
        }

        $scope.CheckImageLength();
        $scope.slickConfig.slidesToShow = $scope.slides;
        $scope.slickConfig.slidesToScroll = $scope.scrollSlides;
        $timeout(function () {
          $scope.removingImage = false;
        }, 500);
      });
    }); // Finally, open the modal

    file_frame.open();
  };

  $scope.OpenMfgSearch = function () {
    $scope.searchModalPage = 'mfg';
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/manufacturers/',
          params: {
            q: ''
          }
        },
        relationships: ['manufacturers'],
        fields: ['mfg_id', 'manufacturer', 'mfg_info', 'mfg_website'],
        fieldPrefixes: ['', '', 'Info: ', 'Website: '],
        id: 'mfg_id',
        selectOne: true
      }]
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Manufacturers', data, 'Add items');
  };

  $scope.OpenPsSearch = function () {
    $scope.searchModalPage = 'ps';
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/pricesheets/',
          params: {
            q: ''
          }
        },
        relationships: ['pricesheets'],
        fields: ['price_sheet_id', 'sheet'],
        fieldPrefixes: ['ID: ', ''],
        id: 'price_sheet_id',
        selectOne: false
      }]
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Price Sheets', data, 'Add items');
  };

  $scope.OpenParcelSearch = function () {
    $scope.searchModalPage = 'parcel';
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/shipping/parcel/',
          params: {
            q: ''
          }
        },
        relationships: ['parcels'],
        fields: ['id', 'title'],
        fieldPrefixes: ['ID: ', ''],
        id: 'id',
        selectOne: false
      }]
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Parcels', data, 'Add items');
  };

  $scope.RemoveAttribute = function (i) {
    if ($scope.activeTab === 1) {
      $scope.numAttributes.splice(i, 1);
      $scope.newProduct['att' + (i + 1) + 'n'] = '';
      $scope.newProduct['att' + (i + 1) + 'd'] = '';
    } else if ($scope.activeTab === 2) {
      $scope.numAttributes.splice(i, 1);
      $scope.selectedProduct['att' + (i + 1) + 'n'] = '';
      $scope.selectedProduct['att' + (i + 1) + 'd'] = '';
    }
  };

  $scope.RemoveImage = function (i) {
    $scope.removingImage = true;

    if ($scope.activeTab === 1) {
      delete $scope.newProduct.images[i];
    } else if ($scope.activeTab === 2) {
      if ($scope.selectedProduct.images[i].wpImg) {
        delete $scope.selectedProduct.images[i];
      } else {
        $scope.selectedProduct.images[i].deleted = true;
      }
    }

    $scope.CheckImageLength();
    $scope.slickConfig.slidesToShow = $scope.slides;
    $scope.slickConfig.slidesToScroll = $scope.scrollSlides;
    $timeout(function () {
      $scope.removingImage = false;
    }, 500);
  };

  $scope.RemoveParcel = function (i) {
    if ($scope.activeTab === 1) {
      $scope.newProduct.parcels.splice(i, 1);
    } else if ($scope.activeTab === 2) {
      $scope.selectedProduct.parcels.splice(i, 1);
    }
  };

  $scope.RemovePricesheet = function (i) {
    if ($scope.activeTab === 1) {
      $scope.newProduct.pricesheets.splice(i, 1);
    } else if ($scope.activeTab === 2) {
      $scope.selectedProduct.pricesheets[i].deleted = true;
    }
  };

  $scope.SearchCancelled = function () {};

  $scope.SearchProducts = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.productEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.products = resp.products;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.SearchResults = function (resp) {
    //callback that is used by the search modal
    Debug.log(resp);

    if ($scope.activeTab === 1) {
      switch ($scope.searchModalPage) {
        case 'mfg':
          $scope.newProduct.mfg_id = resp[0].value.mfg_id;
          $scope.newProduct.manufacturer = resp[0].value.manufacturer;
          break;

        case 'cat':
          $scope.newProduct.category_id = resp[0].value.cat_id;
          $scope.newProduct.category = resp[0].value;
          break;

        case 'ps':
          for (var i = 0; i < resp.length; i++) {
            var skip = false;

            for (var j = 0; j < $scope.newProduct.pricesheets.length; j++) {
              if (resp[i].value.price_sheet_id === $scope.newProduct.pricesheets[j].price_sheet_id) {
                skip = true;
                break;
              }
            }

            if (!skip) {
              $scope.newProduct.pricesheets.push({
                pricesheetindex: resp[i].value,
                ps_item_id: 0,
                price_sheet_id: resp[i].value.price_sheet_id,
                price: 0
              });
            }
          }

          break;

        case 'parcel':
          for (var k = 0; k < resp.length; k++) {
            var skip2 = false;

            for (var l = 0; l < $scope.newProduct.parcels.length; l++) {
              if (resp[k].value.id === $scope.newProduct.parcels[l].id) {
                skip2 = true;
                break;
              }
            }

            if (!skip2) {
              $scope.newProduct.parcels.push(resp[k].value);
              $scope.newProduct.parcels[$scope.newProduct.parcels.length - 1].pivot = {
                parcel_id: resp[k].value.id,
                weight: '',
                mass_unit: ''
              };
            }
          }

          break;
      }
    } else if ($scope.activeTab === 2) {
      switch ($scope.searchModalPage) {
        case 'mfg':
          $scope.selectedProduct.mfg_id = resp[0].value.mfg_id;
          $scope.selectedProduct.manufacturer = resp[0].value;
          break;

        case 'cat':
          $scope.selectedProduct.category_id = resp[0].value.cat_id;
          $scope.selectedProduct.category = resp[0].value;
          break;

        case 'ps':
          for (var q = 0; q < resp.length; q++) {
            var skip3 = false;

            for (var r = 0; r < $scope.selectedProduct.pricesheets.length; r++) {
              if (resp[q].value.price_sheet_id === $scope.selectedProduct.pricesheets[r].price_sheet_id) {
                skip3 = true;
                break;
              }
            }

            if (!skip3) {
              $scope.selectedProduct.pricesheets.push({
                pricesheetindex: resp[q].value,
                ps_item_id: 0,
                price_sheet_id: resp[q].value.price_sheet_id,
                price: 0,
                product_id: $scope.selectedProduct.product_id,
                sku: $scope.selectedProduct.sku
              });
            }
          }

          break;

        case 'parcel':
          for (var t = 0; t < resp.length; t++) {
            var skip4 = false;

            for (var y = 0; y < $scope.selectedProduct.parcels.length; y++) {
              if (resp[t].value.id === $scope.selectedProduct.parcels[y].id) {
                skip4 = true;
                break;
              }
            }

            if (!skip4) {
              $scope.selectedProduct.parcels.push(resp[t].value);
              $scope.selectedProduct.parcels[$scope.selectedProduct.parcels.length - 1].pivot = {
                parcel_id: resp[t].value.id,
                product_id: $scope.selectedProduct.product_id,
                weight: '',
                mass_unit: ''
              };
            }
          }

          break;
      }
    }
  };

  $scope.SetUploading = function () {
    $scope.$apply(function ($scope) {
      $scope.uploading = !$scope.uploading;
    });
  };

  $scope.setFile = function (element) {
    $scope.$apply(function ($scope) {
      $scope.theFile = element.files[0];
    });
    var totalBytes = $scope.theFile.size;

    if (totalBytes < 1000000) {
      $scope.fileSize = Math.floor(totalBytes / 1000) + 'KB';
    } else {
      $scope.fileSize = Math.floor(totalBytes / 1000000) + 'MB';
    }

    Debug.log('File Size: ', $scope.fileSize);
    var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.csv|.txt)$/;

    if (regex.test($scope.theFile.name.toLowerCase())) {
      if (typeof FileReader !== 'undefined') {
        var reader = new FileReader();

        reader.onload = function (e) {
          Papa.parse(reader.result, {
            complete: function complete(results) {
              var products = [];

              for (var i = 0; i <= 4; i++) {
                var info = results.data[i];
                var product = [];
                angular.forEach(info, function (val, key) {
                  product[key] = val;
                });
                products.push(product);
              }

              $scope.$apply(function () {
                $scope.prodSheetUpload = products;
                $scope.IsVisible = true;
              });
              console.log('Finished:', results.data);
            }
          });
          $scope.SetUploading();
        };

        reader.readAsText($scope.theFile);
      } else {
        $window.alert('This browser does not support HTML5.');
      }
    } else {
      $scope.theFile = null;
      $scope.prodSheetUpload = null;
      $scope.SetUploading();
      $window.alert('Please upload a valid CSV file.');
    }
  };

  $scope.SlickSetup = function () {
    $scope.CheckImageLength();
    $scope.slickConfig = {
      enabled: true,
      arrows: true,
      slidesToShow: $scope.slides,
      slidesToScroll: $scope.scrollSlides,
      autoplay: true,
      draggable: true,
      autoplaySpeed: 3000,
      method: {},
      event: {
        beforeChange: function beforeChange(event, slick, currentSlide, nextSlide) {},
        afterChange: function afterChange(event, slick, currentSlide, nextSlide) {}
      }
    };
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchProducts($scope.searchParams.page);
  };

  $scope.UpdateProduct = function () {
    $scope.loading = true;
    var req = {
      method: 'PUT',
      url: $scope.productEndpoint + $scope.selectedProduct.product_id,
      data: $scope.selectedProduct
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.activeTab = 2;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.postUpload = function (index, id) {
    $scope.selectedBatch = {
      batch_id: id
    };
    $scope.activeTab = index;
  };

  $scope.UploadProduct = function () {
    $scope.loading = true;
    var fd = new FormData();
    fd.append('file', $scope.theFile, $scope.theFile.name);
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'upload',
      data: fd,
      transformRequest: angular.identity,
      headers: {
        'Content-Type': undefined
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.postUpload(5, resp.batch_id);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.SortBatchIndex = function (sortBy) {
    $scope.sortAscending = $scope.sortBatchParams.sort_by === sortBy ? !$scope.sortAscending : true;
    $scope.sortBatchParams.sort_by = sortBy;
    $scope.sortBatchParams.sort_type = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SortBatches();
  };

  $scope.SortBatches = function () {
    $scope.loadingMore = true;
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint + 'list',
      params: $scope.sortBatchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.batches = resp.search_results;

      for (var i = 0; i < $scope.batches.length; i++) {
        if ($scope.batches[i].status === 'processing') {
          $scope.UpdateBatchProgress();
          break;
        }
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.ConfirmBatch = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'confirm',
      data: {
        batch_id: $scope.selectedBatch.batch_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedBatch = null;
      $scope.activeTab = 4;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.ChangeBatchTab = function (tabIndex, batchIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedBatch = $scope.batches[batchIndex];
  };

  $scope.UpdateBatchProgress = function () {
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint + 'list',
      params: $scope.sortBatchParams
    };
    var again = false;
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.batches = resp.search_results;

      for (var i = 0; i < $scope.batches.length; i++) {
        if ($scope.batches[i].status === 'processing' && $scope.activeTab === 4) {
          again = true;
          break;
        }
      }

      if (again) {
        $timeout(function () {
          $scope.UpdateBatchProgress();
        }, 1000);
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {});
  };

  if ($scope.activeTab === 2 && !$scope.selectedProduct || $scope.activeTab === 5 && !$scope.selectedBatch) {
    $scope.activeTab = 0;
  }
}]);
angular.module('vendorfuelApp').controller('CatalogPromoCodesController', ['$scope', '$rootScope', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', function ($scope, $rootScope, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, SearchModal) {
  $rootScope.pageNum = 4;
  $scope.activeTab = parseInt($stateParams.activeTab);
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: 'catalog'
  }, {
    name: 'Promo Codes',
    state: null
  }];
  $scope.loading = false;
  $scope.loadingMore = false;
  $scope.saving = false;
  $scope.saved = false;
  $scope.object = Object;
  $scope.searchTerm = '';
  $scope.activeTab = parseInt($stateParams.activeTab);
  $scope.addParams = {
    auto_add: false,
    require_all_items: false,
    products: {
      data: []
    }
  };
  $scope.rppValues = [15, 30, 50, 100];
  $scope.per_page = $scope.rppValues[0];
  $scope.searchParams = {
    q: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.searchProductParams = {
    q: '',
    rpp: $scope.rppValues[0],
    searchFields: ['sku', 'description', 'product_id']
  };
  $scope.sortAscending = true;
  $scope.customerEndpoint = Localized.apiUrl + '/admin/customer/list/';
  $scope.promocodeEndpoint = Localized.apiUrl + '/admin/promo-codes/';
  $scope.productEndpoint = Localized.apiUrl + '/admin/products/';
  $scope.localized = Localized;
  $scope.selectedPromocode = null;
  $scope.promoCodes = [];
  $scope.promoCode = {};
  $scope.discountTypes = {
    'percentage': 'Percentage',
    'discount': 'Discount',
    'price': 'Price'
  };
  $scope.showChanges = false;
  $scope.addParams.discount_type = $scope.discountTypes.percentage;
  $scope.updatedProducts = []; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils; //FUNCTIONS

  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    var req = {
      method: 'GET',
      url: $scope.promocodeEndpoint
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.promoCodes = resp.promoCodes;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        req.url += $scope.selectedPromocode.promo_code_id;
        req.params = $scope.searchProductParams;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedPromocode = resp.promoCode;
          $scope.selectedPromocode.auto_add = $scope.selectedPromocode.auto_add ? true : false;
          $scope.selectedPromocode.date_effective = $scope.selectedPromocode.date_effective ? new Date($scope.selectedPromocode.date_effective) : null;
          $scope.selectedPromocode.date_expires = $scope.selectedPromocode.date_expires ? new Date($scope.selectedPromocode.date_expires) : null;
          $scope.selectedPromocode.require_all_items = $scope.selectedPromocode.require_all_items ? true : false;
          $scope.selectedPromocode.customerName = resp.promoCode.customer ? resp.promoCode.customer.name : '';
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.AddPromoCode = function () {
    $scope.loading = true;

    if ($scope.addParams.products.length) {
      $scope.addParams.products = $scope.addParams.products.data.map(function (product) {
        return product.product_id;
      });
    }

    var req = {
      method: 'POST',
      url: $scope.promocodeEndpoint,
      data: $scope.addParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (!resp.errors.length && resp.promo_code_id) {
        $scope.selectedPromocode = {
          promo_code_id: resp.promo_code_id
        };
        $scope.activeTab = 2;
        $scope.addParams = {
          auto_add: false,
          require_all_items: false,
          products: {
            data: []
          }
        };
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.ChangeTab = function (tabIndex, promocodeIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedPromocode = $scope.promoCodes.data[promocodeIndex];
  };

  $scope.CustomerSearchResults = function (resp) {
    //callback that is used by the search modal
    if (resp.length) {
      if ($scope.activeTab === 1) {
        $scope.addParams.customer_id = resp[0].value.customer_id;
        $scope.addParams.customerName = resp[0].value.name;
        $scope.addParams.email = resp[0].value.email;
      } else {
        $scope.selectedPromocode.customer_id = resp[0].value.customer_id;
        $scope.selectedPromocode.customerName = resp[0].value.name;
        $scope.selectedPromocode.email = resp[0].value.email;
      }
    }
  };

  $scope.DeletePromoCode = function () {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var req = {
          method: 'DELETE',
          url: $scope.promocodeEndpoint + $scope.selectedPromocode.promo_code_id
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.activeTab = 0;
          $scope.selectedPromocode = null;
        }, function (errResp) {
          Debug.log(errResp);
        });
      },
      cancel: function cancel() {}
    };
    $scope.confirm.Show(callback, 'Delete Promo Code?', 'This action cannot be undone.', 'Back', 'DELETE');
  };

  $scope.OpenAddSearchModal = function (type) {
    var callback = {};
    var data = {};

    if (type === 'customer') {
      data = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.customerEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['customers'],
          fields: ['customer_id', 'name', 'email', 'status'],
          fieldPrefixes: ['ID: ', 'Name: ', 'Email: ', 'Status: '],
          id: 'customer_id',
          selectOne: true
        }]
      };
      callback.confirm = $scope.CustomerSearchResults;
    } else if (type === 'product') {
      data = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.productEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['products'],
          fields: ['sku', 'image', 'description', 'status'],
          fieldPrefixes: ['', '', '', 'Status: '],
          id: 'product_id',
          selectOne: false
        }]
      };
      callback.confirm = $scope.ProductSearchResults;
    }

    callback.cancel = $scope.SearchCancelled; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.addParams.code || 'New Promo Code', data, 'Add Customer');
  };

  $scope.OpenUpdateSearchModal = function (type) {
    var callback = {};
    var data = {};

    if (type === 'customer') {
      data = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.customerEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['customers'],
          fields: ['customer_id', 'name', 'email', 'status'],
          fieldPrefixes: ['ID: ', 'Name: ', 'Email: ', 'Status: '],
          id: 'customer_id',
          selectOne: true
        }]
      };
      callback.confirm = $scope.CustomerSearchResults;
    } else if (type === 'product') {
      data = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.productEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['products'],
          fields: ['sku', 'image', 'description', 'status'],
          fieldPrefixes: ['', '', '', 'Status: '],
          id: 'product_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: $scope.promocodeEndpoint + $scope.selectedPromocode.promo_code_id,
            params: {
              q: ''
            }
          },
          relationships: ['promoCode', 'products'],
          fields: ['sku', 'image', 'description', 'status'],
          fieldPrefixes: ['', '', '', 'Status: '],
          id: 'product_id'
        }]
      };
      callback.confirm = $scope.ProductSearchResults;
    }

    callback.cancel = $scope.SearchCancelled; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.selectedPromocode.code, data, 'Add Items');
  };

  $scope.ProductSearchResults = function (resp) {
    if (resp.length) {
      if ($scope.activeTab === 1) {
        if ($scope.addParams.products && $scope.addParams.products.length) {
          var currentIds = $scope.addParams.products.map(function (product) {
            return product.product_id;
          });

          for (var i = 0; i < resp.length; i++) {
            if (!currentIds.includes(resp[i].value.product_id)) {
              $scope.addParams.products.data.push(resp[i].value);
            }
          }
        } else {
          resp.forEach(function (item) {
            $scope.addParams.products.data.push(item.value);
          });
        }
      } else {
        resp.forEach(function (item) {
          var currentIds = $scope.selectedPromocode.products.data.map(function (product) {
            return product.product_id;
          });
          var updatedIds = $scope.updatedProducts.map(function (product) {
            return product.product_id;
          });

          if (item.action === 'add' && !currentIds.includes(item.value.product_id)) {
            $scope.updatedProducts.push(item);
          }

          if (item.action === 'remove' && !updatedIds.includes(item.value.product_id)) {
            $scope.updatedProducts.push(item);
          }
        });
        console.log('Updated Products: ', $scope.updatedProducts);
      }
    }
  };

  $scope.SearchCancelled = function () {//callback that is used by the search modal
  };

  $scope.SearchProducts = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.searchProductParams.q;
    $scope.searchProductParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.promocodeEndpoint + $scope.selectedPromocode.promo_code_id,
      params: $scope.searchProductParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedPromocode.products = resp.products;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.SearchPromoCodes = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.promocodeEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.promoCodes = resp.promoCodes;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.ShowChanges = function () {
    $scope.showChanges = !$scope.showChanges;
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchPromoCodes($scope.searchParams.page);
  };

  $scope.UpdatePromoCode = function () {
    $scope.loading = true;
    $scope.selectedPromocode.products = [];
    angular.forEach($scope.updatedProducts, function (value, key) {
      $scope.selectedPromocode.products.push(value.value.product_id);
    });
    var req = {
      method: 'PUT',
      url: $scope.promocodeEndpoint + $scope.selectedPromocode.promo_code_id,
      data: $scope.selectedPromocode
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.TabChanged(2);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  }; //If the view tab is selected, redirect to the search page since selected product is null


  if ($scope.activeTab === 2) {
    $scope.activeTab = 0;
  }
}]);
angular.module('vendorfuelApp').controller('ReviewsController', ['$scope', '$rootScope', 'Admin', 'Debug', 'Settings', 'Localized', 'Utils', '$stateParams', 'ConfirmModal', function ($scope, $rootScope, Admin, Debug, Settings, Localized, Utils, $stateParams, ConfirmModal) {
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.status = '';
  $rootScope.breadcrumbs = [{
    name: 'Product Reviews',
    state: null
  }];
  $scope.reviewEndpoint = Localized.apiUrl + '/admin/product/review/';
  $scope.searchTerm = '';
  $scope.reviewStatus = [{
    key: 'Approved',
    val: 'approved'
  }, {
    key: 'Pending',
    val: 'pending'
  }, {
    key: 'Deleted',
    val: 'deleted'
  }]; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils; //FUNCTIONS

  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    var req = {
      method: 'GET',
      url: $scope.reviewEndpoint
    };

    switch (i) {
      case 0:
        req.url += 'list';
        Utils.GetHttpPromise(req).then(function (resp) {
          console.log('Resp:', resp.search_results);
          $scope.reviews = resp.search_results;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        $scope.loading = false;
        break;

      case 3:
        $scope.loading = false;
        break;
    }
  };

  $scope.approveReview = function () {
    $scope.updating = true;
    $scope.status = 'Approving';
    var params = {
      review_id: $scope.selectedReview.id
    };
    var req = {
      method: 'POST',
      url: $scope.reviewEndpoint + 'approve',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.selectedReview.status = 'approved';
      $scope.updating = false;
    });
  };

  $scope.ChangeTab = function (tabIndex, reviewIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedReview = $scope.reviews[reviewIndex];
  };

  $scope.deleteReview = function (id) {
    $scope.updating = true;
    $scope.status = 'Removing';
    var params = {
      review_id: id
    };
    var req = {
      method: 'POST',
      url: $scope.reviewEndpoint + 'remove',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.activeTab = 0;
      $scope.updating = false;
    });
  };

  $scope.updateReview = function () {
    $scope.updating = true;
    $scope.status = 'Updating';
    var params = $scope.selectedReview;
    params.review_id = $scope.selectedReview.id;
    var req = {
      method: 'POST',
      url: $scope.reviewEndpoint + 'modify',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.updating = false;
    });
  };
}]);
angular.module('vendorfuelApp').controller('CatalogUomController', ['$scope', '$rootScope', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'uom', function ($scope, $rootScope, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, uom) {
  $scope.appData = uom.uomData();
  $scope.activeTab = parseInt($stateParams.activeTab);
  $scope.filledUom = {};
  $rootScope.pageNum = 10;
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: 'catalog'
  }, {
    name: 'UOM',
    state: null
  }];
  $scope.loading = false;
  $scope.loadingMore = false;
  $scope.saving = false;
  $scope.searchTerm = '';
  $scope.addSuccess = '';
  $scope.activeTab = parseInt($stateParams.activeTab);
  $scope.uomEndpoint = Localized.apiUrl + '/admin/product/uom/';
  $scope.addParams = {};
  $scope.localized = Localized;
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    q: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.uoms = [];
  $scope.uom = {};
  $scope.uomCodes = $scope.appData.uomCodes;
  $scope.selectedUom = null; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  }; //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    var req = {
      method: 'GET',
      url: $scope.uomEndpoint
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.uoms = resp.uoms;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        req.url += $scope.selectedUom.uom_id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.uom = resp.uom;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.AddUom = function () {
    $scope.saving = true;
    var req = {
      method: 'POST',
      url: $scope.uomEndpoint,
      data: $scope.addParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.addParams = {};

      if (!resp.errors.length) {
        $scope.selectedUom = {
          uom_id: resp.uom_id
        };
        $scope.TabChanged(2);
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.saving = false;
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.ChangeTab = function (tabIndex, uomIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedUom = $scope.uoms.data[uomIndex];
  };

  $scope.FillUom = function (uom) {
    $scope.filledUom = uom;
    $scope.addParams.uom = uom.name;
    $scope.addParams.description = uom.name;
    $scope.addParams.code = uom.val;
  };

  $scope.DeleteUom = function () {
    $scope.saving = true;
    var req = {
      method: 'DELETE',
      url: $scope.uomEndpoint + $scope.uom.uom_id
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedUom = null;
      $scope.TabChanged(0);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.saving = false;
      $scope.localized.PushResponseMsg({
        'type': 'success',
        'message': 'Uom Successfully Updates'
      });
    });
  };

  $scope.SearchCancelled = function () {//callback that is used by the search modal
  };

  $scope.SearchResults = function (resp) {
    //callback that is used by the search modal
    Debug.log(resp);
  };

  $scope.SearchUoms = function (page) {
    $scope.searchTerm = $scope.searchParams.q;
    $scope.loadingMore = true;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.uomEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.uoms = resp.uoms;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchUoms($scope.searchParams.page);
  };

  $scope.UpdateUom = function () {
    $scope.saving = true;
    var req = {
      method: 'PUT',
      url: $scope.uomEndpoint + $scope.uom.uom_id,
      data: $scope.uom
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.saving = false;
    });
  }; //If the view tab is selected, redirect to the search page since selected product is null


  if ($scope.activeTab === 2) {
    $scope.activeTab = 0;
  }
}]);
angular.module('vendorfuelApp').controller('CatalogController', ['$scope', '$rootScope', 'Admin', 'Localized', 'Anguledit', 'Utils', function ($scope, $rootScope, Admin, Localized, Anguledit, Utils) {
  $rootScope.pageNum = 4;
  $scope.admin = Admin;
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.anguledit = Anguledit;
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
}]);
angular.module('vendorfuelApp').controller('ContactController', ['$rootScope', '$scope', 'Admin', 'Localized', '$state', function ($rootScope, $scope, Admin, Localized, $state) {
  $rootScope.breadcrumbs = [{
    name: 'Contact Us',
    state: null
  }];
  $scope.admin = Admin;
  $scope.localized = Localized;

  $scope.goToState = function (stateName, tabIndex) {
    $state.go(stateName, {
      activeTab: tabIndex
    });
  };
}]);
angular.module('vendorfuelApp').controller('AccountsController', ['$scope', '$rootScope', '$window', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', 'localStorageService', 'customerAccounts', '$timeout', function ($scope, $rootScope, $window, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, SearchModal, localStorageService, customerAccounts, $timeout) {
  $scope.customerData = customerAccounts.customerData();
  $scope.states = $scope.customerData.states;
  $rootScope.pageNum = 11;
  $rootScope.breadcrumbs = [{
    name: 'Customers',
    state: 'customers',
    url: null
  }, {
    name: 'Accounts',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.loading = false;
  $scope.sheet = {
    selected: 'Select Price Sheet'
  };
  $scope.loadingMore = false;
  $scope.loadingAddress = false;
  $scope.showPassword = false;
  $scope.savingNote = false;
  $scope.localized = Localized;
  $scope.searchTerm = '';
  $scope.addSuccess = '';
  $scope.selectedCustomer = $stateParams.customer || null;
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.addressTab = 0;
  $scope.addParams = {};
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    q: '',
    searchBy: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.sortBatchParams = {
    'sort_by': 'batch_id',
    'sort_type': '',
    'status': 'pending'
  };
  $scope.sortAscending = true;
  $scope.customerEndpoint = Localized.apiUrl + '/admin/customers/';
  $scope.batchEndpoint = Localized.apiUrl + '/admin/customer/batch/';
  $scope.customers = {};
  $scope.customer = {};
  $scope.newCustomer = {
    shipping_flat_rates: []
  };
  $scope.newCustomKeys = [];
  $scope.newCustomValues = [];
  $scope.customerNotes = [];
  $scope.noteParams = {
    note: ''
  };
  $scope.batchListOptions = {
    'pending': 'Pending',
    'confirmed': 'Confirmed',
    'processing': 'Processing',
    'any': 'All'
  };
  $scope.batches = [];
  $scope.selectedBatch = null;
  $scope.selectedBilling = null;
  $scope.selectedShipping = null;
  $scope.myFile = {};
  $scope.limitTypes = {
    'none': 'None',
    'monthly': 'Monthly',
    'quarterly': 'Quarterly',
    'flat': 'Flat'
  };
  $scope.replaceFields = {
    'organization': 'Company Name',
    'rr_po_num': 'Purchase Order Number',
    'issuing_office': 'Issuing Office',
    'cost_center_code': 'Cost Center',
    'attention': 'Attention'
  };
  $scope.statuses = {
    'active': 'Active',
    'inactive': 'Inactive',
    'unverified': 'Unverified'
  };
  $scope.updatedRates = []; // $scope.states =

  $scope.notifications = Localized.GetNotifications();

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  }; //FACTORIES


  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;
  /**
   * gets store settings used for default prefix
   */

  $scope.getDefaultPrefix = function () {
    Settings.store.Get().finally(function () {
      $scope.loading = false;
    });
  };
  /**
   * updates store settings user for default prefix
   */


  $scope.updateDefaultPrefix = function () {
    Settings.store.Set().finally(function () {
      $scope.loading = false;
    });
  }; //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    var req = {
      method: 'GET',
      url: $scope.customerEndpoint
    };

    switch (i) {
      case 0:
        //First tab selected
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.priceSheets = resp.price_sheets;
          $scope.customers = resp.customers;
          $scope.updatedRates = [];
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        //Second tab selected
        $scope.loading = false;
        break;

      case 2:
        var done = 0,
            total = 2;
        req.url += $scope.selectedCustomer.customer_id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.priceSheets = resp.price_sheets;
          $scope.customer = resp.customer;
          $scope.customer.shipping_flat_rates = [];
          $scope.updatedRates = [];
          $scope.noteParams.customer_id = $scope.selectedCustomer.customer_id;
          $scope.customKeys = [];
          $scope.customValues = [];
          angular.forEach($scope.customer.custom, function (value, key) {
            $scope.customKeys.push(key);
            $scope.customValues.push(value);
          });
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          if (++done >= total) {
            $scope.loading = false;
          }
        });
        req = {
          method: 'GET',
          url: Localized.apiUrl + '/admin/customer/note/list',
          params: {
            customer_id: $scope.selectedCustomer.customer_id
          }
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.customerNotes = resp.notes;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          if (++done >= total) {
            $scope.loading = false;
          }
        });
        break;

      case 3:
        $scope.loading = false;
        break;

      case 4:
        req = {
          method: 'GET',
          url: $scope.batchEndpoint + 'list',
          params: $scope.sortBatchParams
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.batches = resp.search_results;

          for (var i = 0; i < $scope.batches.length; i++) {
            if ($scope.batches[i].status === 'processing') {
              $scope.UpdateBatchProgress();
              break;
            }
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 5:
        req = {
          method: 'GET',
          url: $scope.batchEndpoint + 'view',
          params: {
            batch_id: $scope.selectedBatch.batch_id
          }
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedBatch = resp.batches[0];
          $scope.batchHeaders = resp.batches[0].columns;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 6:
        $scope.getDefaultPrefix();
        break;
    }
  };

  $scope.AddCustom = function () {
    var assigned = false,
        i = 0;

    if ($scope.activeTab === 2) {
      while (!assigned) {
        if ($scope.customKeys.indexOf(i) > -1 || $scope.customKeys.indexOf(i.toString()) > -1) {
          i++;
        } else {
          $scope.customKeys.unshift(i);
          $scope.customValues.unshift('');
          assigned = true;
        }
      }
    } else if ($scope.activeTab === 1) {
      while (!assigned) {
        if ($scope.newCustomKeys.indexOf(i) > -1 || $scope.newCustomKeys.indexOf(i.toString()) > -1) {
          i++;
        } else {
          $scope.newCustomKeys.unshift(i);
          $scope.newCustomValues.unshift('');
          assigned = true;
        }
      }
    }
  };

  $scope.AddCustomCheckoutValue = function (num) {
    if ($scope.activeTab === 2) {
      $scope.customer['f' + num + '_value'].push('');
    } else if ($scope.activeTab === 1) {
      if ($scope.newCustomer['f' + num + '_value']) {
        $scope.newCustomer['f' + num + '_value'].push('');
      } else {
        $scope.newCustomer['f' + num + '_value'] = [];
        $scope.newCustomer['f' + num + '_value'].push('');
      }
    }
  };

  $scope.AddCustomer = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.customerEndpoint,
      data: $scope.newCustomer
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (resp.errors.length <= 0) {
        $scope.newCustomKeys = [];
        $scope.newCustomValues = [];
        $scope.selectedCustomer = {
          customer_id: resp.customer_id
        };
        $scope.newCustomer = {};
        $scope.activeTab = 2;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.BillingProfiles = function () {
    $scope.loadingAddress = true;
    $scope.addressTab = 0;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/customer/address/list',
      data: {
        type: 'billing',
        customer_id: $scope.customer.customer_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.billing_addresses = resp.billing_addresses;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingAddress = false;
    });
  };

  $scope.ChangeAddressTab = function (i) {
    $scope.addressTab = i;

    if (i === 0) {
      $scope.selectedBilling = {};
      $scope.selectedShipping = {};
    }
  };

  $scope.ChangeTab = function (tabIndex, customerIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedCustomer = $scope.customers.data[customerIndex];
  };

  $scope.ChangeBatchTab = function (tabIndex, batchIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedBatch = $scope.batches[batchIndex];
  };

  $scope.checkPriceSheet = function (tabIndex) {
    if (tabIndex === 1) {
      angular.forEach($scope.priceSheets, function (sheet) {
        if ($scope.newCustomer.pricesheet.price_sheet_id === sheet.price_sheet_id) {
          $scope.sheet.selected = sheet.sheet;
        }
      });
    }

    if (tabIndex === 2) {
      angular.forEach($scope.priceSheets, function (sheet) {
        if ($scope.customer.price_sheet_id === sheet.price_sheet_id) {
          $scope.sheet.selected = sheet.sheet;
        }
      });
    }
  };

  $scope.ConfirmBatch = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'confirm',
      data: {
        batch_id: $scope.selectedBatch.batch_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedBatch = null;
      $scope.activeTab = 4;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false; //    $scope.localized.PushResponseMsg({
      //     'type': 'success',
      //     'message': "Batch Successfully Confirmed"
      // });

      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.CustomerLogin = function (customer_id) {
    $scope.loggingIn = true;
    var params = {};
    params.customer_id = customer_id;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/customer/login/',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      localStorageService.cookie.set('auth.token', resp.token, {
        'samesite': 'none',
        'secure': true,
        'path': '/'
      });
      localStorageService.cookie.set('user.name', resp.name, {
        'samesite': 'none',
        'secure': true,
        'path': '/'
      });
      localStorageService.cookie.set('user.email', resp.email, {
        'samesite': 'none',
        'secure': true,
        'path': '/'
      });

      if (resp.group) {
        if (resp.group !== '') {
          localStorageService.cookie.set('user.group', resp.group, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.group', null, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        localStorageService.cookie.set('user.group', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.group_admin) {
        if (resp.group_admin === 1) {
          localStorageService.cookie.set('user.group_admin', 'true', {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.group_admin', 'false', {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        localStorageService.cookie.set('user.group_admin', 'false', {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.approver) {
        if (resp.approver === 1) {
          localStorageService.cookie.set('user.approver', 'true', {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.approver', 'false', {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        localStorageService.cookie.set('user.approver', 'false', {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.cart_count) {
        if (resp.cart_count >= 0) {
          localStorageService.cookie.set('user.cartCount', resp.cart_count, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.cartCount', 0, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        localStorageService.cookie.set('user.cartCount', 0, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.punchout_only) {
        if (resp.punchout_only === 1) {
          Debug.log('Punchout Only: True');
          localStorageService.cookie.set('user.cartCount', resp.punchout_only, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.cartCount', null, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        Debug.log('Punchout Only: False');
        localStorageService.cookie.set('user.cartCount', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.company) {
        if (resp.company !== '') {
          localStorageService.cookie.set('user.company', resp.company, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.company', null, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        localStorageService.cookie.set('user.company', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.default_billing_profile) {
        if (resp.default_billing_profile > 0) {
          localStorageService.cookie.set('user.defaultBillingProfile', resp.default_billing_profile, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.defaultBillingProfile', null, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        localStorageService.cookie.set('user.defaultBillingProfile', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.default_shipping_profile) {
        if (resp.default_shipping_profile > 0) {
          localStorageService.cookie.set('user.defaultShippingProfile', resp.default_shipping_profile, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.defaultShippingProfile', null, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        localStorageService.cookie.set('user.defaultShippingProfile', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.group_id) {
        localStorageService.cookie.set('user.currentGroup_id', resp.group_id, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      } else {
        localStorageService.cookie.set('user.currentGroup_id', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.group_id) {
        localStorageService.cookie.set('user.group_id', resp.group_id, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      } else {
        localStorageService.cookie.set('user.group_id', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.group_parent_id) {
        localStorageService.cookie.set('user.group_parent_id', resp.group_parent_id, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      } else {
        localStorageService.cookie.set('user.group_parent_id', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.price_availability) {
        if (resp.price_availability === 1) {
          localStorageService.cookie.set('user.price_availability', resp.price_availability, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.price_availability', null, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        localStorageService.cookie.set('user.price_availability', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      if (resp.cost_center_is_required) {
        if (resp.cost_center_is_required === 1) {
          localStorageService.cookie.set('user.cost_center_is_required', resp.cost_center_is_required, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        } else {
          localStorageService.cookie.set('user.cost_center_is_required', null, {
            'samesite': 'none',
            'secure': true,
            'path': '/'
          });
        }
      } else {
        localStorageService.cookie.set('user.cost_center_is_required', null, {
          'samesite': 'none',
          'secure': true,
          'path': '/'
        });
      }

      $window.open('/welcome', 'Logged In As Customer');
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loggingIn = false;
    });
  };

  $scope.DeleteNote = function (id) {
    $scope.savingNote = true;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/customer/note/remove',
      data: {
        note_id: id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.LoadNotes();
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {});
  };

  $scope.EditAddress = function (type, id) {
    if (type === 'shipping') {
      $scope.selectedShipping = $scope.shipping_addresses[id];
    } else if (type === 'billing') {
      $scope.selectedBilling = $scope.billing_addresses[id];
    }

    $scope.addressTab = 1;
  };

  $scope.FormatDate = function (date) {
    var dateOut = new Date(date);
    return dateOut;
  };

  $scope.GoToOrder = function (order_id) {
    $state.go('orders', {
      activeTab: 4,
      order: order_id
    });
  };

  $scope.GoToProduct = function (item) {
    $state.go('catalog-products', {
      activeTab: 2,
      product: item
    });
  };

  $scope.OpenGroupSearchModal = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/groups/',
          params: {
            q: ''
          }
        },
        relationships: ['groups'],
        fields: ['group_id', 'name', 'parent_group_id', 'default_price_sheet'],
        fieldPrefixes: ['ID: ', '', 'Parent ID: ', 'Price Sheet: '],
        id: 'group_id',
        selectOne: true
      }]
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.customer.name, data, 'Add items');
  };

  $scope.OpenRatesSearchModal = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/shipping/flat-rate/',
          params: {
            q: '',
            excludedField: 'customer_id',
            excludedId: $scope.selectedCustomer.customer_id,
            excludedTable: 'shipping_flat_rate_customer'
          }
        },
        relationships: ['shipping_flat_rates'],
        fields: ['name', 'cost', 'enabled'],
        fieldPrefixes: ['Name: ', 'Cost: ', 'Enabled: '],
        id: 'id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.customerEndpoint + $scope.selectedCustomer.customer_id
        },
        relationships: ['customer', 'flatRateItems'],
        fields: ['name', 'cost', 'enabled'],
        fieldPrefixes: ['Name: ', 'Cost: ', 'Enabled: '],
        id: 'id',
        selectOne: false
      }],
      updatedItems: $scope.updatedRates
    };
    callback = {
      confirm: $scope.rateResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Flat Rates', config, 'Add Shipping Rates');
  };

  $scope.rateResults = function (resp) {
    if ($scope.activeTab === 2) {
      $scope.updatedRates = [];
      resp.forEach(function (rate) {
        if (rate.action === 'add') {
          $scope.updatedRates.push(rate);
          $scope.customer.shipping_flat_rates.push({
            'id': rate.value.id
          });
        }

        if (rate.action === 'unselect') {
          angular.forEach($scope.customer.shipping_flat_rates, function (val, key) {
            if (val.id === rate.value.id) {
              $scope.customer.shipping_flat_rates.splice(key, 1);
            }
          });
        }

        if (rate.action === 'remove') {
          $scope.updatedRates.push(rate);
          $scope.customer.shipping_flat_rates.push({
            'id': rate.value.id,
            'deleted': 1
          });
        }

        if (rate.action === 'deselect') {
          angular.forEach($scope.customer.shipping_flat_rates, function (val, key) {
            if (val.id === rate.value.id) {
              $scope.customer.shipping_flat_rates.splice(key, 1);
            }
          });
        }
      });
    }
  };

  $scope.rateCheck = function (rate) {
    var check = false;
    angular.forEach($scope.updatedRates, function (key) {
      if (key.value.id === rate.id && key.action === 'remove') {
        check = true;
      }
    });
    return check;
  };

  $scope.RemoveAddress = function (type, id) {
    $scope.loadingAddress = true;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/customer/address/remove',
      data: {
        customer_id: $scope.customer.customer_id,
        type: type
      }
    };
    req.data[type + '_id'] = id;
    Utils.GetHttpPromise(req).then(function (resp) {
      if (type === 'billing') {
        $scope.BillingProfiles();
      } else {
        $scope.ShippingProfiles();
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {// $scope.loadingAddress = false;
    });
  };

  $scope.RemoveCustom = function (i) {
    if ($scope.activeTab === 2) {
      $scope.customKeys.splice(i, 1);
      $scope.customValues.splice(i, 1);
    } else if ($scope.activeTab === 1) {
      $scope.newCustomKeys.splice(i, 1);
      $scope.newCustomValues.splice(i, 1);
    }
  };

  $scope.RemoveCustomCheckoutValue = function (num, index) {
    if ($scope.activeTab === 2) {
      $scope.customer['f' + num + '_value'].splice(index, 1);
    } else if ($scope.activeTab === 1) {
      $scope.newCustomer['f' + num + '_value'].splice(index, 1);
    }
  };

  $scope.RemoveUploadFile = function () {
    $scope.accountSheetUpload = null;
    $scope.localized.PushResponseMsg({
      'type': 'danger',
      'message': 'File Successfully Removed'
    });
  };

  $scope.SaveAddress = function (type) {
    $scope.loadingAddress = true;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/customer/address/modify'
    };

    if (type === 'billing') {
      req.data = $scope.selectedBilling;
    } else if (type === 'shipping') {
      req.data = $scope.selectedShipping;
    }

    req.data.customer_id = $scope.customer.customer_id;
    req.data.type = type;
    Utils.GetHttpPromise(req).then(function (resp) {
      if (!resp.errors.length) {
        // $scope.billing_addresses = resp.billing_addresses;
        if (type === 'billing') {
          $scope.BillingProfiles();
        } else if (type === 'shipping') {
          $scope.ShippingProfiles();
        }
      } else {
        $scope.loadingAddress = false;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {});
  };

  $scope.SaveNote = function () {
    $scope.savingNote = true;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/customer/note/add',
      data: $scope.noteParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.LoadNotes();
      $scope.noteParams.note = '';
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {});
  };

  $scope.SendEmail = function (type) {
    $scope.loading = true;
    var req = {
      method: 'POST',
      data: {
        customer_id: $scope.customer.customer_id
      }
    };

    if (type === 'welcome') {
      req.url = Localized.apiUrl + '/admin/customer/send-welcome-email';
    } else if (type === 'verified') {
      req.url = Localized.apiUrl + '/admin/customer/send-verified-email';
    } else {
      $scope.loading = false;
      return;
    }

    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.SearchCancelled = function () {//callback that is used by the search modal
  };

  $scope.SearchCustomers = function (page) {
    $scope.loadingMore = true;
    $scope.searchedBy = $scope.searchParams.searchBy;
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.customerEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.customers = resp.customers;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.SearchResults = function (resp) {
    //callback that is used by the search modal
    if ($scope.activeTab === 2) {
      $scope.customer.group = resp[0].value;
      $scope.customer.group_id = resp[0].value.group_id;
    } else if ($scope.activeTab === 1) {
      $scope.newCustomer.group = resp[0].value;
      $scope.newCustomer.group_id = resp[0].value.group_id;
    }
  };

  $scope.SetUploading = function () {
    $scope.$apply(function ($scope) {
      $scope.uploading = !$scope.uploading;
    });
  };

  $scope.setFile = function (element) {
    $scope.$apply(function ($scope) {
      $scope.theFile = element.files[0];
    });
    var totalBytes = $scope.theFile.size;

    if (totalBytes < 1000000) {
      $scope.fileSize = Math.floor(totalBytes / 1000) + 'KB';
      Debug.log('FileSize: ', $scope.fileSize, ' KB');
    } else {
      $scope.fileSize = Math.floor(totalBytes / 1000000) + 'MB';
      Debug.log('FileSize: ', $scope.fileSize, ' MB');
    }

    Debug.log('File Size: ', $scope.fileSize);
    var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.csv|.txt)$/;

    if (regex.test($scope.theFile.name.toLowerCase())) {
      if (typeof FileReader !== 'undefined') {
        var reader = new FileReader();

        reader.onload = function (e) {
          Papa.parse(reader.result, {
            complete: function complete(results) {
              var products = [];

              for (var i = 0; i <= 4; i++) {
                var info = results.data[i];
                var product = [];
                angular.forEach(info, function (val, key) {
                  product[key] = val;
                });
                products.push(product);
              }

              $scope.$apply(function () {
                $scope.accountSheetUpload = products;
                $scope.IsVisible = true;
              });
              Debug.log('Finished: ', results.data);
            }
          });
          $scope.SetUploading();
        };

        reader.readAsText($scope.theFile);
      } else {
        $window.alert('This browser does not support HTML5.');
      }
    } else {
      $scope.accountSheetUpload = null;
      $scope.theFile = null;
      $scope.SetUploading();
      $window.alert('Please upload a valid CSV file.');
    }
  };

  $scope.ShippingProfiles = function () {
    $scope.loadingAddress = true;
    $scope.addressTab = 0;
    var req = {
      method: 'GET',
      url: Localized.apiUrl + '/admin/customer/address/list',
      params: {
        type: 'shipping',
        customer_id: $scope.customer.customer_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.shipping_addresses = resp.shipping_addresses;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingAddress = false;
    });
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchCustomers($scope.searchParams.page);
  };

  $scope.SortBatchIndex = function (sortBy) {
    $scope.sortAscending = $scope.sortBatchParams.sort_by === sortBy ? !$scope.sortAscending : true;
    $scope.sortBatchParams.sort_by = sortBy;
    $scope.sortBatchParams.sort_type = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SortBatches();
  };

  $scope.SortBatches = function () {
    $scope.loadingMore = true;
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint + 'list',
      params: $scope.sortBatchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.batches = resp.search_results;

      for (var i = 0; i < $scope.batches.length; i++) {
        if ($scope.batches[i].status === 'processing') {
          $scope.UpdateBatchProgress();
          break;
        }
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.ToggleShowPassword = function () {
    $scope.showPassword = !$scope.showPassword;
  };

  $scope.ToggleShowPasswordConfirmation = function () {
    $scope.showPasswordConfirmation = !$scope.showPasswordConfirmation;
  };

  $scope.UpdateCustomer = function () {
    $scope.loading = true;
    $scope.customer.custom = {};

    for (var i = 0; i < $scope.customKeys.length; i++) {
      $scope.customer.custom[$scope.customKeys[i]] = $scope.customValues[i];
    }

    var req = {
      method: 'PUT',
      url: $scope.customerEndpoint + $scope.customer.customer_id,
      data: $scope.customer
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (resp.errors.length <= 0) {
        angular.forEach($scope.updatedRates, function (rate) {
          if (rate.action === 'add') {
            $scope.customer.flatrates.push(rate.value);
          } else {
            angular.forEach($scope.customer.flatrates, function (val, key) {
              if (val.id === rate.value.id) {
                $scope.customer.flatrates.splice(key, 1);
              }
            });
          }
        });
        $scope.updatedRates = [];
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.postUpload = function (index, id) {
    $scope.selectedBatch = {
      batch_id: id
    };
    $scope.activeTab = index;
  };

  $scope.UploadCustomer = function () {
    $scope.loading = true;
    var fd = new FormData();
    fd.append('file', $scope.theFile);
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'upload',
      data: fd,
      transformRequest: angular.identity,
      headers: {
        'Content-Type': undefined
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.postUpload(5, resp.batch_id);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.localized.PushResponseMsg({
        'type': 'success',
        'message': 'File Successfully Uploaded'
      });
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.UpdateBatchProgress = function () {
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint + 'list',
      params: $scope.sortBatchParams
    };
    var again = false;
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.batches = resp.search_results;

      for (var i = 0; i < $scope.batches.length; i++) {
        if ($scope.batches[i].status === 'processing' && $scope.activeTab === 4) {
          again = true;
          break;
        }
      }

      if (again) {
        $timeout(function () {
          $scope.UpdateBatchProgress();
        }, 1000);
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {});
  };

  $scope.updatePriceSheet = function (price_sheet_id, isNew) {
    if (!isNew) {
      $scope.customer.price_sheet_id = price_sheet_id;
    } else {
      $scope.newCustomer.price_sheet_id = price_sheet_id;
    }
  };

  $scope.ViewDocument = function (id) {
    Debug.log(Admin.Download(Localized.apiUrl + '/admin/customer/documents/' + id));
    window.open(Admin.Download(Localized.apiUrl + '/admin/customer/documents/' + id), '_blank');
  };

  $scope.LoadNotes = function () {
    var req = {
      method: 'GET',
      url: Localized.apiUrl + '/admin/customer/note/list',
      params: {
        customer_id: $scope.selectedCustomer.customer_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.customerNotes = resp.notes;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.savingNote = false;
    });
  };

  $scope.RemoveGroup = function () {
    $scope.customer.group = null;
    $scope.customer.group_id = 0;
    Debug.log($scope.customer);
  }; //If the view tab is selected, redirect to the search page since selected product is null


  if ($scope.activeTab === 2 && !$scope.selectedCustomer) {
    $scope.activeTab = 0;
  }

  $scope.updateSettings = function () {};
}]);
angular.module('vendorfuelApp').controller('GroupsController', ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', '$window', '$timeout', function ($scope, $rootScope, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, SearchModal, $window, $timeout) {
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.loading = false;
  $scope.uploading = false;
  $scope.updatedRates = [];
  $scope.searchTerm = '';
  $scope.addSuccess = '';
  $scope.loadingMore = false;
  $rootScope.pageNum = 12;
  $rootScope.breadcrumbs = [{
    name: 'Customers',
    state: 'customers'
  }, {
    name: 'Groups',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.groupEndpoint = Localized.apiUrl + '/admin/groups/';
  $scope.batchEndpoint = Localized.apiUrl + '/admin/group/batch/';
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    q: '',
    searchBy: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.sortBatchParams = {
    'sort_by': 'batch_id',
    'sort_type': '',
    'status': 'pending'
  };
  $scope.sortAscending = true;
  $scope.regValues = [{
    key: 1,
    value: 'Active'
  }, {
    key: 0,
    value: 'Inactive'
  }];
  $scope.newGroup = {
    customers: {
      data: []
    },
    group_registration_available: 0,
    shipping_mode: 'default'
  };
  $scope.shippingModes = {
    'default': 'Default',
    'free': 'Free',
    'method': 'Flat Rate',
    'parcel': 'Parcel'
  };
  $scope.batchListOptions = {
    'pending': 'Pending',
    'confirmed': 'Confirmed',
    'processing': 'Processing',
    'any': 'All'
  }; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  }; //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.GroupSearchResults = function (resp) {
    //callback that is used by the search modal
    if ($scope.activeTab === 2) {
      $scope.selectedGroup.parent_group = resp[0].value;
      $scope.selectedGroup.parent_group_id = resp[0].value.group_id;
    } else if ($scope.activeTab === 1) {
      $scope.newGroup.parent_group = resp[0].value;
      $scope.newGroup.parent_group_id = resp[0].value.group_id;
    }
  };

  $scope.CustomerSearchResults = function (resp) {
    if ($scope.activeTab === 2) {
      var currentIds = $scope.selectedGroup.customers.data.map(function (c) {
        return c.customer_id;
      });

      for (var i = 0; i < resp.length; i++) {
        if (currentIds.includes(resp[i].value.customer_id) && resp[i].action === 'remove') {
          for (var j = 0; j < $scope.selectedGroup.customers.data.length; j++) {
            if ($scope.selectedGroup.customers.data[j].customer_id === resp[i].value.customer_id) {
              $scope.selectedGroup.customers.data.splice(j, 1);
              break;
            }
          }
        }

        if (!currentIds.includes(resp[i].value.customer_id)) {
          $scope.selectedGroup.customers.data.push(resp[i].value);
        }
      }

      Debug.log($scope.selectedGroup.customers.data);
    } else if ($scope.activeTab === 1) {
      if ($scope.newGroup.customers.data && $scope.newGroup.customers.data.length) {
        var customerIds = $scope.newGroup.customers.data.map(function (c) {
          return c.customer_id;
        });

        for (var k = 0; k < resp.length; k++) {
          if (!customerIds.includes(resp[k].value.customer_id)) {
            $scope.newGroup.customers.data.push(resp[k].value);
          }
        }
      } else {
        for (var l = 0; l < resp.length; l++) {
          $scope.newGroup.customers.data.push(resp[l].value);
        }
      }
    }
  };

  $scope.SearchCancelled = function () {//callback that is used by the search modal
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    var params = {};
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;
    var req = {
      method: 'GET',
      url: $scope.groupEndpoint
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.customerGroups = resp.groups;
          $scope.priceSheets = resp.price_sheets;
          $scope.newGroup.default_price_sheet = resp.default_price_sheet;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        //Second tab selected
        if (!$scope.newGroup.default_price_sheet) {
          Utils.GetHttpPromise(req).then(function (resp) {
            $scope.priceSheets = resp.price_sheets;
            $scope.newGroup.default_price_sheet = resp.default_price_sheet;
          }, function (errResp) {
            Debug.log(errResp);
          }).finally(function () {
            $scope.loading = false;
          });
        } else {
          $scope.loading = false;
        }

        break;

      case 2:
        req.url += $scope.selectedGroup.group_id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedGroup = resp.group;
          $scope.selectedGroup.shipping_flat_rates = [];
          $scope.priceSheets = resp.price_sheets;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 3:
        $scope.loading = false;
        break;

      case 4:
        req = {
          method: 'GET',
          url: $scope.batchEndpoint + 'list',
          params: $scope.sortBatchParams
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.batches = resp.search_results;

          for (var i = 0; i < $scope.batches.length; i++) {
            if ($scope.batches[i].status === 'processing') {
              $scope.UpdateBatchProgress();
              break;
            }
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 5:
        req = {
          method: 'GET',
          url: $scope.batchEndpoint + 'view',
          params: {
            batch_id: $scope.selectedBatch.batch_id
          }
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedBatch = resp.batches[0];
          $scope.batchHeaders = resp.batches[0].columns;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.GoToUser = function (user) {
    $state.go('customers-accounts', {
      activeTab: 2,
      customer: user
    });
  };

  $scope.SelectChild = function (group_id) {
    $scope.loading = true;
    var req = {
      method: 'GET',
      url: $scope.groupEndpoint
    };
    req.url += group_id;
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedGroup = resp.group;
      $scope.priceSheets = resp.price_sheets;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.ChangeTab = function (tabIndex, customerIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedGroup = $scope.customerGroups.data[customerIndex];
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchGroups($scope.searchParams.page);
  };

  $scope.SearchGroups = function (page) {
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchedBy = $scope.searchParams.searchBy;
    $scope.loadingMore = true;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.groupEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.customerGroups = resp.groups;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.OpenCustomerSearchModal = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/customers/',
          params: {
            q: ''
          }
        },
        relationships: ['customers', 'group'],
        fields: ['customer_id', 'name', 'email', '.name'],
        fieldPrefixes: ['ID: ', '', '', 'Group: '],
        id: 'customer_id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.groupEndpoint + $scope.selectedGroup.group_id,
          params: {
            q: ''
          }
        },
        relationships: ['group', 'customers'],
        fields: ['customer_id', 'name', 'email', 'status'],
        fieldPrefixes: ['ID: ', '', '', 'Status: '],
        id: 'customer_id'
      }]
    };
    callback = {
      confirm: $scope.CustomerSearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Select Customers', data, 'Add items');
  };

  $scope.OpenGroupSearchModal = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.groupEndpoint,
          params: {
            q: ''
          }
        },
        relationships: ['groups'],
        fields: ['group_id', 'parent_group_id', 'name', 'default_price_sheet'],
        fieldPrefixes: ['ID: ', 'Parent ID: ', '', 'Price Sheet: '],
        id: 'group_id',
        selectOne: true
      }]
    };
    callback = {
      confirm: $scope.GroupSearchResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.newGroup.name || 'New Group', data, 'Add items');
  };

  $scope.OpenRatesSearchModal = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/shipping/flat-rate/',
          params: {
            q: '',
            excludedField: 'group_id',
            excludedId: $scope.selectedGroup.group_id,
            excludedTable: 'shipping_flat_rate_group'
          }
        },
        relationships: ['shipping_flat_rates'],
        fields: ['id', 'name', 'cost', 'enabled'],
        fieldPrefixes: ['', 'Name: ', 'Cost: ', 'Enabled: '],
        id: 'id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.groupEndpoint + $scope.selectedGroup.group_id
        },
        relationships: ['group'],
        fields: ['name', 'cost', 'enabled'],
        fieldPrefixes: ['Name: ', 'Cost: ', 'Enabled: '],
        id: 'id',
        selectOne: false
      }],
      updatedItems: $scope.updatedRates
    };
    callback = {
      confirm: $scope.rateResults,
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Flat Rates', data, 'Add Shipping Rates');
  };

  $scope.rateResults = function (resp) {
    if ($scope.activeTab === 2) {
      $scope.updatedRates = [];
      resp.forEach(function (rate) {
        if (rate.action === 'add') {
          $scope.updatedRates.push(rate);
          $scope.selectedGroup.shipping_flat_rates.push({
            'id': rate.value.id
          });
        }

        if (rate.action === 'unselect') {
          angular.forEach($scope.selectedGroup.shipping_flat_rates, function (val, key) {
            if (val.id === rate.value.id) {
              $scope.selectedGroup.shipping_flat_rates.splice(key, 1);
            }
          });
        }

        if (rate.action === 'remove') {
          $scope.updatedRates.push(rate);
          $scope.selectedGroup.shipping_flat_rates.push({
            'id': rate.value.id,
            'deleted': 1
          });
        }

        if (rate.action === 'deselect') {
          angular.forEach($scope.selectedGroup.shipping_flat_rates, function (val, key) {
            if (val.id === rate.value.id) {
              $scope.selectedGroup.shipping_flat_rates.splice(key, 1);
            }
          });
        }
      });
    }
  };

  $scope.rateCheck = function (rate) {
    var check = false;
    angular.forEach($scope.updatedRates, function (key) {
      if (key.value.id === rate.id && key.action === 'remove') {
        check = true;
      }
    });
    return check;
  };

  $scope.UpdateGroup = function () {
    $scope.loading = true;
    var req = {
      method: 'PUT',
      url: $scope.groupEndpoint + $scope.selectedGroup.group_id,
      data: $scope.selectedGroup
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (resp.errors.length <= 0) {
        angular.forEach($scope.updatedRates, function (rate) {
          if (rate.action === 'add') {
            $scope.selectedGroup.flatrates.push(rate.value);
          } else {
            angular.forEach($scope.selectedGroup.flatrates, function (val, key) {
              if (val.id === rate.value.id) {
                $scope.selectedGroup.flatrates.splice(key, 1);
              }
            });
          }
        });
        $scope.updatedRates = [];
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.AddGroup = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.groupEndpoint,
      data: $scope.newGroup
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (resp.errors.length <= 0) {
        $scope.newGroup = {};
        $scope.selectedGroup = {
          group_id: resp.group_id
        };
        $scope.activeTab = 2;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.DeleteGroup = function () {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var req = {
          method: 'DELETE',
          url: $scope.groupEndpoint + $scope.selectedGroup.group_id
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          if (resp.errors.length < +0) {
            $scope.selectedGroup = null;
            $scope.activeTab = 0;
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
      },
      cancel: function cancel() {}
    };
    $scope.confirm.Show(callback, 'Delete Group?', 'This will delete your group, all child groups, and clear their users of groups.', 'Back', 'DELETE');
  };

  $scope.UpdateBatchProgress = function () {
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint + 'list',
      params: $scope.sortBatchParams
    };
    var again = false;
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.batches = resp.search_results;

      for (var i = 0; i < $scope.batches.length; i++) {
        if ($scope.batches[i].status === 'processing' && $scope.activeTab === 4) {
          again = true;
          break;
        }
      }

      if (again) {
        $timeout(function () {
          $scope.UpdateBatchProgress();
        }, 1000);
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {});
  };

  $scope.SetUploading = function () {
    $scope.$apply(function ($scope) {
      $scope.uploading = !$scope.uploading;
    });
  };

  $scope.SetFile = function (element) {
    $scope.$apply(function ($scope) {
      $scope.theFile = element.files[0];
    });
    var totalBytes = $scope.theFile.size;

    if (totalBytes < 1000000) {
      $scope.fileSize = Math.floor(totalBytes / 1000) + 'KB';
    } else {
      $scope.fileSize = Math.floor(totalBytes / 1000000) + 'MB';
    }

    Debug.log('File Size: ', $scope.fileSize);
    var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.csv|.txt)$/;

    if (regex.test($scope.theFile.name.toLowerCase())) {
      if (typeof FileReader !== 'undefined') {
        var reader = new FileReader();

        reader.onload = function (e) {
          var groups = [];
          var rows = e.target.result.split('\r\n');
          angular.forEach(rows, function (info, index) {
            if (index <= 19) {
              var cells = info.split(',');

              if (cells.length > 1) {
                var group = [];
                angular.forEach(cells, function (val, key) {
                  group[key] = val;
                });
                groups.push(group);
                $scope.$apply(function () {
                  $scope.groupSheetUpload = groups;
                  $scope.IsVisible = true;
                });
              }
            }
          });
          $scope.SetUploading();
        };

        reader.readAsText($scope.theFile);
      } else {
        $window.alert('This browser does not support HTML5.');
      }
    } else {
      $scope.theFile = null;
      $scope.groupSheetUpload = null;
      $scope.SetUploading();
      $window.alert('Please upload a valid CSV file.');
    }
  };

  $scope.SortBatchIndex = function (sortBy) {
    $scope.sortAscending = $scope.sortBatchParams.sort_by === sortBy ? !$scope.sortAscending : true;
    $scope.sortBatchParams.sort_by = sortBy;
    $scope.sortBatchParams.sort_type = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SortBatches();
  };

  $scope.SortBatches = function () {
    $scope.loadingMore = true;
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint + 'list',
      params: $scope.sortBatchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.batches = resp.search_results;

      for (var i = 0; i < $scope.batches.length; i++) {
        if ($scope.batches[i].status === 'processing') {
          $scope.UpdateBatchProgress();
          break;
        }
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.ChangeBatchTab = function (tabIndex, batchIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedBatch = $scope.batches[batchIndex];
  };

  $scope.postUpload = function (index, id) {
    $scope.selectedBatch = {
      batch_id: id
    };
    $scope.activeTab = index;
  };

  $scope.RemoveUploadFile = function () {
    $scope.groupSheetUpload = null;
    $scope.localized.PushResponseMsg({
      'type': 'danger',
      'message': 'File Successfully Removed'
    });
  };

  $scope.UploadGroup = function () {
    $scope.loading = true;
    var fd = new FormData();
    fd.append('file', $scope.myFile);
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'upload',
      data: fd,
      transformRequest: angular.identity,
      headers: {
        'Content-Type': undefined
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.postUpload(5, resp.batch_id);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.localized.PushResponseMsg({
        'type': 'success',
        'message': 'File Successfully Uploaded'
      });
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.ConfirmBatch = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'confirm',
      data: {
        batch_id: $scope.selectedBatch.batch_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedBatch = null;
      $scope.activeTab = 4;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };
}]);
angular.module('vendorfuelApp').directive('groupFile', ['$parse', function ($parse) {
  return {
    restrict: 'A',
    link: function link(scope, element, attrs) {
      var model = $parse(attrs.groupFile);
      var modelSetter = model.assign;
      element.bind('change', function () {
        scope.$apply(function () {
          modelSetter(scope.$parent.$parent.$parent.$parent, element[0].files[0]);
        });
      });
    }
  };
}]);
angular.module('vendorfuelApp').controller('CustomersController', ['$scope', '$rootScope', 'Admin', 'Localized', 'Anguledit', 'Utils', function ($scope, $rootScope, Admin, Localized, Anguledit, Utils) {
  $rootScope.pageNum = 3;
  $scope.admin = Admin;
  $scope.utils = Utils;
  $scope.localized = Localized;
  $scope.anguledit = Anguledit;
  $rootScope.breadcrumbs = [{
    name: 'Customers',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
}]);
angular.module('vendorfuelApp').controller('DashboardController', ['$scope', '$rootScope', '$http', 'Admin', 'Localized', 'Utils', function ($scope, $rootScope, $http, Admin, Localized, Utils) {
  $rootScope.pageNum = 1;
  $rootScope.pageName = 'Dashboard';
  $scope.admin = Admin;
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.loading = true;
  $scope.user = {
    loginEmail: '',
    loginPassword: ''
  };
  $rootScope.breadcrumbs = [{
    name: 'Dashboard',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];

  $scope.LoginCallback = function () {
    $scope.GetDashboard();
  };

  $scope.GetDashboard = function () {
    $scope.loading = true;
    var req = {
      method: 'GET',
      url: Localized.apiUrl + '/admin/stats/dashboard'
    };
    $http(req).then(function successCallback(response) {
      $scope.dashboardInfo = response.data;
      $scope.loading = false;
    }, function errorCallback(response) {});
  };

  if ($scope.admin.Authed()) {
    $scope.GetDashboard();
  } else {
    $scope.loading = false;
  }
}]);
angular.module('vendorfuelApp').controller('EmailController', ['$scope', '$rootScope', '$state', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'EmailsData', function ($scope, $rootScope, $state, Admin, ConfirmModal, Settings, Debug, Utils, Localized, EmailsData) {
  var bee = null;
  $scope.data = EmailsData.dataEmail();
  $rootScope.pageNum = 6;
  $scope.activeTab = 0;
  $rootScope.breadcrumbs = [{
    name: 'Email',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.loading = false;
  $scope.saving = false;
  $scope.emails = [];
  $scope.emailEndpoint = Localized.apiUrl + '/admin/email/';
  $scope.selectedEmail = {};
  $scope.emailSettings = {};
  $scope.showPassword = false;
  $scope.shortCodes = [];
  $scope.shortCodesConditional = [];
  $scope.pendingOptions = [];
  $scope.verifiedOptions = [];
  $scope.shipmentOptions = $scope.data.shipmentOptions;
  $scope.shipmentConditionals = $scope.data.shipmentConditionals;
  $scope.checkoutOptions = $scope.data.checkoutOptions;
  $scope.checkoutConditionals = $scope.data.checkoutConditionals;
  $scope.registerOptions = $scope.data.registerOptions;
  $scope.rmaOptions = $scope.data.rmaOptions; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.loadingBee = false; //FUNCTIONS

  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TransitionState = function () {
    $state.transitionTo('email', {
      activeTab: $scope.activeTab
    }, {
      location: true,
      inherit: true,
      relative: $state.$current,
      notify: false
    });
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    var req = {
      method: 'GET',
      url: $scope.emailEndpoint
    };

    switch (i) {
      case 0:
        //First tab selected
        req.url += 'template/';
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.emailTemplates = resp.email_templates;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.selectedEmail = $scope.emailTemplates[0];
          $scope.shortCodes = $scope.registerOptions;
          $scope.loading = false;
        });
        break;

      case 1:
        req.url += 'mode/';
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.emailSettings = resp;

          if (_typeof($scope.emailSettings.credentials) !== 'object') {
            $scope.emailSettings.credentials = {
              mail_host: '',
              mail_pass: '',
              mail_user: ''
            };
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 2:
        break;
    }
  };

  $scope.SelectTemplate = function (email) {
    $scope.selectedEmail = email;

    if ($scope.selectedEmail.type === 'shipment') {
      $scope.shortCodes = $scope.shipmentOptions;
      $scope.shortCodesConditional = $scope.shipmentConditionals;
    }

    if ($scope.selectedEmail.type === 'checkout') {
      $scope.shortCodes = $scope.checkoutOptions;
      $scope.shortCodesConditional = $scope.checkoutConditionals;
    }

    if ($scope.selectedEmail.type === 'rma') {
      $scope.shortCodes = $scope.rmaOptions;
      $scope.shortCodesConditional = [];
    }

    if ($scope.selectedEmail.type === 'register') {
      $scope.shortCodes = $scope.registerOptions;
      $scope.shortCodesConditional = [];
    }

    if ($scope.selectedEmail.type === 'verified') {
      $scope.shortCodes = $scope.verifiedOptions;
      $scope.shortCodesConditional = [];
    }

    if ($scope.selectedEmail.type === 'pending-approval') {
      $scope.shortCodes = $scope.pendingOptions;
      $scope.shortCodesConditional = [];
    }

    var templateString = email;
    var template = JSON.parse(email.json);
    bee.load(JSON.parse(template));
  };

  $scope.UpdateSettings = function (settings) {
    $scope.saving = true;
    var params = {};
    params.mode = $scope.emailSettings.mode;

    if ($scope.emailSettings.mode === 'smtp') {
      params.credentials = {
        mail_user: $scope.emailSettings.credentials.mail_user,
        mail_host: $scope.emailSettings.credentials.mail_host,
        mail_pass: $scope.emailSettings.credentials.mail_pass
      };
    }

    console.log('Params: ', params);
    var req = {
      method: 'PUT',
      url: $scope.emailEndpoint + 'mode',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.saving = false;
    });
  };

  $scope.UpdateTemplate = function (html, json) {
    var params = {};
    params.notification = $scope.selectedEmail.notification_emails;
    params.sender = $scope.selectedEmail.sender_email;
    params.name = $scope.selectedEmail.sender_name;
    params.subject = $scope.selectedEmail.subject;
    params.message = html;
    params.json = json; // params.type = $scope.selectedEmail.type;

    var req = {
      method: 'PUT',
      url: $scope.emailEndpoint + 'template/' + $scope.selectedEmail.type,
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      angular.forEach($scope.emailTemplates, function (val, key) {
        if (val.id === resp.email_template.id) {
          // $scope.emailTemplates[key];
          $scope.emailTemplates[key] = resp.email_template;
          $scope.selectedEmail = $scope.emailTemplates[key];
        }
      });
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.savingTemplate = false;
    });
  };

  $scope.UploadTemplate = function (e) {
    var templateFile = e.files[0];
    var reader = new FileReader();

    reader.onload = function () {
      var templateString = reader.result;
      var template = JSON.parse(templateString);
      bee.load(JSON.parse(template));
    };

    reader.readAsText(templateFile);
  };

  var save = function save(filename, content) {
    saveAs(new Blob([content], {
      type: 'text/plain;charset=utf-8'
    }), filename);
  };

  $scope.DownloadHtmlTemplate = function (e) {
    save($scope.selectedEmail.type + '.html', $scope.selectedEmail.message);
  };

  $scope.DownloadJsonTemplate = function () {
    save($scope.selectedEmail.type + '.json', $scope.selectedEmail.json);
  };

  var request = function request(method, url, data, type, callback) {
    var req = new XMLHttpRequest();

    req.onreadystatechange = function () {
      if (req.readyState === 4 && req.status === 200) {
        var response = JSON.parse(req.responseText);
        callback(response);
      } else if (req.readyState === 4 && req.status !== 200) {
        console.error('Access denied, invalid credentials. Please check you entered a valid client_id and client_secret.');
      }
    };

    req.open(method, url, true);

    if (data && type) {
      if (type === 'multipart/form-data') {
        var formData = new FormData();

        for (var _i = 0, _Object$entries = Object.entries(data); _i < _Object$entries.length; _i++) {
          var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
              key = _Object$entries$_i[0],
              value = _Object$entries$_i[1];

          formData.append(key, data[key]);
        }

        data = formData;
      } else {
        req.setRequestHeader('Content-type', type);
      }
    }

    req.send(data);
  };

  var specialLinks = [{
    type: 'unsubscribe',
    label: 'SpecialLink.Unsubscribe',
    link: 'http://[unsubscribe]/'
  }, {
    type: 'subscribe',
    label: 'SpecialLink.Subscribe',
    link: 'http://[subscribe]/'
  }];
  var mergeTags = [{
    name: 'tag 1',
    value: '[tag1]'
  }, {
    name: 'tag 2',
    value: '[tag2]'
  }];
  var mergeContents = [{
    name: 'test',
    value: '[content1]'
  }, {
    name: 'content 2',
    value: '[content1]'
  }];

  function userInput(message, sample) {
    return function handler(resolve, reject) {
      var data = prompt(message, JSON.stringify(sample));
      return data === null || data === '' ? reject() : resolve(JSON.parse(data));
    };
  }

  var beeConfig = {
    uid: $scope.uid,
    container: 'bee-plugin-container',
    autosave: 15,
    language: 'en-US',
    trackChanges: true,
    specialLinks: specialLinks,
    mergeTags: mergeTags,
    mergeContents: mergeContents,
    contentDialog: {
      specialLinks: {
        label: 'Add a custom Special Link',
        handler: userInput('Enter the deep link:', {
          type: 'custom',
          label: 'external special link',
          link: 'http://www.example.com'
        })
      },
      mergeTags: {
        label: 'Add custom tag 2',
        handler: userInput('Enter the merge tag:', {
          name: 'name',
          value: 'name'
        })
      },
      mergeContents: {
        label: 'Choose a custom merge content',
        handler: userInput('Enter the merge content:', {
          name: 'my custom content',
          value: '{my-custom-content}'
        })
      },
      rowDisplayConditions: {
        label: 'Open builder',
        handler: userInput('Enter the row display condition:', {
          type: 'People',
          label: 'Person is a developer',
          description: 'Check if a person is a developer',
          before: '{if job === \'developer\'}',
          after: '{endif}'
        })
      }
    },
    onChange: function onChange(jsonFile, response) {
      console.log('json', jsonFile);
      console.log('response', response);
    },
    onSave: function onSave(jsonFile, htmlFile) {
      $scope.savingTemplate = true; // save('test.json', jsonFile);

      $scope.json = JSON.stringify(jsonFile);
      $scope.UpdateTemplate(htmlFile, $scope.json); // save('newsletter.html', htmlFile);
    },
    onSaveAsTemplate: function onSaveAsTemplate(jsonFile) {
      // + thumbnail?
      save('newsletter-template.json', jsonFile); // $scope.json = JSON.stringify(jsonFile);
      // $scope.UpdateTemplate(htmlFile, $scope.json);
    },
    onAutoSave: function onAutoSave(jsonFile) {
      // + thumbnail?
      console.log(new Date().toISOString() + ' autosaving...');
      window.localStorage.setItem('newsletter.autosave', jsonFile); // $scope.json = JSON.stringify(jsonFile);
      // $scope.UpdateTemplate(htmlFile, $scope.json);
    },
    onSend: function onSend(htmlFile) {//write your send test function here
    },
    onError: function onError(errorMessage) {
      console.log('onError ', errorMessage);
    }
  };

  var getBeeFreeAccessToken = function getBeeFreeAccessToken() {
    if (!$scope.loadingBee) {
      $scope.loadingBee = true;
      var req = {
        method: 'GET',
        url: Localized.apiUrl + '/admin/beefree/token'
      };
      Utils.GetHttpPromise(req).then(function (resp) {
        $scope.accessToken = resp.access_token;
        $scope.uid = resp.uid;
        beeConfig.uid = $scope.uid;
        $scope.SetupBee($scope.accessToken);
      }, function (errResp) {
        Debug.log(errResp);
      }).finally(function () {});
    }
  };

  $scope.SetupBee = function (token) {
    BeePlugin.create(token, beeConfig, function (beePluginInstance) {
      console.log('Config: ', beeConfig);
      bee = beePluginInstance;
      request('GET', 'https://rsrc.getbee.io/api/templates/m-bee', null, null, function () {
        var templateString = $scope.selectedEmail;
        var template = JSON.parse($scope.selectedEmail.json);
        bee.start(JSON.parse(template));
      });
    });
  };

  getBeeFreeAccessToken();
}]);
angular.module('vendorfuelApp').controller('FooterController', [function () {}]);
angular.module('vendorfuelApp').controller('HeaderController', ['$rootScope', '$scope', 'Admin', 'Localized', 'Debug', '$state', '$window', function ($rootScope, $scope, Admin, Localized, Debug, $state, $window) {
  $scope.admin = Admin;
  $scope.localized = Localized;
  $scope.notifications = Localized.GetNotifications();

  $scope.RemoveNotification = function (index) {
    Localized.RemoveNotification(index);
  };

  $scope.Logout = function () {
    $rootScope.CollapseMenu();
    Admin.Logout();
  };
  /** Tutorial Setup via Cookies **/


  $scope.tutorialComplete = $window.localStorage.getItem('tutorialComplete');
  $scope.showTutorial = $window.localStorage.getItem('showTutorial');

  if (!$scope.tutorialComplete) {
    $window.localStorage.setItem('showTutorial', 'true');
  }

  if (!$scope.showTutorial) {
    $window.localStorage.setItem('tutorialComplete', 'false');
  }

  $scope.startTutorial = function () {
    if ($scope.tutorialComplete === 'false' && Admin.Authed()) {
      $state.go('tutorial');
      Debug.log('The tutorial is active.', $scope.showTutorial);
    }
  };

  $scope.startTutorial();
  /** End Tutorial Setup **/

  $rootScope.menuItems = [{
    sref: 'dashboard',
    title: 'Dashboard',
    icon: 'fa-tachometer-alt'
  }, {
    sref: 'admin',
    title: 'Admin',
    icon: 'fa-lock'
  }, {
    sref: 'customers',
    title: 'Customers',
    icon: 'fa-users'
  }, {
    sref: 'catalog',
    title: 'Catalog',
    icon: 'fa-file-alt',
    paramEnabled: true,
    paramValue: 0
  }, {
    sref: 'anguledit',
    title: 'AngulEdit',
    icon: 'fa-code'
  }, {
    sref: 'email',
    title: 'Email',
    icon: 'fa-envelope'
  }, {
    sref: 'orders',
    title: 'Orders',
    icon: 'fa-credit-card'
  }, {
    sref: 'reports',
    title: 'Reports',
    icon: 'fa-chart-bar'
  }, {
    sref: 'shipping',
    title: 'Shipping',
    icon: 'fa-truck'
  }, {
    sref: 'taxes',
    title: 'Taxes',
    icon: 'fa-percent'
  }, {
    sref: 'payments',
    title: 'Payments',
    icon: 'fa-handshake'
  }, {
    sref: 'settings',
    title: 'Settings',
    icon: 'fa-sliders-h',
    paramEnabled: true,
    paramValue: 0
  }, {
    sref: 'logout',
    title: 'Logout'
  }];

  $scope.ClearNotifications = function () {
    Localized.ClearNotifications();
  };

  $rootScope.CollapseMenu = function () {
    jQuery('.navbar-collapse').collapse('hide');
  };
}]);
angular.module('vendorfuelApp').controller('LoginController', ['$scope', 'Admin', 'Utils', function ($scope, Admin, Utils) {
  $scope.loggingIn = false;
  $scope.utils = Utils;
  $scope.utils.redirecting = false;
  Admin.login_errors = {};
  $scope.admin = Admin;
  $scope.user = {
    loginEmail: '',
    loginPassword: ''
  };
  var parentCallback = $scope.$parent.LoginCallback;

  $scope.trimExtraSp = function (str) {
    return str.replace(/\s+/g, '');
  };

  $scope.Login = function () {
    Admin.login_errors = {};
    $scope.loggingIn = true;
    Admin.Login($scope.user.loginEmail, $scope.trimExtraSp($scope.user.loginPassword), $scope.user.loginAuthenticator).then(function successCallback() {
      if (parentCallback && Object.keys(Admin.login_errors).length === 0) {
        parentCallback();
      }

      $scope.loggingIn = false;

      if (Object.keys(Admin.login_errors).length === 0) {
        if ($scope.utils.ReturnLocation !== null) {
          $scope.utils.setLocation($scope.utils.ReturnLocation, false);
          $scope.utils.redirecting = false;
          $scope.utils.ReturnLocation = null;
        }
      }
    });
  };

  $scope.ToggleShowPassword = function (type) {
    if (type === 'password') {
      $scope.showPassword = !$scope.showPassword;
    }

    if (type === 'conf') {
      $scope.showPasswordConf = !$scope.showPasswordConf;
    }
  };
}]);
angular.module('vendorfuelApp').controller('LogoutController', ['$scope', '$rootScope', '$state', 'Admin', function ($scope, $rootScope, $state, Admin) {
  $rootScope.breadcrumbs = [{
    name: 'Logout',
    state: null
  }];
  $scope.admin = Admin;

  $scope.Logout = function () {
    $rootScope.CollapseMenu();
    Admin.Logout();
    $state.go('dashboard');
  };

  $scope.Logout();
}]);
angular.module('vendorfuelApp').controller('MenuController', ['$scope', 'Admin', function ($scope, Admin) {
  $scope.admin = Admin;

  $scope.Logout = function () {
    Admin.Logout();
  };
}]);
angular.module('vendorfuelApp').controller('OrdersController', ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', '$uibModal', 'orders', function ($scope, $rootScope, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, $uibModal, orders) {
  $scope.countryData = orders.ordersData();
  $rootScope.pageNum = 7;
  $scope.orders = [];
  $rootScope.breadcrumbs = [{
    name: 'Orders',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.loading = true;
  $scope.loadingMore = false;
  $scope.searchTerm = '';
  $scope.saving = false;
  $scope.saved = false;
  $scope.localized = Localized;
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.ordersEndpoint = Localized.apiUrl + '/admin/orders/';
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    q: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.states = $scope.countryData.states;
  $scope.countries = $scope.countryData.countries;
  $scope.selectedOrder = {};
  $scope.selectedOrder.order_id = $stateParams.order || null; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils; //FUNCTIONS

  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    var req = {
      method: 'GET',
      url: $scope.ordersEndpoint,
      params: $scope.searchParams
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.orders = resp.orders;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        $scope.loading = false;
        break;

      case 3:
        $scope.loading = false;
        break;

      case 4:
        req.url += $scope.selectedOrder.order_id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedOrder = resp.order;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.ChangeTab = function (tab, index) {
    $scope.selectedOrder = $scope.orders.data[index];
    $scope.activeTab = tab;
  };

  $scope.filterOrders = function (filter) {
    if (filter === 'default') {
      $scope.searchParams.status = '';
    } else {
      $scope.searchParams.status = filter;
    }

    $scope.SearchOrders();
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.SearchOrders($scope.searchParams.page);
  };

  $scope.SearchOrders = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchParams.page = page || 1;

    if ($scope.searchParams.status) {
      $scope.searchParams.searchBy = 'Status';
    }

    var req = {
      method: 'GET',
      url: $scope.ordersEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.orders = resp.orders;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.GoToProduct = function (item) {
    $state.go('catalog-products', {
      activeTab: 2,
      product: item
    });
  };

  $scope.OpenRmaModal = function (item) {
    var order = $scope.selectedOrder;
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/rma.html',
      size: 'lg',
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.loading = false;
        $scope.order = order;
        $scope.item = item;
        $scope.returnStatuses = {
          none: 'No return requested',
          requested: 'Requested',
          denied: 'Denied',
          approved: 'Approved',
          refunded: 'Refunded',
          replaced: 'Replaced'
        };
        $scope.returnReasons = {
          defective: 'Defective',
          'wrong item': 'Wrong Item',
          exchange: 'Exchange',
          other: 'Other'
        };

        $scope.Confirm = function () {
          $scope.loading = true;
          var req = {
            method: 'POST',
            url: Localized.apiUrl + '/admin/rma/modify',
            data: $scope.item
          };
          Utils.GetHttpPromise(req).then(function (resp) {
            $uibModalInstance.close();
          }, function (errResp) {
            Debug.log(errResp);
          }).finally(function () {
            $scope.loading = false;
          });
        };

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };
      }]
    }).result.then(function () {
      $scope.TabChanged(4);
    }, function () {});
  };

  $scope.OpenShipmentModal = function () {
    var order_id = $scope.selectedOrder.order_id;
    var states = $scope.states;
    var countries = $scope.countries;
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/shipment.html',
      size: 'lg',
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.loading = false;
        $scope.shipment = {
          order_id: order_id,
          country_code: 'US',
          country_phone_code: 1
        };
        $scope.states = states;
        $scope.countries = countries;

        $scope.Confirm = function () {
          $scope.loading = true;
          var req = {
            method: 'POST',
            url: Localized.apiUrl + '/admin/order/shipment/add',
            data: $scope.shipment
          };
          Utils.GetHttpPromise(req).then(function (resp) {
            $uibModalInstance.close();
          }, function (errResp) {
            Debug.log(errResp);
            $scope.loading = false;
          }).finally(function () {});
        };

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };
      }]
    }).result.then(function () {
      $scope.TabChanged(4);
    }, function () {});
  };

  $scope.ResendOrder = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/order/resend',
      data: {
        order_id: $scope.selectedOrder.order_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.TabChanged(4);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.ResendEmail = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/order/resend-email',
      data: {
        order_id: $scope.selectedOrder.order_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.RemoveShipment = function (shipment) {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/order/shipment/remove',
      data: {
        shipment_id: shipment.shipment_id
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.TabChanged(4);
    }, function (errResp) {
      Debug.log(errResp);
      $scope.loading = false;
    }).finally(function () {});
  };

  $scope.setUploading = function () {
    $scope.$apply(function ($scope) {
      $scope.uploading = !$scope.uploading;
    });
  };

  $scope.setFile = function (element) {
    $scope.$apply(function ($scope) {
      $scope.theFile = element.files[0];
    });
    var fd = new FormData();
    fd.append('file', $scope.theFile);
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/order/shipment/upload/zip',
      data: fd,
      transformRequest: angular.identity,
      headers: {
        'Content-Type': undefined
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.uploading = false;
    });
  };
}]);
angular.module('vendorfuelApp').directive('fileModel', ['$parse', function ($parse) {
  return {
    restrict: 'A',
    link: function link(scope, element, attrs) {
      var model = $parse(attrs.fileModel);
      var modelSetter = model.assign;
      element.bind('change', function () {
        scope.$apply(function () {
          modelSetter(scope.$parent.$parent.$parent, element[0].files);
        });
      });
    }
  };
}]);
angular.module('vendorfuelApp').controller('PaymentProcessorController', ['$scope', '$parse', function ($scope, $parse) {
  $scope.processorIndex = null;
  $scope.enabled = 0;
  $scope.attributeCount = 0;
  $scope.$watch('$viewContentLoaded', function () {
    if ($scope.$parent.gateways[$scope.processorIndex]) {
      var gateway = $scope.$parent.gateways[$scope.processorIndex];
      $scope.enabled = Number(gateway.enabled);
      var i = 1;
      angular.forEach(gateway, function (value, key) {
        //$scope.attributeCount = i;
        if (key !== 'enabled') {
          var index = 'atrributeIndex';
          var valueIndex = 'attribute';
          index = index.concat(i);
          valueIndex = valueIndex.concat(i);
          $parse(index).assign($scope, key);
          $parse(valueIndex).assign($scope, value);
          i++;
        }
      });
    } else {
      for (var j = 1; j <= $scope.attributeCount;) {
        var valueIndex = 'attribute';
        valueIndex = valueIndex.concat(j);
        $parse(valueIndex).assign($scope, '');
        j++;
      }
    }

    console.log($scope);
  });

  $scope.updateGateway = function () {
    console.log($scope);
    var gateway = {};
    gateway[$scope.processorIndex] = {};
    gateway[$scope.processorIndex].enabled = $scope.enabled;

    for (var i = 1; i <= $scope.attributeCount;) {
      var index = 'attributeIndex';
      var valueIndex = 'attribute';
      index = index.concat(i);
      valueIndex = valueIndex.concat(i);

      if ($scope[index] !== 'enabled') {
        console.log($scope[index]);
        console.log($scope[valueIndex]);
        gateway[$scope.processorIndex][$scope[index]] = $scope[valueIndex];
        i++;
      }
    }

    $scope.$parent.gateways[$scope.processorIndex] = gateway[$scope.processorIndex];
    $scope.$parent.updateGateway(gateway);
  };

  $scope.setPrimaryCCProcessor = function () {
    var gateway = {};
    gateway[$scope.processorIndex] = {};

    if ($scope.keyIndex !== '') {
      gateway[$scope.processorIndex][$scope.keyIndex] = $scope.key;
    }

    if ($scope.secretIndex !== '') {
      gateway[$scope.processorIndex][$scope.secretIndex] = $scope.secret;
    }

    gateway[$scope.processorIndex].enabled = $scope.enabled;
    $scope.$parent.gateways[$scope.processorIndex] = gateway[$scope.processorIndex];
    $scope.$parent.setPrimaryCCProcessor(gateway);
  };

  $scope.authorizeAccess = function () {
    $scope.$parent.authorizeAccess($scope.processorIndex);
  };

  $scope.revokeAccess = function () {
    $scope.$parent.revokeAccess($scope.processorIndex);
  };
}]);
angular.module('vendorfuelApp').controller('PaymentsController', ['$filter', '$scope', '$rootScope', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', function ($filter, $scope, $rootScope, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $rootScope.pageNum = 10;
  $rootScope.breadcrumbs = [{
    name: 'Catalog',
    state: 'catalog'
  }, {
    name: 'Payments',
    state: null
  }];
  $scope.loading = false;
  $scope.gatewaysEndpoint = Localized.apiUrl + '/admin/gateways/';
  $scope.addParams = {};
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    q: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.gateways = [];
  $scope.gateway = {};
  $scope.selectedGateway = null; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.templates = [{
    name: 'Qualpay',
    url: localized.dir.url + '/assets/app/templates/payment_processors/QualPay.html'
  }, {
    name: 'AuthorizeNet',
    url: localized.dir.url + '/assets/app/templates/payment_processors/AuthorizeNet.html'
  }, {
    name: 'PayPal',
    url: localized.dir.url + '/assets/app/templates/payment_processors/PayPal.html'
  }, {
    name: 'PayFabric',
    url: localized.dir.url + '/assets/app/templates/payment_processors/PayFabric.html'
  }, {
    name: 'Stripe',
    url: localized.dir.url + '/assets/app/templates/payment_processors/Stripe.html'
  }, {
    name: 'SquareUp',
    url: localized.dir.url + '/assets/app/templates/payment_processors/SquareUp.html'
  }];
  $scope.template = $scope.templates[0]; //FUNCTIONS

  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.SearchResults = function (resp) {
    //callback that is used by the search modal
    Debug.log(resp);
  };

  $scope.SearchCancelled = function () {//callback that is used by the search modal
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    var req = {
      method: 'GET',
      url: $scope.gatewaysEndpoint
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.gateways = resp.gateways;
          angular.forEach($scope.gateways, function (value, key) {
            if (value.enabled === 1) {
              $scope.template = $filter('filter')($scope.templates, {
                name: key
              })[0];
            }
          });
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.updateGateway = function (gateway) {
    var data = {};
    data.gateways = gateway;
    var req = {
      method: 'PUT',
      url: $scope.gatewaysEndpoint,
      data: data
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if ('paypal' in gateway) {
        $scope.utils.HttpPut($scope.localized.wpRestUrl + '/settings/paypal', {}, {
          paypal_client_id: gateway.paypal.client_id
        });
      }

      if ('authnet' in gateway) {
        $scope.utils.HttpPut($scope.localized.wpRestUrl + '/settings/authnet', {}, {
          public_key: gateway.authnet.key,
          id: gateway.authnet.id
        });
      }

      if ('stripe' in gateway) {
        $scope.utils.HttpPut($scope.localized.wpRestUrl + '/settings/stripe', {}, {
          stripe_pk: gateway.stripe.publishableKey
        });
      }

      if ('squareup' in gateway) {
        $scope.utils.HttpPut($scope.localized.wpRestUrl + '/settings/squareup', {}, {
          location_id: gateway.squareup.locationID
        });
      }

      $scope.utils.HttpPut($scope.localized.wpRestUrl + '/payment/enabled', {}, {
        gateway: gateway
      });
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.authorizeAccess = function (processorIndex) {
    $scope.loading = true;
    var req = {
      method: 'GET',
      url: Localized.apiUrl + '/admin/payments/' + processorIndex + '/authorize'
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      window.open(resp.auth_url, '_blank');
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.revokeAccess = function (processorIndex) {
    $scope.loading = true;
    var req = {
      method: 'GET',
      url: Localized.apiUrl + '/admin/payments/' + processorIndex + '/revoke'
    };
    Utils.GetHttpPromise(req).then(function (resp) {//window.open(resp.auth_url,'_blank');
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.ChangeTab = function (tabIndex, uomIndex) {
    $scope.activeTab = tabIndex;
  };
}]);
angular.module('vendorfuelApp').controller('ReportsController', ['$scope', '$rootScope', '$cookies', '$timeout', 'Admin', 'Reports', 'Debug', 'Settings', 'Localized', 'Utils', '$stateParams', 'ConfirmModal', function ($scope, $rootScope, $cookies, $timeout, Admin, Reports, Debug, Settings, Localized, Utils, $stateParams, ConfirmModal) {
  $rootScope.pageNum = 8;
  $rootScope.pageName = 'Reports';
  $rootScope.breadcrumbs = [{
    name: 'Reports',
    state: 'reports',
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.admin = Admin;
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.reportsEndpoint = Localized.apiUrl + '/reports/'; // $scope.user = {loginEmail: "", loginPassword: ""};

  $scope.reportLoading = false;
  $scope.loading = false; // Initialize objects/arrays

  $scope.storeTables = Reports.getStoreTables();
  $scope.allTables = Reports.getAllTables();
  $scope.comparators = Reports.getComparators();
  $scope.rppValues = [15, 30, 50, 100];
  $scope.per_page = $scope.rppValues[0];
  $scope.confirm = ConfirmModal;
  $scope.clear = true;
  $scope.savedReports = []; // List of person/shared reports that were saved

  $scope.downloads = []; // List of downloaded reports

  $scope.allColumns = []; // Columns of all selected tables
  // Schedule update response message variable

  $scope.scheduleSaveSuccessful = false;
  $scope.scheduleSaveError = false;
  $scope.frequencies = {
    'daily': 'Daily',
    'weekly': 'Weekly',
    'monthly': 'Monthly',
    'quarterly': 'Quarterly',
    'clear': 'Clear Schedule'
  }; // Data and headers for table after running report

  $scope.reportData = {};
  $scope.reportHeaders = [];
  $scope.filterOperators = ['OR', 'AND'];
  $scope.joinTypes = {
    'standard': 'Standard',
    'left': 'Left',
    'right': 'Right'
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    $scope.loading = true;
    Settings.errors = {};
    var req = {
      method: 'GET',
      url: $scope.reportsEndpoint
    };

    switch (i) {
      case 0:
        // Initialize reports page
        // Request saved reports from API, populate saved reports list
        req.url += 'all';
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.savedReports = [];
          angular.forEach(resp.personal_reports, function (value, key) {
            $scope.savedReports.push(value);
          });
          angular.forEach(resp.shared_reports, function (value, key) {
            $scope.savedReports.push(value);
          });
          $scope.AssignReport(null);
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        req.url += 'download';
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.downloads = resp.reports;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 2:
        req.url += 'all';
        $scope.scheduleReports = {};
        $scope.scheduleReports.id = [];
        $scope.scheduleReports.frequency = [];
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.savedReports = [];
          angular.forEach(resp.personal_reports, function (value, key) {
            $scope.savedReports.push(value);
          });
          angular.forEach(resp.shared_reports, function (value, key) {
            $scope.savedReports.push(value);
          });
          $scope.AssignReport(null);
          angular.forEach($scope.savedReports, function (value, key) {
            $scope.scheduleReports.id.push(value.id);
            $scope.scheduleReports.frequency.push(value.frequency);
          });
          $scope.UpdateScheduleModel(0);
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.AddJoinRow = function () {
    var initJoin = $scope.allTables.admin_groups[0];
    $scope.selectedParams.joinTable.push(initJoin.table);
    $scope.UpdateColumns(initJoin.table, '');
    $scope.selectedParams.joinSelect.push(initJoin.value);
    $scope.selectedParams.joinTerm.push('=');
    $scope.selectedParams.joinValue.push('');
    $scope.selectedParams.joinIsNested.push(false);
    $scope.selectedParams.joinType.push('standard');
  };

  $scope.AddFilterRow = function () {
    if ($scope.selectedParams.filterSelect.push('') === 1) {
      $scope.selectedParams.filterToken.push('(', 'ex', ')');
    } else {
      $scope.selectedParams.filterToken.splice($scope.selectedParams.filterToken.length - 1, 0, 'ex');
    }

    $scope.selectedParams.filterTerm.push($scope.comparators[0]);
    $scope.selectedParams.filterValue.push('');
    $scope.selectedParams.filterOperator.push('OR');
  };

  $scope.AddGroupFilter = function (index, type) {
    var tokenGroup = ['(', 'ex', ')'];
    var exCount = 0;

    for (var i = 0; i < $scope.selectedParams.filterToken.length; i++) {
      if ($scope.selectedParams.filterToken[i] === 'ex') {
        if (index === exCount) {
          if (type === 'group') {
            $scope.selectedParams.filterToken.splice.apply($scope.selectedParams.filterToken, [i + 1, 0].concat(tokenGroup));
          } else {
            $scope.selectedParams.filterToken.splice(i + 1, 0, 'ex');
          }

          break;
        }

        exCount++;
      }
    }

    $scope.selectedParams.filterSelect.splice(index + 1, 0, '');
    $scope.selectedParams.filterTerm.splice(index + 1, 0, $scope.comparators[0]);
    $scope.selectedParams.filterValue.splice(index + 1, 0, '');
    $scope.selectedParams.filterOperator.splice(index + 1, 0, 'OR');
  }; // Populate selectedParams object with selected saved report


  $scope.AssignReport = function (selectedReport) {
    // Reset report parameters
    // Parameters to use in request with the API
    $scope.clear = false;
    $scope.selectedParams = {};
    $scope.selectedParams.tables = [];
    $scope.selectedParams.headers = [];
    $scope.selectedParams.joinTable = [];
    $scope.selectedParams.joinSelect = [];
    $scope.selectedParams.joinTerm = [];
    $scope.selectedParams.joinValue = [];
    $scope.selectedParams.joinType = [];
    $scope.selectedParams.joinIsNested = [];
    $scope.selectedParams.filterSelect = [];
    $scope.selectedParams.filterTerm = [];
    $scope.selectedParams.filterValue = [];
    $scope.selectedParams.filterOperator = [];
    $scope.selectedParams.filterToken = [];
    $scope.selectedParams.groupBy = [];
    $scope.selectedParams.nestedQuery = []; // Only supported in the JOIN clause right now

    $scope.selectedParams.direction = 'asc';
    $scope.selectedParams.shared = false;
    $scope.allColumns = [];

    if (!selectedReport) {
      return;
    }

    $scope.selectedParams.tables.push(selectedReport.tables.value[0]);
    $scope.UpdateColumns($scope.selectedParams.tables[0], '');

    if (selectedReport.joins.table) {
      for (var i = 0; i < selectedReport.joins.table.length; i++) {
        $scope.selectedParams.joinTable[i] = selectedReport.joins.table[i];
        $scope.selectedParams.joinSelect[i] = selectedReport.joins.select[i];
        $scope.selectedParams.joinTerm[i] = selectedReport.joins.term[i];
        $scope.selectedParams.joinValue[i] = selectedReport.joins.value[i];
        $scope.selectedParams.joinType[i] = selectedReport.joins.type[i];
        $scope.selectedParams.joinIsNested[i] = selectedReport.joins.isNested[i];
        $scope.UpdateColumns($scope.selectedParams.joinTable[i], '');
      }
    }

    if (selectedReport.filters.select) {
      for (var j = 0; j < selectedReport.filters.select.length; j++) {
        $scope.selectedParams.filterSelect[j] = selectedReport.filters.select[j];
        $scope.selectedParams.filterTerm[j] = selectedReport.filters.term[j];
        $scope.selectedParams.filterValue[j] = selectedReport.filters.value[j];
        $scope.selectedParams.filterOperator[j] = selectedReport.filters.operator[j];
      }

      for (var l = 0; l < selectedReport.filters.token.length; l++) {
        $scope.selectedParams.filterToken[l] = selectedReport.filters.token[l];
      }
    }

    for (var p = 0; p < selectedReport.headers.value.length; p++) {
      $scope.selectedParams.headers[p] = selectedReport.headers.value[p];
    }

    $scope.selectedParams.shared = selectedReport.shared;
    $scope.selectedParams.report_id = selectedReport.id;
    $scope.selectedParams.order = selectedReport.order;
    $scope.selectedParams.direction = selectedReport.direction;
    $scope.selectedParams.name = selectedReport.name;
    $scope.selectedParams.frequency = selectedReport.frequency;
  };

  $scope.ClearReport = function (report) {
    $scope.reportData = {};
    $scope.AssignReport(null);
    $scope.clear = true;
  };

  $scope.DeleteReport = function (selectedReport) {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var req = {
          method: 'DELETE',
          url: $scope.reportsEndpoint + selectedReport.id
        };
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.TabChanged(0);
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
      },
      cancel: function cancel() {}
    };
    $scope.confirm.Show(callback, 'Delete Report?', 'This action cannot be undone.', 'Back', 'DELETE');
  };

  $scope.Download = function (download_id) {
    var tokenA = $cookies.get('vendorfuel-admin-tokena');
    var tokenB = $cookies.get('vendorfuel-admin-tokenb');
    var req = $scope.reportsEndpoint + 'download/' + download_id + '?apikey=' + Localized.apiKey + '&tokena=' + tokenA + '&tokenb=' + tokenB;
    window.open(req, '_blank'); // var a = document.createElement('A');
    // a.href = req;
    // a.download = req.substr(req.lastIndexOf('/') + 1);
    // document.body.appendChild(a);
    // a.click();
    // document.body.removeChild(a);
  };

  $scope.DownloadReport = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.reportsEndpoint + 'export',
      data: $scope.selectedParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.GroupNumber = function (index) {
    var exCount = 0;
    var depth = 0;

    for (var i = 0; i < $scope.selectedParams.filterToken.length; i++) {
      if ($scope.selectedParams.filterToken[i] === '(') {
        depth++;
      }

      if ($scope.selectedParams.filterToken[i] === ')') {
        depth--;
      }

      if ($scope.selectedParams.filterToken[i] === 'ex') {
        if (index === exCount) {
          break;
        }

        exCount++;
      }
    }

    return depth - 1;
  };

  $scope.RemoveJoin = function (index) {
    $scope.selectedParams.joinSelect.splice(index, 1);
    $scope.selectedParams.joinTerm.splice(index, 1);
    $scope.selectedParams.joinValue.splice(index, 1);
    $scope.selectedParams.joinIsNested.splice(index, 1);
    $scope.selectedParams.joinType.splice(index, 1);
    var removedJoin = $scope.selectedParams.joinTable.splice(index, 1);
    $scope.UpdateColumns('', removedJoin[0]);
  };

  $scope.RemoveFilter = function (index) {
    var exCount = 0;

    for (var i = 0; i < $scope.selectedParams.filterToken.length; i++) {
      if ($scope.selectedParams.filterToken[i] === 'ex') {
        if (exCount === index) {
          var x = 1;

          while ($scope.selectedParams.filterToken[i - x] === '(' && $scope.selectedParams.filterToken[i + x] === ')') {
            $scope.selectedParams.filterToken[i - x] = ' ';
            $scope.selectedParams.filterToken[i + x] = ' ';
            x++;
          }

          $scope.selectedParams.filterToken[i] = ' ';
          break;
        }

        exCount++;
      }
    }

    for (i = $scope.selectedParams.filterToken.length - 1; i >= 0; i--) {
      if ($scope.selectedParams.filterToken[i] === ' ') {
        $scope.selectedParams.filterToken.splice(i, 1);
      }
    }

    $scope.selectedParams.filterSelect.splice(index, 1);
    $scope.selectedParams.filterTerm.splice(index, 1);
    $scope.selectedParams.filterValue.splice(index, 1);
    $scope.selectedParams.filterOperator.splice(index, 1);
  };

  $scope.RunReport = function (rpp, page) {
    $scope.reportRan = false;
    $scope.reportLoading = true; // $scope.loading = true;

    $scope.selectedParams.rpp = rpp;
    $scope.selectedParams.page = page;
    var req = {
      method: 'POST',
      url: $scope.reportsEndpoint + 'run',
      data: $scope.selectedParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.reportData = resp.results;

      if (resp.results && resp.results.data && resp.results.data.length) {
        $scope.reportHeaders = Object.keys(resp.results.data[0]);
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      // $scope.loading = false;
      $scope.reportLoading = false;
      $scope.reportRan = true;
    });
  };

  $scope.SaveReport = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.reportsEndpoint,
      data: $scope.selectedParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.Test = function () {
    Debug.log($scope.scheduleReports);
    Debug.log($scope.selectedParams);
  }; // Update table columns


  $scope.UpdateColumns = function (newValue, oldValue) {
    // If removing columns
    if (oldValue !== '') {
      // Check if table we're switching from is not selected on another table/join, else skip
      if (!$scope.selectedParams.tables.includes(oldValue) && !$scope.selectedParams.joinTable.includes(oldValue)) {
        var i = $scope.allColumns.length;
        var found = false;

        while (i-- && !found) {
          // Find table we're switching from and remove from list
          if ($scope.allColumns[i].table === oldValue) {
            for (var j = 0; j < $scope.allTables[oldValue].length; j++) {
              $scope.allColumns.splice(i--, 1);
            }

            found = true;
          }
        }
      }
    } // If adding columns


    if (newValue !== '') {
      var tableExists = false,
          k = $scope.allColumns.length - 1;

      while (!tableExists && k >= 0) {
        // Check if new table/join is already in list
        if ($scope.allColumns[k].table === newValue) {
          tableExists = true;
        }

        k--;
      }

      if (!tableExists) {
        // If table not in list, add
        angular.forEach($scope.allTables[newValue], function (value, key) {
          $scope.allColumns.push(value);
        });
      }
    }
  };

  $scope.UpdateReport = function (selectedReport) {
    $scope.loading = true;
    var req = {
      method: 'PUT',
      url: $scope.reportsEndpoint + selectedReport.id,
      data: $scope.selectedParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.UpdateScheduleModel = function (index) {
    $scope.selectedId = $scope.savedReports[index].id;
    $scope.scheduleReports.selectedIndex = index;
  };

  $scope.UpdateSchedules = function () {
    $scope.loading = true;
    angular.forEach($scope.scheduleReports.frequency, function (value, key) {
      if (value === 'Clear Schedule') {
        $scope.scheduleReports.frequency[key] = 'null';
      }
    });
    var req = {
      method: 'POST',
      url: $scope.reportsEndpoint + 'schedule',
      data: $scope.scheduleReports
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (!resp.errors.length) {
        $scope.scheduleSaveSuccessful = true;
        $timeout(function () {
          $scope.scheduleSaveSuccessful = false;
        }, 5000);
      } else {
        $scope.scheduleSaveError = true;
        $timeout(function () {
          $scope.scheduleSaveError = false;
        }, 5000);
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.AssignReport(null);
}]);
angular.module('vendorfuelApp').controller('ResetPasswordController', ['$scope', 'Admin', 'Localized', 'Utils', '$location', '$stateParams', function ($scope, Admin, Localized, Utils, $location, $stateParams) {
  $scope.requesting = false;
  $scope.utils = Utils;
  $scope.localized = Localized;
  $scope.utils.redirecting = false;
  Admin.login_errors = {};
  $scope.admin = Admin;
  $scope.resetEmail = null;
  $scope.password = '';
  $scope.password_confirmation = '';
  var parentCallback = $scope.$parent.LoginCallback;

  if ($stateParams.code && $stateParams.auth) {
    $scope.reseting = true;
  }

  $scope.trimExtraSp = function (str) {
    return str.replace(/\s+/g, '');
  };

  $scope.requestReset = function () {
    Admin.login_errors = {};
    $scope.requesting = true;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/password-reset/request',
      data: {
        email: $scope.resetEmail,
        url: $location.absUrl()
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      // Debug.log(resp);
      $scope.requested = true;
      $scope.requesting = false;
    }, function (errResp) {//  Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.submitReset = function () {
    Admin.login_errors = {};
    $scope.submitting = true;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/admin/password-reset/submit',
      data: {
        code: $stateParams.code,
        auth: $stateParams.auth,
        password: $scope.password,
        password_confirmation: $scope.password_confirmation
      }
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      Admin.SetTokens(resp.name, resp.tokena, resp.tokenb, resp.token);
      $scope.utils.setLocation('/dashboard');
      console.log($scope.localized);
    }, function (errResp) {
      console.log($scope.localized);
    }).finally(function () {
      $scope.submitting = false;
    });
  };
}]);
angular.module('vendorfuelApp').controller('SettingsController', ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'Tenant', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', '$timeout', '$window', function ($scope, $rootScope, $state, $stateParams, Admin, Tenant, ConfirmModal, Settings, Debug, Utils, Localized, $timeout, $window) {
  //Controller instantiation and injection of the following: $scope and $rootScope (local and global scope), $http (used to make HTTP requests), Admin (VF Admin factory), ConfirmModal (VF modal to confirm actions), Settings (VF factory to update and retrieve settings)
  //SCOPE VARIABLES AND INITIALIZATION
  $rootScope.pageNum = 13;
  $rootScope.pageName = 'Settings';
  $rootScope.breadcrumbs = [{
    name: 'Settings',
    state: 'settings({activeTab : 0})'
  }, {
    name: 'General',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.loading = true;
  $scope.saving = false;
  $scope.saved = false;
  $scope.activeTab = parseInt($stateParams.activeTab); //FACTORIES

  $scope.admin = Admin;
  $scope.tenant = Tenant;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.loadingWallet = false;
  $scope.loadedWallet = false;
  $scope.walletUrl = null;

  if ($stateParams.id && $stateParams.activeTab === 5) {
    updateBilling($stateParams.id);
  }

  $scope.resetTutorial = function () {
    $scope.saving = true;
    $timeout(function () {
      $window.localStorage.setItem('tutorialComplete', 'false');
      $window.localStorage.setItem('showTutorial', 'true');
      Debug.log('Tutorial cookies have been reset.');
      $scope.saving = false;
    }, 1000).then(function () {
      Localized.PushResponseMsg({
        'type': 'success',
        'message': 'Tutorial cookies have been reset.'
      });
    });
  };

  $scope.sendPaymentDataToAnet = function () {
    $scope.loading = true;
    var authData = {};
    authData.clientKey = '6xPAg3UaLrk68ZpavX8GUK9NrZeEZgDFtKSvqf9AFS4263Z7At756YM6QqRsYsyy';
    authData.apiLoginID = '3k74XW9b6';
    var cardData = {};
    console.log($scope.settings.billing);
    cardData.cardNumber = $scope.settings.billing.saved.card.number;
    cardData.month = $scope.settings.billing.saved.card.expMonth.toString();
    cardData.year = $scope.settings.billing.saved.card.expYear.toString();
    cardData.cardCode = $scope.settings.billing.saved.card.cvv.toString();
    var secureData = {};
    secureData.authData = authData;
    secureData.cardData = cardData;
    Accept.dispatchData(secureData, responseHandler);
  };

  function updateBilling(id) {
    $scope.settings.billing.saved.cardId = id;
    delete $scope.settings.billing.saved.card;
    var req = {
      method: 'POST',
      url: Localized.apiUrl + '/tenant/billing/update',
      data: $scope.settings.billing.saved
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      Debug.log(resp);
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  }

  $scope.retrieveWalletUrl = function () {
    if (!$scope.loadingWallet && !$scope.loadedWallet) {
      $scope.loadingWallet = true;
      $scope.loadedWallet = false;
      var req = {
        method: 'GET',
        url: Localized.apiUrl + '/tenant/billing/wallet/url',
        params: {
          'return_url': Localized.apiUrl + '/tenant/PayFabricReturn/'
        }
      };
      Utils.GetHttpPromise(req).then(function (resp) {
        console.log(resp);
        $scope.walletUrl = resp.url;
        var win = window.open($scope.walletUrl, '_blank', 'channelmode=yes,fullscreen=no,menubar=no,titlebar=no,toolbar=no,status=no,width=800,height=800');
        var timer = setInterval(function () {
          if (win.closed) {
            clearInterval(timer);
            $scope.LoadBillingSettings();
          }
        }, 1000);
        $scope.loadedWallet = true;
      }, function (errResp) {
        Debug.log(errResp);
      }).finally(function () {
        $scope.loadingWallet = false;
      });
    }
  };

  function responseHandler(response) {
    if (response.messages.resultCode === 'Error') {
      var i = 0;

      while (i < response.messages.message.length) {
        console.log(response.messages.message[i].code + ': ' + response.messages.message[i].text);
        i = i + 1;
      }

      $scope.loading = false;
    } else {
      $scope.settings.billing.saved.opaqueDataDescriptor = response.opaqueData.dataDescriptor;
      $scope.settings.billing.saved.opaqueDataValue = response.opaqueData.dataValue;
      $scope.settings.billing.saved.cardEnding = $scope.settings.billing.saved.card.number.replace(/\d(?=\d{4})/g, 'X');
      delete $scope.settings.billing.saved.card;
      var req = {
        method: 'POST',
        url: Localized.apiUrl + '/tenant/billing/update',
        data: $scope.settings.billing.saved
      };
      Utils.GetHttpPromise(req).then(function (resp) {
        Debug.log(resp);
      }, function (errResp) {
        Debug.log(errResp);
      }).finally(function () {
        $scope.loading = false;
      });
    }
  } //FUNCTIONS


  $scope.LoginCallback = function () {
    $scope.loading = true;

    if ($scope.activeTab === 0) {
      $scope.LoadStoreSettings();
    } else if ($scope.activeTab === 3) {
      $scope.LoadGatewaysSettings();
    } else if ($scope.activeTab === 4) {
      $scope.LoadBillingSettings();
    }
  };

  $scope.TransitionState = function () {
    $state.transitionTo('settings', {
      activeTab: $scope.activeTab
    }, {
      location: true,
      inherit: true,
      relative: $state.$current,
      notify: false
    });
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    $scope.TransitionState();
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    $scope.cancelled = false;

    switch (i) {
      case 0:
        $rootScope.breadcrumbs[1].name = 'Store';
        getSettings(Settings.store);
        break;

      case 1:
        $rootScope.breadcrumbs[1].name = 'Plugin';
        getSettings(Settings.general);
        break;

      case 2:
        $rootScope.breadcrumbs[1].name = 'Conversions';
        getSettings(Settings.conversions);
        break;

      case 3:
        $rootScope.breadcrumbs[1].name = 'Images';
        getSettings(Settings.image);
        break;
    }
  };

  $scope.SubmitUpdate = function (i, form) {
    switch (i) {
      case 0:
        $scope.UpdateStoreSettings(form);
        break;

      case 1:
        $scope.UpdateGeneralSettings(form);
        break;

      case 2:
        $scope.UpdateConversionsSettings(form);
        break;

      case 3:
        $scope.UpdateImageSettings(form);
        break;
    }
  };

  function getSettings(tab) {
    var promise = tab.Get().then(function successCallback(response) {
      console.log('!!', tab.saved);
      $scope.loading = false;
    }, function errorCallback(response) {
      $scope.loading = false;
    });
    return promise;
  }

  function updateSettings(tab, form) {
    Settings.errors = {};
    $scope.saving = true;
    $scope.saved = false;
    $scope.cancelled = false;
    var promise = tab.Set().then(function successCallback(response) {
      $scope.saving = false;
      $scope.saved = Object.keys(Settings.errors).length === 0;
      form.$setPristine();
      form.$setUntouched();
    }, function errorCallback(response) {
      $scope.saving = false;
    });
    return promise;
  }

  $scope.LoadStoreSettings = function () {
    $scope.loading = true;

    if ($scope.admin.Authed()) {
      getSettings(Settings.store);
    } else {
      $scope.loading = false;
    }
  };

  $scope.LoadGatewaysSettings = function () {
    $scope.loading = true;

    if ($scope.admin.Authed()) {
      getSettings(Settings.gateways);
    } else {
      $scope.loading = false;
    }
  };

  $scope.LoadBillingSettings = function (r) {
    if (r === undefined) {
      r = false;
    }

    $scope.loading = true;

    if ($scope.tenant.Authed()) {
      getSettings(Settings.billing);
    } else {
      $scope.loading = false;
    }
  };

  $scope.UpdateGeneralSettings = function (form) {
    if ($scope.settings.general.saved.apiUrl === '' || $scope.settings.general.saved.apiKey === '') {
      Admin.Logout();
    }

    updateSettings(Settings.general, form);
  };

  $scope.UpdateStoreSettings = function (form) {
    updateSettings(Settings.store, form);
  };

  $scope.UpdateConversionsSettings = function (form) {
    updateSettings(Settings.conversions, form);
  };

  $scope.UpdateImageSettings = function (form) {
    updateSettings(Settings.image, form);
  };

  $scope.UpdateGatewaysSettings = function (form) {
    updateSettings(Settings.gateways, form);
  };

  $scope.UpdateBillingSettings = function (form) {
    updateSettings(Settings.billing, form).then(function () {
      getSettings(Settings.billing);
    });
  };

  $scope.CancelSubscription = function () {
    $scope.saving = true;
    $scope.saved = false;
    $scope.cancelled = false;
    Settings.billing.cancelling = true;
    Settings.billing.Cancel().then(function () {
      getSettings(Settings.billing).then(function () {
        $scope.saving = false;

        if (Settings.billing.saved.status !== 'active') {
          $scope.cancelled = true;
          Settings.billing.cancelling = false;
        }
      });
    });
  };

  $scope.SubscriptionNotcancelled = function () {
    Debug.log('CANCELLATION NOT CONFIRMED!');
  };

  $scope.ConfirmCancelSubscription = function () {
    var callback = {
      confirm: $scope.CancelSubscription,
      cancel: $scope.SubscriptionNotcancelled
    };
    ConfirmModal.Show(callback, 'Are you sure you want to cancel your subscription?', 'We will be sorry to see you go...', 'No', 'Yes');
  };
}]);
angular.module('vendorfuelApp').controller('ShippingFlatRatesController', ['$scope', '$rootScope', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', function ($scope, $rootScope, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, SearchModal) {
  $rootScope.breadcrumbs = [{
    name: 'Shipping',
    state: 'shipping'
  }, {
    name: 'Flat Rates',
    state: null
  }];
  $scope.loading = true;
  $scope.saving = false;
  $scope.saved = false;
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.shippingFlatRateEndpoint = Localized.apiUrl + '/admin/shipping/flat-rate/';
  $scope.selectedFlatRate = null;
  $scope.createFlatRate = {
    name: '',
    label: '',
    cost: 0.00,
    free_if_total: 0,
    free_order_total: 0.00,
    enabled: 0,
    modifiers: []
  };
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    q: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.updatedCustomers = [];
  $scope.del = 0; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils; //FUNCTIONS

  $scope.updateModifiers = function (rateType, modType, index) {
    if (modType === 0) {
      if (rateType.modifiers.length - $scope.del < 5) {
        rateType.modifiers.push({
          'cost': 0,
          'order_total_min': 0,
          'order_total_max': 0
        });
      }
    } else if (modType === 1) {
      $scope.del += 1;

      if (rateType.modifiers[index].hasOwnProperty('id')) {
        rateType.modifiers[index].deleted = 1;
      } else {
        rateType.modifiers.splice(index, 1);
      }
    }

    return false;
  };

  $scope.TabChanged = function (i) {
    $scope.modifiers = [];

    if ($scope.selectedFlatRate && $scope.selectedFlatRate.modifiers) {
      $scope.selectedFlatRate.modifiers = [];
    }

    Localized.ClearResponseMsg();
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    var req = {
      method: 'GET',
      url: $scope.shippingFlatRateEndpoint
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.flatRates = resp.shipping_flat_rates;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.createFlatRate = {
          name: '',
          label: '',
          cost: 0.00,
          free_if_total: 0,
          free_order_total: 0.00,
          enabled: 0,
          modifiers: []
        };
        $scope.loading = false;
        break;

      case 2:
        req.url += $scope.selectedFlatRate.id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedFlatRate = resp.shipping_flat_rate;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          if ($scope.selectedFlatRate && $scope.selectedFlatRate.modifiers) {
            $scope.modifiers = angular.copy($scope.selectedFlatRate.modifiers);
          }

          $scope.loading = false;
        });
        break;
    }
  };

  $scope.DeleteFlatRate = function () {
    $scope.deleting = true;
    var req = {
      method: 'DELETE',
      url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.selectedFlatRate = null;
      $scope.activeTab = 0;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.deleting = false;
    });
  };

  $scope.ChangeTab = function (tabIndex, flatRateIndex) {
    $scope.activeTab = tabIndex;
    $scope.selectedFlatRate = $scope.flatRates.data[flatRateIndex];
  };

  $scope.CreateFlatRate = function () {
    $scope.updating = true;
    var params = $scope.createFlatRate;
    var req = {
      method: 'POST',
      url: $scope.shippingFlatRateEndpoint,
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (!resp.errors || resp.errors.length <= 0) {
        $scope.selectedFlatRate = {
          id: resp.id
        };
        $scope.createFlatRate = {
          name: '',
          label: '',
          cost: 0.00,
          free_if_total: 0,
          free_order_total: 0.00,
          enabled: 0,
          modifiers: []
        };
        $scope.activeTab = 2;
        $scope.localized.PushResponseMsg({
          'type': 'success',
          'message': 'Map Successfully Removed'
        });
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.updating = false;
    });
  };

  $scope.OpenCustomerSearchModal = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/customers/',
          params: {
            q: '',
            excludedField: 'shipping_flat_rate_id',
            excludedId: $scope.selectedFlatRate.id,
            excludedTable: 'shipping_flat_rate_customer'
          }
        },
        relationships: ['customers'],
        fields: ['customer_id', 'name', 'email', 'status'],
        fieldPrefixes: ['ID: ', '', '', 'Status: '],
        id: 'customer_id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id,
          params: {
            q: ''
          }
        },
        relationships: ['shipping_flat_rate', 'customerSearchItems'],
        fields: ['customer_id', 'name', 'email', 'status'],
        fieldPrefixes: ['ID: ', '', '', 'Status: '],
        id: 'customer_id'
      }],
      updatedItems: $scope.updatedCustomers
    };
    callback = {
      confirm: $scope.customerSearchResults,
      cancel: function cancel() {//Cancelled
      }
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Select Customers', config, 'Add items');
  };

  $scope.OpenGroupSearchModal = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/groups/',
          params: {
            q: '',
            excludedField: 'shipping_flat_rate_id',
            excludedId: $scope.selectedFlatRate.id,
            excludedTable: 'shipping_flat_rate_group'
          }
        },
        relationships: ['groups'],
        fields: ['group_id', 'name'],
        fieldPrefixes: ['ID: ', ''],
        id: 'group_id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id,
          params: {
            q: ''
          }
        },
        relationships: ['shipping_flat_rate', 'groupSearchItems'],
        fields: ['group_id', 'name'],
        fieldPrefixes: ['ID: ', ''],
        id: 'group_id'
      }],
      updatedItems: $scope.updatedGroups
    };
    callback = {
      confirm: $scope.groupSearchResults,
      cancel: function cancel() {//Cancelled
      }
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Select Groups', config, 'Add items');
  };

  $scope.OpenPriceSheetSearchModal = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiUrl + '/admin/pricesheets/',
          params: {
            q: '',
            excludedField: 'shipping_flat_rate_id',
            excludedId: $scope.selectedFlatRate.id,
            excludedTable: 'shipping_flat_rate_price_sheet'
          }
        },
        relationships: ['pricesheets'],
        fields: ['price_sheet_id', 'sheet'],
        fieldPrefixes: ['ID: ', ''],
        id: 'price_sheet_id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id,
          params: {
            q: ''
          }
        },
        relationships: ['shipping_flat_rate', 'priceSheetSearchItems'],
        fields: ['price_sheet_id', 'sheet'],
        fieldPrefixes: ['ID: ', ''],
        id: 'price_sheet_id'
      }],
      updatedItems: $scope.updatedSheets
    };
    callback = {
      confirm: $scope.sheetSearchResults,
      cancel: function cancel() {//Cancelled
      }
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Select Price Sheets', config, 'Add items');
  };

  $scope.customerSearchResults = function (resp) {
    if ($scope.activeTab === 2) {
      $scope.updatedCustomers = [];
      resp.forEach(function (result) {
        if (result.action === 'add') {
          $scope.updatedCustomers.push(result);
          $scope.selectedFlatRate.customers.push({
            'customer_id': result.value.customer_id,
            'status': result.value.status,
            'name': result.value.name,
            'email': result.value.email,
            'action': 'add'
          });
        }

        if (result.action === 'unselect') {
          angular.forEach($scope.selectedFlatRate.customers, function (val, key) {
            if (val.customer_id === result.value.customer_id) {
              $scope.selectedFlatRate.customers.splice(key, 1);
            }
          });
        }

        if (result.action === 'remove') {
          $scope.updatedCustomers.push(result);
          angular.forEach($scope.selectedFlatRate.customers, function (val, key) {
            if (val.customer_id === result.value.customer_id) {
              $scope.selectedFlatRate.customers[key].deleted = 1;
              $scope.selectedFlatRate.customers[key].action = 'remove';
            }
          });
        }

        if (result.action === 'deselect') {
          angular.forEach($scope.selectedFlatRate.customers, function (val, key) {
            if (val.customer_id === result.value.customer_id) {
              $scope.selectedFlatRate.customers.splice(key, 1);
            }
          });
        }
      });
    }
  };

  $scope.customerCheck = function (customer) {
    var check = false;
    angular.forEach($scope.updatedCustomers, function (key) {
      if (key.value.id === customer.customer_id && key.action === 'remove') {
        check = true;
      }
    });
    return check;
  };

  $scope.groupSearchResults = function (resp) {
    if ($scope.activeTab === 2) {
      $scope.updatedGroups = [];
      resp.forEach(function (result) {
        if (result.action === 'add') {
          $scope.updatedGroups.push(result);
          $scope.selectedFlatRate.groups.push({
            'group_id': result.value.group_id,
            'name': result.value.name,
            'action': 'add'
          });
        }

        if (result.action === 'unselect') {
          angular.forEach($scope.selectedFlatRate.groups, function (val, key) {
            if (val.group_id === result.value.group_id) {
              $scope.selectedFlatRate.groups.splice(key, 1);
            }
          });
        }

        if (result.action === 'remove') {
          $scope.updatedGroups.push(result);
          angular.forEach($scope.selectedFlatRate.groups, function (val, key) {
            if (val.group_id === result.value.group_id) {
              $scope.selectedFlatRate.groups[key].deleted = 1;
              $scope.selectedFlatRate.groups[key].action = 'remove';
            }
          });
        }

        if (result.action === 'deselect') {
          angular.forEach($scope.selectedFlatRate.groups, function (val, key) {
            if (val.group_id === result.value.group_id) {
              $scope.selectedFlatRate.groups.splice(key, 1);
            }
          });
        }
      });
    }
  };

  $scope.SearchShippingFlatRates = function (page) {
    $scope.loadingMore = true;
    $scope.searchTerm = $scope.searchParams.q;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.shippingFlatRateEndpoint,
      data: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.flatRates = resp.shipping_flat_rates;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.sheetSearchResults = function (resp) {
    if ($scope.activeTab === 2) {
      $scope.updatedSheets = [];
      resp.forEach(function (result) {
        if (result.action === 'add') {
          $scope.updatedSheets.push(result);
          $scope.selectedFlatRate.pricesheets.push({
            'id': result.value.price_sheet_id,
            'price_sheet_id': result.value.price_sheet_id,
            'name': result.value.sheet,
            'action': 'add'
          });
        }

        if (result.action === 'unselect') {
          angular.forEach($scope.selectedFlatRate.pricesheets, function (val, key) {
            if (val.price_sheet_id === result.value.price_sheet_id) {
              $scope.selectedFlatRate.pricesheets.splice(key, 1);
            }
          });
        }

        if (result.action === 'remove') {
          $scope.updatedSheets.push(result);
          angular.forEach($scope.selectedFlatRate.pricesheets, function (val, key) {
            if (val.price_sheet_id === result.value.price_sheet_id) {
              $scope.selectedFlatRate.pricesheets[key].deleted = 1;
              $scope.selectedFlatRate.pricesheets[key].action = 'remove';
            }
          });
        }

        if (result.action === 'deselect') {
          angular.forEach($scope.selectedFlatRate.pricesheets, function (val, key) {
            if (val.price_sheet_id === result.value.price_sheet_id) {
              $scope.selectedFlatRate.pricesheets.splice(key, 1);
            }
          });
        }
      });
    }
  };

  $scope.UpdateFlatRate = function () {
    $scope.updating = true;
    var req = {
      method: 'PUT',
      url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id,
      data: $scope.selectedFlatRate
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      Debug.log($scope.selectedFlatRate);

      if (resp.errors.length <= 0) {
        $scope.updateResults();
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.updating = false;
    });
  };

  $scope.updateResults = function () {
    angular.forEach($scope.updatedCustomers, function (result) {
      if (result.action === 'remove') {
        angular.forEach($scope.selectedFlatRate.customers, function (val, key) {
          if (val.customer_id === result.value.customer_id) {
            $scope.selectedFlatRate.customers.splice(key, 1);
          }
        });
      }
    });
    angular.forEach($scope.updatedGroups, function (result) {
      if (result.action === 'remove') {
        angular.forEach($scope.selectedFlatRate.groups, function (val, key) {
          if (val.group_id === result.value.group_id) {
            $scope.selectedFlatRate.groups.splice(key, 1);
          }
        });
      }
    });
    angular.forEach($scope.updatedSheets, function (result) {
      if (result.action === 'remove') {
        angular.forEach($scope.selectedFlatRate.pricesheets, function (val, key) {
          if (val.price_sheet_id === result.value.price_sheet_id) {
            $scope.selectedFlatRate.pricesheets.splice(key, 1);
          }
        });
      }
    });
    $scope.updatedGroups = [];
    $scope.updatedCustomers = [];
    $scope.updatedPriceSheets = [];
  };
}]);
angular.module('vendorfuelApp').controller('ShippingParcelsController', ['$scope', '$rootScope', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', function ($scope, $rootScope, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
  $rootScope.breadcrumbs = [{
    name: 'Shipping',
    state: 'shipping'
  }, {
    name: 'Shipping Parcels',
    state: null
  }];
  $scope.loading = true;
  $scope.saving = false;
  $scope.saved = false;
  $scope.addSuccess = '';
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.shippingParcelEndpoint = Localized.apiUrl + '/admin/shipping/parcel/';
  $scope.selectedParcel = null;
  $scope.warehouse = {};
  $scope.gateways = {};
  $scope.createParcel = {};
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    q: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.distanceUnits = {
    'in': 'Inches',
    'cm': 'Centimeters'
  }; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;

  $scope.clearAddCatagory = function () {
    $scope.addSuccess = '';
  }; //FUNCTIONS


  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    var req = {
      method: 'GET',
      url: $scope.shippingParcelEndpoint
    };

    switch (i) {
      case 0:
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.shippingParcels = resp.parcels;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 1:
        $scope.loading = false;
        break;

      case 2:
        Debug.log('2');
        req.url += $scope.selectedParcel.id;
        Utils.GetHttpPromise(req).then(function (resp) {
          $scope.selectedParcel = resp.data.parcel;
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 3:
        req.url = Localized.apiUrl + '/admin/shipping/gateways';
        Utils.GetHttpPromise(req).then(function (resp) {
          if (resp.gateways) {
            $scope.gateways = resp.gateways;

            if (_typeof($scope.gateways.shippo) === 'object' && ($scope.gateways.shippo.key || $scope.gateways.shippo.key === '')) {
              $scope.gateways.shippo = $scope.gateways.shippo.key;
            }
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;

      case 4:
        req.url = Localized.apiUrl + '/admin/shipping/warehouse';
        Utils.GetHttpPromise(req).then(function (resp) {
          if (resp.warehouse) {
            $scope.warehouse = resp.warehouse;
          }
        }, function (errResp) {
          Debug.log(errResp);
        }).finally(function () {
          $scope.loading = false;
        });
        break;
    }
  };

  $scope.ChangeTab = function (tabIndex, index) {
    console.log($scope.shippingParcels.data[index]);
    $scope.activeTab = tabIndex;
    $scope.selectedParcel = $scope.shippingParcels.data[index];
  };

  $scope.CreateParcel = function () {
    $scope.loading = true;
    var params = $scope.createParcel;
    var req = {
      method: 'POST',
      url: $scope.shippingParcelEndpoint,
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      if (!resp.errors.length) {
        $scope.selectedParcel = {
          id: resp.parcel.id
        };
        $scope.createParcel = {};
        $scope.activeTab = 2;
      }
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.addSuccess = Localized.GetResponseMsgs();
    });
  };

  $scope.SearchParcels = function (page) {
    $scope.loadingMore = true;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.shippingParcelEndpoint,
      params: $scope.searchParams
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.shippingParcels = resp.parcels;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loadingMore = false;
    });
  };

  $scope.UpdateParcel = function () {
    $scope.loading = true;
    var req = {
      method: 'PUT',
      url: $scope.shippingParcelEndpoint + $scope.selectedParcel.id,
      data: $scope.selectedParcel
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.UpdateWarehouse = function () {
    $scope.loading = true;
    var params = $scope.warehouse;
    var req = {
      method: 'PUT',
      url: Localized.apiUrl + '/admin/shipping/warehouse',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.UpdateGateways = function () {
    $scope.loading = true;
    var params = {
      gateways: $scope.gateways
    };
    var req = {
      method: 'PUT',
      url: Localized.apiUrl + '/admin/shipping/gateways',
      data: params
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
      $scope.localized.PushResponseMsg({
        'type': 'success',
        'message': 'Gateway Successfully Updated'
      });
    });
  };

  if ($scope.activeTab === 2 && !$scope.selectedParcel) {
    $scope.activeTab = 0;
  }
}]);
angular.module('vendorfuelApp').controller('ShippingController', ['$scope', '$rootScope', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', function ($scope, $rootScope, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
  $rootScope.pageNum = 10;
  $rootScope.breadcrumbs = [{
    name: 'Shipping',
    state: null
  }];
  $scope.loading = true;
  $scope.updating = false;
  $scope.shippingMode = null;
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.modeEndpoint = Localized.apiUrl + '/admin/shipping/mode/'; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils;

  $scope.GetModeSetting = function () {
    var req = {
      method: 'GET',
      url: $scope.modeEndpoint
    };
    Utils.GetHttpPromise(req).then(function (resp) {
      $scope.shippingMode = resp;
    }, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.loading = false;
    });
  };

  $scope.UpdateModeSetting = function () {
    $scope.updating = true;
    var req = {
      method: 'PUT',
      url: $scope.modeEndpoint,
      data: $scope.shippingMode
    };
    Utils.GetHttpPromise(req).then(function (resp) {}, function (errResp) {
      Debug.log(errResp);
    }).finally(function () {
      $scope.updating = false;
      $scope.localized.PushResponseMsg({
        'type': 'success',
        'message': 'Shipping Mode Successfully Updated'
      });
    });
  };
}]);
angular.module('vendorfuelApp').controller('SubscribeController', ['$rootScope', '$scope', '$http', '$filter', 'Utils', 'Settings', 'Localized', 'Debug', '$timeout', function ($rootScope, $scope, $http, $filter, Utils, Settings, Localized, Debug, $timeout) {
  $scope.localized = Localized;
  $scope.utils = Utils;
  $scope.utils.redirecting = false;
  $rootScope.pageNum = 0;
  $rootScope.pageName = 'Subscribe';
  $rootScope.breadcrumbs = [{
    name: 'Subscribe',
    state: null
  }];
  $scope.vfApiUrl = $rootScope.vfApiUrl;
  $scope.signUpDisable = '!store.name || !store.url || !store.first_name || !store.last_name || !store.email || !store.emailConfirmation || !store.password || !store.passwordConfirm ||!terms || !privacy';
  $scope.tiers = [{
    description: 'Kindling',
    pricesheets: '1',
    products: '5',
    price: 0,
    value: 4,
    selected: false
  }, {
    description: 'Ember',
    pricesheets: '1',
    products: '25',
    price: 19,
    value: 1,
    selected: false
  }, {
    description: 'Inferno',
    pricesheets: 'Unlimited',
    products: 'Unlimited',
    price: 99,
    value: 3,
    selected: false
  }, {
    description: 'Flame',
    pricesheets: '2',
    products: '100',
    price: 49,
    value: 2,
    selected: false
  }];
  $scope.selectedTier = null;
  $scope.submittingOrder = false;
  $scope.orderComplete = false;
  $scope.store = {
    storeName: '',
    storeUrl: '',
    first_name: '',
    last_name: '',
    email: '',
    password: '',
    passwordConfirm: ''
  };
  $scope.billing = {
    firstName: '',
    lastName: '',
    addressLineOne: '',
    addressLineTwo: '',
    city: '',
    state: '',
    postalCode: ''
  };
  $scope.payment = {
    cardNumber: '',
    expMonth: '',
    expYear: '',
    cvv: ''
  };
  Utils.HttpGet(Localized.wpRestUrl + '/wp/site/info').then(function successCallback(response) {
    $scope.store.name = response.name;
    $scope.store.url = response.url;
  }); // $scope.cleanErrorMessages = function(str){
  // 	return str.toString().trim()
  // }

  $scope.selectTier = function (tier) {
    $scope.selectedTier = tier;
    angular.forEach($scope.tiers, function (value, key) {
      if (tier.value === value.value) {
        value.selected = true;
      } else {
        value.selected = false;
      }
    });
  };

  $scope.ToggleShowPassword = function (type) {
    if (type === 'password') {
      $scope.showPassword = !$scope.showPassword;
    }

    if (type === 'conf') {
      $scope.showPasswordConf = !$scope.showPasswordConf;
    }
  };

  $scope.formValidation = $scope.store.name || $scope.store.url || $scope.store.first_name || $scope.store.last_name || $scope.store.email || $scope.store.emailConfirmation || $scope.store.password || $scope.store.passwordConfirm;

  $scope.SignUp = function () {
    $scope.errors = [];
    $scope.submittingOrder = true;
    $scope.orderComplete = false;
    var req = {
      method: 'POST',
      url: $scope.vfApiUrl + '/tenant/stores',
      data: {
        'store': {
          'tier': $scope.selectedTier.value,
          'name': $scope.store.name,
          'url': $scope.store.url
        },
        'user': {
          'first_name': $scope.store.first_name,
          'last_name': $scope.store.last_name,
          'email': $scope.store.email,
          'email_confirmation': $scope.store.emailConfirmation,
          'password': $scope.store.password,
          'password_confirmation': $scope.store.passwordConfirm,
          'phone': $scope.store.phone
        }
      }
    };
    $http(req).then(function (resp) {
      Debug.log('REQUEST COMPLETED', resp);
      angular.forEach(resp.data.errors, function (value, key) {
        $scope.localized.PushNotification({
          'type': 'danger',
          'message': value
        });
      });
      $scope.storeDetails = resp.data.store;
      $scope.storeDetails.billing = resp.data.billing;
      $timeout(function (response) {
        if (resp.data && resp.data.errors && resp.data.errors.length > 0) {
          $scope.errors = resp.data.errors;
        } else {
          //TODO: set apikey
          $scope.storeDetails.term = '1 Month';
          $scope.storeDetails.nextBillDate = $filter('date')($scope.storeDetails.billing.next_payment_due, 'longDate');
          Localized.apiKey = $scope.storeDetails.api_key;
          Settings.general.Get().then(function successCallback(response) {
            Settings.general.saved.apiKey = Localized.apiKey;
            Settings.general.Set();
            Debug.log(Settings.general.saved);
            $scope.orderComplete = true;
          });
        }

        if ($scope.utils.ReturnLocation !== null) {
          $scope.utils.setLocation($scope.utils.ReturnLocation, false);
          $scope.utils.ReturnLocation = null;
          $scope.utils.redirecting = false;
        }

        $scope.submittingOrder = false;
      }, 1500);
    }, function (response) {
      Debug.log('REQUEST FAILED', response); //$scope.subscribe.errors = Errors.parseToList(resp.data)
      //$scope.errors.push(Object.values(resp.data.errors));
      //$scope.errors.push(Object.values(resp.data.errors).reduce((c, v) => c.concat(v), []));

      if (response.data && response.data.errors) {
        angular.forEach(response.data.errors, function (value, key) {
          var err = Utils.cleanErrorMessages(value); //var errors = value.toString().trim()

          $scope.errors.push(err);
        });
      }

      $scope.submittingOrder = false;
      return response;
    });
  };
}]);
angular.module('vendorfuelApp').controller('TaxesController', ['$rootScope', '$scope', 'SelectModal', 'Utils', 'Localized', '$window', 'AlertModal', 'Admin', '$stateParams', '$state', 'taxes', function ($rootScope, $scope, SelectModal, Utils, Localized, $window, AlertModal, Admin, $stateParams, $state, taxes) {
  //SCOPE VARIABLES AND INITIALIZATION
  $scope.taxes = taxes.taxesData();
  $rootScope.breadcrumbs = [{
    name: 'Taxes',
    state: null,
    url: 'https://docs.vendorfuel.com'
  }];
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $scope.selectedStates = [];
  $scope.stateOptions = $scope.taxes.stateTaxes;
  $scope.avalaraConfig = {};
  $scope.saveAvalaraConfig = {};
  $scope.avalaraTestConnection = false; //FACTORIES

  $scope.admin = Admin;
  $scope.localized = Localized;
  $scope.utils = Utils; //FUNCTIONS

  $scope.TransitionState = function () {
    $state.transitionTo('taxes', {
      activeTab: $scope.activeTab
    }, {
      location: true,
      inherit: true,
      relative: $state.$current,
      notify: false
    });
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    $scope.TransitionState();
    $scope.loading = true;

    switch (i) {
      case 0:
        Utils.HttpGet($rootScope.vfApiUrl + '/admin/tax-states').then(function (response) {
          $scope.selectedStates = response.tax_states;
          $scope.BuildStateOptions();
          $scope.loading = false;
        });
        break;

      case 1:
        Utils.HttpGet($rootScope.vfApiUrl + '/admin/tax/avalara/config').then(function (response) {
          $scope.avalaraConfig = response.avalara_config;
          $scope.avalaraConfig.tax_enabled = intToBool($scope.avalaraConfig.tax_enabled);
          $scope.avalaraConfig.address_validation = intToBool($scope.avalaraConfig.address_validation);
          $scope.avalaraConfig.document_committing = intToBool($scope.avalaraConfig.document_committing);
          $scope.avalaraConfig.logging = intToBool($scope.avalaraConfig.logging);
          $scope.loading = false;
        });
        break;
    }
  }; // Tab 1


  $scope.BuildSelectedStateArr = function () {
    var tempArr = [];
    angular.forEach($scope.stateOptions, function (option) {
      if (option.active) {
        tempArr.push(option.value);
      }
    });
    $scope.selectedStates = tempArr;
  };

  $scope.BuildStateOptions = function () {
    angular.forEach($scope.selectedStates, function (state) {
      var optionIndex = $scope.stateOptions.findIndex(function (i) {
        return i.value === state ? i : false;
      });

      if (optionIndex >= 0) {
        $scope.stateOptions[optionIndex].active = true;
      }
    });
  };

  $scope.SelectStatesCallback = function (options) {
    $scope.loading = true;
    $scope.stateOptions = options;
    $scope.BuildSelectedStateArr();
    var params = {}; // TODO: This cannot be the right way to do submit the array of states, but this is the only way I could get it to work

    angular.forEach($scope.selectedStates, function (state, index) {
      var paramString = 'state_id[' + index + ']';
      params[paramString] = state;
    });
    Utils.HttpPost($rootScope.vfApiUrl + '/admin/tax-states', params).then(function (response) {
      $scope.loading = false;
    });
  };

  $scope.SelectStates = function () {
    var callback = {
      confirm: $scope.SelectStatesCallback
    };
    SelectModal.Show(callback, 'Select States', $scope.stateOptions);
  };

  $scope.GetStateCount = function () {
    return Object.keys($scope.selectedStates).length;
  }; // Tab 2


  $scope.AvalaraTest = function () {
    $scope.loading = true;
    Utils.HttpPost($rootScope.vfApiUrl + '/admin/tax/avalara/test', $scope.avalaraConfig).then(function (response) {
      $scope.avalaraTestConnection = response.errors.length <= 0;
      var testMessage = 'Avalara connection test successful!';

      if (!$scope.avalaraTestConnection) {
        testMessage = 'Avalara connection test failed!';
      }

      var callback = {
        confirm: function confirm() {
          $scope.loading = false;
        }
      };
      AlertModal.Show(callback, 'Connection Test Results', testMessage, 'Ok');
    });
  };

  $scope.ViewLog = function () {
    $scope.loading = true;
    Utils.HttpPost($rootScope.vfApiUrl + '/admin/tax/avalara/log', $scope.avalaraConfig).then(function (response) {
      if (response.log) {
        var callback = {
          confirm: function confirm() {
            $scope.loading = false;
          }
        };
        AlertModal.Show(callback, 'Connection Test Results', response.log, 'Ok');
      }
    });
  };

  $scope.AvalaraDashboard = function () {
    $window.open('https://admin-avatax.avalara.net/login.aspx');
  };

  $scope.Save = function () {
    $scope.loading = true;
    $scope.avalaraConfig.tax_enabled = boolToInt($scope.avalaraConfig.tax_enabled);
    $scope.avalaraConfig.address_validation = boolToInt($scope.avalaraConfig.address_validation);
    $scope.avalaraConfig.document_committing = boolToInt($scope.avalaraConfig.document_committing);
    $scope.avalaraConfig.logging = boolToInt($scope.avalaraConfig.logging);
    Utils.HttpPut($rootScope.vfApiUrl + '/admin/tax/avalara/config', $scope.avalaraConfig).then(function (response) {
      $scope.avalaraConfig.tax_enabled = intToBool($scope.avalaraConfig.tax_enabled);
      $scope.avalaraConfig.address_validation = intToBool($scope.avalaraConfig.address_validation);
      $scope.avalaraConfig.document_committing = intToBool($scope.avalaraConfig.document_committing);
      $scope.avalaraConfig.logging = intToBool($scope.avalaraConfig.logging);
      $scope.loading = false;
    });
  };

  function intToBool(val) {
    if (val === '1' || val === 1) {
      return true;
    } else {
      return false;
    }
  }

  function boolToInt(val) {
    if (val === true) {
      return 1;
    } else {
      return 0;
    }
  }
}]);
angular.module('vendorfuelApp').controller('TenantLoginController', ['$scope', 'Tenant', 'Utils', 'Admin', function ($scope, Tenant, Utils, Admin) {
  $scope.loggingIn = false;
  $scope.utils = Utils;
  $scope.utils.redirecting = false;
  $scope.admin = Admin;
  Tenant.login_errors = {};
  $scope.loginErrors = [];
  $scope.user = {
    loginEmail: '',
    loginPassword: ''
  };
  var parentCallback = $scope.$parent.LoginCallback;

  $scope.Login = function () {
    Tenant.login_errors = {};
    $scope.loggingIn = true;
    Tenant.Login($scope.user.loginEmail, $scope.user.loginPassword).then(function successCallback() {
      if (parentCallback && Object.keys(Tenant.login_errors).length === 0) {
        parentCallback();
      }

      if (Object.keys(Tenant.login_errors).length) {
        $scope.loginErrors.push(Tenant.login_errors.toString());
        console.log('xxxxx', $scope.loginErrors);
        console.log('sdsdsds', Tenant.login_errors);
        $scope.loggingIn = false;
      }

      if (Object.keys(Tenant.login_errors).length === 0) {
        if ($scope.utils.ReturnLocation !== null) {
          $scope.utils.setLocation($scope.utils.ReturnLocation, false);
          $scope.utils.redirecting = false;
          $scope.utils.ReturnLocation = null;
        }
      }
    });
  };

  $scope.ToggleShowPassword = function (type) {
    if (type === 'password') {
      $scope.showPassword = !$scope.showPassword;
    }
  };
}]);
angular.module('vendorfuelApp').controller('TutorialController', ['$rootScope', '$scope', 'Admin', 'Localized', 'Debug', '$state', '$stateParams', '$window', function ($rootScope, $scope, Admin, Localized, Debug, $state, $stateParams, $window) {
  $scope.activeTab = parseInt($stateParams.activeTab) || 0;
  $rootScope.breadcrumbs = [{
    name: 'VendorFuel Tutorial',
    state: null
  }];
  $scope.admin = Admin;
  $scope.localized = Localized;
  $scope.tutorialOptions = {};
  $scope.tutorialComplete = $window.localStorage.getItem('tutorialComplete');
  $scope.showTutorial = $window.localStorage.getItem('showTutorial');

  $scope.goToState = function (stateName, tabIndex) {
    $state.go(stateName, {
      activeTab: tabIndex
    });
  };

  if ($window.localStorage.getItem('showTutorial') === 'true') {
    $scope.tutorialOptions.show = true;
  } else {
    $scope.tutorialOptions.show = false;
  }

  $scope.disableTutorial = function () {
    if ($scope.tutorialOptions.show === true) {
      $window.localStorage.setItem('tutorialComplete', 'true');
      $window.localStorage.setItem('showTutorial', 'false');
      Debug.log('Tutorial has been disabled.');
    } else {
      $window.localStorage.setItem('tutorialComplete', 'false');
      $window.localStorage.setItem('showTutorial', 'true');
      Debug.log('Tutorial has been re-enabled.');
    }
  };
}]);
//# sourceMappingURL=vendorfuel-app.js.map
